# Teachable CMS Marketing Site

## Documentation

https://github.com/UseFedora/teachable-marketing/wiki

## Setup

To install dependencies:

``` zsh
$ bundle install
$ yarn install
```

Setup the database:

``` zsh
$ rake db:create
$ rake db:migrate
```

## Get Production Data

First, connect to the production VPN. Then:

``` zsh
$ yarn import-prod:local
```

## Start Servers

You'll need 3 processes.

Web server:

``` zsh
$ bundle exec rails server
```

Sidekiq for processing background jobs:

``` zsh
$ bundle exec sidekiq
```

And webpack for compiling and serving assets:

``` zsh
$ yarn start
```

## Authentication

In development mode, you don't need to go through the real authentication flow,
you'll click on which admin user to login as.

To circumvent this, and use a proper setup, make sure to run AAA and InternalSSO.

After that, you can disable the fake login by setting the environment variable:

``` sh
AAA_FAKE_MODE="false"
AAA_URL="[[REPLACE ME WITH THE REAL LOCAL URL]]"
```
