const { sendEmailSubmitConversion } = require('../conversion-events');

$(document).ready(function () {
  ContentDownloadHeroForm.initialize();
});

var ContentDownloadHeroForm = {

  initialize: function (selector) {
    Common.clickOrEnter({
      click: '.content-download-hero-form.top .cta-button',
      enter: '.content-download-hero-form.top .email-input',
      action: ContentDownloadHeroForm.handleEmailSubmit,
    });
    $('.content-download-hero-form.top .email-input').on('keydown', ContentDownloadHeroForm.clearError);
    Common.clickOrEnter({
      click: '.content-download-hero-form.bottom .cta-button',
      enter: '.content-download-hero-form.bottom .email-input',
      action: ContentDownloadHeroForm.handleEmailSubmit,
    });
    $('.content-download-hero-form.bottom .email-input').on('keydown', ContentDownloadHeroForm.clearError);
  },

  determineProperSelector: function (e) {
    return $(e.target).parents('.top').length ? '.top' : '.bottom';
  },

  clearError: function (e) {
    var selector = ContentDownloadHeroForm.determineProperSelector(e);
    $(selector + ' .email-input-container').removeClass('error');
  },

  handleEmailSubmit: function (e) {
    var selector = ContentDownloadHeroForm.determineProperSelector(e);
    var email = $(selector + ' .email-input').val();
    if (!Common.validateEmail(email)) {
      $(selector + ' .email-input-container').addClass('error');
    } else {
      var contentUpgradeSelector = selector + ' .content-download-info';
      var eventName = $(contentUpgradeSelector + ' .event-name').text();
      var contentInfo = {
        cta: {
          text: $(contentUpgradeSelector + ' .button-text').text(),
          url: $(contentUpgradeSelector + ' .redemption-link').text(),
        },
        title: $(contentUpgradeSelector + ' .title').text(),
        body_text: $(contentUpgradeSelector + ' .body-text').html()
      };
      Tracking.irisEmit("content_download_hero_form_email_submitted", {
        email: email,
        target: ['segment', 'iterable', ],
        description: eventName,
        content_info: contentInfo,  // for Iterable
        iterable: {  // TODO: Remove this and handle within iterable-client
          event_name: 'Marketing - Submitted Content Download Request',
          instance_id: 1,
          email_submitted_event: true,
        },
      });
      sendEmailSubmitConversion();
      ContentDownloadHeroForm.sendDataToIterable(email, eventName, contentInfo);
    }
  },

  sendDataToIterable: function (email, eventName, contentInfo) {
    var data = {
      content_info: contentInfo
    }
    Iterable.sendEvent({
      eventName: 'Marketing - Submitted Content Download Request',
      email: email,
      instanceId: 1,
      data: data,
      isEmailSubmittedEvent: true
    }).then(function(response) {
      var slug = $('#slug').text();
      window.location.href = "/get/" + slug + "/thank-you"
    });
  }
};
