import padStart from 'lodash/padStart';

$(document).ready(function() {
  if ($('.countdown-timer-component').length > 0) CountdownTimer.initialize();
});

var CountdownTimer = {

  timers: {},

  initialize: function() {
    CountdownTimer.setUpTimers();
  },

  tick: function(id) {
    var end = CountdownTimer.timers[id].end;
    var difference = end - CountdownTimer.timers[id].start;
    var days;
    var hours;
    var minutes;
    var seconds;
    if (difference < 0) {
      clearInterval(CountdownTimer.timers[id].interval);
      days = 0;
      hours = 0;
      minutes = 0;
      seconds = 0;
      if (CountdownTimer.timers[id].onEnd) {
        eval(CountdownTimer.timers[id].onEnd)
      }
    } else {
      days = Math.floor(difference / (1000 * 60 * 60 * 24));
      hours = Math.floor((difference % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
      minutes = Math.floor((difference % (1000 * 60 * 60)) / (1000 * 60));
      seconds = Math.floor((difference % (1000 * 60)) / 1000);
    }

    $('#' + id + ' .days-container .days').text(padStart(days, 2, '0'));
    $('#' + id + ' .hours-container .hours').text(padStart(hours, 2, '0'));
    $('#' + id + ' .minutes-container .minutes').text(padStart(minutes, 2, '0'));
    $('#' + id + ' .seconds-container .seconds').text(padStart(seconds, 2, '0'));

    CountdownTimer.timers[id].start.setSeconds(CountdownTimer.timers[id].start.getSeconds() + 1)
  },

  setUpTimers: function() {
    var $timers = $('.countdown-timer-component');
    for (var i = 0; i < $timers.length; i++) {
      var $timer = $timers[i];
      var id = $timer.id;
      var timerData = $($timer).find('.data-payload').data();

      function createTick(id) {
        return function() { CountdownTimer.tick(id); }
      }

      CountdownTimer.timers[id] = {
        end: new Date(timerData.end),
        interval: setInterval(createTick(id), 1000),
        onEnd: $($timer).data().onEnd,
        start: new Date()
      };
    }
  }
};
