var axios = require('axios')
var { mountApp } =  require('@teachable/creator-checkout')

// Inject CSRF token into proxied endpoints
axios.interceptors.request.use(config => {
  if (config.url[0] === '/') {
    const tokenMeta = document.querySelector('meta[name=csrf-token]')
    if (tokenMeta) {
      return {
        ...config,
        headers: {
          ...config.headers,
          'X-CSRF-Token': tokenMeta.content,
        }
      }
    }
  }

  return config
})

var host =
  $("meta[id=environment]").attr("data-env") === "test"
    ? ""
    : Common.getProperMarketingApiEndpoint()

const {
  stripeApiKey,
  planId,
  planType,
  planPrice,
  lineItems,
  disclaimer,
  planName,
} = document.querySelector('#creator-checkout-payload').dataset
const adverb = planType === 'Annual' ? 'annually' : 'monthly'

const PROPS = {
  host,
  iris: { emit: Tracking.irisEmit },
  proxiedUrls: {
    login: "/api/login/check_account",
    calculateSalesTax: `${Common.getProperMarketingApiEndpoint()}/calculate_sales_tax`,
  },
  plan: {
    id: Number(planId),
    price: Number(planPrice),
    descriptionText: `
      You are signing up for a Teachable ${planName} ${planType} plan. You will be charged ${adverb}.
    `,
    lineItems: JSON.parse(lineItems).filter(s => s !== ''),
    billingInterval: adverb
  },
  paymentInfoDisclaimer: disclaimer,
  stripeApiKey,
};

console.log(PROPS)
mountApp('#creator-checkout-root', PROPS)
