const { sendEmailSubmitConversion } = require('./conversion-events');

$(document).ready(function() {
  EmailCaptureCta.initialize();
});

var EmailCaptureCta = {

  initialize: function() {
    Common.clickOrEnter({
      click: '.email-capture button',
      enter: '.email-capture input',
      action: EmailCaptureCta.submit
    });
    $('.email-capture input').on('keydown', EmailCaptureCta.clearError);
  },

  clearError: function(e) {
    var children = e.target.parentElement.parentElement.children;
    var error = children[children.length - 1].classList.add("hidden");
  },

  submit: function(e) {
    e.preventDefault();
    var container = e.target.parentElement;
    var input = container.children[2];
    var email = input.value.trim();
    var emailOK = Common.validateEmail(email);
    if (!emailOK) {
      var children = e.target.parentElement.parentElement.children;
      children[children.length - 1].classList.remove("hidden");
    } else {
      var redirect = container.children[0].innerHTML;
      var campaign = container.children[1].innerHTML;
      Tracking.irisEmit('marketing_email_submitted', {
        instanceId: 1,
        email: email,
        eventName: 'Marketing - Email Submitted',
        utm_campaign: campaign,
        target: 'iterable'
      });
      // Iterable.sendEvent isn't a+ compliant so we gotta wrap it
      const iterableSend = new Promise((resolve) => Iterable.sendEvent({
        instanceId: 1,
        email: email,
        eventName: 'Marketing - Email Submitted',
        overrideTracking: {
          utm: {
            campaign: campaign
          }
        }
      }).then(resolve));
      Promise.all([iterableSend, sendEmailSubmitConversion()]).then(() => {
        var preservedParamsObject = Common.preservedParamsObject();
        if (Object.keys(preservedParamsObject).length > 0) {
          window.location.href = redirect + '?' + Tools.getStringFromObject(preservedParamsObject, '&');
        } else {
          window.location.href = redirect;
        };
      });
    }
  }
}
