const { sendEmailSubmitConversion } = require('./conversion-events');

$(document).ready(function() {
  EmailInputForm.initialize();
});

var EmailInputForm = {

  initialize: function() {
    $('.email-input-form form').on('submit', EmailInputForm.submitForm);
    $('.email-input-form input:not([type="submit"])').on('keydown', EmailInputForm.clearError);
  },

  clearError: function(e) {
    e.target.parentElement.children[0].classList.remove("show");
  },

  submitForm: function(e) {
    e.preventDefault();
    var form = e.target;
    var nameField = $(form).find("#form-name")[0];
    var emailField = $(form).find("#form-email")[0];
    var nameVisible = !!nameField;
    if (nameVisible) {
      var name = nameField.value.trim();
    }
    var email = emailField.value.trim();
    var emailOK = Common.validateEmail(email);
    var nameOK = !!(!nameVisible || name);
    if (!nameOK) {
      $(form).find("#error-name").addClass("show");
    }
    if (!emailOK) {
      $(form).find("#error-email").addClass("show");
    }
    if (nameOK && emailOK) {
      var segmentEvent = $(form).find(".segment-event")[0].innerHTML;
      var iterableEvent = $(form).find(".iterable-event")[0].innerHTML;
      var pageId = $(form).find(".page-id")[0].innerHTML;
      var utmCampaign = $(form).find(".utm-campaign")[0].innerHTML;
      var utmSource = $(form).find(".utm-source")[0].innerHTML;
      sendEmailSubmitConversion();
      Tracking.irisEmit(iterableEvent, {
        instanceId: 1,
        email: email,
        eventName: iterableEvent,
        data: {
          name: name,
          page_id: pageId
        },
        target: 'iterable'
      });
      Iterable.sendEvent({
        instanceId: 1,
        email: email,
        eventName: iterableEvent,
        alsoSendEmailSubmittedEvent: (iterableEvent !== 'Marketing - Email Submitted'),
        data: {
          first_name: name,
          page_id: pageId
        },
        overrideTracking: {
          utm: {
            campaign: utmCampaign,
            source: utmSource
          }
        }
      }).then(function() {
        window.location = $(form).find(".redirect")[0].innerHTML;
      });
    }
  }
};
