$(document).ready(function() {
  if ($('section.event-series-add-to-calendar').length > 0) {
    EventSeriesAddToCalendar.initialize();
  }
});

var EventSeriesAddToCalendar = {

  initialize: function() {
    $('section.event-series-add-to-calendar .orange-plus-button').click(EventSeriesAddToCalendar.clickAddToCalendarButton);
    $('section.event-series-add-to-calendar .green-calendar-button').click(EventSeriesAddToCalendar.clickAddToCalendarButton);
    $('li.add-to-calendar-link').click(EventSeriesAddToCalendar.clickCalendarType);
  },

  clickAddToCalendarButton: function() {
    $('.dropdown-container').toggle();
  },

  clickCalendarType: function(e) {
    var $startDateDiv = $('section.event-series-add-to-calendar .formatted-start-time');
    var $endDateDiv = $('section.event-series-add-to-calendar .formatted-end-time');

    var startTimeString = $startDateDiv.html();
    var startTime = new Date(startTimeString);

    var endTimeString = $endDateDiv.html();
    var endTime = new Date(endTimeString);

    var webinarTitle = $('.default-white-header').html();
    var urlArray = document.URL.split('/');
    // urlArray[urlArray.length - 1] = 'play';
    var playUrl = $('#event-series-schedule-url').data("schedule-url");
    switch (e.target.innerHTML) {
      case 'Google calendar':
        $('a.google')[0].click();
        break
      case 'Yahoo! calendar':
        $('a.yahoo')[0].click();
        break
      case 'iCal':
        var href = EventSeriesAddToCalendar.getIcsHref('icon-ical', 'iCal', webinarTitle, startTime, endTime, playUrl);
        window.location.href = href;
        break
      case 'Outlook calendar':
        var href = EventSeriesAddToCalendar.getIcsHref('icon-outlook', 'Outlook', webinarTitle, startTime, endTime, playUrl);
        window.location.href = href;
    }
    $('.dropdown-container').toggle();
  },

  getIcsHref: function(eClass, calendarName, title, startTime, endTime, playUrl) {
    return encodeURI(
      'data:text/calendar;charset=utf8,' + [
        'BEGIN:VCALENDAR',
        'VERSION:2.0',
        'BEGIN:VEVENT',
        'URL:' + playUrl,
        'DTSTART:' + EventSeriesAddToCalendar.formatDateForHref(startTime),
        'DTEND:' + EventSeriesAddToCalendar.formatDateForHref(endTime),
        'DESCRIPTION:' + playUrl,
        'SUMMARY:' + title,
        'END:VEVENT',
        'END:VCALENDAR'
      ].join('\n'));
  },

  formatDateForHref: function(date) {
    return date.toISOString().replace(/-|:|\.\d+/g, '');
  }
}
