// Unsubscribe in Chrome here: chrome://settings/content/notifications
$(document).ready(function() {
  if (window.location.pathname.indexOf('admin') === -1) {
    FirebaseMessaging.initialize();
  }
});

var FirebaseMessaging = {

  initialize: function() {
    messaging = firebase.messaging();
    // messaging.onMessage(function(payload) {
      // TO DO - SOMETHING WITH THE MESSAGE
    // });
    if (!Common.localStorageDisabled) {
      if (!localStorage.getItem('TeachableBrowserToken') && localStorage.getItem('email')) {
        try {
          FirebaseMessaging.requestPermission();
        } catch(e) {
          console.log('Firebase Request Permission Error');
        }
      }
    }
  },

  requestPermission: function() {
    messaging.requestPermission().then(function() {
      FirebaseMessaging.getToken();
    });
  },

  getToken: function() {
    messaging.getToken().then(function(currentToken) {
      if (currentToken) {
        localStorage.setItem('browserTokenValue', currentToken);
        FirebaseMessaging.sendTokenToIterable(currentToken);
        Iterable.sendEvent({
          eventName: 'Marketing - Browser Push Optin Confirmed',
          email: localStorage.getItem('email'),
          instanceId: 1
        });
        Tracking.irisEmit('marketing_browser_push_optin_confirmed', {
          eventName: 'Marketing - Browser Push Optin Confirmed',
          email: localStorage.getItem('email'),
          instanceId: 1,
          target: 'iterable'
        });
      } else {
        FirebaseMessaging.requestPermission();
      }
    });
  },

  sendTokenToIterable: function(token) {
    var email = localStorage.getItem('email');
    var url = '/api/register_token?instance_id=1&email=' + encodeURIComponent(email) + '&token=' + token;
    $.ajax({
      url: url,
      method: 'POST',
      success: function(response) {
        localStorage.setItem('TeachableBrowserToken', true);
      }
    });
  }
}
