$(document).ready(function() {
  FiveSteps.initialize();
});

var FiveSteps = {

  initialize: function() {
    $('.five-simple-steps li > a').click(FiveSteps.clickNumber);
    $('.next-step').click(FiveSteps.clickButton);
  },

  clickNumber: function(event) {
    event.preventDefault();
    var target = event.target;
    var parent;
    if (target.matches('a')) {
      parent = target.parentElement;
    } else {
      parent = target.parentElement.parentElement;
    }
    FiveSteps.activateStep(parent.dataset.step);
  },

  clickButton: function(event) {
    var step = event.target.parentElement.parentElement.dataset.step;
    if (step === '5') {
      window.location.href = '/create-account?utm_source=5steps';
    } else {
      FiveSteps.activateStep(+step + 1);
    }
  },

  activateStep: function(step) {
    $('.five-simple-steps li').removeClass('active');
    $('.second-row').removeClass('active');
    $('[data-step=' + step + ']').addClass('active');
  }
}
