$(document).ready(function() {
  ForgotPassword.initialize();
});

var ForgotPassword = {

  initialize: function() {
    Common.clickOrEnter({
      click: "#forgot_final",
      enter: "#modal_forgot_email_field",
      action: ForgotPassword.clickButton
    });
    $('#modal_forgot_email_field').on('keydown', ForgotPassword.clearEmailErrors);
  },

  clearEmailErrors: function() {
    $("#error_email").removeClass("show");
    $("#error_server").removeClass("show");
  },

  clickButton: function(e) {
    e.preventDefault();
    var email = $("#modal_forgot_email_field").val();
    var emailOK = Common.validateEmail(email);

    if (emailOK) {
      $("#right-box-spinner").removeClass("hidden");
      ForgotPassword.sendData(email);
    } else {
      $("#error_email").addClass("show");
    }
  },

  sendData: function(email) {
    $.ajax({
      type: "GET",
      url: "https://academy.teachable.com/api/v1/account_retrieval",
      data: {
        email: email
      },
      success: function() {
        Tracking.irisEmit('clicked_ui', {
          name: 'send_password_reset_instructions'
        });
        window.location = "/login?reset=true";
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        $("#error_server").addClass("show");
        $("#right-box-spinner").addClass("hidden");
      }
    });
  }
}
