$(document).ready(function() {
  FourStepsExpid2.initialize();
});

var FourStepsExpid2 = {

  initialize: function() {
    $('.four-steps-expid2 li > a').click(FourStepsExpid2.clickNumber);
    $('.next-step').click(FourStepsExpid2.clickButton);
  },

  clickNumber: function(event) {
    event.preventDefault();
    var target = event.target;
    var parent;
    if (target.matches('a')) {
      parent = target.parentElement;
    } else {
      parent = target.parentElement.parentElement;
    }
    FourStepsExpid2.activateStep(parent.dataset.step);
  },

  clickButton: function(event) {
    var step = event.target.parentElement.parentElement.dataset.step;
    if (step === '4') {
      $('[data-step=' + step + ']').addClass('active');
      window.location.href = '/create-account?utm_source=4steps';
    } else {
      FourStepsExpid2.activateStep(+step + 1);
    }
  },

  activateStep: function(step) {
    $('.four-steps-expid2 li').removeClass('active');
    $('.second-row').removeClass('active');
    $('[data-step=' + step + ']').addClass('active');
  }
}
