$(document).ready(function() {
  Iterable.initialize();
});

var Iterable = {

  initialize: function() {
    if (window.location.pathname.indexOf('email-address-confirmed') > -1) {
      Iterable.confirmEmailAddress();
    }
  },

  sendEvent: function(args) {
    var defaults = {
      eventName: '',
      email: '',
      instanceId: 0,
      data: {},
      alsoSendEmailSubmittedEvent: false
    };
    args = Object.assign(defaults, args);
    args.data.tracking = Iterable.getTrackingParams(args.overrideTracking);
    if (args.alsoSendEmailSubmittedEvent) {
      Iterable.sendEvent({
        eventName: 'Marketing - Email Submitted',
        email: args.email,
        instanceId: 1
      });
    }
    return $.ajax({
      type: 'POST',
      url: '/api/send_iterable_event',
      data: {
        instance_id: args.instanceId,
        email: args.email,
        event_name: args.eventName,
        i_campaign_id: Common.params['i_campaign_id'] || '0',
        i_template_id: Common.params['i_template_id'] || '0',
        data: args.data
      }
    });
  },

  getTrackingParams: function(overrides) {
    var overrides = overrides || {};
    return {
      utm: {
        campaign: (overrides.utm && overrides.utm.campaign) || Common.params['utm_campaign'],
        source: (overrides.utm && overrides.utm.source) || Common.params['utm_source'],
        medium: (overrides.utm && overrides.utm.medium) || Common.params['utm_medium'],
        term: (overrides.utm && overrides.utm.term) || Common.params['utm_term'],
        content: (overrides.utm && overrides.utm.content) || Common.params['utm_content']
      },
      mt: {
        campaign_group: (overrides.mt && overrides.mt.campaignGroup) || Common.params['mt_campaign_group'],
        tier: (overrides.mt && overrides.mt.tier) || Common.params['mt_tier'],
        interval: (overrides.mt && overrides.mt.interval) || Common.params['mt_interval']
      },
      other: {
        upgrade_src: (overrides.other && overrides.other.upgradeSrc) || Common.params['upgrade_src'],
        src: (overrides.other && overrides.other.src) || Common.params['src'],
        mbsy: (overrides.other && overrides.other.msby) || Common.params['mbsy']
      }
    }
  },

  confirmEmailAddress: function() {
    var email = Common.params.email;
    if (email) {
      Iterable.sendEvent({
        eventName: 'Marketing - Email Optin Confirmed',
        email: email,
        instanceId: 1
      });
    }
  }
}

module.exports = Iterable;
