const { sendEmailSubmitConversion } = require('../conversion-events');

$(document).ready(function() {
  ExitIntentModal.initialize();
});

var ExitIntentModal = {

  initialize: function() {
    var exitIntentModalContainer = document.getElementsByClassName('exit-intent-modal-container')[0];
    window.ob = ouibounce(exitIntentModalContainer, {
      callback: function() {
        exitIntentModalContainer.setAttribute('style', 'display: flex;');
        Tracking.irisEmit('viewed_exit_intent_modal_ebook', {
          target: 'segment'
        });
      }
    });
    $('.exit-intent-modal .close-modal-button').click(ExitIntentModal.clickCloseButton);
    Common.clickOrEnter({
      click: '.exit-intent-modal .download-button',
      enter: '.exit-intent-modal input',
      action: ExitIntentModal.clickDownloadButton
    });
  },

  clickCloseButton: function() {
    // manually remove ouibounce's background
    $('.modal-backdrop').remove();
    $('body').removeClass('modal-open');
    $('body').attr('style', '');
  },

  clickDownloadButton: function() {
    var email = $('.exit-intent-modal input')[0].value;
    var data = {
      cta: {
        text: 'Get the ebook',
        url: 'https://cdn2.hubspot.net/hubfs/677576/Content_Upgrades/How%20to%20create%20professional%20course%20content%20people%20will%20love%20-%20Teachable.pdf?t=1499376986773'
      },
      title: 'How to Create Professional Course Content People Will Love',
      body_text: 'Trust us, this is an ebook you’ll actually want to read. With beautiful images, interactive links and an additional resource guide, this is everything you need to create a course. IT covers...<ul><li>Structuring your course</li><li>Creating slides + giving you freebies</li><li>DIY video production</li><li>Conducting killer interviews</li></ul>'
    }
    if (Common.validateEmail(email)) {
      localStorage.setItem('email', email);
      Tracking.irisEmit('submitted_exit_intent_modal_ebook', {
        email: email,
        target: ['segment', 'iterable', ],
        content_info: data,
        iterable: {  // TODO: Remove this and handle within iterable-client
          event_name: 'Marketing - Submitted Exit Intent Modal',
          instance_id: 1,
          email_submitted_event: true,
        }
      });
      const iterableSend = new Promise((resolve) => Iterable.sendEvent({
        eventName: 'Marketing - Submitted Exit Intent Modal',
        email: email,
        instanceId: 1,
        data: data,
        isEmailSubmittedEvent: true
      }).then(resolve));
      Promise.all([iterableSend, sendEmailSubmitConversion()]).then(() => {
        window.location = '/webinars/quickstart/register?message_id=1&utm_source=teachable-exit-intent&src=teachable-exit-intent';
      });
    }
  }
}
