$(document).ready(function() {
  PricingComparison.initialize();
});

var PricingComparison = {

  initialize: function() {
    PricingComparison.$activePlan = $("#pricing-comparison-plan-options > li.active");
    $("#pricing-comparison-plan-options > li").click(PricingComparison.changePlan);
    $("#mobile-pricing-comparison-table-register").click(PricingComparison.register);
    $("#pricing-comparison-mobile .category-header").click(PricingComparison.toggleCategoryInfoAndHeader);
  },

  changePlan: function(e) {
    if (e.currentTarget != PricingComparison.$activePlan[0]) {
      PricingComparison.$activePlan.removeClass('active');
      PricingComparison.getOpenCategoryHeaders();
      PricingComparison.toggleAllCategoryInfo('close');
      PricingComparison.$activePlan = $(e.currentTarget);
      PricingComparison.$activePlan.addClass('active');
      PricingComparison.toggleAllCategoryInfo('open');
    }
  },

  toggleCategoryInfoAndHeader: function(e) {
    var categoryHeader = e.currentTarget.id;
    var currentPlan = PricingComparison.getCurrentPlan();
    var categoryInfoId = PricingComparison.getCategoryInfoId(categoryHeader, currentPlan);

    if($(categoryInfoId).hasClass('hidden')) {
      $('#' + categoryHeader).removeClass('inactive');
      PricingComparison.openCategoryInfo(categoryInfoId);
      $('#' + categoryHeader).addClass('active');
    } else {
      $('#' + categoryHeader).addClass('inactive');
      PricingComparison.closeCategoryInfo(categoryInfoId);
      $('#' + categoryHeader).removeClass('active');
    }
  },

  toggleAllCategoryInfo: function(openOrClose) {
    var typeOfToggle;
    if (openOrClose === 'close') {
      typeOfToggle = PricingComparison.closeCategoryInfo;
    } else {
      typeOfToggle = PricingComparison.openCategoryInfo;
    }

    for(var i = 0; i < PricingComparison.openCategoryHeaders.length; i++) {
      typeOfToggle(PricingComparison.getCategoryInfoId(PricingComparison.openCategoryHeaders[i], PricingComparison.getCurrentPlan()));
    }
  },

  getCurrentPlan: function() {
    return PricingComparison.$activePlan.text();
  },

  getCategoryInfoId: function(categoryHeader, currentPlan) {
    currentPlan = currentPlan.toLowerCase().replace(/\040/g, '-');
    return ('#' + categoryHeader + '-' + currentPlan);
  },

  getOpenCategoryHeaders: function() {
    var $openCategoryHeaders = $("#pricing-comparison-mobile .category-header.active");
    var openCategoryHeaders = [];
    $openCategoryHeaders.each(function(index, categoryHeader) {
      openCategoryHeaders.push(categoryHeader.id);
    });

    PricingComparison.openCategoryHeaders = openCategoryHeaders;
  },

  closeCategoryInfo: function(categoryInfoId) {
    $(categoryInfoId).addClass('hidden');
  },

  openCategoryInfo: function(categoryInfoId) {
    $(categoryInfoId).removeClass('hidden');
  },

  getPlanIds: function() {
    return {
      'Basic': $('#pricing-comparison-mobile #basic').attr('value'),
      'Pro': $('#pricing-comparison-mobile #professional').attr('value'),
      'Business': $('#pricing-comparison-mobile #business').attr('value')
    };
  },

  register: function() {
    var currentPlan = PricingComparison.getCurrentPlan();
    var href = '/create-account';
    var allPlanIds = PricingComparison.getPlanIds();
    if (allPlanIds[currentPlan]) {
      href += ('?plan_id=' + allPlanIds[currentPlan]);
    }
    if (Common.params.upgrade_src) {
      href += ('&upgrade_src=' + Common.params.upgrade_src);
    }
    if (Common.params.coupon_cde) {
      href += ('&coupon_code=' + Common.params.coupon_code);
    }
    window.location.href = href;
  }
};
