$(document).ready(function() {
  Pricing.initialize();
});

var Pricing = {

  initialize: function() {
    this.resetToggleSwitch();
    $(".pricing-table #pricing-table-switch").change(Pricing.toggleSwitch);
    $('.pricing-match-height').matchHeight({ byRow: false });
    $('.choose-button').click(Pricing.clickChoosePlan);
    Pricing.replaceFirstPartialHeaders();
  },

  toggleSwitch: function(e) {
    var $pricingTable = $(e.currentTarget).parents('section');
    $pricingTable.find('.toggle span.active').removeClass('active');
    if ($pricingTable.find("#pricing-table-switch").is(':checked')) {
      $pricingTable.find('.toggle .annual').addClass('active');
      $pricingTable.addClass('annual');
    } else {
      $pricingTable.find('.toggle .monthly').addClass('active');
      $pricingTable.removeClass('annual');
    }
  },

  replaceFirstPartialHeaders: function() {
    if (Common.params["headline"]) {
      $('.pricing-table h1')[0].innerHTML = decodeURIComponent(Common.params["headline"]);
    }
    if (Common.params["subtitle"]) {
      $('.pricing-table h2')[0].innerHTML = decodeURIComponent(Common.params["subtitle"]);
    }
  },

  clickChoosePlan: function() {
    Tracking.irisEmit('pricing_choose_plan_clicked', {
      target: 'segment'
    });
  },

  resetToggleSwitch: function() {
    $('.pricing-table').each(function() {
      var $checkBox = $(this).find('input:checkbox');
      if ($checkBox[0]) {
        if ($(this).hasClass('annual')){
          $checkBox.prop('checked', true);
        } else {
          $checkBox.prop('checked', false);
        }
      }
    });
  },
};
