$(document).ready(function() {
  Showcase.initialize();
});

// translate slick init event into native event for lazyloading
$(document).on('init', (e) => {
  document.dispatchEvent(new Event('slickInit'));
});
var Showcase = {

  initialize: function() {
    var isMobile = $(window).width() <= 767;

    $('.homepage-slider').on('beforeChange', function(e, slick, curSlide, nextSlide) {
      Showcase.beforeChange(e, slick, curSlide, nextSlide);
    });
    $('.homepage-slider').on('afterChange', function(e, slick, curSlide, nextSlide) {
      Showcase.afterChange(e, slick, curSlide, nextSlide);
    });

    $('.homepage-slider').slick({
      prevArrow: '<button type="button" class="slick-prev">&#8249;</button>',
      nextArrow: '<button type="button" class="slick-next">&#8250;</button>',
      slidesToShow: isMobile ? 1 : 3,
      initialSlide: isMobile ? 1 : 0,
      centerPadding: '5px',
      focusOnSelect: true,
      infinite: true,
      speed: 900
    });

    $('.showcase').removeClass('hidden');
  },

  beforeChange: function(e, slick, currentSlide, nextSlide) {
    if ($(window).width() > 767) {
      $('.item .text').removeClass('active');
      $('.homepage-slider')[0].classList.add('transitioning');
    }
    $('.small-text .text').removeClass('active');
  },

  afterChange: function(e, slick, currentSlide, nextSlide) {
    var index = Showcase.getSlideIndex(currentSlide);
    if ($(window).width() > 767) {
      $('.slick-current + .slick-active .text')[0].classList.add('active');
      $('.homepage-slider')[0].classList.remove('transitioning');
    }
    $('.small-text .text')[index].classList.add('active');
  },

  getSlideIndex: function(currentSlide) {
    if ($(window).width() <= 767) {
      return currentSlide - 1 === -1 ? 4 : currentSlide - 1;
    } else {
      return $('.slick-current + .slick-active')[0].dataset.slickIndex - 1;
    }
  }
}
