$(document).ready(() => {
  SimpleEmailInputHero.initialize();
});

var SimpleEmailInputHero = {

  initialize: () => {
    $('.simple-email-input-hero form').submit(SimpleEmailInputHero.submitForm);
    $('.simple-email-input-hero form input[type="email"]').on('keydown', SimpleEmailInputHero.clearError);
  },

  submitForm: (e) => {
    e.preventDefault();
    let emailField = e.target.children[0].children[0];
    let email = emailField.value;
    let emailOK = Common.validateEmail(email);
    if (emailOK) {
      let iterableCampaign = JSON.parse(e.target.parentElement.parentElement.parentElement.parentElement.parentElement.dataset.iterable);
      let iterableObj = {
        eventName: 'Marketing - Email Submitted',
        email: email,
        instanceId: 1,
        isEmailSubmittedEvent: true,
        data: {
          id: iterableCampaign['ID'],
          title: iterableCampaign['Title'],
          campaign_group: iterableCampaign['Campaign Group']
        }
      }
      Iterable.sendEvent(iterableObj);
      let redirectUrl = e.target.parentElement.parentElement.parentElement.parentElement.parentElement.dataset.redirect;
      Common.redirectWithPreservedParams(redirectUrl);
    } else {
      e.target.children[1].classList.remove("hidden");
    }
  },

  clearError: (e) => {
    let errorDiv = e.target.parentElement.parentElement.children[1];
    errorDiv.classList.add("hidden");
  }
};
