$(document).ready(function() {
  SubNavMenuToggleVisibility.initialize();
});

var SubNavMenuToggleVisibility = {

  initialize: function() {
    $('.nav-partial').hide();
    $('.nav-partial.active').show();
    for (var i = 1; i <= $('.nav-link').length; i++) {
      $('.nav-link-' + i).on('click', SubNavMenuToggleVisibility.clickTab.bind(null, i));
    }
    SubNavMenuToggleVisibility.applyAnchorTagSelection();
  },

  clickTab: function(i) {
    $activeTab = $('.nav-link-' + i);
    $('.nav-link.active').removeClass('active');
    $activeTab.addClass('active');

    $activePartial = $('.nav-partial-' + i);
    $('.nav-partial').hide();
    $activePartial.addClass('active').show();

    window.location.hash = SubNavMenuToggleVisibility.getTabHash($activeTab.attr('id'));
  },

  applyAnchorTagSelection: function() {
    var hash = decodeURI(window.location.hash).toLowerCase();
    if (hash) {
      $('.sub-nav-menu-toggle-visibility li').each(function() {
        var tabHash = SubNavMenuToggleVisibility.getTabHash(this.id);
        if (hash === tabHash) {
          $(this).click();
        }
      });
    }
  },

  getTabHash: function(tabId) {
    return '#' + tabId.slice(0, -4);
  }
}
