const { sendEmailSubmitConversion } = require('./conversion-events');

$(document).ready(function () {
  CreatorChallengeEmailInputForm.initialize();
});

var CreatorChallengeEmailInputForm = {

  initialize: function () {
    $('.summit-creator-challenge-email-input-form form').on('submit', CreatorChallengeEmailInputForm.submitForm);
    $('.summit-creator-challenge-email-input-form input:not([type="submit"])').on('keydown', CreatorChallengeEmailInputForm.clearError);
  },

  clearError: function (e) {
    e.target.parentElement.children[3].classList.remove("show");
  },

  showAccountError: function () {
    $(".account-error-row").removeClass("hidden");
  },

  submitForm: function (e) {
    e.preventDefault();
    var form = e.target;
    var emailField = $(form).find("#form-email")[0];
    var email = emailField.value.trim();
    var emailOK = Common.validateEmail(email);
    if (!emailOK) {
      $(form).find("#error-email").addClass("show");
    }
    if (emailOK) {
      var iterableMetadata = JSON.parse($(".iterable-metadata")[0].innerHTML);
      $.ajax({
        type: "POST",
        url: "/api/check_email",
        data: {
          email: email
        },
        success: function (response) {
          if (response.type !== "paying_owner") {
            CreatorChallengeEmailInputForm.showAccountError();
          } else {
            Tracking.irisEmit("summit_registered", {
              email: email,
              target: ["iterable"],
              iterable: {
                event_name: "Marketing - Email Submitted",
                instance_id: 1,
                data: iterableMetadata
              }
            });
            const iterableSend = new Promise((resolve) => Iterable.sendEvent({
              email: email,
              eventName: "Marketing - Email Submitted",
              instanceId: 1,
              data: iterableMetadata
            }).then(resolve));
            Promise.all([iterableSend, sendEmailSubmitConversion()]).then(function () {
              CreatorChallengeEmailInputForm.redirect("/creator-challenge/thank-you", email);
            });
          }
        }
      });
    }
  },

  redirect: function (url, email) {
    var params = Common.params;
    params.email = email;
    window.location.href = url + Common.paramsObjectToSearchString(params);
  }
};
