$(document).ready(function () {
  SummitCreatorChallengeHero.initialize();
});

var SummitCreatorChallengeHero = {

  initialize: function () {
    Common.clickOrEnter({
      click: ".summit-creator-challenge-hero .orange-button",
      enter: ".summit-creator-challenge-hero input",
      action: SummitCreatorChallengeHero.clickCTA
    });
    $(".summit-creator-challenge-hero input").on("keydown", SummitCreatorChallengeHero.clearEmailError);
  },

  clickCTA: function (e) {
    var inputContainerDiv = e.target.parentElement;
    var email = inputContainerDiv.children[0].value;
    var emailOK = Common.validateEmail(email);
    if (emailOK) {
      var iterableMetadata = JSON.parse($(".iterable-metadata")[0].innerHTML);
      $.ajax({
        type: "GET",
        url: "/api/check_email",
        data: {
          email: email
        },
        success: function (response) {
          var url;
          switch (response.type) {
            case "lead":
              url = "/coaching-challenge/choose-plan";
              break;
            case "teachable_account_non_owner":
              url = "/coaching-challenge/choose-plan";
              break;
            case "teachable_account_free_plan":
              url = "/coaching-challenge/choose-plan"
              break;
            case "paying_owner":
              url = "/coaching-challenge/confirmed";
              break;
            case "paying_owner_no_teachable_account":
              url = "/coaching-challenge/confirmed";
              break;
            case "owner_free_plan":
              url = "/coaching-challenge/choose-plan";
              break;
          }
          Tracking.irisEmit("summit_registered", {
            email: email,
            target: ["iterable"],
            iterable: {
              event_name: "Marketing - Email Submitted",
              instance_id: 1,
              data: iterableMetadata
            }
          });
          Iterable.sendEvent({
            email: email,
            eventName: "Marketing - Email Submitted",
            instanceId: 1,
            data: iterableMetadata
          }).then(function () {
            SummitCreatorChallengeHero.redirect(url, email);
          });
        }
      });
    } else {
      var errorField = inputContainerDiv.children[2];
      errorField.classList.remove("hidden");
    }
  },

  clearEmailError: function (e) {
    var inputContainerDiv = e.target.parentElement;
    var errorField = inputContainerDiv.children[2];
    errorField.classList.add("hidden");
  },

  redirect: function (url, email) {
    var params = Common.params;
    params.email = email;
    window.location.href = url + Common.paramsObjectToSearchString(params);
  }
};
