$(document).ready(function() {
  SummitCta.initialize();
});

var SummitCta = {

  initialize: function() {
    $(".summit-cta .summit-cta-register-button").click(SummitCta.clickCTA); // only exists on page if no Button Url
    Common.clickOrEnter({
      click: ".summit-cta .orange-button",
      enter: ".summit-cta input",
      action: SummitCta.clickCTA
    });
    $(".summit-cta input").on("keydown", SummitCta.clearEmailError);
  },

  clickCTA: function(e) {
    var inputContainerDiv = e.target.parentElement;
    var email = inputContainerDiv.children[0].value;
    var emailOK = Common.validateEmail(email);
    if (emailOK) {
      var url = inputContainerDiv.children[3].innerHTML;
      var iterableMetadata = JSON.parse($(".iterable-metadata")[0].innerHTML);
      Tracking.irisEmit("summit_registered", {
        email: email,
        target: ["iterable"],
        iterable: {
          event_name: "Marketing - Enrolled in Major Promotion",
          instance_id: 1,
          data: iterableMetadata
        }
      });
      Iterable.sendEvent({
        email: email,
        eventName: "Marketing - Enrolled in Major Promotion",
        instanceId: 1,
        data: iterableMetadata
      }).then(function() {
        SummitCta.redirect(url, email);
      });
    } else {
      var errorField = inputContainerDiv.children[2];
      errorField.classList.remove("hidden");
    }
  },

  clearEmailError: function(e) {
    var inputContainerDiv = e.target.parentElement;
    var errorField = inputContainerDiv.children[2];
    errorField.classList.add("hidden");
  },

  redirect: function(url, email) {
    var params = Common.params;
    params.email = email;
    window.location.href = url + Common.paramsObjectToSearchString(params);
  }
};
