$(document).ready(function() {
  SummitRegisterModalSelectTrack.initialize();
});

var emailInputClass = ".summit-register-modal-select-track .summit-register-email";

var SummitRegisterModalSelectTrack = {

  initialize: function() {
    $(".summit-register-modal-select-track .modal-close-button").click(SummitRegisterModalSelectTrack.closeModal);
    if ($(".summit-register-modal-select-track").length > 0 && Common.params["email"]) {
      $(".summit-register-modal-select-track .summit-register-email").val(unescape(Common.params["email"]));
      if (Common.params["modal_open"] == "true") {
        SummitRegisterModalSelectTrack.openModal();
      }
    }
    Common.clickOrEnter({
      click: ".summit-register-modal-select-track .orange-button",
      enter: emailInputClass,
      action: SummitRegisterModalSelectTrack.clickCTA
    });
    $(".summit-register-modal-select-track .summit-register-email").on("keydown", SummitRegisterModalSelectTrack.clearEmailError);
  },

  openModal: function() {
    $(".summit-register-modal-select-track .modal").modal("show"); // opened using bootstrap
    var $dataDiv = $(".summit-register-modal-select-track .data");
    var segmentOpenModalEvent = $dataDiv.data().openSegment;
    var email = Common.params.email || localStorage.getItem("email");
    if (email && segmentOpenModalEvent) {
      Tracking.irisEmit("summit_registration_track_selector_opened", {
        email: email,
        target: "segment",
        description: segmentOpenModalEvent,
      });
    }
  },

  closeModal: function(e) {
    $(".summit-register-modal-select-track .modal").modal("hide");
  },

  clickCTA: function() {
    var email = $.trim($(emailInputClass).val());
    var emailOK = Common.validateEmail(email);
    if (emailOK) {
      var track = $("input[type=radio]:checked").val();
      var $dataDiv = $(".summit-register-modal-select-track .data");
      var segmentRegisterEvent = $dataDiv.data().registerSegment;
      var iterableRegisterEvent = $dataDiv.data().registerIterable;
      var eventDate = $dataDiv.data().eventDate;
      const sendEvents = new Promise((resolve) => {
        if (segmentRegisterEvent) {
          Tracking.irisEmit("summit_registration_track_registered", {
            email: email,
            track: track,
            target: ['segment', 'iterable', ],
            description: segmentRegisterEvent,
            iterable: {  // TODO: Remove this and handle within iterable-client
              event_name: iterableRegisterEvent,
              instance_id: 1,
            },
          });
        }
        if (iterableRegisterEvent) {
          Iterable.sendEvent({
            email: email,
            eventName: iterableRegisterEvent,
            instanceId: 1,
            data: {
              track: track,
              datetime: eventDate
            }
          }).then(resolve);
        } else {
          resolve();
        }
      }).then(() => {
        SummitRegisterModalSelectTrack.redirect(email);
      });
    } else {
      $(".summit-register-modal-select-track .public-error").removeClass("hidden");
    }
  },

  redirect: function(email) {
    var params = Common.params;
    params.email = email;
    window.location.href = "/live/thank-you" + Common.paramsObjectToSearchString(params);
  },

  clearEmailError: function() {
    $(".summit-register-modal-select-track .public-error").addClass("hidden");
  }
};
