$(document).ready(function() {
  SummitRegisterModal.initialize();
});

var SummitRegisterModal = {

  initialize: function() {
    $("#summit-register-modal").click(SummitRegisterModal.closeModal);
    Common.clickOrEnter({
      click: '#reserve-spot',
      enter: '#summit-register-email',
      action: SummitRegisterModal.clickCTA
    });
    $("#summit-register-email").on('keydown', SummitRegisterModal.clearEmailError);
  },

  openModal: function() {
    $("#summit-register-modal").modal('show'); // opened using bootstrap
    var segmentEventObject = Common.getSegmentEventObject('summit-open-modal-event-for-segment');
    if (segmentEventObject.event) {
      var irisEvent = $.trim($('#summit-open-modal-event-for-segment').attr('value'));
      Tracking.irisEmit("summit_registration_opened", {
        target: 'segment',
        description: irisEvent
      });
    }
    setTimeout(function() {
      $("#summit-register-email").focus();
    }, 500);
  },

  closeModal: function(e) {
    var targetId = e.target.id;
    if (targetId !== 'summit-register-email' && targetId !== 'reserve-spot') {
      $("#summit-register-modal").modal('hide');
    }
  },

  clickCTA: function() {
    var email = $.trim($('#summit-register-email').val());
    var emailOK = Common.validateEmail(email);
    if (emailOK) {
      var segmentObject = SummitRegisterModal.objectForSegmentApi();
      if (segmentObject.event) {
        var irisObject = SummitRegisterModal.objectForIrisApi();
        Tracking.irisEmit(irisObject.event, irisObject.metadata);
        setTimeout(summitRegisterModal.thankYouUrl, 300);
      } else {
        SummitRegisterModal.thankYouUrl();
      }
    } else {
      $("#summit-register-modal-form-container").addClass("with-error");
      $("#summit-error-invalid-email").css('display', 'block');
    }
  },

  objectForSegmentApi: function() {
    var object = {}
    object.event = "summit_registration_call_to_action_clicked";;
    object.email = $.trim($('#summit-register-email').val());
    object.templateId = Common.params['i_template_id'];
    object.campaignId = Common.params['i_campaign_id'];
    object.description = $.trim($('#summit-segment-event-for-api').attr('value'));
    var dateTime = $.trim($('#summit-segment-date-time').attr('value'));
    if (dateTime !== '') {
      object.datetime = dateTime;
    }
    return object;
  },

  objectForIrisApi: function() {
    var object = {};
    object.event = formatEventForIris($.trim($('#summit-segment-event-for-api').attr('value')));
    object.metadata = {};
    object.metadata.email = formatEventForIris($.trim($('#summit-register-email').val()));
    object.metadata.template_id = Common.params['i_template_id'];
    object.metadata.campaign_id = Common.params['i_campaign_id'];
    object.metadata.target = 'segment';
    var dateTime = $.trim($('#summit-segment-date-time').attr('value'));
    if (dateTime !== '') {
      object.metadata.datetime = dateTime;
    }
    return object;
  },

  thankYouUrl: function() {
    var params = Common.params;
    window.location.href = ("/summit/thank-you?email=" + $.trim($('#summit-register-email').val()) + "&src=" + params["src"] + "&utm_source=" + params["utm_source"] + "&utm_medium=" + params["utm_medium"]);
  },

  clearEmailError: function() {
    $("#summit-register-modal-form-container").removeClass("with-error");
    $("#summit-error-invalid-email").css('display', 'none');
  }
};
