$(document).ready(function() {
  Support.initialize();
});

var Support = {

  initialize: function() {
    Common.clickOrEnter({
      click: "#support-final",
      enter: "#support-fields input",
      action: Support.clickButton
    });
    $('#support-email-field').on('keydown', Support.clearEmailError);
    $('#support-password-field').on('keydown', Support.clearPasswordError);
  },

  clearEmailError: function() {
    $("#error-invalid-email").removeClass("show");
    $("#error-server").removeClass("show");
  },

  clearPasswordError: function() {
    $("#error-password").removeClass("show");
    $("#error-server").removeClass("show");
  },

  clickButton: function(e) {
    e.preventDefault();
    var email = $("#support-email-field").val().toLowerCase();
    var pw = $("#support-password-field").val();
    var emailOK = Common.validateEmail(email);
    var passwordOK = pw.length >= 6;
    if (!emailOK) {
      $("#error-invalid-email").addClass("show");
    }
    if (!passwordOK) {
      $("#error-password").addClass("show");
    }
    if (emailOK && passwordOK) {
      $("#support-final").addClass("disabled");
      $("#right-box-spinner").removeClass("hidden");
      if ($("#recaptcha-enabled").length > 0){
        Support.sendLogInDataWithRecaptcha(email, pw);
      } else {
        Support.sendLogInData(email, pw);
      }
    }
  },

  sendLogInDataWithRecaptcha: function(email, pw) {
    grecaptcha.ready(function() {
      // do request for recaptcha token
      // response is promise with passed token
      grecaptcha.execute(Common.getRecaptchaSiteKey(), {action: 'login'}).then(function(token) {
        // add token to form
        $('#support-fields').prepend('<input type="hidden" name="g-recaptcha-response" value="' + token + '">');
        Support.sendLogInData(email,pw)
      });
    });
  },

  sendLogInData: function(email, pw) {
    $.ajax({
      type: "POST",
      url: "/api/login/validate",
      data: {
        email: email,
        password: pw,
        recaptcha: $("input[name='g-recaptcha-response']").attr("value")
      },
      success: function(response) {
        if (response.sign_ins.length > 0) {
          window.location.href = response.sign_ins[0].zendesk_url;
        } else {
          $("#error-server").addClass("show");
          $("#support-final").removeClass("disabled");
          $("#right-box-spinner").addClass("hidden");
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        $("#error-server").addClass("show");
        $("#support-final").removeClass("disabled");
        $("#right-box-spinner").addClass("hidden");
      }
    });
  }
}
