$(document).ready(function() {
  UrlInputForm.initialize();
});

var UrlInputForm = {

  initialize: function() {
    $('.url-input-form .orange-button').on('click', UrlInputForm.clickSubmitButton);
    $('.url-input-form #form-url').on('keydown', UrlInputForm.clearUrlError);
    $('.url-input-form #form-email').on('keydown', UrlInputForm.clearEmailError);
  },

  clearUrlError: function() {
    $('.url-input-form #error-url').removeClass('show');
  },

  clearEmailError: function() {
    $('.url-input-form #error-email').removeClass('show');
  },

  validateUrl: function(url) {
    var re = /^(?:http(s)?:\/\/)?[\w.-]+(?:\.[\w\.-]+)+[\w\-\._~:/?#[\]@!\$&'\(\)\*\+,;=.]+$/;
    return re.test(url);
  },

  clickSubmitButton: function(e) {
    e.preventDefault();
    var url = $.trim($('.url-input-form #form-url').val());
    var email = $.trim($('.url-input-form #form-email').val());
    var emailOk = Common.validateEmail(email);
    var urlOk = UrlInputForm.validateUrl(url);

    if (!urlOk) {
      $('.url-input-form #error-url').addClass('show');
    }

    if (!emailOk) {
      $('.url-input-form #error-email').addClass('show');
    }

    if (emailOk && urlOk) {
      window.location.href = '/create-account?email=' + email;
    }
  }
};
