require('./wistia-tracker');

$(document).ready(function() {
  var directories = Common.getUrlDirectories();
  if (directories[directories.length - 4] === 'webinars' && directories[directories.length - 2] === 'play') {
    AutomatedWebinarPlay.initialize();
  }
});

var AutomatedWebinarPlay = {

  originalPlayerHeight: $('.automated-webinar-play .video-container .wistia_responsive_padding').height(),

  initialize: function() {
    // Create IE + others compatible event handler
    var eventMethod = window.addEventListener ? "addEventListener" : "attachEvent";
    var eventer = window[eventMethod];
    var messageEvent = eventMethod == "attachEvent" ? "onmessage" : "message";

    // Listen to message from child window
    eventer(messageEvent,function(e) {
      if (e.origin === 'https://fast.wistia.net') {
        if (e.data === 'offer-displayed-below') {
          $('.automated-webinar-player-wrapper').addClass('offers-displayed')
        } else if (e.data === 'offers-not-displayed-below') {
          $('.automated-webinar-player-wrapper').removeClass('offers-displayed')
        } else if (e.data.startsWith('offer-displayed:')) {
          var offerId = e.data.split(":")[1];
          Tracking.irisEmit('saw_automated_event_offer', {
            offer_id: offerId
          });
        } else if (e.data.startsWith('offer-clicked:')) {
          var offerId = e.data.split(":")[1];
          Tracking.irisEmit('clicked_automated_event_offer', {
            offer_id: offerId
          });
        }
      }
    },false);
  },

}
