$(document).ready(function() {
  var directories = Common.getUrlDirectories();
  if (directories[1] === 'webinars' && directories[directories.length - 1] === 'thank-you') {
    WebinarThankYou.initialize();
  }
});

var WebinarThankYou = {

  initialize: function() {
    $('section.add-webinar-to-calendar .orange-button').click(WebinarThankYou.clickThankYouButton);
    $('li').click(WebinarThankYou.clickCalendarType);
  },

  clickThankYouButton: function() {
    $('.dropdown-container').toggle();
  },

  clickCalendarType: function(e) {
    var $dateDiv = $('.formatted-start-time');
    var timeString = $dateDiv.html();
    var startTime = new Date(timeString);
    var endTime = new Date(timeString);
    endTime.setMinutes(endTime.getMinutes() + 90);
    var webinarTitle = $('.default-white-header').html();
    var urlArray = document.URL.split('/');
    urlArray[urlArray.length - 1] = 'play';
    var playUrl = urlArray.join('/');
    switch (e.target.innerHTML) {
      case 'Google calendar':
        $('a.google')[0].click();
        break
      case 'Yahoo! calendar':
        $('a.yahoo')[0].click();
        break
      case 'iCal':
        var href = WebinarThankYou.getIcsHref('icon-ical', 'iCal', webinarTitle, startTime, endTime, playUrl);
        window.location.href = href;
        break
      case 'Outlook calendar':
        var href = WebinarThankYou.getIcsHref('icon-outlook', 'Outlook', webinarTitle, startTime, endTime, playUrl);
        window.location.href = href;
    }
  },

  getIcsHref: function(eClass, calendarName, title, startTime, endTime, playUrl) {
    return encodeURI(
      'data:text/calendar;charset=utf8,' + [
        'BEGIN:VCALENDAR',
        'VERSION:2.0',
        'BEGIN:VEVENT',
        'URL:' + playUrl,
        'DTSTART:' + WebinarThankYou.formatDateForHref(startTime),
        'DTEND:' + WebinarThankYou.formatDateForHref(endTime),
        'DESCRIPTION:' + playUrl,
        'SUMMARY:' + title,
        'END:VEVENT',
        'END:VCALENDAR'
      ].join('\n'));
  },

  formatDateForHref: function(date) {
    return date.toISOString().replace(/-|:|\.\d+/g, '');
  }
}
