const HEARTBEAT_INTERVAL = 5000;

let curSecond;
let heartbeat;

const calls = {
  statechange: (curState, prevState) => {
    if (curState !== 'playing' || heartbeat) {
      return;
    }

    Tracking.irisEmit('joined_webinar', window.webinarData);
    heartbeat = setInterval(() => {
      Tracking.irisEmit('watched_webinar', {
        timestamp: curSecond
      });
    }, HEARTBEAT_INTERVAL);
  },
  secondchange: (second) => {
    curSecond = second;
  }
}

window.addEventListener('message', (e) => {
  if (e.origin !== 'https://fast.wistia.net') {
    return;
  }

  let data;
  try {
    data = JSON.parse(e.data);
  } catch (e) {
    return
  }

  if (data.method === '_trigger') {
    const [callerName, ...args] = data.args;
    const call = calls[callerName];
    if (call) {
      call(...args);
    }
  }
});
