var Tools = {

  convertBooleanToTFString: function(input) {
    if ([true, false].indexOf(input) > -1) {
      return input ? "t" : "f";
    } else {
      return input;
    }
  },

  convertObjectKeysToUnderscore: function(object) {
    var result = {};
    Object.keys(object).forEach(function(key) {
      result[Tools.convertToUnderscore(key)] = object[key];
    });
    return result;
  },

  convertToUnderscore: function(input) {
    return input.replace(/([A-Z])/g, function($1) { return "_" + $1.toLowerCase(); }).replace('__', '_');
  },

  convertTrueFalseFromStringToBoolean: function(string) {
    if (string === "t") {
      return true;
    } else if (string === "f") {
      return false;
    } else {
      return string;
    }
  },

  formatCurrency: function(amount) {
    var parts = amount.toString().split(".");
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    return parts.join(".");
  },

  getStringFromObject: function(obj, separator) {
    return Object.keys(obj)
      .map(key => `${key}=${obj[key]}`)
      .join(separator);
  },

  rearrangeFields: function(currentOrder, draggedIndex, dropZoneIndex) {
    var result = {};
    var draggedTaskId;
    if (dropZoneIndex == -1) {
      draggedTaskId = currentOrder[draggedIndex];
      result[0] = draggedTaskId;
    }
    for (var i = 0; i < Object.keys(currentOrder).length; i++) {
      if (i != draggedIndex) {
        result[Object.keys(result).length] = currentOrder[i];
      }
      if (i == dropZoneIndex) {
        result[Object.keys(result).length] = currentOrder[draggedIndex];
      }
    }
    return result;
  },

  unCamelCase: function(str) {
    return str.replace(/([a-z])([A-Z])/g, '$1 $2');
  }
};

if (typeof module == 'undefined') {
  window.Tools = Tools;
} else {
  module.exports = Tools;
}
