class Admin::Api::FeaturesController < AdminController

  expire_page :@feature, only: [:update, :destroy]

  def index
    @features = Feature.all.order(:text)
    render 'index.json.jbuilder'
  end

  def show
    @feature = Feature.find(params[:id])
    render 'show.json.jbuilder'
  end

  def create
    @feature = Feature.new(feature_params)
    if @feature.save
      @features = Feature.all.order(:text)
      render 'index.json.jbuilder'
    else
      render json: @feature.errors.full_messages, status: 422
    end
  end

  def update
    @feature = Feature.find(params[:id])
    if @feature.update(feature_params)
      render 'show.json.jbuilder'
    else
      render json: @feature.errors.full_messages, status: 422
    end
  end

  def destroy
    @feature = Feature.find(params[:id])
    if @feature.destroy
      @features = Feature.all.order(:text)
      render 'index.json.jbuilder'
    else
      render json: @feature.errors.full_messages, status: 422
    end
  end

  private

  def feature_params
    params[:feature].permit(:text)
  end

end
