class Admin::Api::PartialsController < AdminController

  include Fieldable

  expire_page :@belongs_to_instance, only: [:update]

  def index
    @partials = Partial.all.includes(:page_partials, :image)
    render 'index.json.jbuilder'
  end

  def create
    @partial = Partial.new(partial_params)
    if @partial.save
      render 'create.json.jbuilder'
    else
      render json: @partial.errors.full_messages, status: 422
    end
  end

  def show
    @partial = Partial.find(params[:id])
    @fields = @partial.partial_fields.includes(:menu_options).order(:order)
    @templates = Template.all
    render 'show.json.jbuilder'
  end

  def update
    args = {
      field_model: 'partial_field',
      belongs_to_model: 'partial',
      belongs_to_params: partial_params,
      instance_model: 'page_partial',
      instance_field_model: 'page_partial_field'
    }
    fieldable_update(args)
  end

  def destroy
    @partial = Partial.find(params[:id])
    @partial.destroy
    render json: @partial
  end

  def pages
    @pages = Partial.pages(params[:id])
    render 'pages.json.jbuilder'
  end

  private

  def partial_params
    params.require(:partial).permit(:id, :name, :image_id, :devs_only)
  end

end
