class Admin::Api::PlansController < AdminController

  expire_page :@plan, only: [:update]

  def index
    @plans = Plan.all.order(:order)
    @tooltips = Tooltip.all
    render "index.json.jbuilder"
  end

  def update
    @plan = Plan.find(plan_params[:id])
    if @plan.update(plan_params)
      render "show.json.jbuilder"
    else
      render "errors.json.jbuilder", status: 422
    end
  end

  private

  def plan_params
    params[:plan].permit(:id, :name, :tagline, :annual_included, :order, :monthly_price, :annual_price, :includes_text, :app_monthly_plan_id, :app_annual_plan_id)
  end

end
