class Admin::Api::RedirectsController < AdminController

  def index
    @redirects = Redirect.all.includes(:pages, :blog_posts)
    render "index.json.jbuilder"
  end

  def create
    redirect = Redirect.new(redirect_params)
    if redirect.save
      @redirects = Redirect.all.includes(:pages, :blog_posts)
      render "index.json.jbuilder"
    else
      render json: redirect.errors.full_messages, status: 422
    end
  end

  def show
    @redirect = Redirect.find(params[:id])
    render "show.json.jbuilder"
  end

  def update
    @redirect = Redirect.find(params[:id])
    if @redirect.update(redirect_params)
      render "show.json.jbuilder"
    else
      render json: @redirect.errors.full_messages, status: 422
    end
  end

  def destroy
    redirect = Redirect.find(params[:id])
    redirect.destroy
    render json: redirect
  end

  private

  def redirect_params
    params[:redirect].permit(:url, :redirect, :active, :status_code)
  end

end
