class Admin::Api::TooltipsController < AdminController

  expire_page :@tooltip, only: [:update, :destroy]

  def index
    @tooltips = Tooltip.all
    render 'index.json.jbuilder'
  end

  def show
    @tooltip = Tooltip.find(params[:id])
    render 'show.json.jbuilder'
  end

  def create
    @tooltip = Tooltip.new(tooltip_params)
    if @tooltip.save
      @tooltips = Tooltip.all
      render 'index.json.jbuilder'
    else
      render json: @tooltip.errors.full_messages, status: 422
    end
  end

  def update
    @tooltip = Tooltip.find(params[:id])
    if @tooltip.update(tooltip_params)
      render 'show.json.jbuilder'
    else
      render json: @tooltip.errors.full_messages, status: 422
    end
  end

  def destroy
    @tooltip = Tooltip.find(params[:id])
    @tooltip.destroy
    PlanFeature.where(tooltip_id: @tooltip.id).update_all(tooltip_id: nil)
    render json: @tooltip
  end

  private

  def tooltip_params
    params[:tooltip].permit(:text)
  end

end
