class Admin::Api::UploadsController < AdminController

  def reusable_index
    @uploads = Upload.where(upload_type: "image", reusable: true)
    render 'reusable_index.json.jbuilder'
  end

  def create
    @upload = Upload.new(upload_params)
    if @upload.save
      render 'create.json.jbuilder'
    else
      render json: @upload.errors.full_messages, status: 422
    end
  end

  def update
    @upload = Upload.find(params[:id])
    if @upload.update(upload_params)
      render 'update.json.jbuilder'
    else
      render json: @upload.errors.full_messages, status: 422
    end
  end

  private

  def upload_params
    params[:upload].permit(:upload_type, :category, :url, :uploaded_by, :s3_url, :reusable)
  end

end
