class Admin::Api::WebinarObjectsController < AdminController

  include Reorderable

  def create
    current_length = WebinarObject.where(webinar_id: webinar_object_params[:webinar_id], objekt_name: webinar_object_params[:objekt_name]).length
    @webinar_object = WebinarObject.new(webinar_id: webinar_object_params[:webinar_id], objekt_id: webinar_object_params[:objekt_id], objekt_name: webinar_object_params[:objekt_name], order: current_length)
    if @webinar_object.save
      @selected_objects = WebinarObject.where(webinar_id: @webinar_object.webinar_id, objekt_name: @webinar_object.objekt_name)
      @other_objects = Objekt.where(template_id: Objekt.find(@webinar_object.objekt_id).template_id) - @selected_objects.map(&:objekt)
      @template_name = webinar_object_params[:objekt_name]
      render "index.json.jbuilder"
    else
      render json: @webinar_object.errors.full_messages, status: 422
    end
  end

  def rearrange
    params[:new_order].each do |index, id|
      webinar_object = WebinarObject.find(id)
      webinar_object.update(order: index)
    end
    @webinar_objects = WebinarObject.where(webinar_id: params[:webinar_id], objekt_name: params[:objekt_name])
    @template_name = params[:objekt_name]
    render "rearrange.json.jbuilder"
  end

  def destroy
    @webinar_object = WebinarObject.find(params[:id])
    @webinar_object.destroy
    reorder(WebinarObject.where(webinar_id: @webinar_object.webinar_id, objekt_name: @webinar_object.objekt_name).order(:order))
    @selected_objects = WebinarObject.where(webinar_id: @webinar_object.webinar_id, objekt_name: @webinar_object.objekt_name)
    @other_objects = Objekt.where(template_id: Objekt.find(@webinar_object.objekt_id).template_id) - @selected_objects.map(&:objekt)
    @template_name = @webinar_object.objekt_name
    render "index.json.jbuilder"
  end

  private

  def webinar_object_params
    params[:webinar_object].permit(:webinar_id, :objekt_id, :objekt_name)
  end

end
