class Admin::Api::WebinarOffersController < AdminController

  def create
    @webinar_offer = WebinarOffer.new(webinar_offer_params)
    if @webinar_offer.save
      @webinar_offers = WebinarOffer.where(webinar_id: @webinar_offer.webinar_id)
      render "index.json.jbuilder"
    else
      render json: @webinar_offer.errors.full_messages, status: 422
    end
  end

  def show
    @webinar_offer = WebinarOffer.find(params[:id])
    @webinar = Webinar.find(@webinar_offer.webinar_id)
    render "show.json.jbuilder"
  end

  def update
    @webinar_offer = WebinarOffer.find(params[:id])
    if @webinar_offer.update(webinar_offer_params)
      @webinar = Webinar.find(@webinar_offer.webinar_id)
      render "show.json.jbuilder"
    else
      render json: @webinar_offer.errors.full_messages, status: 422
    end
  end

  def destroy
    @webinar_offer = WebinarOffer.find(params[:id])
    @webinar_offer.destroy!
    render json: @webinar_offer
  end

  private

  def webinar_offer_params
    params.require(:webinar_offer).permit(
      :duration,
      :start_time,
      :title,
      :description,
      :cta_button_type,
      :cta_button_text,
      :cta_url,
      :webinar_id
    )
  end

end
