class Admin::BlogPostsController < AdminController
  include Blogable

  def initialize
    @blog_page = true
    super
  end

  def index
    render "index.html.erb"
  end

  def show
    @blog_post = BlogPost.find_by_id(params[:id])
    render "show.html.erb"
  end

  def preview
    @blog_page_type = 'show'
    @blog_post = BlogPost
      .includes(:cover_photo, :categories, :author)
      .find(params[:id])

    if @blog_post
      @nav_items = get_nav_items
      @categories = @blog_post.categories
      @related_posts = @categories
        .reduce([]) { |acc, category| acc += get_posts_by_category(category, 4, [@blog_post.id]) }
        .shuffle
        .take(4)

      render '/blog/show.html.erb'
    else
      redirect_to '/404'
    end
  end
end
