class Api::RegistrationsController < ApplicationController

  protect_from_forgery with: :null_session, prepend: true
  before_action :verify_authenticity_token

  def create
    response = Teachable.register_teachable_account(
      name:     registration_params[:name],
      email:    registration_params[:email],
      password: registration_params[:password],
      referral: registration_params[:referral]
    )
    if response.success?
      render json: { redirect_url:  response["redirect_url"] }
    else
      render json: response, status: :not_acceptable
    end
  end

  private

  def registration_params
    params.require(:registration).permit(:name, :email, :password, :referral)
  end

end
