require 'will_paginate/array'

class ApplicationController < ActionController::Base

  # Prevent CSRF attacks by raising an exception. (For APIs, you may want to use :null_session instead.)
  protect_from_forgery with: :exception, prepend: true

  rescue_from ActionController::InvalidAuthenticityToken, ActionController::InvalidCrossOriginRequest, with: :render_400

  private

  def render_400(error = nil)
    render text: "#{error.class}: #{error}", status: 400
  end

  def aaa
    @_aaa ||= request.env["aaa.helper"] || AAA::RequestHelper.new(env: request.env, site_id: "cms")
  end

  def get_signed_in_user
    if aaa.logged_in?
      @current_user = User.find_by(email: aaa.current_session.emails)
      @current_user ||= User.find_by(id: aaa.current_session.member_id)
      @aaa_account_id = aaa.current_session.account_id
    end
  end

end
