module Netlifiable
  extend ActiveSupport::Concern

  included do
    after_commit :build_netlify

    def self.has_many(name, scope = nil, options = {}, &extension)
      new_options = options.merge(after_remove: :build_netlify, after_add: :build_netlify)
      super(name, scope, new_options, &extension)
    end

  end

  def build_netlify(*)
    BuildNetlify.perform_async
  end

end
