module WebinarBonuses
  extend ActiveSupport::Concern

  def create_bonuses_array(webinar)
    total_bonus_value = 0
    bonuses = []
    webinar.basic_replay_bonuses.each do |objekt|
      field_values_hash = objekt.field_values_hash
      bonus = starting_bonus_object(webinar, field_values_hash)
      bonus['plan_name'] = 'basic'
      bonus['fast_action'] = false
      bonuses << bonus
      total_bonus_value += field_values_hash['Value'].to_i
    end
    webinar.pro_replay_bonuses.each do |objekt|
      field_values_hash = objekt.field_values_hash
      bonus = starting_bonus_object(webinar, field_values_hash)
      bonus['plan_name'] = 'professional'
      bonus['fast_action'] = false
      bonuses << bonus
      total_bonus_value += field_values_hash['Value'].to_i
    end
    webinar.basic_play_bonuses.each do |objekt|
      field_values_hash = objekt.field_values_hash
      bonus = starting_bonus_object(webinar, field_values_hash)
      bonus['plan_name'] = 'basic'
      bonus['fast_action'] = true
      bonuses << bonus
      total_bonus_value += field_values_hash['Value'].to_i
    end
    webinar.pro_play_bonuses.each do |objekt|
      field_values_hash = objekt.field_values_hash
      bonus = starting_bonus_object(webinar, field_values_hash)
      bonus['plan_name'] = 'professional'
      bonus['fast_action'] = true
      bonuses << bonus
      total_bonus_value += field_values_hash['Value'].to_i
    end
    [bonuses, total_bonus_value]
  end

  private

  def starting_bonus_object(webinar, field_values_hash)
    {
      'copy' => field_values_hash['Name'],
      'image' => (field_values_hash['Image'].empty? ? '' : Upload.find(field_values_hash['Image']).url),
      'description' => field_values_hash['Description'],
      'course_id' => field_values_hash['Course ID'],
      'value' => field_values_hash['Value'],
      'sub_length' => webinar.upgrade_timeframe
    }
  end

end
