class JobPostsController < ApplicationController

  LEVER_API_URL = "https://api.lever.co/v0/postings/teachable"
  LEVER_APPLICATION_URL = "https://jobs.lever.co/teachable"

  def show
    @job_post_data = fetch_job_post(params[:id])
    render :show
  end

  def fetch_job_post(job_id)
    @data = HTTParty.get(LEVER_API_URL + "/#{job_id}")
    return nil if @data["error"]
    {
      meta_title: "Teachable - #{@data["text"]}",
      meta_description: @data["descriptionPlain"],
      department: @data["categories"]["department"],
      title: @data["text"],
      location: @data["categories"]["location"],
      description: @data["description"],
      lists: @data["lists"].map { |list| { header: list["text"], items: list["content"] } },
      closing_summary: @data["additional"],
      application_href: LEVER_APPLICATION_URL + "/#{params[:id]}/apply",
    }
  end
end
