class PagesController < ApplicationController

  caches_action :show, unless: -> { params[:page] == 'create-account' || 'create-account-v2' }

  include Pricing

  def show
    @page ||= Page.includes(page_partials: [:partial]).find_by_url("/#{params[:page]}")
    if @page && @page.active
      get_pricing_info
      render 'show.html.erb'
    else
      @redirect = Redirect.where("lower(url) = ?", "/#{params[:page].try(:downcase)}").first
      if @redirect && @redirect.active
        redirect_to @redirect.redirect, status: @redirect.status_code
      else
        @page = Page.find_by_url('/404_error')
        render 'show.html.erb', status: 404
      end
    end
  end

  def robots
    respond_to :text
    expires_in 6.hours, public: true
  end

end
