# frozen_string_literal: true

class SessionsController < ApplicationController

  def after_login
    if (token = params[:token].presence)
      if (res = aaa.after_login(token: token))
        if params[:no_redirect] == "true"
          render plain: "logged in with #{params[:token]}", layout: false
        else
          url = res.fetch(:details, :flow, :success_url)
          redirect_to url
        end
      else
        redirect_to "/"
      end
    else
      redirect_to "/"
    end
  end

  def destroy
    aaa.logout
    redirect_to "/"
  end

  def fake_login
    @users = User.all.map { |user|
      [
        "#{user.name} (#{user.email})",
        AAA::Test.generate_token(
          id: user.id,
          name: user.name,
          email: user.email,
        ),
      ]
    }
  end

end
