module Teachable
  module Api
    module V1
      class ApplicationController < ActionController::Base
        before_action :verify_teachable_request!

        private

        def verify_teachable_request!
          if params[:api_key] != ENV.fetch("TEACHABLE_CROSS_PLATFORM_API_KEY")
            render json: { "message": "you are not authorized to do this" }, status: :unauthorized
          end
        end
      end
    end
  end
end
