module Teachable
  module Api
    module V1
      class DataAccessController < Teachable::Api::V1::ApplicationController

        def show
          email = params[:email]
          if email.nil?
            render json: { "error" => "Missing email param" }, status: :not_acceptable
          else
            registrant = Registrant.find_by(email: email)
            if registrant
              registrations = registrant.registrations
              data = {
                registrant: {
                  email: registrant.email,
                },
                registrations: registrations.map do |registration|
                  {
                    webinar_id: registration.webinar_id,
                    start_time: registration.webinar_start_time.iso8601
                  }
                end
              }
              render json: data, status: :ok
            else
              head :no_content
            end
          end
        end

      end
    end
  end
end
