module Teachable
  module Api
    module V1
      class DataErasureController < Teachable::Api::V1::ApplicationController

        def destroy
          email = params[:email]
          if email.nil?
            render json: { "error" => "Missing email param" }, status: :not_acceptable
          else
            registrant = Registrant.find_by(email: email)
            if registrant
              registrations = registrant.registrations
              registrations.destroy_all
              registrant.destroy
              render json: {status: "PII has been removed for User"}, status: :ok
            else
              head :no_content
            end
          end

        end

      end
    end
  end
end
