module Teachable
  module Api
    module V1
      class RegistrantsController < Teachable::Api::V1::ApplicationController

        def index
          if params[:email]
            registrant = Registrant.find_by(email: params[:email])
            if registrant
              webinars = registrant.registrations.map(&:webinar)
              webinars.select! { |webinar| webinar.proper_time1 >= (Time.now.end_of_day - 2.days) || (webinar.time2 && webinar.time2 >= (Time.now.end_of_day - 2.days)) }
              webinars.sort_by! { |webinar| webinar.time2 ? webinar.time2 : webinar.proper_time1 }
              webinar = webinars.last
              render json: { upgrade_src: "#{webinar.url}-play" }
            else
              render json: { error: "Unable to find registrant with email: #{params[:email]}" }, status: :not_found
            end
          else
            render json: { error: "Missing email param" }, status: 422
          end
        end

      end
    end
  end
end
