module Teachable
  module Api
    module V1
      class WebinarsController < Teachable::Api::V1::ApplicationController

        def index
          time_format = "%A, %B %-d, %Y %-l:%m %p"
          @webinars = []
          Webinar.all.each do |webinar|
            object = {
              id: webinar.id,
              webinar_title: webinar.title,
              url_string: webinar.url,
              recurring: webinar.recurring
            }
            if webinar.recurring
              object[:start_time] = webinar.next_recurring_event.strftime(time_format)
            else
              object[:start_time] = webinar.time.strftime(time_format)
            end
            @webinars << object
            if webinar.time2
              @webinars << {
                id: webinar.id,
                webinar_title: webinar.title,
                url_string: webinar.url,
                start_time: webinar.time.strftime(time_format),
                recurring: webinar.recurring
              }
            end
          end
          render "index.json.jbuilder"
        end

      end
    end
  end
end
