class TestsController < ApplicationController

  def school_sign_ups
    response = HTTParty.post(marketing_api_endpoint, headers: { "Content-Type" => "application/json" }, body: params.to_json)
    render json: response.parsed_response, status: response.code
  end

  def coupon_or_poll
    response = HTTParty.get(marketing_api_endpoint, headers: { "Content-Type" => "application/json" })
    render json: response.parsed_response, status: response.code
  end

  def check_email
    email_response = Teachable.check_email(email: params[:email])
    if email_response.is_a?(Hash)
      render json: email_response
    else
      render text: "email_response is #{email_response}", status: 500
    end
  end

  private

  def marketing_api_endpoint
    ENV.fetch("TEACHABLE_API_BASE_URL", "https://marketing-api.zeachable.com") + request.fullpath
  end

end
