# Handles redirecting requests to tracking links
class TrackingLinkRedirectsController < ApplicationController

  before_action :set_tracking_link, only: :redirect
  before_action :get_signed_in_user, only: :redirect

  def redirect
    # For whatever reason the cookie value is wrapped in quotes
    cms_user_id = @current_user ? @current_user.id : nil

    redirector = TrackingLinks.track_and_redirect(
      tracking_link: @tracking_link,
      request: request,
      cms_user_id: cms_user_id
    )

    # Set all tracking cookies returned
    redirector.cookies.each do |key, value|
      cookies.permanent[key] = value
    end

    redirect_to redirector.redirect_url, status: 301
  end

  private

  def set_tracking_link
    @tracking_link = TrackingLink.published.find_by(slug: params[:slug])
    if !@tracking_link
      render html: "Link not found", status: 404
    end
  end

end
