module MetadataHelper

  def set_metadata!(rendered_entity)
    is_metadatable = rendered_entity && rendered_entity.class.included_modules.include?(Metadatable)
    if is_metadatable
      set_canonical_url!(rendered_entity.canonical_url)
      set_title!(rendered_entity.title_text)
      set_meta_description!(rendered_entity.description)
      set_index!(rendered_entity.index_page)
    end
  end

  def set_index!(will_index)
    robots_content = will_index ? "index" : "noindex"
    content_for :robots, robots_content
  end

  def set_canonical_url!(url)
    content_for :canonical_url, url
  end

  def set_title!(title)
    content_for :title, title
  end

  def set_meta_description!(description)
    content_for :meta_description, description
  end

  def set_meta_image!(image_url)
    content_for :meta_image, image_url
  end

  def set_twitter_card_type!(card_type)
    content_for :twitter_card_type, card_type
  end

  def set_twitter_domain!(domain)
    content_for :twitter_domain, domain
  end

  def set_article_metadata!(author_name)
    content_for :og_type, "article"
    content_for :author_name, author_name
  end

  def set_og_url!(og_url)
    content_for :og_url, og_url
  end
end
