class Country
  DIVIDER = {name: ("—" * 14), code: nil, disabled: true }

  def self.all
    @countries ||= YAML.load_file("config/countries.yml")
  end

  def self.create_option_hash(country_hash)
    {name: country_hash['name'], code: country_hash['ISO3166-1-Alpha-2'], disabled: false}
  end

  def self.select_options
    country = @countries || all
    priority_countries = ['United States', 'Canada']
    everything = @countries.map {|country_hash| create_option_hash(country_hash)}
    everything = everything.sort_by {|country_hash| country_hash[:name]}
    priority, other = everything.partition {|hash| priority_countries.include?(hash[:name])}
    priority.reverse + [DIVIDER] + other
  end
end
