module Teachable

  def self.calculate_sales_tax(zip_code:, state:, amount:)
    return { tax_amount: 0, tax_rate: 0 } if zip_code.nil? || state.nil? || amount.nil?
    url = ENV.fetch("TEACHABLE_API_BASE_URL", "http://marketing-api.worksonmy.computer:3000") +
          "/calculate_sales_tax?state=#{state.downcase}&amount=#{amount}&zip=#{zip_code}"
    HTTParty.get(url).parsed_response
  end

  def self.check_email(email:)
    url = ENV.fetch("TEACHABLE_API_BASE_URL", "http://marketing-api.worksonmy.computer:3000") + "/check_email?email=#{CGI.escape(email)}"
    HTTParty.get(url).parsed_response
  end

  def self.login(email, password, referral)
    url = ENV.fetch("TEACHABLE_SSO_BASE_URL", "https://sso.zeachable.com") + "/api/v1/my_teachable_sign_in/validate"
    HTTParty.post(
      url,
      body: {
        email: email,
        password: password,
        referral: referral,
        auth_token: ENV["MARKETING_API_AUTH_TOKEN"],
      }
    )
  end

  def self.register_teachable_account(name:, email:, password:, referral:)
    url = ENV.fetch("TEACHABLE_SSO_BASE_URL", "https://sso.zeachable.com") + "/api/v1/my_teachable_registration"
    HTTParty.post(
      url,
      body: {
        name: name,
        email: email,
        password: password,
        referral: referral,
        agreed_to_terms: true,
        auth_token: ENV["MARKETING_API_AUTH_TOKEN"],
      }
    )
  end

end
