module StandardPageValidations
  extend ActiveSupport::Concern

  included do
    validates_presence_of :url
    validates_inclusion_of :active, in: [true, false]
    validates_uniqueness_of :url
    validate :valid_url
  end

  def valid_url
    unless url[0] == "/" && !url.include?("?") && !url.include?("&")
      errors.add(:url, "is invalid")
    end
  end

end
