class EventSeries < ApplicationRecord

  include Netlifiable

  validates :name, presence: true, uniqueness: true

  has_many :webinars_event_series
  has_many :webinars, through: :webinars_event_series

  def generate_default_pages(_creator)
  end

  def available_webinars
    Webinar.where.not(id: webinars.pluck(:id))
  end

  def start_day
    webinars.sort_by{ |webinar| webinar.proper_time1 }.first.try!(:proper_time1)
  end

  def end_day
    webinars.sort_by{ |webinar| webinar.proper_time1 }.last.try!(:proper_time1)
  end

  def schedule_page_url
    "https://teachable.com/women-who-create/schedule"
  end

end
