class Field < ApplicationRecord

  validates :name, :field_type, :char_limit, :order, :template_id, presence: true
  validates_inclusion_of :mandatory, :in => [true, false]
  validates :name, uniqueness: { scope: :template_id }
  validate :validate_char_limit

  belongs_to :template
  has_many :menu_options, as: :optionable, dependent: :destroy
  has_many :objekt_fields, dependent: :destroy

  def validate_char_limit
    if field_type == "text"
      validates_numericality_of :char_limit, :greater_than_or_equal_to => 1, :message => "can't be zero"
    end
  end

end
