class ObjektField < ApplicationRecord

  include Netlifiable

  validates :objekt_id, :field_id, presence: true
  validate :template_presence
  validate :objekt_field_is_number

  belongs_to :field
  belongs_to :objekt

  has_one(
    :image,
    class_name: "Upload",
    foreign_key: :id,
    primary_key: :value
  )
  has_one(
    :instance,
    class_name: "Objekt",
    foreign_key: :id,
    primary_key: :value
  )

  def order
    field.order
  end

  def template_presence
    errors.add(field.name, "is mandatory") if field.mandatory && value.strip == ""
  end

  def objekt_field_is_number
    if field.field_type == "number" && !value.empty?
      validates_numericality_of :value, message: "#{field.name} is not a number"
    end
  end
end
