class PartialField < ApplicationRecord

  validates :name, :field_type, :char_limit, :order, :partial_id, presence: true
  validates_inclusion_of :mandatory, :in => [true, false]
  validates :name, uniqueness: { scope: :partial_id }
  validate :validate_char_limit

  has_many :menu_options, as: :optionable, dependent: :destroy
  has_many :page_partial_fields, dependent: :destroy

  def validate_char_limit
    if field_type == "text" || field_type == "header"
      validates_numericality_of :char_limit, :greater_than_or_equal_to => 1, :message => "can't be zero"
    end
  end

end
