class Permission < ApplicationRecord

  validates :name, presence: true

  has_many :permission_privileges
  has_many :privileges, through: :permission_privileges

  def self.proper_permissions_for_access(current_user)
    case current_user.permission.name
    when "Super administrator"
      all
    when "Administrator"
      where(name: ["User", "Webinars Only"])
    end
  end

end
