class Registration < ApplicationRecord

  belongs_to :webinar
  belongs_to :registrant

  validates :registrant_id, :webinar_id, presence: true
  validates :registrant_id, uniqueness: { scope: [:webinar_start_time, :webinar_id]}

  after_commit :send_pendo_tracking_event, on: :create

  def send_pendo_tracking_event
    SendPendoTrackingEvent.perform_async(
      event="cms.registration.create",
      visitor_id=registrant.email,
      properties={
        webinar_time: webinar_start_time,
        webinar_name: webinar.name,
        webinar_id: webinar_id,
      }
    )
  end

end
