class Sitemap
  include Singleton

  @@slack_client = Slack::Web::Client.new

  def self.xml
    self.generate!
    File.open("./tmp/sitemap.xml").read
  end

  def self.generate!
    Raven.capture do
      SitemapGenerator::Sitemap.default_host = ENV['HOST']
      SitemapGenerator::Sitemap.public_path = 'tmp/'
      SitemapGenerator::Sitemap.include_root = false
      SitemapGenerator::Sitemap.compress = false

      SitemapGenerator::Sitemap.create do
        Page.where(active: true).find_each { |page| add page.url, lastmod: page.updated_at }
        BlogPost.published.find_each { |post| add "/blog#{post.url}", lastmod: post.date }
        ContentCategory.find_each { |category| add category.url }
        # Add Webinars?
      end
    end
  end
end
