class WebinarOffer < ApplicationRecord

  belongs_to :webinar

  validates :cta_button_type, inclusion: %w[green_button orange_button link]
  validates :title, presence: true
  validates_numericality_of :duration, :greater_than_or_equal_to => 1
  validates_numericality_of :start_time, :greater_than_or_equal_to => 0
  validates :cta_button_text, presence: true
  validates :cta_url, presence: true

end
