class EventSeries::Creator

  def self.call(params, creator)
    new(params, creator).call
  end

  def initialize(params, creator)
    @params = params
    @creator = creator
    @event_series = EventSeries.new(name: params["name"], description: params["description"])
  end

  def call
    @event_series.transaction do
      @event_series.save!
      if @params["webinar_ids"].present? && @params["webinar_ids"].any?
        @params["webinar_ids"].each do |id|
          WebinarsEventSeries.create!(
            webinar_id: id,
            event_series_id: @event_series.id
          )
        end
      end
      @event_series.generate_default_pages(@creator)
      @event_series
    end
  end

end
