json.page do
  json.id @page.id
  json.name @page.name
  json.url @page.url
  json.active @page.active
  json.titleText @page.title_text
  json.description @page.description
  json.indexPage @page.index_page
  json.canonicalUrl @page.canonical_url
  json.createdBy @page.creator ? @page.creator.name : @page.deleted_creator_name
  json.notes @page.notes
  json.displayExitIntentModal @page.display_exit_intent_modal
  json.googleOptimize @page.google_optimize
  json.ogImageId @page.og_image_id ? @page.og_image_id : ""
  json.ogImageUrl @page.og_image_id ? @page.og_image.url : ""
  json.liveChat @page.live_chat
  json.theme @page.theme
end
json.pagePartials @page.page_partials do |page_partial|
  json.id page_partial.id
  json.order page_partial.order
  json.visible page_partial.visible
  json.name @partials.select { |partial| partial.id == page_partial.partial_id }.first.name
  # ^ because we have already queried the DB to get all the partials, it seems silly to query it again to get the page partials' partial names
  json.fieldsCount @field_counts[page_partial.partial_id] || 0
end
json.partials @partials.select { |partial| @current_user.permission.level >= 2 ? true : partial.devs_only == false } do |partial|
  json.id partial.id
  json.name partial.name
  json.devsOnly partial.devs_only
  if partial.image_id
    json.imageUrl partial.image.url
  end
end
json.headerTypes @header_types
