json.template do
  json.id @template.id
  json.name @template.name
  json.plural @template.plural
  json.imageUrl @template.image_url
  json.editable @template.editable
end
json.templates @templates do |template|
  json.id template.id
  json.name template.name
end
json.fields @fields do |field|
  json.id field.id
  json.frontEndId field.id
  json.name field.name
  json.mandatory field.mandatory == true ? "yes" : "no"
  json.fieldType field.field_type
  json.objectType field.object_type || ""
  json.charLimit field.char_limit.to_s
  json.order field.order
  json.description field.description || ""
  json.menuOptions field.menu_options do |menu_option|
    json.id menu_option.id
    json.order menu_option.order
    json.value menu_option.value
  end
end
# @instances is used in create_field to update instances of a template when a field is added
# but it's also used to gather instances of templates when creating a new objekt (in case the objekt has objekt fields)
# only send it down in the latter case
if @instances.is_a?(Hash)
  json.instances @instances.map { |key, value| [key, value.map { |instance_object| instance_object.map { |key, value| [key.to_s.camelize(:lower).to_sym, value]}.to_h }] }.to_h
end
