json.webinar do
  json.id @webinar.id
  json.name @webinar.name
  json.title @webinar.title
  json.url @webinar.url
  json.recurring @webinar.recurring
  json.time @webinar.recurring ? @webinar.recurring_info : @webinar.time.strftime("%-m/%-d/%y %-l:%M %P")
  json.time2 @webinar.time2 ? @webinar.time2.strftime("%-m/%-d/%y %-l:%M %P") : ""
  json.header @webinar.header
  json.subheader @webinar.subheader
  json.bulletPoints @webinar.bullet_points
  json.thankYouVideoId @webinar.thank_you_video_id
  json.upgradeTimeframe @webinar.upgrade_timeframe
  json.upgradeOptions @webinar.upgrade_options
  json.basicReplayBundle @webinar.basic_replay_bundle || ""
  json.basicPlayBundle @webinar.basic_play_bundle || ""
  json.proReplayBundle @webinar.pro_replay_bundle || ""
  json.proPlayBundle @webinar.pro_play_bundle || ""
  json.replayVideoId @webinar.replay_video_id
  json.customModalImage @webinar.custom_modal_image || ""
  json.chatTimeString @proper_time ? @proper_time.strftime("%A, %B") + " " + @proper_time.strftime("%-d") + "@ " + @proper_time.strftime("%-l:%M %P") + " ET | " + (@proper_time - 3.hours).strftime("%-l:%M %P") + " PT" : ''
  json.liveStartDate @webinar.live_start_date ? @webinar.live_start_date.strftime("%-m/%-d/%y %-l:%M %P") : ""
  json.liveEndDate @webinar.live_end_date ? @webinar.live_end_date.strftime("%-m/%-d/%y %-l:%M %P") : ""
  json.redirect @webinar.redirect || ""
  json.customUtmContent @webinar.custom_utm_content
  json.customUtmCampaign @webinar.custom_utm_campaign
  json.customMtCampaign @webinar.custom_mt_campaign
  json.couponCode @webinar.coupon_code
  json.faq @webinar.faq
  json.sidebarOptions JSON.parse(@webinar.sidebar_options).presence || Webinar.default_sidebar_options
  json.customCtaText @webinar.custom_cta_text
  json.customCtaUrl @webinar.custom_cta_url
  json.webinarType @webinar.webinar_type
  json.automationInterval @webinar.automation_interval
  json.platform @webinar.platform
  json.automatedHostHeader @webinar.automated_host_header || ""
  json.automatedHostDescription @webinar.automated_host_description || ""
  json.automatedHostImageUrl @webinar.automated_host_image_url || ""
  json.automatedHeroImageUrl @webinar.automated_hero_image_url || ""
  json.upcomingSessionId CGI.escape(@webinar.automated_event_times(force: true)[0][:time_key])
  json.automatedPostEventRedirect @webinar.automated_post_event_redirect
  json.duration @webinar.duration || ""
  json.description @webinar.description || ""
  json.displayThankYouFreeAccountCta @webinar.display_thank_you_free_account_cta
  json.regPageWarning @webinar.reg_page_warning
  json.expectedDuration @webinar.expected_duration
  json.automatedCtaHeader @webinar.automated_cta_header || ""
end
json.bundles @bundles do |bundle|
  json.id bundle.id
  json.name Objekt.find(bundle.id).field_values_hash["Name"]
end
json.downloads @downloads do |webinar_object|
  json.id webinar_object.id
  json.name webinar_object.objekt.field_values_hash["Name"]
  json.order webinar_object.order
end
json.otherDownloads @other_downloads do |objekt|
  json.id objekt.id
  json.name objekt.field_values_hash["Name"]
end
json.hosts @hosts do |webinar_object|
  json.id webinar_object.id
  json.name webinar_object.objekt.field_values_hash["Name"]
  json.order webinar_object.order
end
json.otherHosts @other_hosts do |objekt|
  json.id objekt.id
  json.name objekt.field_values_hash["Name"]
end
json.offers @offers do |offer|
  json.id offer.id
  json.startTime offer.start_time
  json.duration offer.duration
  json.ctaUrl offer.cta_url
  json.ctaButtonType offer.cta_button_type
  json.ctaButtonText offer.cta_button_text
  json.description offer.description
  json.title offer.title
end
