# https://github.com/DataDog/dd-trace-rb/blob/master/docs/GettingStarted.md#integration-instrumentation
tags = { env: APP_ENV, app: "cms", version: APP_VERSION }

hostname = ENV["DATADOG_HOSTNAME"]

Datadog.configure do |c|
  c.use :rails,    service_name: "cms",           distributed_tracing: true
  c.use :http,     service_name: "cms-http",      distributed_tracing: true
  c.use :dalli,    service_name: "cms-memcached"
  c.use :rake,     service_name: "cms-rake" if defined?(::Rake::Task)
  c.use :redis,    service_name: "cms-redis"
  c.use :sidekiq,  service_name: "cms-sidekiq"
  c.tracer(env: APP_ENV, log: Rails.logger, enabled: !!hostname, hostname: hostname, tags: tags)
end

require "raven"
Raven.configure do |config|
  config.silence_ready       = true
  config.release             = APP_VERSION
  config.logger              = Rails.logger
  config.current_environment = APP_ENV
  config.excluded_exceptions = []
  config.tags = { environment: APP_ENV }
end
