const { resolve } = require('path')
const loaders = require('./loaders')
const plugins = require('./plugins')
const entry = require('./entry')

const base = resolve(__dirname, '../../')

module.exports = {
  entry: entry,
  context: base,
  output: {
    path: resolve(base, 'public', 'assets'),
    filename: 'javascripts/[name]-bundle-[hash].js',
    devtoolModuleFilenameTemplate: '[resourcePath]',
    devtoolFallbackModuleFilenameTemplate: '[resourcePath]?[hash]',
    publicPath: '/assets/'
  },
  plugins: plugins,
  module: {
    rules: loaders
  },
  resolve: {
    alias: {
      Components: './frontend/components',
      Public:  './app/assets/javascripts/teachable/public',
      Images: resolve(base, 'app', 'assets', 'images'), // not sure why this happens, but css-loader requires absolute paths
      moment$: 'moment/min/moment.min.js'
    },
    extensions: ['.js', '.jsx', '.ts', '.tsx']
  },
  devtool: 'source-map'
};
