const ManifestPlugin = require('webpack-manifest-plugin');
const MiniCssExtractPlugin = require('mini-css-extract-plugin');
const webpack = require('webpack');

const manifestPlugin = new ManifestPlugin({
  publicPath: '/assets/', // trailing slash necessary
  writeToFileEmit: true,
  fileName: 'manifest-webpack.json'
});

const ignorePlugin = new webpack.IgnorePlugin({
  resourceRegExp: /^\.\/locale$/,
  contextRegExp: /moment\/min$/,
});

const miniCssExtractPlugin = new MiniCssExtractPlugin({
  filename: 'stylesheets/[name].[contenthash].css'
});

module.exports = [
  manifestPlugin,
  ignorePlugin,
  miniCssExtractPlugin,
];
