const webpack = require('webpack')
const TerserWebpackPlugin = require('terser-webpack-plugin')
const ManifestPlugin = require('webpack-manifest-plugin')
const CompressionPlugin = require('compression-webpack-plugin');
const merge = require('webpack-merge')

const baseConfig = require('./base')
const outputPath = __dirname + '/public/javascripts'

module.exports = merge(baseConfig, {
  // context: __dirname,
  mode: 'production',
  plugins:[
    new webpack.DefinePlugin({
      'process.env':{
        'NODE_ENV': JSON.stringify('production')
      }
    }),
    new TerserWebpackPlugin({
      sourceMap: true,
      parallel: !process.env.CI
    }),
    new CompressionPlugin()
  ]
})
