class AddPlanTables < ActiveRecord::Migration[4.2]
  def change
    create_table :plans do |t|
      t.string :name, null: false
      t.string :tagline, null: false
      t.integer :monthly_price, null: false
      t.integer :annual_price, null: false
      t.string :includes_text, null: false
      t.integer :order, null: false
    end

    add_index :plans, :order, unique: true

    create_table :features do |t|
      t.string :text, null: false
    end

    create_table :plan_features do |t|
      t.integer :plan_id, null: false
      t.integer :feature_id, null: false
      t.integer :tooltip_id
      t.integer :order, null: false
    end

    add_index :plan_features, :plan_id
    add_index :plan_features, :feature_id
    add_index :plan_features, :tooltip_id
    add_index :plan_features, [:order, :plan_id], unique: true

    create_table :tooltips do |t|
      t.string :text, null: false
    end
  end
end
