class AddPartialFields < ActiveRecord::Migration[4.2]
  def change
    create_table :partial_fields do |t|
      t.integer :partial_id, null: false
      t.string :name, null: false
      t.string :field_type, null: false
      t.boolean :mandatory, default: false
      t.integer :char_limit, default: 0
      t.integer :order, null: false
    end

    add_index :partial_fields, :partial_id
    add_index :partial_fields, [:partial_id, :name], unique: true

    create_table :page_partials do |t|
      t.integer :page_id, null: false
      t.integer :partial_id, null: false
      t.boolean :expanded, default: true
      t.integer :order, null: false
    end

    add_index :page_partials, :partial_id
    add_index :page_partials, :page_id
    add_index :page_partials, [:partial_id, :page_id], unique: true

    create_table :page_partial_fields do |t|
      t.integer :page_partial_id, null: false
      t.integer :partial_field_id, null: false
      t.string :value
    end

    add_index :page_partial_fields, :page_partial_id
    add_index :page_partial_fields, :partial_field_id
  end
end
