class AddBlogPosts < ActiveRecord::Migration[4.2]
  def change
    create_table :blog_posts do |t|
      # General:
      t.string :name, null: false
      t.string :url, null: false
      t.boolean :active, default: false

      # General--SEO:
      t.string :title_text
      t.string :description, default: ""
      t.boolean :index_page, default: false
      t.string :canonical_url, default: ""
      t.string :seo_image_url
      t.string :seo_image_alt_text

      # General--SEO--New implementation:
      # OpenGraph / Facebook:
      t.string :og_description
      t.string :og_title

      # Twitter:
      t.string :twitter_summary_description
      t.string :twitter_summary_title

      # Blog-Specific:
      t.integer :cover_photo_id, null: false
      t.string :title, null: false
      t.integer :author_id, null: false
      t.text :content, null: false
      t.datetime :publish_date
      t.boolean :catalogued, default: false
    end
  end
end
