class AddRegistrantsAndRegistrations < ActiveRecord::Migration[4.2]
  def change
    create_table :registrants do |t|
      t.string :email, null: false
    end

    create_table :registrations do |t|
      t.integer :registrant_id, null: false
      t.integer :webinar_id, null: false
      t.datetime :webinar_start_time
    end

    add_index :registrations, [:registrant_id, :webinar_id, :webinar_start_time], unique: true, name: 'registrations_unique'
  end
end
