class CreateContentDownloads < ActiveRecord::Migration[4.2]
  def change
    create_table :content_downloads do |t|
      t.timestamps null: false

      # General
      t.string :name, null: false
      t.string :rich_text_description

      # Landing Page
      t.integer :landing_page_id
      t.integer :landing_page_background_image_id
      t.integer :landing_page_large_image_id
      t.string :landing_page_header
      t.string :landing_page_button_text
      t.jsonb :landing_page_bullet_points, default: "[]"

      # Content
      t.integer :content_type, default: 0 # enum for file, external link, etc.
      t.integer :content_score
      t.integer :upload_id
    end
  end
end
