# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# Note that this schema.rb definition is the authoritative source for your
# database schema. If you need to create the application database on another
# system, you should be using db:schema:load, not running all the migrations
# from scratch. The latter is a flawed and unsustainable approach (the more migrations
# you'll amass, the slower it'll run and the greater likelihood for issues).
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 20200518162242) do

  # These are extensions that must be enabled in order to support this database
  enable_extension "plpgsql"
  enable_extension "uuid-ossp"
  enable_extension "pgcrypto"

  create_table "banner_fields", force: :cascade do |t|
    t.integer "banner_id", null: false
    t.string "banner_field_key", null: false
    t.string "value", default: ""
    t.datetime "created_at", null: false
    t.datetime "updated_at", null: false
  end

  create_table "banner_pages", force: :cascade do |t|
    t.integer "banner_id", null: false
    t.integer "page_id", null: false
  end

  create_table "banner_webinars", force: :cascade do |t|
    t.integer "banner_id", null: false
    t.integer "webinar_id", null: false
    t.datetime "created_at", null: false
    t.datetime "updated_at", null: false
    t.index ["banner_id"], name: "index_banner_webinars_on_banner_id"
    t.index ["webinar_id"], name: "index_banner_webinars_on_webinar_id"
  end

  create_table "banners", force: :cascade do |t|
    t.string "name", null: false
    t.string "banner_key", null: false
    t.datetime "created_at", null: false
    t.datetime "updated_at", null: false
    t.boolean "active", default: false
    t.integer "inclusion_method", default: 1
  end

  create_table "blog_post_categories", id: :serial, force: :cascade do |t|
    t.integer "blog_post_id", null: false
    t.integer "blog_category_id", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "blog_posts", id: :serial, force: :cascade do |t|
    t.string "title_text"
    t.string "description", default: ""
    t.boolean "index_page", default: false
    t.string "canonical_url", default: ""
    t.string "seo_image_alt_text"
    t.string "og_description"
    t.string "og_title"
    t.string "twitter_summary_description"
    t.string "twitter_summary_title"
    t.integer "cover_photo_id"
    t.string "title", null: false
    t.integer "author_id", null: false
    t.text "html_content", default: ""
    t.datetime "date"
    t.integer "seo_image_id"
    t.string "cover_photo_alt_text", default: ""
    t.string "url", default: ""
    t.string "editor_content_state"
    t.string "author_type", default: "User"
    t.string "tags", default: [], array: true
    t.string "old_canonical_url"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean "active", default: false
    t.integer "mobile_cover_photo_id"
  end

  create_table "content_categories", id: :serial, force: :cascade do |t|
    t.string "name"
    t.string "header", default: ""
    t.string "subheader", default: ""
    t.string "url", default: ""
    t.string "title_text", default: ""
    t.string "description", default: ""
    t.integer "content_download_1_id"
    t.integer "content_download_2_id"
    t.string "content_download_1_event_name", default: ""
    t.integer "content_download_1_workflow_id"
    t.string "content_download_2_event_name", default: ""
    t.integer "content_download_2_workflow_id"
    t.integer "parent_id"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "content_downloads", id: :serial, force: :cascade do |t|
    t.datetime "created_at", null: false
    t.datetime "updated_at", null: false
    t.string "name", default: "", null: false
    t.string "rich_text_description", default: ""
    t.integer "landing_page_background_image_id"
    t.integer "landing_page_large_image_id"
    t.string "landing_page_header", default: ""
    t.string "landing_page_button_text", default: ""
    t.string "landing_page_bullet_points", default: ""
    t.integer "content_type", default: 0
    t.integer "content_score"
    t.integer "upload_id"
    t.string "external_link", default: ""
    t.integer "content_category_id"
    t.integer "content_funnel_stage_id", null: false
    t.string "landing_page_slug", default: ""
    t.boolean "active", default: false
    t.string "landing_page_bullet_header", default: ""
    t.string "title_text", default: ""
    t.string "description", default: ""
    t.string "landing_page_event_name", default: ""
    t.integer "preview_card_image_id"
    t.integer "hero_form_background_image_id"
    t.string "hero_form_header", default: ""
    t.string "hero_form_button_text", default: ""
    t.text "custom_redirect", default: ""
  end

  create_table "content_funnel_stages", id: :serial, force: :cascade do |t|
    t.string "name", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "event_series", force: :cascade do |t|
    t.string "name", null: false
    t.text "description", default: ""
    t.datetime "created_at", null: false
    t.datetime "updated_at", null: false
    t.jsonb "iterable_metadata"
    t.index ["name"], name: "index_event_series_on_name", unique: true
  end

  create_table "features", id: :serial, force: :cascade do |t|
    t.string "text", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "fields", id: :serial, force: :cascade do |t|
    t.string "name", null: false
    t.integer "template_id", null: false
    t.string "field_type", null: false
    t.boolean "mandatory", default: false
    t.integer "char_limit", default: 0
    t.integer "order", null: false
    t.text "object_type"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.text "description", default: ""
    t.index ["template_id", "name"], name: "index_fields_on_template_id_and_name", unique: true
    t.index ["template_id"], name: "index_fields_on_template_id"
  end

  create_table "header_types", id: :serial, force: :cascade do |t|
    t.string "name"
    t.integer "order"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "jobs", force: :cascade do |t|
    t.string "name", null: false
    t.string "text", default: ""
    t.boolean "show_progress", default: true
    t.integer "current_value", default: 0
    t.integer "total_value", default: 0
    t.jsonb "metadata", default: {}
    t.boolean "done", default: false
    t.boolean "killed", default: false
  end

  create_table "menu_options", id: :serial, force: :cascade do |t|
    t.string "value"
    t.integer "optionable_id"
    t.string "optionable_type"
    t.integer "order", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "objekt_fields", id: :serial, force: :cascade do |t|
    t.integer "objekt_id", null: false
    t.integer "field_id", null: false
    t.string "value"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["field_id"], name: "index_objekt_fields_on_field_id"
    t.index ["objekt_id"], name: "index_objekt_fields_on_objekt_id"
  end

  create_table "objekts", id: :serial, force: :cascade do |t|
    t.integer "template_id", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["template_id"], name: "index_objekts_on_template_id"
  end

  create_table "page_partial_fields", id: :serial, force: :cascade do |t|
    t.integer "page_partial_id", null: false
    t.integer "partial_field_id", null: false
    t.string "value"
    t.integer "header_type", default: 1
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["page_partial_id"], name: "index_page_partial_fields_on_page_partial_id"
    t.index ["partial_field_id"], name: "index_page_partial_fields_on_partial_field_id"
  end

  create_table "page_partials", id: :serial, force: :cascade do |t|
    t.integer "page_id"
    t.integer "partial_id", null: false
    t.integer "order", null: false
    t.boolean "visible", default: true
    t.integer "field_id"
    t.integer "page_partial_field_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["page_id"], name: "index_page_partials_on_page_id"
    t.index ["partial_id"], name: "index_page_partials_on_partial_id"
  end

  create_table "pages", id: :serial, force: :cascade do |t|
    t.string "name", null: false
    t.string "url", null: false
    t.integer "creator_id", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean "active", default: false
    t.string "title_text"
    t.string "description", default: ""
    t.boolean "index_page", default: true
    t.string "canonical_url", default: ""
    t.string "deleted_creator_name"
    t.text "notes", default: ""
    t.boolean "display_exit_intent_modal", default: true
    t.boolean "google_optimize", default: false
    t.integer "og_image_id"
    t.boolean "live_chat", default: false
    t.integer "theme", default: 0, null: false
    t.index ["creator_id"], name: "index_pages_on_creator_id"
    t.index ["name"], name: "index_pages_on_name", unique: true
    t.index ["url"], name: "index_pages_on_url", unique: true
  end

  create_table "partial_categories", id: :serial, force: :cascade do |t|
    t.string "name"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "partial_fields", id: :serial, force: :cascade do |t|
    t.integer "partial_id", null: false
    t.string "name", null: false
    t.string "field_type", null: false
    t.boolean "mandatory", default: false
    t.integer "char_limit", default: 0
    t.integer "order", null: false
    t.text "object_type"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.text "placeholder", default: ""
    t.text "description", default: ""
    t.index ["partial_id", "name"], name: "index_partial_fields_on_partial_id_and_name", unique: true
    t.index ["partial_id"], name: "index_partial_fields_on_partial_id"
  end

  create_table "partials", id: :serial, force: :cascade do |t|
    t.string "name", null: false
    t.integer "image_id"
    t.integer "partial_category_id", default: 1
    t.boolean "devs_only", default: true
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["name"], name: "index_partials_on_name", unique: true
  end

  create_table "permission_privileges", id: :serial, force: :cascade do |t|
    t.integer "permission_id", null: false
    t.integer "privilege_id", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["permission_id", "privilege_id"], name: "index_permission_privileges_on_permission_id_and_privilege_id", unique: true
  end

  create_table "permissions", id: :serial, force: :cascade do |t|
    t.string "name", null: false
    t.integer "level", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "plan_features", id: :serial, force: :cascade do |t|
    t.integer "plan_id"
    t.integer "feature_id", null: false
    t.integer "tooltip_id"
    t.integer "order", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["feature_id"], name: "index_plan_features_on_feature_id"
    t.index ["plan_id", "feature_id"], name: "index_plan_features_on_plan_id_and_feature_id", unique: true
    t.index ["plan_id"], name: "index_plan_features_on_plan_id"
    t.index ["tooltip_id"], name: "index_plan_features_on_tooltip_id"
  end

  create_table "plans", id: :serial, force: :cascade do |t|
    t.string "name", null: false
    t.string "tagline"
    t.integer "monthly_price", null: false
    t.integer "annual_price"
    t.string "includes_text"
    t.integer "order", null: false
    t.boolean "annual_included", null: false
    t.integer "app_monthly_plan_id", null: false
    t.integer "app_annual_plan_id"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "privileges", id: :serial, force: :cascade do |t|
    t.string "name", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "redirects", id: :serial, force: :cascade do |t|
    t.string "url", null: false
    t.string "redirect", null: false
    t.boolean "active", default: true
    t.string "status_code", default: "301"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["url"], name: "index_redirects_on_url", unique: true
  end

  create_table "registrants", id: :serial, force: :cascade do |t|
    t.string "email", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "registrations", id: :serial, force: :cascade do |t|
    t.integer "registrant_id", null: false
    t.integer "webinar_id", null: false
    t.datetime "webinar_start_time"
    t.string "campaignid"
    t.string "templateid"
    t.string "utm_campaign"
    t.string "utm_source"
    t.string "utm_medium"
    t.string "utm_term"
    t.string "utm_content"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string "mbsy"
    t.string "mt_tier", default: ""
    t.string "mt_interval", default: ""
    t.string "mt_campaign_group", default: ""
    t.index ["registrant_id", "webinar_id", "webinar_start_time"], name: "registrations_unique", unique: true
  end

  create_table "scheduled_tasks", force: :cascade do |t|
    t.datetime "time", null: false
    t.integer "status", null: false
    t.integer "action", null: false
    t.integer "schedulable_id", null: false
    t.string "schedulable_type", null: false
  end

  create_table "teams", id: :serial, force: :cascade do |t|
    t.string "name", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "templates", id: :serial, force: :cascade do |t|
    t.string "name", null: false
    t.integer "image_id"
    t.boolean "devs_only", default: false
    t.string "plural", default: ""
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean "editable", default: true
    t.index ["name"], name: "index_templates_on_name", unique: true
  end

  create_table "tooltips", id: :serial, force: :cascade do |t|
    t.string "text", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "tracking_link_redirect_events", id: :uuid, default: -> { "gen_random_uuid()" }, force: :cascade do |t|
    t.bigint "tracking_link_id", null: false
    t.datetime "redirected_at", null: false
    t.text "referrer"
    t.inet "visitor_ip", null: false
    t.text "visitor_user_agent"
    t.uuid "anonymous_id", null: false, comment: "stored in cookie if not set, used for tracking unique visitors"
    t.text "request_url", null: false, comment: "Full url including query string of the tracking link clicked"
    t.text "redirect_url", null: false, comment: "url the link redirects to"
    t.bigint "cms_user_id", comment: "References the user table - cms_user to distinguish from teachable accounts and fedora users"
    t.datetime "created_at", null: false
    t.datetime "updated_at", null: false
    t.index ["anonymous_id"], name: "index_tracking_link_redirect_events_on_anonymous_id"
    t.index ["cms_user_id"], name: "index_tracking_link_redirect_events_on_cms_user_id"
    t.index ["redirected_at"], name: "index_link_redirect_events_on_redirected_at_desc", order: { redirected_at: :desc }
    t.index ["redirected_at"], name: "index_tracking_link_redirect_events_on_redirected_at"
    t.index ["tracking_link_id"], name: "index_tracking_link_redirect_events_on_tracking_link_id"
  end

  create_table "tracking_links", force: :cascade do |t|
    t.text "slug", null: false, comment: "the identifier in the short url"
    t.text "destination_url", null: false, comment: "url to redirect to"
    t.jsonb "additional_query_params", default: {}, null: false, comment: "query params to append to destination url"
    t.jsonb "metadata", default: {}, null: false, comment: "query params to append to destination url"
    t.text "forward_query_params_whitelist", default: [], comment: "whitelist of query params to forward from the destination_url", array: true
    t.boolean "forward_all_query_params", default: false, null: false
    t.string "status", default: "draft", null: false, comment: "draft/published/hidden, should be an enum"
    t.datetime "published_at"
    t.datetime "hidden_at"
    t.text "description", comment: "Optional description of the link"
    t.bigint "creator_id", null: false
    t.bigint "publisher_id"
    t.bigint "hider_id"
    t.datetime "created_at", null: false
    t.datetime "updated_at", null: false
    t.boolean "latest_version", default: true
    t.index ["additional_query_params"], name: "index_tracking_links_on_additional_query_params", using: :gin
    t.index ["creator_id"], name: "index_tracking_links_on_creator_id"
    t.index ["hider_id"], name: "index_tracking_links_on_hider_id"
    t.index ["metadata"], name: "index_tracking_links_on_metadata", using: :gin
    t.index ["publisher_id"], name: "index_tracking_links_on_publisher_id"
    t.index ["slug"], name: "index_tracking_links_on_slug"
    t.index ["status"], name: "index_tracking_links_on_status"
  end

  create_table "uploads", id: :serial, force: :cascade do |t|
    t.string "url", null: false
    t.string "category", null: false
    t.integer "uploaded_by", null: false
    t.string "s3_url"
    t.boolean "reusable", default: false
    t.string "upload_type"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "users", id: :serial, force: :cascade do |t|
    t.datetime "created_at", null: false
    t.datetime "updated_at", null: false
    t.string "email", null: false
    t.string "name", null: false
    t.string "title", default: ""
    t.integer "team_id", null: false
    t.integer "permission_id", null: false
    t.integer "image_id"
    t.string "bio", default: ""
    t.string "twitter_handle", default: ""
    t.index ["email"], name: "index_users_on_email"
    t.index ["image_id"], name: "index_users_on_image_id"
  end

  create_table "webinar_objects", id: :serial, force: :cascade do |t|
    t.integer "webinar_id"
    t.integer "objekt_id"
    t.string "objekt_name"
    t.integer "order", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "webinar_offers", force: :cascade do |t|
    t.integer "duration"
    t.integer "start_time"
    t.string "title", default: ""
    t.text "description", default: ""
    t.string "cta_button_type", default: "orange_button"
    t.text "cta_button_text", default: ""
    t.text "cta_url", default: ""
    t.bigint "webinar_id"
    t.index ["webinar_id"], name: "index_webinar_offers_on_webinar_id"
  end

  create_table "webinars", id: :serial, force: :cascade do |t|
    t.string "name", null: false
    t.string "title", null: false
    t.string "url", null: false
    t.datetime "time"
    t.boolean "recurring", default: false
    t.string "recurring_info", default: ""
    t.string "recurrence"
    t.string "bullet_points", default: ""
    t.datetime "time2"
    t.string "header", default: ""
    t.string "subheader", default: ""
    t.string "thank_you_video_id", default: ""
    t.string "upgrade_timeframe", default: "monthly"
    t.integer "basic_replay_bundle"
    t.integer "basic_play_bundle"
    t.integer "pro_replay_bundle"
    t.integer "pro_play_bundle"
    t.string "replay_video_id", default: ""
    t.string "upgrade_options", default: "basic/pro"
    t.string "custom_modal_image"
    t.datetime "live_start_date"
    t.datetime "live_end_date"
    t.text "redirect"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.text "custom_utm_content", default: ""
    t.text "custom_utm_campaign", default: ""
    t.string "coupon_code", default: ""
    t.string "custom_mt_campaign", default: ""
    t.text "faq", default: ""
    t.jsonb "sidebar_options", default: "{}"
    t.string "custom_cta_text", default: ""
    t.string "custom_cta_url", default: ""
    t.integer "webinar_type", default: 0
    t.integer "automation_interval", default: 0
    t.integer "platform", default: 1
    t.text "automated_host_header"
    t.text "automated_host_description"
    t.text "automated_host_image_url"
    t.text "automated_hero_image_url"
    t.string "automated_post_event_redirect", default: ""
    t.float "duration"
    t.text "description", default: ""
    t.boolean "display_thank_you_free_account_cta", default: true
    t.boolean "reg_page_warning", default: true
    t.integer "expected_duration"
    t.text "automated_cta_header"
    t.index ["url"], name: "index_webinars_on_url", unique: true
  end

  create_table "webinars_event_series", force: :cascade do |t|
    t.bigint "webinar_id"
    t.bigint "event_series_id"
    t.datetime "created_at", null: false
    t.datetime "updated_at", null: false
    t.index ["event_series_id"], name: "index_webinars_event_series_on_event_series_id"
    t.index ["webinar_id"], name: "index_webinars_event_series_on_webinar_id"
  end

  add_foreign_key "tracking_link_redirect_events", "tracking_links"
  add_foreign_key "tracking_link_redirect_events", "users", column: "cms_user_id"
  add_foreign_key "tracking_links", "users", column: "creator_id"
  add_foreign_key "tracking_links", "users", column: "hider_id"
  add_foreign_key "tracking_links", "users", column: "publisher_id"
  add_foreign_key "webinar_offers", "webinars"
end
