@blog @javascript
Feature: Blog actions

Background:
  Given I'm logged in as Robb
  And Content Data exists
  And the Blog Settings object exists
  And I have some new blog data to enter

# BASIC FUNCTIONALITY -----

Scenario: Updating valid blog settings
  Given I am viewing the blog admin area
  When I fill in the blog settings tabs with valid settings
  When I save the blog form
  Then I should see "Saved"
  And the public blog settings pages should have the correct content
  And the public blog settings pages should have the correct content

Scenario: Updating invalid blog settings
  Given I am viewing the blog admin area
  When I fill in the blog settings tabs with invalid settings
  When I save the blog form
  Then I should see the appropriate blog settings error messages

Scenario: Updating valid category settings
  Given I am viewing the blog admin area
  When I fill in a category tab with valid settings
  When I save the blog form
  Then I should see "Saved"
  And the public blog category page should have the correct content

Scenario: Updating invalid category settings
  Given I am viewing the blog admin area
  When I fill in a category tab with invalid settings
  When I save the blog form
  Then I should see the appropriate category error messages

Scenario: Creating a post
  Given I am viewing the blog admin area
  When I add a new blog post
  When I fill in the new post modal with a title and title text
  Then the new blog post should exist
  And I should be redirected to the blog post details page

Scenario: Updating a post
  Given I am on the blog post's details page
  When I update the post's content
  Then the blog post's public page should reflect the changes

Scenario: Changing a post's category
  Given I am on the blog post's details page
  When I select the first category checkbox
  When I save the blog post
  Then the blog post's category page should reflect the changes

Scenario: Deleting a post
  Given I am on the blog post's details page
  When I click the delete button
  When I choose to permanently delete the post
  Then the post should not exist
