@nested-page-partial @javascript
Feature: Nested page partial actions

  Background:
    Given I'm logged in as Robb
    And the "Sub Nav Menu - Toggle Visibility" partial is a page partial for the "Home" page
    And the "CTA" partial

  Scenario: Adding a nested page partial to a page
    Given I'm on the details page for the "Home" page
    When I change the "Nav Link Text 1" field to "CTA"
    And I add the "CTA" partial to "Nav Partial 1" field
    And I change the "Large Header" field to "Test"
    Then I should see "Saved"
    And the "Sub Nav Menu - Toggle Visibility" page partial should be updated
    And the "CTA" page partial should be updated

  Scenario: Viewing a partial that is a nested page partial
    Given the "CTA" is a nested page partial for the 'Sub Nav Menu - Toggle Visibility'
    And I'm on the edit page for the "CTA" partial
    Then I should see all of the partial's pages

  Scenario: Deleting a nested page partial
    Given the "CTA" is a nested page partial for the 'Sub Nav Menu - Toggle Visibility'
    And I'm on the details page for the "Home" page
    When I delete the nested partial from the "Nav Partial 1" field
    Then the field should not contain a partial

  Scenario: Deleting the parent of a nested page partial
    Given the "CTA" is a nested page partial for the 'Sub Nav Menu - Toggle Visibility'
    And I'm on the details page for the "Home" page
    When I delete the parent of the nested partial
    Then none of its nested page partials should exist in the database
