@objekt @javascript
Feature: Object actions

  Background:
    Given I'm logged in as Robb
    And a school object

  Scenario: Viewing all objects
    Given the "All Fields Mandatory" template
    And I'm on the admin/objects page
    Then I should see all of the templates

  Scenario: Viewing all of a template's objects
    Given I'm on the page with all of the "School" objects
    Then I should see all of the "School" objects

  Scenario: Creating a new object
    Given the "All Fields Mandatory" template
    And a "School" object containing a "Creator" of "Madeline"
    And I'm on the page with all of the "All Fields Mandatory" objects
    When I create a new instance of the object
    Then the object should exist

  Scenario: Editing an object
    Given a "School" object containing a "Creator" of "Madeline"
    # And Two Content Upgrades exist
    And Content Data exists
    And the Blog Settings object exists
    And I'm on the edit page for the object
    When I change the "Creator" field to "Jess"
    Then I should see "Saved"
    And the object should be updated

  Scenario: Deleting an instance of an object
    Given a "School" object containing a "Creator" of "Madeline"
    And I'm on the edit page for the object
    When I delete the object
    Then I should see "Schools"
    And the object should not exist

  Scenario: Object field errors show
    Given a "School" object containing a "Creator" of "Madeline"
    And I'm on the edit page for the object
    When I change the "Creator" field to ""
    Then I should see "Creator is mandatory"
    And the "Creator" field should not be changed

  Scenario: Errors don't show for fields with default values
    Given the "All Fields Mandatory" template
    And a "School" object containing a "Creator" of "Madeline"
    And I'm on the page with all of the "All Fields Mandatory" objects
    When I click the "Add New" button
    And I save the object
    Then I should see the correct mandatory errors
