@page-partial @javascript @create-features-page
Feature: Page partial actions

  Background:
    Given I'm logged in as Robb
    And the "CTA" partial is a page partial for the "Home" page

  Scenario: Viewing all of a page's page partials
    Given the "Footer" partial is a page partial for the "Home" page
    And I'm on the details page for the "Home" page
    Then I should see all of the page's page partials

  @create-home-page
  Scenario: Adding a new partial to a page
    Given the "Footer" partial
    And I'm on the details page for the "Home" page
    When I add the "Footer" partial to the page
    Then the page should have a partial named "Footer"

  Scenario: Deleting an existing page partial from a page
    Given the "Footer" partial is a page partial for the "Home" page
    And I'm on the details page for the "Home" page
    When I delete the page partial
    Then the page should not have a partial named "Footer"

  Scenario: Copying an existing page partial to a new page
    Given the "Footer" partial is a page partial for the "Home" page
    And I'm on the details page for the "Home" page
    When I copy the page partial
    And I'm on the details page for the "Features" page
    Then the page should have a partial named "Footer"

  Scenario: Changing the value of a page partial field # <-- this test is flaky, for some reason capybara sometimes grabs the wrong color option (Background Green instead of Pale Green)
    Given a school object
    And the "All Fields Mandatory" partial is a page partial for the "Home" page
    And I'm on the details page for the "Home" page
    When I change the values of all the fields
    Then I should see "Saved"
    And the "All Fields Mandatory" page partial should be updated

  Scenario: Moving the last page partial to the 1st position on a page
    Given the "Footer" partial is a page partial for the "Home" page
    And I'm on the details page for the "Home" page
    When I drag the "Footer" partial to the 1st position
    Then the page partial should be in the correct position

  Scenario: Moving the first page partial to the last position on a page
    Given the "Footer" partial is a page partial for the "Home" page
    And the "Sub Nav Menu - Toggle Visibility" partial is a page partial for the "Home" page
    And I'm on the details page for the "Home" page
    When I drag the "CTA" partial to the last position
    Then the page partial should be in the correct position

  Scenario: Moving the first page partial to the 2nd position on a page
    Given the "Sub Nav Menu - Toggle Visibility" partial is a page partial for the "Home" page
    And the "Footer" partial is a page partial for the "Home" page
    And I'm on the details page for the "Home" page
    When I drag the "CTA" partial to the 2nd position
    Then the page partial should be in the correct position

  Scenario: Moving the last page partial to the 2nd position on a page
    Given the "Sub Nav Menu - Toggle Visibility" partial is a page partial for the "Home" page
    And the "Footer" partial is a page partial for the "Home" page
    And I'm on the details page for the "Home" page
    When I drag the "Footer" partial to the 2nd position
    Then the page partial should be in the correct position
