@partial @javascript
Feature: Partial actions

  Background:
    Given I'm logged in as Robb
    And the "CTA" partial

  Scenario: Viewing all partials
    Given the "Nav Menu" partial
    And the "Footer" partial
    And I'm on the admin/partials page
    Then I should see all of the partials

  Scenario: Viewing partial instances
    Given the "CTA" partial is a page partial for the "Test" page
    And the "CTA" partial is a page partial for the "Home" page
    And I'm on the edit page for the "CTA" partial
    Then I should see all of the partial's pages

  Scenario: Creating a new partial
    Given I'm on the admin/partials page
    When I create the "Bonus" partial
    Then the partial should exist

  Scenario: Partial errors show
    Given I'm on the admin/partials page
    When I create the "CTA" partial
    Then user should see "Name has already been taken"
    And there should only be 1 instance of the partial

  Scenario: Adding a new field to a partial
    Given I'm on the edit page for the "CTA" partial
    When I add the "Small Header Width" field to the partial
    Then I should see "Saved"
    And the partial should have the "Small Header Width" field

  Scenario: Editing an existing partial field
    Given a partial field with the name of "Large Header"
    And I'm on the edit page for the "CTA" partial
    When I change the "name" partial field to "Superheader"
    Then I should see "Saved"
    And the partial should have the "Superheader" field

  Scenario: Deleting an existing partial field
    Given a partial field with the name of "Small Header"
    And I'm on the edit page for the "CTA" partial
    When I delete the partial field
    Then I should see "Saved"
    And the partial should not have a field named "Small Header"

  Scenario: Deleting an existing partial
    Given I'm on the edit page for the "CTA" partial
    When I delete the partial
    Then I should see "Add Partial"
    And the "CTA" partial should not exist
