@plan @javascript
Feature: Plan actions

  Background:
    Given I'm logged in as Robb
    And I'm on the admin/plans page

  Scenario: Each plan has a section
    Then I should see a section for each plan

  Scenario: The correct information is displayed for each plan
    Then I should see the correct information for each plan
    And I should see the correct price for each plan
    And I should see the correct features for each plan

  Scenario: Updating a plan's information
    Given the "Business" plan
    When I change the "Includes Text" to "Test"
    Then the plan's "Includes Text" should be changed
    And I should see "Saved"

  Scenario: Plan information errors show
    Given the "Basic" plan
    When I change the "name" to "Business"
    Then I should see "Name has already been taken"
    And the plan's "name" should not be changed

  Scenario: Adding a feature to a plan
    Given the "Basic" plan
    When I add the "Basic quizzes" plan feature
    Then the plan feature should be one of the plan's features

  Scenario: Deleting a feature for a plan
    Given the "Basic" plan
    When I delete the "2 owners/authors" plan feature
    Then the plan feature should not be one of the plan's features

  Scenario: Changing a plan's tooltip
    Given the "Basic" plan
    And the "Monthly payouts" plan feature
    When I change the tooltip to "0% rate only applies if you set up custom payment gateways."
    Then the plan feature should have the correct tooltip

  # Scenario: Dragging a plan's feature down to the last position
    # Given the "Basic" plan
    # When I drag the "Coupon codes" plan feature to the last position
    # Then the plan feature should be in the correct position

  Scenario: Dragging a plan's feature up to the 1st position
    Given the "Basic" plan
    When I drag the "Coupon codes" plan feature to the 1st position
    Then the plan feature should be in the correct position

  # Scenario: Dragging a plan's feature down to the 6th position
    # Given the "Basic" plan
    # When I drag the "2 owners/authors" plan feature to the 3rd position
    # Then the plan feature should be in the correct position
