@template @javascript
Feature: Template actions

  Background:
    Given I'm logged in as Robb
    And the "School" template

  Scenario: Viewing all template instances
    Given the "All Fields Mandatory" template
    And I'm on the admin/templates page
    Then I should see all of the templates

  Scenario: Clicking on a template square takes you to its edit page
    Given I'm on the admin/templates page
    When I click the "School" template
    Then I should be on the edit page for the "School" template

  Scenario: Creating a new template
    Given I'm on the admin/templates page
    When I create the "All Fields" template
    Then the template should exist
    And I should be on the edit page for the "All Fields" template

  Scenario: Template errors show
    Given I'm on the admin/templates page
    When I create the "School" template
    Then I should see "Name has already been taken"
    And there should only be 1 instance of the template

  Scenario: Deleting an existing template
    Given I'm on the edit page for the "School" template
    When I delete the template
    Then I should see "Object Templates"
    And the "School" template should not exist

  Scenario: Adding a new field to a template
    Given I'm on the edit page for the "School" template
    When I add the "Name" field to the template
    Then I should see "Saved"
    And the template should have the "Name" field

  Scenario: Template field errors show
    Given I'm on the edit page for the "School" template
    When I add the "Creator" field to the template
    Then I should see "Name has already been taken"
    And I should see "Save"
    And the template should have 1 field named "Creator"

  Scenario: Editing an existing template field
    Given a template field with the name of "Creator"
    And I'm on the edit page for the "School" template
    When I change the "name" template field to "Test"
    Then I should see "Saved"
    And the template should have the "Test" field

  Scenario: Deleting an existing template field
    Given a template field with the name of "Creator"
    And I'm on the edit page for the "School" template
    When I delete the template field
    Then I should see "Saved"
    And the template should not have a field named "Creator"

  Scenario: Cannot add a header, page partial, or webinar to a template
    Given I'm on the edit page for the "School" template
    When I open the type dropwdown for a field
    Then the type dropdown shouldn't have the following menu options:
      | Option          |
      | Header          |
      | Page Partial    |
      | Webinar         |
