@tooltip-and-feature @javascript
Feature: Tooltip and feature actions

  Background:
    Given I'm logged in as Robb
    And I'm on the admin/plans page

  Scenario: Viewing all tooltips
    Then I should see all of the tooltips
    And the tooltips should be alphabetized

  Scenario: Viewing all features
    Then I should see all of the features
    And the features should be alphabetized

  Scenario: Creating a tooltip
    When I create the "Fifty sessions" tooltip
    Then the tooltip should exist
    And the tooltips should be alphabetized

  Scenario: Tooltip errors show
    When I create another "Has 30-day delay" tooltip
    Then I should see "Text has already been taken"
    And there should only be 1 instance of the tooltip

  Scenario: Editing an existing tooltip
    Given I'm on the details page for the "Has 30-day delay" tooltip
    And the "Has 30-day delay" tooltip
    When I change the tooltip's text to "No delay"
    And return to the plans page
    Then the tooltip should have the correct information
    And the tooltips should be alphabetized

  Scenario: Deleting a tooltip
    Given I'm on the details page for the "Has 30-day delay" tooltip
    And the "Has 30-day delay" tooltip
    When I delete the tooltip
    Then the tooltip should not exist
    And the tooltips should be alphabetized

  Scenario: Creating a feature
    When I create the "Code snippets" feature
    Then the feature should exist
    And the features should be alphabetized

  Scenario: Feature errors show
    When I create another "5% transaction fees" feature
    Then I should see "Text has already been taken"
    And there should only be 1 instance of the feature

  Scenario: Editing an existing feature
    Given I'm on the details page for the "5% transaction fees" feature
    And the "5% transaction fees" feature
    When I change the feature's text to "0% transaction fees"
    And return to the plans page
    Then the feature should have the correct information
    And the features should be alphabetized

  Scenario: Deleting a feature
    Given I'm on the details page for the "5% transaction fees" feature
    And the "5% transaction fees" feature
    When I delete the feature
    Then the feature should not exist
    And the features should be alphabetized
