@tracking-link @javascript
Feature: Tracking Link actions

  Background:
    Given I'm logged in as Robb

  Scenario: Viewing all tracking links
    Given there exists a tracking link with destination "https://teachable.com"
    When I go to view tracking links
    Then I see a list of all tracking links

  Scenario: Creating a new tracking link
    Given I create a tracking link with destination "https://testing.teachable.com?zEbDc"
    When I go to view tracking links
    Then I should see a tracking link with the destination "https://testing.teachable.com?zEbDc"

  Scenario: Editing an existing draft tracking link
    Given there is a "draft" tracking link with the destination "https://testing.teachable.com"
    When I edit the tracking link with the following information:
      | field            | value                |
      | status           | published            |
      | channel          | email                |
      | subchannel       | test                 |
      | destinationUrl   | https://google.com   |
    Then I should see a tracking link with the destination "https://google.com"
    And when I look at the tracking link with the destination "https://google.com" I see the following information set:
      | field            | value                |
      | status           | Published            |
      | channel          | Email                |
      | subchannel       | test                 |
      | destinationUrl   | https://google.com   |

  Scenario: Editing a published tracking link
    Given there is a "published" tracking link with the destination "https://testing.teachable.com"
    When I edit the tracking link with the following information:
      | field            | value                |
      | status           | published            |
      | channel          | email                |
      | subchannel       | test                 |
      | destinationUrl   | https://google.com   |
    Then I should see a tracking link with the destination "https://google.com"
    And when I look at the tracking link with the destination "https://google.com" I see the following information set:
      | field            | value                |
      | status           | Published            |
      | channel          | Email                |
      | subchannel       | test                 |
      | destinationUrl   | https://google.com   |
    And there are now 2 tracking link records with the destination "https://google.com" and the same slug
