@user @javascript
Feature: User actions

  Scenario: Viewing all users
    Given I'm logged in as Robb
    And I'm on the admin/users page
    Then I should see all of the users

  @create-teams-and-privileges
  Scenario: Creating a new user
    Given I'm logged in as Robb
    And I'm on the admin/users page
    When I create a valid user named "Madeline"
    Then the "Madeline" should exist

  @create-teams-and-privileges
  Scenario: Administrators can only create users and non users
    Given I'm logged in as Robb
    And I'm on the admin/users page
    When I click the "Add User" button
    And I click the permissions dropdown
    Then I should only see permission levels below administrator

  @create-teams-and-privileges
  Scenario: Field errors show
    Given I'm logged in as Robb
    And I'm on the admin/users page
    When I create an invalid user named "Madeline"
    Then I should see "Name can't be blank"
    And I should see "Email can't be blank"
    And I should see "Password can't be blank"

  @create-permissions-and-privileges
  Scenario: A user cannot delete him/herself
    Given I'm logged in as Robb
    And I'm on the edit page for "Robb"
    Then I should not see "Permanently delete user"

  @create-permissions-and-privileges
  Scenario: Cannot delete a user if you're not an administrator or above
    Given a user named "Madeline"
    And I'm logged in as Jess
    And I'm on the edit page for "Madeline"
    Then I should see "User profile"
    Then I should not see "Permanently delete user"

  @create-teams-and-privileges
  Scenario: Updating a user's information
    Given I'm logged in as Robb
    And I'm on the edit page for "Robb"
    When I change the "Title" to "Super Awesome"
    Then the user's "Title" should be changed
    And I should see "Saved"

  Scenario: Deleting a user who has blog posts
    Given a user named "Madeline" with a blog post
    And the Guest Author template exists
    And I'm logged in as Robb
    When I delete the user "Madeline"
    Then the user "Madeline" should not exist in the database
    And a Guest Author Objekt with a name of Madeline should be in the database
    And Madeline's blog post should be assigned to an appropriate Guest Author Objekt
