@webinar-admin @webinar-admin-chat @javascript
Feature: Webinar Chat Admin

Background:
  Given a webinar named test-suite
  And I'm logged in as Robb

Scenario: Sending a chat message
  Given an admin visits the Test-suite chat page
  When they send the message "hewwo :3c"
  Then they should see Robb, Teachable's message saying "hewwo :3c"
  And the message "hewwo :3c" should be marked as a teachable message

Scenario: Recieving a chat message
  Given an admin visits the Test-suite chat page
  When a message reading "こんばんは" is sent
  Then they should see someone else's message saying "こんばんは"

Scenario: Replying to a user
  Given an admin visits the Test-suite chat page
  When a message reading "reply to me" is sent
  And the admin replies to the message "reply to me" with "i am replying"
  Then the message "reply to me" should have a reply saying "i am replying"

Scenario: Privately replying to a user
  Given an admin visits the Test-suite chat page
  When a message reading "sidebar pls" is sent
  And the admin privately replies to the message "sidebar pls" with "ok what do u want"
  Then the message "sidebar pls" should have a private reply saying "ok what do u want"

Scenario: Blocking a user
  Given an admin visits the Test-suite chat page
  When a message reading "block me" is sent
  And the admin blocks the sender of the message "block me"
  Then someone else should appear as blocked

Scenario Outline: Receiving message types
  Given an admin visits the Test-suite chat page
  When a <status> message reading <message> is sent
  Then they should see someone else's message saying <message>
  And a message reading <message> should be in the <tab_name> tab

  Examples:
     | status  | tab_name         | message                                                                                                                                      |
     | blocked | Blocked          | "podia is ok i guess"                                                                                                                        |
     |         | Hello            | "bonjour"                                                                                                                                    |
     |         | General comments | Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque interdum rutrum sodales. Nullam mattis fermentum libero, non volutpat. |
     |         | Questions        | "por que no las dos?"                                                                                                                        |
