@login @javascript @vcr-record
Feature: Logging In

  Background:
    Given a user named PeterNoSchools with a MyTeachable account with 0 schools
    And a user named Peter with a MyTeachable account with 1 school
    And a user named Jackson with a MyTeachable account with many schools

    And a user named Donald with an old account with 1 school
    And a user named Obama with an old account with many schools

  Scenario: Logging in as a MyTeachable user with 0 schools
    Given PeterNoSchools visits the login page
    When he enters his login credentials
    And clicks the "Log in to Teachable" button
    Then he should see "You have no schools or enrollments."

  Scenario: Logging in as a MyTeachable user with 1 school
    Given Peter visits the login page
    When he enters his login credentials
    And clicks the "Log in to Teachable" button
    And closes the myTeachable account modal
    Then he should be in the app

    When he logs out of the app
    Then he should see "Login"

  Scenario: Logging in as a MyTeachable user with many schools
    Given Jackson visits the login page
    When he enters his login credentials
    And clicks the "Log in to Teachable" button
    Then he should see "Schools I Own"

  Scenario: Logging in as a old user with 1 school
    Given Donald visits the login page
    When he enters his login credentials
    And clicks the "Log in to Teachable" button
    And closes the myTeachable account modal
    Then he should be in the app

    When he logs out of the app
    Then he should see "Login"

  Scenario: Logging in as a old user with many schools
    Given Obama visits the login page
    When he enters his login credentials
    And clicks the "Log in to Teachable" button
    And selects "Gravy Train Express" from the dropdown
    And clicks the "Select School" button
    And closes the myTeachable account modal
    Then he should be in the app

    When he logs out of the app
    Then he should see "Login"

  Scenario: Logging into support
    Given Obama visits the support-login page
    When he enters his support login credentials
    And clicks the "Log Into myTeachable" button
    #Then he should be in Zendesk

  Scenario: Resetting password
    Given Obama visits the forgot-password page
    When he enters his email into the forgot password email field
    And clicks the "Send me instructions" button
    Then he should see "You will receive an email with instructions on how to reset your password in a few minutes."
