@single_page_checkout @javascript
Feature: Single page checkout React - coupons


  Scenario: User sees full plan price when no coupon
    Given I visit the create-account page with params of "plan_id=185"
    Then I should see "Add a coupon code"


  Scenario: Coupon code is automatically applied when code is in the params
    Given I visit the create-account page with params of "plan_id=185&coupon_code=74171E0C0F77309E8F35B7DD741093DA"
    Then I should see "100% OFF"
    And the plan's price should be $0.00


  Scenario: Discount and billing cycle information shows for a valid free monthly coupon
    Given I visit the create-account page with params of "plan_id=186"
    When I enter a valid "3 months free" coupon for the "Basic Monthly" plan
    Then I should see "100% OFF"
    And the plan's price should be $0.00


  Scenario: Only discount information shows when code is for less than 100% for a monthly plan
    Given I visit the create-account page with params of "plan_id=186&coupon_code=53558E71494B395F2DD59B13146ABCA4"
    Then I should see "50% OFF"
    And the plan's price should be $59.50


  Scenario: Errors show for invalid code and clear
    Given I visit the create-account page with params of "plan_id=185"
    When I enter an invalid "3 months free" coupon for the "Professional Annual" plan
    Then I should see "Coupon code is invalid."
    And the apply button should be enabled

    When I fill in the coupon box with "anotherBadCoupon"
    Then I should not see "Coupon code is invalid."


  Scenario: Errors show for a valid code for a different plan
    Given I visit the create-account page with params of "plan_id=218"
    When I enter a valid "3 months free" coupon for the "Basic Monthly" plan
    Then I should see "Coupon code is invalid."


  Scenario: Decodes coupon parameter
    Given I visit the create-account page with params of "plan_id=185&coupon_code=47%25OFF"
    Then the coupon code should be "47%OFF"
    And I should see "Coupon code is invalid."
