@single_page_checkout @javascript
Feature: Single page checkout React - With an existing Teachable Account that owns schools on paid plans

  Scenario: Signing Up for the current plan
    Given I visit the create-account page with params of "plan_id=185"
    When I enter "madeline777@fake.com" as my email address
    And I verify my existing account
    Then my cooking school in the list is disabled

  Scenario: Successfully signing up with existing payment information on file
    Given I visit the create-account page with params of "plan_id=185"
    When I enter "madeline777@fake.com" as my email address
    And I verify my existing account
    And I select "cooking" in the list
    And I sign up with the existing information
    Then I should see "Thanks for joining Teachable."

  Scenario: Successfully signing up while adding new payment information instead of using existing information
    Given I visit the create-account page with params of "plan_id=185"
    When I enter "madeline777@fake.com" as my email address
    And I verify my existing account
    And I select "cooking" in the list
    And I choose new payment method
    And I fill my credit card information:
      | cardnumber  | 5555555555554444  |
      | exp-date    | 10 / 21           |
      | cvc         | 321               |
      | country     | United States     |
      | state       | Indiana           |
      | postal code | 46765             |
    When I click the purchase button
    Then I should see "Thanks for joining Teachable."

  Scenario: Successfully signing up a US user with no existing payment information on file
    Given I visit the create-account page with params of "plan_id=185"
    When I enter "madeline777@fake.com" as my email address
    And I verify my existing account
    And I select "cooking" in the list
    And I fill my credit card information:
      | cardnumber  | 5555555555554444  |
      | exp-date    | 10 / 21           |
      | cvc         | 321               |
      | country     | United States     |
      | state       | Indiana           |
      | postal code | 46765             |
    When I click the purchase button
    Then I should see "Thanks for joining Teachable."

  Scenario: Successfully signing up a Canadian user with no existing payment information on file
    Given I visit the create-account page with params of "plan_id=185"
    When I enter "madeline777@fake.com" as my email address
    And I verify my existing account
    And I select "cooking" in the list
    And I fill my credit card information:
      | cardnumber  | 4000001240000000  |
      | exp-date    | 10 / 21           |
      | cvc         | 321               |
      | country     | Canada            |
      | postal code | M4C1N3            |
    When I click the purchase button
    Then I should see "Thanks for joining Teachable."
