@single_page_checkout @javascript
Feature: Single page checkout React - With an existing Teachable Account that does not have owner schools

  Scenario: Successfully signing up a US user
    Given I visit the create-account page with params of "plan_id=185"
    When I enter "madeline777@fake.com" as my email address
    And I verify my existing account
    When I create new school "cooking"
    And I fill my credit card information:
      | cardnumber   | 5555555555554444  |
      | exp-date     | 10 / 21           |
      | cvc          | 321               |
      | country      | United States     |
      | state        | Indiana           |
      | postal code  | 46765             |
    And I click the purchase button
    Then I should see "Thanks for joining Teachable."

  Scenario: Successfully signing up a Canadian user
    Given I visit the create-account page with params of "plan_id=153"
    When I enter "madeline24@fake.com" as my email address
    And I verify my existing account
    When I create new school "cooking"
    And I fill my credit card information:
      | cardnumber  | 4000001240000000  |
      | exp-date    | 10 / 21           |
      | cvc         | 321               |
      | country     | Canada            |
      | postal code | M4C1N3            |
    And I click the purchase button
    Then I should see "Thanks for joining Teachable."
    And I should be on a page with the title "Nice! You're on the Basic Plan now"

  Scenario: Field errors show and clear
    Given I visit the create-account page with params of "plan_id=185"
    When I try to click the purchase button
    Then I should see the purchase button disabled

    When I enter "madeline.test@test.com" as my email address
    And I fill my credit card information:
      | cardnumber  | 4242424242424242 |
    When I try to click the purchase button
    Then I should see the purchase button still disabled

  Scenario: Errors show for invalid stripe fields
    Given I visit the create-account page with params of "plan_id=185"
    When I enter "madeline777@fake.com" as my email address
    When I fill my credit card information:
      | cardnumber  | 424     |
      | exp-date    | 10 / 11 |
      | cvc         | 3       |
      | postal code | M4C1N3  |
    Then I should see "Please enter a password which is at least six characters"
    And I should see "Your card number is incomplete."
    And I should see "Your card's expiration year is in the past."
    And I should see "Your card's security code is incomplete."

#   the test failed/invalid on this part as we dont have validation for non US postal-code
#   Jira ticket: PAYOUTS-1046
#  Scenario: Country and billing code error shows
#    Given I visit the create-account page with params of "plan_id=10"
#    When I enter "madeline777@fake.com" as my email address
#    And I verify my existing account
#    When I create new school "cooking"
#    And I fill my credit card information:
#      | cardnumber  | 4000001240000000  |
#      | exp-date    | 10 / 21           |
#      | cvc         | 321               |
#      | country     | Algeria           |
#      | postal code | 00000000          |
#    When I click the purchase button
#    Then I should see "Invalid Postal Code."
