@single_page_checkout @javascript
Feature: Single page checkout React - Without an existing Teachable Account

  Scenario: Creating an account with an invalid plan id in the params
    Given I visit the create-account page with params of "plan_id=123231231"
    Then I should see "Get Started with Teachable"
    Then I should not see "Order summary"

  Scenario: Creating an account with the plan id for a free plan in the params
    Given I visit the create-account page with params of "plan_id=4"
    Then I should see "Get Started with Teachable"
    Then I should not see "Order summary"

  Scenario: Successfully signing up a US user
    Given I visit the create-account page with params of "plan_id=185"
    When I enter "madeline7782@fake.com" as my email address
    And I sign up using the following information:
      | account name     | madeline          |
      | password         | password          |
      | confirm password | password          |
      | school name      | cooking           |
    And I fill my credit card information:
      | cardnumber  | 5555555555554444  |
      | exp-date    | 10 / 21           |
      | cvc         | 321               |
      | country     | United States     |
      | state       | Indiana           |
      | postal code | 46765             |
    And I click the purchase button
    Then I should see "Thanks for joining Teachable."
    And I should be on a page with the title "Nice! You're on the Professional Plan now"

  Scenario: Successfully signing up a Canadian user
    Given I visit the create-account page with params of "plan_id=153"
    When I enter "madeline252@fake.com" as my email address
    And I sign up using the following information:
      | account name     | madeline          |
      | password         | password          |
      | confirm password | password          |
      | school name      | cooking           |
    And I fill my credit card information:
      | cardnumber  | 4000001240000000  |
      | exp-date    | 10 / 21           |
      | cvc         | 321               |
      | country     | Canada            |
      | postal code | M4C1N3            |
    And I click the purchase button
    Then I should see "Thanks for joining Teachable."
    And I should be on a page with the title "Nice! You're on the Basic Plan now"

  Scenario: Field errors show and clear
    Given I visit the create-account page with params of "plan_id=153"
    When I try to click the purchase button
    Then I should see the purchase button disabled
    When I enter "madeline.test@test.com" as my email address
    And I fill my credit card information:
      | cardnumber  | 4242424242424242 |
    When I try to click the purchase button
    Then I should see "Please enter a password which is at least six characters"
    And I should see the purchase button still disabled

  Scenario: Confirm password, name and school name errors show
    Given I visit the create-account page with params of "plan_id=185"
    When I enter "testtt@testt.com" as my email address
    And I sign up using the following information:
      | password     | password      |
    Then I should see "Passwords do not match"
    And I should see "Please enter your name"
    And I should see "Please enter your school name"

  Scenario: Errors show for invalid stripe fields
    Given I visit the create-account page with params of "plan_id=153"
    And I fill my credit card information:
      | cardnumber  | 4242    |
      | exp-date    | 10 / 11 |
      | cvc         | 3       |
      | postal code | 10010   |
    And I should see "Your card number is incomplete."
    And I should see "Your card's expiration year is in the past."
    And I should see "Your card's security code is incomplete."

#   the test failed/invalid on this part as we dont have validation for non US postal-code
#   Jira ticket: PAYOUTS-1046
#  Scenario: Country and billing code error shows
#    Given I visit the create-account page with params of "plan_id=10"
#    When I enter "madeline16@fake.com" as my email address
#    And I sign up using the following information:
#      | account name     | madeline          |
#      | password         | password          |
#      | confirm password | password          |
#      | school name      | cooking           |
#    And I fill my credit card information:
#      | cardnumber  | 4000001240000000  |
#      | exp-date    | 10 / 21           |
#      | cvc         | 321               |
#      | country     | Algeria           |
#      | postal code | M4C1N3            |
#    Then I should see "Invalid Postal Code."
