@single_page_checkout @javascript
Feature: Single page checkout V2 - With an existing Teachable Account that that owns only schools on the free plan

  Scenario: Successfully signing up with existing payment information on file
    Given I visit the create-account-v2 page with params of "plan_id=153"
    When I enter the following information:
      | field            | value                |
      | email            | madeline776@fake.com |
    And I am verifying my existing account
    And I select the first school in the list
    And I sign up with the following information:
      | field            | value             |
    Then I should be on a page with the title "This school isn't published right now."

  Scenario: Successfully signing up while adding new payment information instead of using existing information
    Given I visit the create-account-v2 page with params of "plan_id=153"
    When I enter the following information:
      | field            | value                |
      | email            | madeline776@fake.com |
    And I am verifying my existing account
    And I select the first school in the list
    And I select new payment method
    And I sign up with the following information:
      | field            | value             |
      | card number      | 5555555555554444  |
      | card expiration  | 10 / 21           |
      | cvc code         | 321               |
      | country code     | United States     |
      | region code      | Indiana           |
      | postal code      | 46765             |
    Then I should be on a page with the title "This school isn't published right now."

  Scenario: Successfully signing up a US user with no existing payment information on file
    Given I visit the create-account-v2 page with params of "plan_id=153"
    When I enter the following information:
      | field            | value                |
      | email            | madeline776@fake.com |
    And I am verifying my existing account
    And I select the first school in the list
    And I sign up with the following information:
      | field            | value             |
      | card number      | 5555555555554444  |
      | card expiration  | 10 / 21           |
      | cvc code         | 321               |
      | country code     | United States     |
      | region code      | Indiana           |
      | postal code      | 46765             |
    Then I should be on a page with the title "This school isn't published right now."

  Scenario: Successfully signing up a Canadian user with no existing payment information on file
    Given I visit the create-account-v2 page with params of "plan_id=185"
    When I enter the following information:
      | field            | value               |
      | email            | madeline776@fake.com |
    And I am verifying my existing account
    And I select the first school in the list
    And I sign up with the following information:
      | field            | value             |
      | card number      | 4000001240000000  |
      | card expiration  | 10 / 21           |
      | cvc code         | 321               |
      | country code     | Canada            |
      | postal code      | M4C1N3            |
    Then I should be on a page with the title "This school isn't published right now."
