@single_page_checkout @javascript
Feature: Single page checkout V2 - With an existing Teachable Account that does not have owner schools

  Scenario: Successfully signing up a US user
    Given I visit the create-account-v2 page with params of "plan_id=185"
    When I enter the following information:
      | field            | value                |
      | email            | madeline777@fake.com |
    And I am verifying my existing account
    And I select create new school
    And I sign up with the following information:
      | field            | value             |
      | school name      | cooking           |
      | card number      | 5555555555554444  |
      | card expiration  | 10 / 21           |
      | cvc code         | 321               |
      | country code     | United States     |
      | region code      | Indiana           |
      | postal code      | 46765             |
    Then I should be on a page with the title "This school isn't published right now."

  Scenario: Successfully signing up a Canadian user
    Given I visit the create-account-v2 page with params of "plan_id=153"
    When I enter the following information:
      | field            | value               |
      | email            | madeline24@fake.com |
    And I am verifying my existing account
    And I select create new school
    And I sign up with the following information:
      | field            | value             |
      | school name      | cooking           |
      | card number      | 4000001240000000  |
      | card expiration  | 10 / 21           |
      | cvc code         | 321               |
      | country code     | Canada            |
      | postal code      | M4C1N3            |
    Then I should be on a page with the title "This school isn't published right now."

  Scenario: Field errors show and clear
    Given I visit the create-account-v2 page with params of "plan_id=185"
    When I press the purchase button
    Then I should see "Please enter a valid email."

    And I should see "Please enter a valid card number."
    And I should see "Please enter a valid expiration date."
    And I should see "Please enter a valid cvc code."
    And I should see "Please select a country."
    And I should see "Please enter a valid zip code."

    And I should not see "Passwords do not match."
    And I should not see "Please select a state"

    When I enter the following information:
      | field        | value                  |
      | email        | madeline.test@test.com |
      | card number  | 4242424242424242       |
    Then I should not see "Please enter a valid email."
    And I should not see "Please enter a valid card number."

  Scenario: Errors show for invalid stripe fields
    Given I visit the create-account-v2 page with params of "plan_id=153"
    When I sign up with the following information:
      | field           | value   |
      | card number     | 424     |
      | card expiration | 10 / 11 |
      | cvc code        | 3       |
    Then I should see "Please enter a valid card number."
    And I should see "Please enter a valid expiration date."
    And I should see "Please enter a valid cvc code."

  Scenario: Country and billing code error shows
    Given I visit the create-account-v2 page with params of "plan_id=185"
    When I enter the following information:
      | field            | value                |
      | email            | madeline777@fake.com |
    And I am verifying my existing account
    And I select create new school
    And I sign up with the following information:
      | field            | value             |
      | school name      | cooking           |
      | card number      | 4000001240000000  |
      | card expiration  | 10 / 21           |
      | cvc code         | 321               |
      | country code     | Algeria           |
      | postal code      | M4C1N3            |
    Then I should see "Your credit card and billing country do not match. Please reselect your billing country."
