# api has no staging environment. so each test will hit the real api.
# use testing@teachable.com to record vcr tests.
@subscription_preference @javascript
Feature: Subscribing and unsubscribing to marketing emails

Scenario: Error shows when no email in params
  Given I visit the subscription-preferences page
  Then I should see "Uh oh, looks like we're having an issue."
  And I should see "Contact us here"

Scenario: User sees all message and channel preferences
  Given I visit the subscription-preferences?email=testing@teachable.com&id=b2169aa29b3d29b60894aeca4ceb06cbf7e41594 page
  Then I should see all message and channel preferences
  And I should be subscribed to all messages

Scenario: No messages are checked if a user is unsubscribe from the channel on page load
  Given I visit the subscription-preferences?email=testing@teachable.com&id=b2169aa29b3d29b60894aeca4ceb06cbf7e41594 page
  Then I should be unsubscribed from the channel
  And I should be unsubscribed from all messages

Scenario: Unsubscribed messages (Company News, Deals and Promotions, and Product Updates) are unchecked on page load
  Given I visit the subscription-preferences?email=testing@teachable.com&id=b2169aa29b3d29b60894aeca4ceb06cbf7e41594 page
  Then I should be unsubscribed from the following messages:
  | Company News & Announcements |
  | Deals & Promotions          |
  | Product Updates & Tips      |

  When I resubscribe to "Deals & Promotions"
  Then I should be resubscribed to the message

Scenario: Unsubscribing from messages
  Given I visit the subscription-preferences?email=testing@teachable.com&id=b2169aa29b3d29b60894aeca4ceb06cbf7e41594 page
  When I unsubscribe to the following messages:
  | Company News & Announcements |
  | Deals & Promotions          |
  Then I should be unsubscribed from only those messages

  When I submit my preferences
  Then I should see "Your subscription preferences have been updated."

Scenario: Unsubscribing from channel
  Given I visit the subscription-preferences?email=testing@teachable.com&id=b2169aa29b3d29b60894aeca4ceb06cbf7e41594 page
  When I unsubscribe from the channel
  Then I should be unsubscribed from the channel
  And I should be unsubscribed from all messages

  When I submit my preferences
  Then I should see "Your subscription preferences have been updated."

Scenario: Previous message preferences show when you resubscribe to the channel
  Given I visit the subscription-preferences?email=testing@teachable.com&id=b2169aa29b3d29b60894aeca4ceb06cbf7e41594 page
  When I unsubscribe from the channel
  Then I should be unsubscribed from the channel
  And I should be unsubscribed from all messages

  When I resubscribe to the channel
  Then I should be subscribed to the channel
  And I should be subscribed to all messages

Scenario: Resubscribing to a previously subscribed message while being unsubscribed from the channel
  Given I visit the subscription-preferences?email=testing@teachable.com&id=b2169aa29b3d29b60894aeca4ceb06cbf7e41594 page
  When I unsubscribe from the channel
  Then I should be unsubscribed from the channel
  And I should be unsubscribed from all messages

  When I resubscribe to the following messages:
  | Company News & Announcements |
  | Deals & Promotions          |
  | Product Updates & Tips      |

  Then I should be unsubscribed to the channel
  And I should be resubscribed to only those messages

Scenario: Resubscribing to a previously unsubscribed message while being unsubscribed from the channel
  Given I visit the subscription-preferences?email=testing@teachable.com&id=b2169aa29b3d29b60894aeca4ceb06cbf7e41594 page
  When I unsubscribe to the following messages:
  | Company News & Announcements |
  | Deals & Promotions          |
  | Product Updates & Tips      |
  And I unsubscribe from the channel
  Then I should be unsubscribed from the channel
  And I should be unsubscribed from all messages

  When I resubscribe to "Deals & Promotions"
  Then I should be unsubscribed to the channel
  And I should be resubscribed to the message

Scenario: Resubscribing to the channel while being unsubscribed from all messages
  Given I visit the subscription-preferences?email=testing@teachable.com&id=b2169aa29b3d29b60894aeca4ceb06cbf7e41594 page
  When I unsubscribe from all messages
  And I unsubscribe from the channel
  Then I should be unsubscribed from the channel
  And I should be unsubscribed from all messages

  When I resubscribe to the channel
  Then I should be subscribed to the channel
  And I should be subscribed to all messages
