When(/^I create the following menu options:$/) do |table|
  @context.create(table.rows)
end

When(/^I create the "(.+)" menu option$/) do |option|
  @context.create(option)
end

When(/^I add the "(.+)" menu option$/) do |option|
  @context.create_single_option(option)
end

When(/^I delete the "(.+)" option from the "(.+)" field$/) do |option, field|
  @context.delete(option, field)
end

Then(/^I should see all the menu options for the "(.+)" field$/) do |field_name|
  @context.expect_all(field_name)
end

Then(/^the menu options should exist$/) do
  @context.expect_options
end

Then(/^the option should not exist$/) do
  @context.expect_to_no_exist
end
