Given(/^the "(.+)" is a nested page partial for the '(.+)'$/) do |partial_name, parent_partial_name|
  @context.given_nested_page_partial(partial_name, parent_partial_name)
end

When(/^I add the "(.+)" partial to "(.+)" field$/) do |partial, field|
  @context.add_partial_to_field(partial, field)
end

When(/^I delete the nested partial from the "(.+)" field$/) do |field_name|
  @context.delete_nested_partial(field_name)
end

When(/^I delete the parent of the nested partial$/) do
  @context.delete_parent_partial
end

Then(/^the field should not contain a partial$/) do
  @context.expect_empty_field_in_database
  @context.expect_empty_field_on_page
end

Then(/^none of its nested page partials should exist in the database$/) do
  @context.expect_no_nested_page_partials
end
