Given(/^I'm on the page with all of the "(.+)" objects$/) do |name|
  @context.given_page_with_all_objekts(name)
end

Given(/^a school object$/) do
  @context.given_school_objekt
end

Given(/^a "(.+)" object containing a "(.+)" of "(.+)"$/) do |template, field_name, value|
  @context.given_an_objekt(template, field_name, value)
end

Given(/^I'm on the edit page for the object$/) do
  @context.given_on_edit_page
end

When(/^I create a new instance of the object$/) do
  @context.create_objekt
end

When(/^I save the object$/) do
  @context.save
end

Then(/^I should see all of the "(?:.+)" objects$/) do
  @context.expect_objekts_on_page
end

Then(/^the object should exist$/) do
  objekt = Objekt.last
  @context.expect_field_values_in_database(objekt)
  @context.expect_in_index(true, objekt)
end

Then(/^the object should be updated$/) do
  @context.expect_updated
end

Then(/^the "(.+)" field should not be changed$/) do |field|
  @context.expect_field_not_changed(field)
end

Then(/^the object should not exist$/) do
  @context.expect_not_to_exist
end

Then(/^I should see the correct mandatory errors$/) do
  @context.expect_correct_mandatory_errors
end
