Given(/^the "(.+)" plan$/) do |plan|
  @context.given_plan(plan)
end

Given(/^the "(.+)" plan feature$/) do |text|
  @context.given_plan_feature(text)
end

When(/^I add the "(.+)" plan feature$/) do |text|
  @context.add_feature(text)
end

When(/^I delete the "(.+)" plan feature$/) do |text|
  @context.delete_feature(text)
end

When(/^I change the tooltip to "(.+)"$/) do |text|
  @context.change_tooltip(text)
end

Then(/^the plan feature should be one of the plan's features$/) do
  @context.expect_feature_to_exist
  @context.expect_feature_text_to_exist_in_plan_features
end

Then(/^the plan feature should not be one of the plan's features$/) do
  @context.expect_feature_to_not_exist
  @context.expect_feature_text_no_in_plan_features
end

Then(/^I should see a section for each plan$/) do
  @context.expect_all_sections
end

Then(/^I should see the correct (information|price|features) for each plan$/) do |type|
  @context.expect_for_all_plans(type)
end

Then(/^the plan feature should have the correct tooltip$/) do
  @context.expect_correct_tooltip_for_plan_feature
  @context.expect_user_to_see_tooltip
end
