Given(/^the "(.+)" (tooltip|feature)$/) do |text, item|
  @context.given_a_tooltip_or_feature(text, item)
end

When(/^I create (?:the|another) "(.+)" (tooltip|feature)$/) do |text, item|
  @context.create_tooltip_or_feature(text, item)
end

When(/^I change the (tooltip|feature)'s text to "(.+)"$/) do |item, new_text|
  @context.change_tooltip_or_feature(item, new_text)
end

When(/^return to the plans page$/) do
  @context.visit_page("/admin/plans", "Rob")
end

When(/^I delete the (tooltip|feature)$/) do |item|
  @context.delete(item)
end

Then(/^I should see all of the (tooltips|features)$/) do |item|
  @context.expect_all(item)
end

Then(/^the (tooltips|features) should be alphabetized$/) do |item|
  @context.expect_alphabetized(item)
end

Then(/^the (tooltip|feature) (should|should not) exist$/) do |item, should_or_not|
  @context.expect_existance(item, should_or_not)
end

Then(/^the (tooltip|feature) should have the correct information$/) do |item|
  @context.expect_correct_information(item)
end
