import React from 'react'

interface _EditableLinkProps {
  className: string
  handleChange: any
  isSelected: boolean
  linkHrefValue: string
}

interface _EditableLinkState extends ComponentState {
  linkHrefPlaceholder: string
  linkHrefValue: string
}

export default class _EditableLink extends React.Component<_EditableLinkProps, _EditableLinkState> {
  constructor(props) {
    super(props);
    this.state = {
      linkHrefValue: this.props.linkHrefValue || '',
      linkHrefPlaceholder: 'This is the link URL'
    }
  }

  // HANDLERS -----

  handleLinkHrefChange(e) {
    e.preventDefault();
    const linkHrefValue = e.target.value;
    this.setState({ linkHrefValue }, () => {
      this.props.handleChange(linkHrefValue);
    });
  }

  // RENDERING -----

  render() {
    return this.props.isSelected ? this.renderSelected() : null;
  }

  renderSelected() {
    return (
      <div className={ this.props.className + ' editable-link-container' }>
        <div className="editable-link-connecting-line"></div>
        <input
          placeholder={ this.state.linkHrefPlaceholder }
          onFocus={ () => this.setState({ linkHrefPlaceholder: '' }) }
          onBlur={ () => this.setState({ linkHrefPlaceholder: 'This is the link URL' }) }
          ref="linkHrefInput"
          className="editable-link link-href-input"
          value={ this.state.linkHrefValue }
          onChange={ this.handleLinkHrefChange.bind(this) }
        />
    </div>

    );
  }
}
