import React from 'react'

interface _MediaTextInputProps {
  handleChange?: any
  isCollapsed: boolean
  isReadonly?: boolean
  resourceName: string
  value: string
}

interface _MediaTextInputState extends ComponentState {
  value: string
}

export default class _MediaTextInput extends React.Component<_MediaTextInputProps, _MediaTextInputState> {
  constructor(props) {
    super(props);

    this.state = {
      value: this.props.value || '',
    };
  }

  handleChange(e) {
    e.preventDefault();
    const value = e.target.value;
    this.setState({ value }, () => {
      this.props.handleChange(value)
    });
  }

  render() {
    const { resourceName, isCollapsed, isReadonly } = this.props;
    const inputProps = {
      className: "media-text-input",
      onChange: this.handleChange.bind(this),
      value: this.state.value
    };
    if (isReadonly) {
      inputProps["readOnly"] = true;
      delete inputProps.onChange;
    }
    return (
      <div className={ 'media-individual-text-input-container' + (isCollapsed ? ' collapsed' : '') }>
        <p className="media-text-input-label">{ resourceName + ':' }</p>
        <input { ...inputProps } />
      </div>
    );
  }
}
