import Immutable from 'immutable';
import React from 'react';

export const META_STYLES = {

  align: [
    'align-left',
    'align-center',
    'align-right',
  ],

  size: [
    'width',
    'height'
  ]
};

export const CUSTOM_STYLES_MAP = {
  'BOLD': {
    fontFamily: 'TeachableSans-Bold',
  },

  'ITALIC': {
    fontStyle: 'italic',
  },

  'UNDERLINE': {
    textDecoration: 'underline',
  },

  // Pseudo-styles (used only in editor mode):
  'PSEUDO_SELECT': {
    background: '#D1EDEB',
  }
}

export const BLOCK_HEADER_STYLES = [
  'unstyled',
  'header-two',
  'header-three',
  'header-four',
  // Disabled for now. Will re-enable per request:
  // 'blockquote',
  'code-block',
]

export const BLOCK_LIST_STYLES = [
  'unordered-list-item',
  'ordered-list-item',
];

export const CUSTOM_ENTITY_TYPES = [
  'CTA',
  'TESTIMONIAL',
  'TIP',
  'HTML',
];

export const DEFAULT_ENTITY_BLOCK_STYLES = {
  CTA: ['align-center'],
  IMAGE: ['align-center'],
}

export const BLOCK_RENDER_MAP = Immutable.Map({

  'unstyled': {
    element: 'div',
    aliasedElements: ['p'],

  },

  'unordered-list-item': {
    element: 'li',
    wrapper: <ul></ul>,
  },

  'ordered-list-item': {
    element: 'li',
    wrapper: <ol></ol>,
  },

  // Disabled for now. Can re-enable per request:
  // 'blockquote': {
  //   element: 'blockquote',
  // },

  'code-block': {
    element: 'pre',
  },

  'header-two': {
   element: 'h2',
  },

  'header-three': {
   element: 'h3',
  },

  'header-four': {
   element: 'h4',
  },

  'atomic': {
    element: 'figure',
  },

});

export const DEFAULT_BLOCK_INLINE_STYLES = {
  'unstyled': [
    'CUSTOM_COLOR_rgba(69,72,75,1)',
  ],

  'header-two': [
    'CUSTOM_COLOR_rgba(44,47,51,1)',
  ],

  'header-three':[
    'CUSTOM_COLOR_rgba(44,47,51,1)',
  ],

  'header-four': [
    'CUSTOM_COLOR_rgba(44,47,51,1)',
    'BOLD',
  ],
}
