const REPLACEMENTS = {
  // TODO: Keep for now
  // cta2: {
  //   regex: new RegExp([
  //     '(<a)',
  //     '(.*)',
  //     '(id="cta_button.*")',
  //     '(.*)',
  //     '(cta_dest_link=")',
  //     '([^"]*)("+)',
  //     '(.*)(>+)',
  //     '(.*)',
  //     '(<\/a>+)'
  //   ].join(''), 'g'),
  //
  //   replaceValue: `
  //     <h2> --- CTA HERE --- </h2>
  //     <p><strong>(^ HEADER TEXT IS (USUALLY) ABOVE ^)</strong></p>
  //     <p><strong>URL:</strong> $6</p>
  //     <p><strong>Button text:</strong> $10</p>
  //     <h2> --- CTA END --- </h2>
  //   `
  // },

  h1s: {
    regex: /h1/g,
    replaceValue: 'h2',
  },

  brTag: {
    regex: /<br>/g,
    replaceValue: '',
  },

  hiddenImages: {
    regex: /<img.*?class=".*?hidden.*?".*?>/g,
    replaceValue: ''
  },

  // TODO: Keep for now.
  // spanMetadata: {
  //   regex: new RegExp([
  //     '(<span)',                         // Open span tag
  //     '(.*?)',                            // anything
  //     '(id="hs_cos_wrapper_post_body")', // id used for metadata
  //     '(.*?)',                            // anything
  //     '(>)',                             // closing bracket
  //     '(.*?)',                            // anything
  //     '(<\/p>)'                         // closing p tag (lol @ hubspot)
  //   ].join(''), 'g'),
  //
  //   replaceValue: '',
  // },

  hiddenPTags: {
    regex: /<p.*?class=".*?hidden.*?".*?>.*?<\/p>/g,
    replaceValue: ''
  },

  emptyLine: {
    regex: new RegExp([
      '(<)',            // Open tag brace
      '(p|h1|h2|h3)',   // Any text tag
      '(.*)',           // Any additional attributes
      '(>)',            // Closing brace
      '(&nbsp;)',       // Empty space
      '(<\/)',          // Closing tag brace
      '(p|h1|h2|h3)',   // Any text tag
      '(>)'             // Closing brace
    ].join(''), 'g'),

    replaceValue: ''
  },

  cta1: {
    regex: new RegExp([
      '(<!--HubSpot Call-to-Action Code -->)',
      '([\\s\\S]*?)',
      '(.*?)',
      '([\\s\\S]*?)',
      '(<!-- end HubSpot Call-to-Action Code -->)',
    ].join(''), 'g'),

    replaceValue: (match) => {
      const re = /(<!--HubSpot Call-to-Action Code -->)([\s\S]*?)(.*)([\s\S]*?)(<!-- end HubSpot Call-to-Action Code -->)/;
      const matchGroups = re.exec(match);

      const matchGroupContainingUrl = matchGroups[4] || matchGroups[3];
      console.log(matchGroupContainingUrl);
      const url = /(<a)(.*?)(href=\")(.*?)(\")(.*?)(>)/.exec(matchGroupContainingUrl)[4];

      let buttonText;

      const buttonText1 = /(<img)(.*?)(alt=\")(.*?)(\")(.*?)(>)/.exec(matchGroupContainingUrl);
      if (buttonText1) {
        buttonText = buttonText1[4];
      } else {
        const buttonText2 = /(<a.*?>)(.*?)(<\/a>)/.exec(matchGroupContainingUrl);
        if (buttonText2) buttonText = buttonText2[2];
      }


      return `
        <h2> --- CTA HERE --- </h2>
        <p><strong>(^ HEADER TEXT IS (USUALLY) ABOVE ^)</strong></p>
        <p><strong>URL:</strong> ${url}</p>
        <p><strong>Button text:</strong> ${buttonText}</p>
        <h2> --- CTA END --- </h2>
      `;
    }
  },

  divImg: {
    regex: /(<div>)(<img[^>]*)(>)(<\/div>)/g,
    replaceValue: (match) => match + '<p></p>'
  },

  // TODO: Keep for now.
  // imageInsideInlineTag: {
  //   regex: /(<p.*?>|<span.*?>)(.*)(<img.*?>)(.*)(<\/p>|<\/span>)/g,
  //   replaceValue: (match) => {
  //     const re = /(<p.*?>|<span.*?>)(.*)(<img.*?>)(.*)(<\/p>|<\/span>)/;
  //     const matchGroups = re.exec(match);
  //     matchGroups.splice(0, 1);
  //     const imgTagIndex = matchGroups.indexOf(matchGroups.filter(group => group.startsWith('<img'))[0]);
  //     const imgTag = '<div>' + matchGroups.splice(imgTagIndex, 1)[0] + '</div>';
  //     return imgTag + matchGroups.join('');
  //   }
  // },

  iframe: {
    regex: /(<iframe.*?>.*?<\/iframe>)/g,
    replaceValue: (match) => {
      return `
        <h2> --- IFRAME HERE --- </h2>
        <p><strong>(Add opening tag:)</strong></p>
        <p>${match.slice(1, match.length).replace('http:', 'https:')}</p>
        <h2> --- IFRAME END --- </h2>
      `;
    },
  },

  // TODO: Keep for now.
  // script: {
  //   regex: /(<script.*?>.*<\/script>)/g,
  //   replaceValue: (match) => {
  //     return `
  //       <h2> --- SCRIPT HERE --- </h2>
  //       <p><strong>(Add opening tag:)</strong></p>
  //       <p>${match.slice(1, match.length)}</p>
  //       <h2> --- SCRIPT END --- </h2>
  //     `;
  //   }
  // }
};

export const parseHTML = (rawHTML) => {
  let parsedHTML = rawHTML;
  Object.keys(REPLACEMENTS).forEach(replacementType => {
    const { regex, replaceValue } = REPLACEMENTS[replacementType];
    parsedHTML = parsedHTML.replace(regex, replaceValue);
  });

  return parsedHTML.replace('\n', '') + '<p></p>';
};
