import React from 'react';
import _DropdownMenu from './_dropdown-menu';
import ColorPicker from './color-picker/color-picker';

export default class ColorSelectionButton extends _DropdownMenu {
  constructor(props) {
    super(props)
  }

  // RENDERING -----

  render() {
    const { isExpanded } = this.state;
    const { currentColor } = this.props;
    const buttonProps = {
      ref: 'button',
      className: (
        'style-button style-options-menu-button color-icon'
        + (isExpanded ? ' pressed' : '')
      ),
      onMouseDown: this.handleMouseDown,
    };
    return (
      <div className="style-button-options-menu-container">
        <div { ...buttonProps } >
          { this.renderPreviewColorSquare(currentColor) }
        </div>
        { this.renderMenu() }
      </div>
    );
  }

  renderPreviewColorSquare(backgroundColor) {
    return (
      <div
        id="color-preview-square"
        style={ { backgroundColor, height: '100%' } }
        onMouseDown={ this.handleMouseDown.bind(this) }>
      </div>
    );
  }

  renderMenu() {
    return (
      <div ref="menu">
        <ColorPicker
          isCollapsed={ !this.state.isExpanded }
          currentColor={ this.props.currentColor }
          toggleColorStyle={ this.props.toggleColorStyle }
          onMouseDown={ this.handleMouseDown.bind(this) }
        />
      </div>
    );
  }
}
