import React from 'react';
import camelCase from 'lodash/camelCase';

const HEADER_ELEMENTS = {
  'header-one': 'h1',
  'header-two': 'h2',
  'header-three': 'h3',
  'header-four': 'h4',
}

export const getStyleIcon = (styleCode, isPressed) => {
  if (styleCode.startsWith('header')) {
    const Tag = HEADER_ELEMENTS[styleCode];
    const text = styleCode.split('-')[0] + ' ' + Tag[Tag.length - 1];
    return <Tag className="text-icon">{ text }</Tag>
  }

  if (styleCode === 'unstyled') {
    return <p className="unstyled">{ 'Paragraph ' }</p>
  }

  const baseName = camelCase(styleCode);
  const fullName = baseName + (isPressed ? 'Pressed': 'Unpressed');
  return <img id={ `${baseName}-icon` } src={ window.Images[fullName] } />;
}

export const getOptionMenuIcon = (styleCode, isPressed) => {
  return TEXT_ICON_PREVIEWS[styleCode] || getStyleIcon(styleCode, isPressed);
}

export const TEXT_ICON_PREVIEWS = {
  'header-one': <h1 className="option-icon">Header 1</h1>,
  'header-two': <h2 className="option-icon">Header 2</h2>,
  'header-three': <h3 className="option-icon">Header 3</h3>,
  'header-four': <h4 className="option-icon">Header 4</h4>,
  'unstyled': <p className="option-icon unstyled">Paragraph</p>,
}
