import Admin from './../admin'
import React from 'react';

interface PagePartialNewState extends ComponentState {
  partials: any;
  previewImageUrl: string;
}

interface PagePartialNewProps {
  addPartial: any;
  closeModal: any;
  partials: any[];
}

export default class PagePartialsNew extends React.Component<PagePartialNewProps, PagePartialNewState> {

  constructor(props) {
    super(props);
    this.state = {
      fetching: false,
      partials: [],
      previewImageUrl: null,
      searchText: ""
    };
  }

  componentDidMount() {
    this.setState({
      partials: this.props.partials
    });
  }

  clickPartial(e) {
    var partialId = e.target.dataset.id;
    this.setState({ fetching: true }, () => this.props.addPartial(partialId));
    this.props.closeModal();
  }

  mouseEnter(previewImageUrl) {
    this.setState({ previewImageUrl });
  }

  mouseLeave() {
    this.setState({ previewImageUrl: null });
  }

  renderPreviewImage() {
    if (this.state.previewImageUrl) {
      var styles = { backgroundImage: `url(${this.state.previewImageUrl})` };
      return <div className="preview-image-container" style={ styles }></div>
    } else {
      return <div className="preview-image-container"></div>
    }
  }

  render() {
    var filteredPartials = Admin.filterSearchText(this.state.partials, this.state.searchText, 'name');
    return(
      <div id="page-partials-new" className="admin-modal">
        <div className="component">
          { Admin.renderSpinner(this.state.fetching) }
          { Admin.renderGrayedOut(this.state.fetching) }
          { this.renderPreviewImage() }
          <div className="clearfix">
            <input className="search-box" onChange={ Admin.changeSearchText.bind(this) } value={ this.state.searchText } />
          </div>
          <div className="partials-container">
            <div className="clearfix">
              { filteredPartials.map(function(partial, index) {
                return(
                  <a key={ index } onClick={ this.clickPartial.bind(this) } data-id={ partial.id } onMouseEnter={ this.mouseEnter.bind(this, partial.imageUrl) } onMouseLeave={ this.mouseLeave.bind(this) }>
                    { partial.name }
                  </a>
                )
              }.bind(this)) }
            </div>
          </div>
        </div>
      </div>
    );
  }
}
