import React from 'react'

interface Offer {
  id?: number;
  duration: number;
  startTime: number;
  ctaButtonText: string;
  ctaUrl: string;
  ctaButtonType: string;
  description: string;
  title: string;
}

interface WebinarOfferProps {
  offer: Offer;
  webinarDuration: number;
}

class WebinarOffer extends React.Component<WebinarOfferProps, {}> {

  constructor(props) {
    super(props);
  }

  clickRow(e) {
    window.location.href = `/admin/webinar_offers/${this.props.offer.id}`;
  }

  renderAppearanceCell() {
    let webinarDurationSeconds = this.props.webinarDuration * 60;
    let halfway = webinarDurationSeconds / 2;
    if (this.props.offer.startTime <= halfway) {
      let minute = Math.round(this.props.offer.startTime / 60);
      return `${minute} minute${minute === 1 ? '' : 's'} in`;
    } else {
      let minute = Math.round((webinarDurationSeconds - this.props.offer.startTime) / 60);
      return `with ${minute} minute${minute === 1 ? '' : 's'} left`;
    }
  }

  render() {
    return(
      <tr onClick={ this.clickRow.bind(this) } style={ { cursor: 'pointer' } }>
        <td>{ this.props.offer.title }</td>
        <td>{ this.props.offer.description }</td>
        <td>{ this.renderAppearanceCell() }</td>
        <td>{ this.props.offer.duration } seconds</td>
      </tr>
    );
  }
}

export default WebinarOffer;
