require 'filestack'

class BlogPostMassUpdater

  def initialize
    @filestack_client = FilestackClient.new("AtM7HNKzQZ6u2HxwJF1Jiz")
    @posts = BlogPost.where("editor_content_state like ?", "{%") # fragile check for valid json

    @hard_coded_cta_redirects = {
      'https://cta-redirect.hubspot.com/cta/redirect/677576/322a308e-36bd-4d9b-aa98-be78342fdd01' => 'https://teachable.com/get/download-studio-setup-guide',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/8774f87e-db50-4373-8a1c-e7329a2cbfd7' => 'https://teachable.com/get/the-teachable-signature-plug-and-play-email-launch-sequence',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/21329363-b524-4c0d-9da7-07e69d595be6' => 'https://teachable.com/get/download-keynote-powerpoint-templates',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/553f5b08-44a2-47bf-ab3b-5b87df8d9af9' => 'https://copyhackers.com/get-it-now',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/69d6d56e-8233-412b-9757-d77d2ea96a31' => 'https://teachable.com/get/email-campaigns',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/528cd9da-641a-4aa7-b15c-1b0afcea7b06' => 'https://teachable.com/get/landing-page-design-download',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/52c10b23-ac98-4fae-9b38-c3dcd626c610' => 'https://teachable.com/get/how-to-teach-online',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/cc16e052-7f6d-4340-99b9-525dfe41e2ff' => 'https://teachable.com/webinars/7-steps-to-launch/register?src=teachable-blog-emails',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/a097b7de-f8ee-4c56-8ceb-3b8ca526561d' => 'https://teachable.com/get/download-welcome-emails',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/d01d0fbb-da3a-418e-9008-f8eef73680b4' => 'https://gleam.io/RpUYF/pat-flynns-will-it-fly-competition',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/69744168-361f-4fb2-9cc6-62586ab23f5e' => 'https://teachable.com/get/make-money-online',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/c761d175-bf58-46e5-8810-87da9f3220db' => 'https://teachable.com/get/teachable-ebook-create-content-for-your-online-course',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/da12a2f4-85bb-43d9-b658-97603b908916' => 'https://teachable.com/get/email-campaigns',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/f6e2105e-cd1b-4383-98fb-eee9974a2087' => 'https://teachable.com/get/abandoned-cart-email',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/05aab608-8cbd-45f9-aced-a5d8733bc80b' => 'https://teachable.com/201712-prod-aff-feature',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/4d66dcc5-325d-4423-a4c8-886fd3c77662' => 'https://teachable.com/get/download-list-building-101',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/3b3d42b9-97fc-450e-a04b-802d0567e757' => 'https://teachable.com/upsell-masterclass',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/c65b9599-98ae-44c1-b3c4-a831762c71af' => 'https://teachable.com/create-account',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/16d23d8a-e813-4bce-ac97-80daa4de2d3f' => 'https://teachable.com/get/new-course-checklist',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/78de34d9-f060-45bf-a6e8-abd31732a423' => 'https://teachable.com/get/create-a-course-resource-bundle',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/5d9c6579-1484-424f-acee-ae3c6e0e2037' => 'https://teachable.com/get/email-campaigns',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/ee9c489f-2d4d-45ac-87c1-98daad415223' => 'https://teachable.com/get/create-a-course-resource-bundle',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/598c2c99-4200-4359-8730-c6ede7b41cde' => 'https://vizia.co/?src=teachable-blog',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/54449ef0-8efa-48b7-9691-b0c6ed980975' => 'https://teachable.com/get/black-friday-cyber-monday-email-templates',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/7969bbc5-6ce6-4acd-904f-23d4a2a62b07' => 'https://teachable.com/get/monetize-your-blog-cheat-sheet',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/bd2c0953-f2e9-40e6-9fb3-0c3397562656' => 'https://teachable.com/get/instagram-templates',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/1eb2bd8b-b5b1-4742-b5f3-b80b1ef64ef3' => 'https://teachable.com/get/how-to-write-sales-pitch',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/92380d70-26e4-4e5d-92ba-04e501be7525' => 'https://teachable.com/get/webinar-replay-grow-your-course-with-pinterest',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/9d26dfed-c5c1-48a7-9e0b-21ecfa9e9e3c' => 'https://teachable.com/webinars/7-steps-to-launch/register?src=teachable-blog-repurposing',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/686c9e1d-c1a5-425f-a1c8-a415c5255bc3' => 'https://teachable.com/webinars/7-steps-to-launch/register?src=teachable-blog-blogging',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/8e1de64a-162a-40d5-bef0-6639b59e49a7' => 'https://teachable.com/get/pinterest-resources',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/1d69a8cc-9137-4f3a-b936-17e373a21cda' => 'https://teachable.com/get/get-the-teachable-blog-calendar',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/dc76cd3b-bc79-4615-9c44-ea4c7a46b4a6' => 'https://teachable.com/get/course-pricing-calculator',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/a5357c8b-a23f-4371-a94f-06a5411173ba' => 'https://teachable.com/create-account',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/c4fcdd9a-480e-40bd-a0b0-d4a89e61b924' => 'https://itunes.apple.com/us/app/teachable-online-courses/id1177062376?mt=8',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/8f762bac-33fd-405f-920e-42337e0d945c' => 'https://teachable.com/get/on-page-optimization-checklist-tutorial',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/b909035c-f6e7-446e-a4de-e8ca4586a822' => 'https://teachable.com/webinars/7-steps-to-launch/register',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/51f0ccf8-1de2-42c8-a9d0-54c77a6f61af' => 'https://teachable.com/webinars/7-steps-to-launch/register',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/ea11980a-0949-4052-8c8a-122d6cbd8d90' => 'https://teachable.com/get/get-the-teachable-worksheet-templates',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/5a5932f8-7ecd-422b-bcc2-834dd56769e5' => 'https://teachable.com/get/creative-course-interviews',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/85e0d89e-db96-4985-985d-e6d411497721' => 'https://teachable.com/webinars/7-steps-to-launch/register?src=blog',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/7409a892-d638-4b9e-9a7c-6310918251b1' => 'https://teachable.com/get/course-name',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/74afcd5a-531f-427e-9861-0de69a03d343' => 'https://teachable.com/replay/sales-page-masterclass',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/2bf1b493-5e05-4bb7-ae61-311aa3208cf5' => 'https://teachable.com/webinars/7-steps-to-launch/register?src=teachable-blog-twitter',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/071f358b-e72e-4bf3-8fca-ec3f4350e898' => 'https://collegeinfogeek.com/get-better-grades/',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/ed2ee268-1d0c-468d-9b03-62b82be4002b' => 'https://teachable.com/get/email-campaigns',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/faf2d4c0-558d-43f8-860d-9182eab1b059' => 'https://teachable.com/webinars/7-steps-to-launch/register/?src=teachable-blog-contentupgrade-sprague',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/8243c155-87c9-45e2-8f8a-0a7ef47ef36c' => 'https://teachable.com/get/download-copywriting-examples',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/3a87cda9-d741-4b7c-a6e9-8c1113a9fee1' => 'https://teachable.com/get/download-the-profitable-course-idea-workbook',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/76152f14-5cfa-4dc4-9553-193fccc37c8b' => 'https://teachable.com/get/build-community-with-slack-download',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/63d110d9-0ed9-4228-a7c5-722cb810e1f8' => 'https://bornforthisbook.com/about',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/5cf4db82-4840-4d6d-b2d3-7a9a1c9427eb' => 'https://teachable.com/get/digital-marketing-terms',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/5f088808-e0f7-4f8b-95b4-a7eaf902d87c' => 'https://teachable.com/get/download-interview-resources',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/d725872d-25ce-494a-9add-8d069ada4f8e' => 'https://teachable.com/get/download-product-launch-emails',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/0ab83fad-7fd4-41bc-a2f2-a70f354f0b06' => 'https://teachable.com/get/gift-this-course-tutorial',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/3af6d6c2-c08e-401e-9134-52ddbc4d8f85' => 'https://teachable.com/get/online-course-launch-0',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/4c2263f6-6ca7-4b27-801b-6bb3d9c9eb42' => 'https://teachable.com/get/online-course-launch-0',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/3128e833-5ba7-4c19-b17e-4891ca5f4b9c' => 'https://teachable.com/get/our-guide-track-your-engagement-with-online-communites-while-marketing-your-course',
      'https://cta-redirect.hubspot.com/cta/redirect/677576/dd150490-d25b-4c6e-9c01-75fb5718158c' => 'https://teachable.com/get/how-to-teach-online',
    }
  end

  def replace_cta_links!
    replacement_map = get_cta_replacement_map
    blog_posts = BlogPost.all

    blog_posts.each do |blog_post|
      content_state = blog_post.editor_content_state
      html_content = blog_post.html_content

      replacement_map.each do |current_url, redirected_url|
        next if current_url == redirected_url
        next if !current_url || !redirected_url

        content_state.gsub!(current_url, redirected_url)
        html_content.gsub!(current_url, redirected_url)
      end

      blog_post.update(
        editor_content_state: content_state,
        html_content: html_content
      )
    end
  end

  def get_cta_replacement_map
    posts = BlogPost.published

    all_cta_urls = [];

    posts.each do |post|
      cta_entities = post.get_draftjs_entities_by_type("CTA")
      cta_urls = cta_entities.map { |cta_entity| cta_entity.fetch("data").fetch("buttonHref") }
      all_cta_urls << cta_urls
    end

    replacement_map = {}
    non_200s = []

    all_cta_urls.flatten.uniq.each.with_index do |url_to_replace, i|
      next if url_to_replace.starts_with?("https://teachable.com/get/", "/get/")
      url_to_replace.gsub!("&20", "")
      url_to_replace.gsub!(" ", "")
      response = HTTParty.head(URI.encode(url_to_replace))
      if response.code != 200
        non_200s << url_to_replace
        next
      end
      new_url = response.request.last_uri.to_s
      replacement_map[url_to_replace] = new_url
    end

    @hard_coded_cta_redirects.each do |redirect, url|
      replacement_map[redirect] = url
    end

    p "********* NON 200 REDIRECTS: #{non_200s.length} ***********"
    non_200s.each { |non_200| p "#{non_200}"; p "" }

    p '************ SAME URL: ******************'
    same_urls = replacement_map.select { |k, v| k == v && v.include?("teachable") }
    p same_urls.keys

    # p '************ REPLACEMENT MAP ******************'
    # replacement_map.each { |k, v| p "#{k}: #{v}" }

    replacement_map
  end

  def run_link_analysis!
    relative_link_analysis = YAML.load_file('./lib/tasks/blog_post_relative_link_analysis.yml') || {}

    @link_exceptions = []
    newly_analyzed_links = get_all_relative_links.map { |url| analyze_relative_url(url) }
    newly_analyzed_links.each { |new_link_analysis| relative_link_analysis.merge!(new_link_analysis) }

    File.write('./lib/tasks/blog_post_relative_link_analysis.yml', relative_link_analysis.to_yaml)

    @link_exceptions.uniq.each { |link_exception| p link_exception }
  end

  def replace_relative_links!
    relative_link_analysis = YAML.load_file('./lib/tasks/blog_post_relative_link_analysis.yml') || {}
    skipped_urls = []

    @posts.each do |blog_post|
      content_state = blog_post.editor_content_state
      html_content = blog_post.html_content

      content_urls = get_urls_from_post(blog_post)
      content_urls.each do |url|
        next unless is_relative_url?(url)

        analysis_entry = relative_link_analysis[url]
        if !analysis_entry
          new_url_entry = check_possible_analysis_entries(url, relative_link_analysis)
          if new_url_entry
            analysis_entry = relative_link_analysis[new_url_entry]
          else
            skipped << url
            break
          end
        end
        new_url = "/blog/#{analysis_entry[:slug]}"
        content_state.gsub!(url, new_url)
        html_content.gsub!(url, new_url)
      end

      blog_post.update(
        editor_content_state: content_state,
        html_content: html_content
      )
    end

    p "These URLS were skipped: "
    p skipped_urls
  end

  def replace_internal_redirects!
    internal_redirect_map = get_internal_redirects
    blog_posts = BlogPost.all

    blog_posts.each do |blog_post|
      editor_content_state = blog_post.editor_content_state
      html_content = blog_post.html_content
      next if editor_content_state.nil? || html_content.nil?

      internal_redirect_map.each do |current_url, redirected_url|
        next if current_url == redirected_url

        editor_content_state.gsub!(/(\/blog\/#{current_url})/, "/blog/#{redirected_url}/")
        html_content.gsub!(/(\/blog\/#{current_url})/, "/blog/#{redirected_url}")
      end

      blog_post.update(
        editor_content_state: editor_content_state,
        html_content: html_content
      )
    end
  end

  def replace_images!
    posts = BlogPost.all

    posts.each do |post|
      p post.id
      image_entities = post.get_draftjs_entities_by_type("IMAGE")
      image_urls = image_entities.map { |img_entity| img_entity.fetch("data").fetch("src") }

      image_url_replacement_map = image_urls.each_with_object({}) do |old_url, obj|
        next if old_url.starts_with?("https://cdn.filestack")
        obj[old_url] = upload_image!(old_url, post.title)
      end

      image_url_replacement_map.each do |old_url, new_url|
        post.editor_content_state.gsub!(old_url, new_url)
        post.html_content.gsub!(old_url, new_url)
        post.save!
      end
    end
  end

  def get_internal_redirects
    links = @posts.map { |post| get_urls_from_post(post) }.flatten.select { |url| url.starts_with?("/blog") }.uniq
    redirects = {}

    # Possible outlier posts:
    non_200s = []
    redirects_not_in_cms = []
    no_posts_at_all = []

    links.each do |link|
      original_slug = link.split("/").last
      response = HTTParty.head("http://blog.teachable.com/#{original_slug}")

      non_200s << original_slug if response.code != 200

      if response.code == 200
        redirect_slug = response.request.last_uri.to_s.split("/").last
        if redirect_slug != original_slug
          redirects[original_slug] = redirect_slug
        end
      end
    end

    redirects.each do |current_url, redirected_url|
      redirected_post_in_cms = BlogPost.find_by(url: "/#{redirected_url}")
      cms_link = redirected_post_in_cms ? "https://teachable.com/admin/blog_posts/#{redirected_post_in_cms.id}" : ""

      if !redirected_post_in_cms
        if redirected_url == "blog.teachable.com"
          current_post =  BlogPost.find_by(url: "/" + current_url)
          current_post.update(active: false, index_page: false) if current_post
          no_posts_at_all << current_url unless current_post
        else
          redirects_not_in_cms << redirected_url
        end
      end

      p "#{current_url} | #{redirected_url} | #{cms_link}"
    end

    p "NON 200 RESPONSES: "
    p non_200s - ["blog", "grow-your-business", "create-your-course", "teachable-updates"]
    p "REDIRECTS NOT IN CMS:"
    p redirects_not_in_cms.uniq - ["blog.teachable.com"]
    p "NO POSTS AT ALL: "
    p no_posts_at_all

    redirects
  end

  private

  def analyze_relative_url(original_url)
    path = clean_path(original_url)
    slug = parse_slug_from_path(path)
    blog_post_id = BlogPost.find_by(url: "/#{slug}").try!(:id)

    if !blog_post_id
      response = HTTParty.head("http://blog.teachable.com/#{slug}")
      case response.code
      when 200
        redirect_slug = response.request.last_uri.to_s.split("/").last
        blog_post_id = BlogPost.find_by(url: "/#{redirect_slug}").try!(:id)
        @link_exceptions << " ***** This exists live but not in the CMS: #{slug}" if !blog_post_id
      when 404
        @link_exceptions << "***** This 404'd: #{slug}"
      end
    end

    return {
      original_url => {
        slug: slug,
        blog_post_id: blog_post_id,
      }
    }
  end

  def get_specific_relative_links(relative_link_pattern)
    posts = BlogPost.all
    posts_with_relative_links = posts.select do |post|
      link_entities = post.get_draftjs_entities_by_type("LINK")
      link_urls = link_entities.map { |link_entity| link_entity.fetch("data").fetch("url") }

      matching_urls = link_urls.flatten.uniq.select { |link| link.include?(relative_link_pattern) }
      p matching_urls if matching_urls.length > 0

      matching_urls.length > 0
    end

    posts_with_relative_links
  end

  def check_possible_analysis_entries(original_url, analysis)
    analysis_keys = analysis.keys

    substrings = analysis_keys.select { |k| k.include?(original_url) }
    return substrings[0] if substrings.length > 0

    superstrings = analysis_keys.select { |k| original_url.include?(k) }
    return superstrings[0] if superstrings.length > 0

    return nil
  end

  def get_all_relative_links
    relative_links = @posts.map { |post| get_urls_from_post(post) }.flatten.select { |url| is_relative_url?(url) }.uniq
    p "**************************************************"
    p "************ #{relative_links.length} Relative Links Found ************"
    p "**************************************************"
    relative_links
  end

  def get_urls_from_post(post)
    post.get_draftjs_entities_by_type("LINK").map { |link_entity| link_entity.fetch("data").fetch("url") }
  end

  def is_relative_url?(url)
    # Exclude links to an id via fragment like `#content` and links with an implied protocol like //google.com
    is_already_replaced = url.starts_with?("/blog")
    return true if !!url.match(/(http:|https:)?(\/\/blog.teachable.com)/) && !is_already_replaced

    uri = URI.parse(url)
    uri.relative? && uri.path.present? && uri.host.nil? && !is_already_replaced
  end

  def clean_path(url)
    URI.parse(url).path.gsub("../","").gsub("com/teachable", "").gsub(".html", "")
  end

  def parse_slug_from_path(path)
    path = path[0..-2] if path.last == "/"
    return path if path == ""
    path.split("/").last.gsub(".html", "")
  end

  def upload_image! (image_url, title)
    p "***** #{title} *****"
    p "    Uploading: #{image_url}"
    filelink = @filestack_client.upload(external_url: image_url, storage: 's3')
    image_params = {
      upload_type: 'image',
      url: filelink.url,
      s3_url: filelink.metadata['key'],
      category: "blog_post_content",
      uploaded_by: 1
    }

    image = Upload.new(image_params)
    if image.save
      image.url
    else
      image.errors.full_messages.each do |error|
        p "IMAGE ERROR: " + error
      end
    end
  end

  # TODO: Can delete active & inactive post methods after migration
  def verify_active_posts
    posts = BlogPost.where(active: true)

    result = []
    posts.each do |post|
      response = HTTParty.head("http://blog.teachable.com#{post.url}")
      if response.code == 404
        p "404'd: #{post.url} ID: #{post.id}"
        result << post.url
      end

      redirect_slug = response.request.last_uri.to_s.split("/").last
      next if !!redirect_slug.match(/blog.teachable.com/)
      if redirect_slug != post.url[1..-1]
        p "CHECK: #{post.url} ID: #{post.id}"
        result << post.url
      end
    end

    result
  end

  def verify_inactive_posts
    posts = BlogPost.where(active: false)

    result = []
    posts.each do |post|
      response = HTTParty.head("http://blog.teachable.com#{post.url}")

      if response.code == 200
        redirect_slug = response.request.last_uri.to_s.split("/").last
        next if redirect_slug == "blog.teachable.com"
        result << post if redirect_slug == post.url[1..-1]
      end
    end

    p result
  end
end


task robb_test: :environment do
  # Generates the initial relative link analysis YAML file
  updater = BlogPostMassUpdater.new
  updater.get_specific_relative_links("//blog.teachable.com")
end

task blog_post_relative_link_analysis: :environment do
  # Generates the initial relative link analysis YAML file
  updater = BlogPostMassUpdater.new
  updater.run_link_analysis!
end

task blog_post_replace_relative_links: :environment do
  # In-place replacement for internal relative links
  updater = BlogPostMassUpdater.new
  updater.replace_relative_links!
end

task blog_post_get_internal_redirects: :environment do
  # Printout of all internal relative redirects
  updater = BlogPostMassUpdater.new
  updater.get_internal_redirects
end

task blog_post_replace_internal_redirects: :environment do
  # In-place replacement for internal relative links that are redirected
  updater = BlogPostMassUpdater.new
  updater.replace_internal_redirects!
end

task blog_post_replace_images: :environment do
  # Replace all images in blog posts with our own uploads
  updater = BlogPostMassUpdater.new
  updater.replace_images!
end

task blog_post_replace_cta_links: :environment do
  # Replace all images in blog posts with our own uploads
  updater = BlogPostMassUpdater.new
  updater.replace_cta_links!
end
