namespace :migrate do
  task partials: :environment do

    Dir.mkdir("config/partials") unless File.directory?("config/partials")

    # Migrate The Partials
    Partial.find_each do |partial|
      data = {
        "legacy_id"  => partial.id,
        "partial"    => "_#{partial.name.downcase.tr ' ', '_'}",
        "name"       => partial.name,
        "key"        => partial.name.parameterize,
        "devs_only"  => partial.devs_only,
        "image"      => partial.image.try!(:url),
        "fields"     => partial.partial_fields.order(:order).map do |field|
          {
            "name"            => field.name,
            "mandatory"       => field.mandatory,
            "type"            => field.field_type,
            "character_limit" => field.char_limit,
            "placeholder"     => field.placeholder,
            "object_type"     => field.object_type,
            "key"             => "#{partial.name.parameterize}-#{field.name.parameterize}",
          }
        end,
      }
      File.write(
        Rails.root.join("config", "partials", "#{partial.name.parameterize}.yml"),
        data.to_yaml
      )
    end

  end

end
