class RemoteImageUploader
  @@filestack_client = FilestackClient.new(ENV["FILESTACK_API_KEY"])

  def initialize (category)
    @category = category
  end

  def upload_from_url!(image_url)
    p "*** Uploading: #{image_url}"
    filelink = @@filestack_client.upload(external_url: image_url, storage: 's3')
    image = Upload.new(image_params(filelink))

    if image.save
      image
    else
      image.errors.full_messages.each do |error|
        p "IMAGE UPLOAD ERROR: " + error
      end
    end
  end

  def upload_from_filepath!(filepath)
    p "*** Uploading: #{filepath}"
    filelink = @@filestack_client.upload(filepath: filepath, storage: 's3')
    image = Upload.new(image_params(filelink))

    if image.save
      image
    else
      image.errors.full_messages.each do |error|
        p "IMAGE UPLOAD ERROR: " + error
      end
    end
  end

  private

  def image_params(filelink)
    {
      upload_type: 'image',
      url: filelink.url,
      s3_url: filelink.metadata['key'],
      category: @category,
      uploaded_by: 1
    }
  end
end
