def testing_generate_configuration_command
  getting_page = true
  while getting_page
    page_info = STDIN.gets.chomp
    if %r{^/}.match?(page_info)
      page = Page.find_by(url: page_info)
      getting_page = false
    elsif page_info.to_i != 0
      page = Page.find_by(id: page_info)
      if page.present?
        getting_page = false
      else
        puts "\e[31mUh-oh, it looks like there isn't a page with ID #{page_info}. Please try again by entering either the page or the ID of the page.\e[0m"
      end
    else
      puts "\e[31mUh-oh we couldn't find a page with that info :/ (you entered #{page_info})\n\nPlease try again\e[0m\n\nWhat page would you like to test? (enter either the path or ID of the page)"
    end
  end

  Testing::ConfigurationGenerator.call(page.url)

  file_path = Rails.root.join("config", "testing", "page_definitions", "#{page.name.parameterize}.yml")
  puts "Awesome, a configuration file has been generated at #{file_path}"
  puts "Now in your tests, just enter the following command to generate the page:"
  puts "\e[32mTesting::PageGenerator.create_page('#{page.name.parameterize}')\e[0m"
end

namespace :testing do
  task generate_configuration: :environment do
    puts "Hey there, so you want to make a local page testable?\nGood news!\n\nI can do that for you no problem\n\nWhat page would you like to test? (enter either the path or ID of the page)"
    testing_generate_configuration_command
    puts "Would you like to generate another configuration? [Yn]"
    continue_generating_configurations = STDIN.gets.chomp
    while continue_generating_configurations.downcase == "y"
      puts "What page would you like to test? (enter either the path or ID of the page)"
      testing_generate_configuration_command
      puts "Would you like to generate yet another configuration? [Yn]"
      continue_generating_configurations = STDIN.gets.chomp
    end
    puts "Awesome! Have a great day :)"
  end
end
