task update_payments_faqs: :environment do
  faq_partial = Partial.find_by(name: "FAQ 7")
  faq_page_partials = faq_partial.page_partials
  faq_page_partial_fields = faq_page_partials.map(&:page_partial_fields).flatten.uniq
  updated_page_ids = []

  questions_replacement_map = [
    {
      old: "What happens if I cannot set up direct payouts via Stripe Connect or PayPal?",
      new: "What happens if I cannot set up direct payouts via Teachable Payments, Stripe Connect or PayPal?"
    },
  ]

  faq_page_partial_fields.each do |faq_ppf|
    questions_replacement_map.each do |replacement|
      if faq_ppf.value == replacement[:old]
        faq_ppf.update!(value: replacement[:new])
        updated_page_ids << faq_ppf.page.id
      end
    end
  end

  answers_replacement_map = [
    {
      question: "When do I get paid?",
      answer: "If you're using any custom payment gateway (available on Professional and above) or Teachable Payments, payouts will be distributed daily or based on your selected payout cadence, within an initial two day trailing lag. When using the Monthly Payment gateway, you'll be paid out at the beginning of each month for purchases made at least 30 days ago. For example, if one student pays you on March 5, and another pays you on March 25, you’ll receive both students’ payments at the beginning of May. This system allows us enough time to honor our 30-day refund policy."
    },

    {
      question: "Who pays my affiliates and authors out?",
      answer: "If you have custom payment gateway(s) enabled or BackOffice disabled, you are responsible for paying authors and affiliates out. If you use BackOffice, we will automatically pay out your authors and affiliates, send them the necessary tax forms at the end of the year, and take care of all the reporting."
    },

    {
      question: "What happens if I cannot set up direct payouts via Teachable Payments, Stripe Connect or PayPal?",
      answer: "If you cannot set up Teachable Payments or custom payment gateways (available on Professional plan or above), Teachable can collect funds for you and pay you on our regular payment schedule.
      \n\nWhen using the Monthly Payment Gateway, there is a processing fee of 2.9% + 30¢ for US transactions. For international transactions, there is an additional 1% fee for credit and debit cards, and 1.5% fee for PayPal. These are standard rates cha
rged by Stripe & PayPal. Additionally, you’re charged a transaction fee that varies based on your plan:
\n
\n*   Free: $1 + 10%
\n*   Basic: 5%
\n*   Professional: 0%
\n*   Business: 0%"
    },

    {
      question: "Do I need a payment processor?",
      answer: "Teachable handles the payment processing for you, so you don’t need a separate processor. We accept credit card, debit card, and PayPal."
    }
  ]

  faq_page_partials.each do |faq_pp|
    faq_page_partial_fields = faq_pp.page_partial_fields
    faq_page_partial_fields.each_with_index do |faq_ppf, i|
      answers_replacement_map.each do |replacement|
        if faq_ppf.value == replacement[:question]
          faq_page_partial_fields[i + 1].update!(value: replacement[:answer])
          updated_page_ids << faq_ppf.page.id
        end
      end
    end
  end

  p "SPOT CHECKS: "
  updated_page_ids.each { |id| p "UPDATED PAGE ID: #{id}" }
end
