Wistia.plugin('automated-player', function (video, options) {
  video.bind('pause', function () {
    if (video.state() == 'paused') {
      video.play();
    }
  });

  var offers = JSON.parse(video.options.plugin['automated-player'].offers);

  var styles = `
  @font-face {
    font-family: 'Basis-Grotesque-Regular';
    font-display: swap;
    font-weight: 400;
    font-style: normal;
    src: url("//d2oz8i5n9se8ej.cloudfront.net/fonts/basis-grotesque/basis-grotesque-regular-pro.eot");
    src: url("//d2oz8i5n9se8ej.cloudfront.net/fonts/basis-grotesque/basis-grotesque-regular-pro.woff") format("woff"),
      url("//d2oz8i5n9se8ej.cloudfront.net/fonts/basis-grotesque/basis-grotesque-regular-pro.woff2") format("woff2");
  }

  @font-face {
    font-family: 'Basis-Grotesque-Medium';
    font-display: swap;
    font-weight: 600;
    font-style: normal;
    src: url("//d2oz8i5n9se8ej.cloudfront.net/fonts/basis-grotesque/basis-grotesque-medium-pro.eot");
    src: url("//d2oz8i5n9se8ej.cloudfront.net/fonts/basis-grotesque/basis-grotesque-medium-pro.woff") format("woff"),
      url("//d2oz8i5n9se8ej.cloudfront.net/fonts/basis-grotesque/basis-grotesque-medium-pro.woff2") format("woff2");
  }

    #${video.grid.bottom.id} {
      justify-content: space-evenly;
      display: flex;
      flex-direction: row;
    }

    .offers-container {
      color: rgb(34, 34, 34);
      width: 180px;
      margin-left: 10px;
      margin-bottom: 10px;
      font-family: 'Basis-Grotesque-Regular';
      background-color: rgba(248, 250, 244);
    }

    .offers-container-below.offers-container {
      width: 200px;
      margin-bottom: 0px;
      margin-left: 0px;
      margin-top: 10px;
    }

    .offers-container-below.offer-container {
      padding-left: initial;
      padding-top: initial;
      padding-bottom: initial;
      margin-left: 5px;
      margin-right: 5px;
    }

    .offers-container-below hr {
      display: none;
    }

    .offers-container-below .offer-header {
      font-size: 1.2em;
    }

    .offers-container-below .offer-description {
      font-size: 0.9em;
    }

    .offers-container-below .offer-cta {
      font-size: 0.9em;
    }

    .offers-container hr {
      border: rgba(0,0,0,0.15) solid 1px;
      width: 50%;
      margin: 10px 25% 0 25%;
      padding-left: 20px;
    }

    .offer-container {
      padding-left: 20px;
      padding-right: 20px;
      padding-top: 5px;
      padding-bottom: 5px;
      text-align: center;
    }

    .offer-cta {
      cursor: pointer;
    }

    .link {
      color: rgb(255, 255, 255);
    }

    .green-button {
      align-items: flex-start;
      background-color: rgb(27, 73, 66);
      border-bottom-color: rgb(255, 255, 255);
      border-bottom-left-radius: 100px;
      border-bottom-right-radius: 100px;
      border-bottom-style: none;
      border-bottom-width: 0px;
      border-image-outset: 0px;
      border-image-repeat: stretch;
      border-image-slice: 100%;
      border-image-source: none;
      border-image-width: 1;
      border-left-color: rgb(255, 255, 255);
      border-left-style: none;
      border-left-width: 0px;
      border-right-color: rgb(255, 255, 255);
      border-right-style: none;
      border-right-width: 0px;
      border-top-color: rgb(255, 255, 255);
      border-top-left-radius: 100px;
      border-top-right-radius: 100px;
      border-top-style: none;
      border-top-width: 0px;
      box-shadow: none;
      color: rgb(255, 255, 255);
      cursor: pointer;
      display: block;
      font-family: Basis-Grotesque-Regular;
      font-size: 18px;
      font-stretch: 100%;
      font-style: normal;
      font-variant-caps: normal;
      font-variant-east-asian: normal;
      font-variant-ligatures: normal;
      font-variant-numeric: normal;
      font-weight: 400;
      letter-spacing: normal;
      line-height: 25.7143px;
      margin-bottom: 10px;
      outline-color: rgb(255, 255, 255);
      outline-style: none;
      outline-width: 0px;
      overflow-x: visible;
      overflow-y: visible;
      padding-bottom: 10px;
      padding-top: 10px;
      right: 0px;
      text-align: center;
      text-decoration-color: rgb(255, 255, 255);
      text-decoration-line: none;
      text-decoration-style: solid;
      text-indent: 0px;
      text-rendering: auto;
      text-shadow: none;
      text-size-adjust: 100%;
      text-transform: none;
      word-spacing: 0px;
      writing-mode: horizontal-tb;
      -webkit-appearance: none;
      -webkit-font-smoothing: antialiased;
      -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
      -webkit-border-image: none;
    }

    .orange-button {
      align-items: flex-start;
      background-color: rgb(34, 34, 34);
      border-bottom-color: rgb(255, 255, 255);
      border-bottom-left-radius: 100px;
      border-bottom-right-radius: 100px;
      border-bottom-style: none;
      border-bottom-width: 0px;
      border-image-outset: 0px;
      border-image-repeat: stretch;
      border-image-slice: 100%;
      border-image-source: none;
      border-image-width: 1;
      border-left-color: rgb(255, 255, 255);
      border-left-style: none;
      border-left-width: 0px;
      border-right-color: rgb(255, 255, 255);
      border-right-style: none;
      border-right-width: 0px;
      border-top-color: rgb(255, 255, 255);
      border-top-left-radius: 100px;
      border-top-right-radius: 100px;
      border-top-style: none;
      border-top-width: 0px;
      box-shadow: none;
      color: rgb(255, 255, 255);
      cursor: pointer;
      display: block;
      font-family: Basis-Grotesque-Regular;
      font-size: 18px;
      font-stretch: 100%;
      font-style: normal;
      font-variant-caps: normal;
      font-variant-east-asian: normal;
      font-variant-ligatures: normal;
      font-variant-numeric: normal;
      font-weight: 400;
      letter-spacing: normal;
      line-height: 25.7143px;
      margin-bottom: 10px;
      outline-color: rgb(255, 255, 255);
      outline-style: none;
      outline-width: 0px;
      overflow-x: visible;
      overflow-y: visible;
      padding-bottom: 10px;
      padding-top: 10px;
      right: 0px;
      text-align: center;
      text-decoration-color: rgb(255, 255, 255);
      text-decoration-line: none;
      text-decoration-style: solid;
      text-indent: 0px;
      text-rendering: auto;
      text-shadow: none;
      text-size-adjust: 100%;
      text-transform: none;
      word-spacing: 0px;
      writing-mode: horizontal-tb;
      -webkit-appearance: none;
      -webkit-font-smoothing: antialiased;
      -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
      -webkit-border-image: none;
    }
  `;

  var addStyles = function (styles) {
    /* Create style element */
    var css = document.createElement('style');
    css.type = 'text/css';

    if (css.styleSheet) {
      css.styleSheet.cssText = styles;
    }
    else {
      css.appendChild(document.createTextNode(styles));
    }
    /* Append style to the head element */
    document.getElementsByTagName("head")[0].appendChild(css);
  }

  var renderOfferHeader = function (title) {
    let offerHeaderElem = document.createElement('h2');
    offerHeaderElem.classList.add('offer-header')
    offerHeaderElem.innerText = title.replace(/\+/g, ' ');
    return offerHeaderElem
  }

  var renderOfferDescription = function (description) {
    let offerDescriptionElem = document.createElement('p');
    offerDescriptionElem.classList.add('offer-description');
    offerDescriptionElem.innerText = description.replace(/\+/g, ' ');
    return offerDescriptionElem;
  }

  var clickedOffer = function (event) {
    var offerId = event.target.dataset.offerId
    window.parent.postMessage(`offer-clicked:${offerId}`, video._attrs.pageUrl)
  }

  var renderOfferCta = function (offer) {
    let offerCtaElem = document.createElement('a');
    offerCtaElem.classList.add('offer-cta')
    offerCtaElem.classList.add(offer.cta_button_type.replace(/_/g, '-'))
    offerCtaElem.href = offer.cta_url;
    offerCtaElem.target = '_blank'

    offerCtaElem.innerText = offer.cta_button_text.replace(/\+/g, ' ');
    offerCtaElem.setAttribute('data-offer-id', offer.id)
    offerCtaElem.addEventListener('click', clickedOffer)
    return offerCtaElem
  }

  var renderOffer = function (offer) {
    let offerElem = document.createElement('div');
    offerElem.classList.add('offer-container')

    offerElem.appendChild(renderOfferHeader(offer.title))
    offerElem.appendChild(renderOfferDescription(offer.description))
    offerElem.appendChild(renderOfferCta(offer))

    return offerElem
  }

  addStyles(styles)

  offers.map((offer) => {
    video.bind('betweentimes', offer.start_time, offer.start_time + offer.duration, function (withinInterval) {
      if (withinInterval) {
        var myElem = document.createElement('div');
        if (video._attrs.startingWidth >= 767) {
          myElem.classList.add('offers-container')
          myElem.setAttribute('id', `offer-${offer.id}`)
          var myOffer = renderOffer(offer)
          myElem.appendChild(myOffer)
          video.grid.right.appendChild(myElem);
          video.fit();
        } else {
          myElem.classList.add('offers-container')
          myElem.classList.add('offers-container-below')
          myElem.setAttribute('id', `offer-${offer.id}`)
          var myOffer = renderOffer(offer)
          myElem.appendChild(myOffer)
          video.grid.bottom.appendChild(myElem);
          window.parent.postMessage("offer-displayed-below", video._attrs.pageUrl)
        }
        window.parent.postMessage(`offer-displayed:${offer.id}`, video._attrs.pageUrl)
      } else {
        document.getElementById(`offer-${offer.id}`).remove()
        if (document.getElementsByClassName("offers-container").length === 0 && video._attrs.startingWidth < 767) {
          window.parent.postMessage("offers-not-displayed-below", video._attrs.pageUrl)
        }
        video.fit();
      }
    });
  })

  video.bind('end', function () {
    var redirectUrl = video.options.plugin['automated-player'].postRedirectUrl;
    if (redirectUrl) {
      window.parent.location = redirectUrl;
    }
  });
})