# frozen_string_literal: true

FactoryBot.define do
  factory :tracking_link do
    sequence :slug do |n|
      "example-slug-#{n}"
    end
    status { "draft" }
    sequence :destination_url do |n|
      "https://example.com/destination-path-#{n}"
    end
    association :creator, factory: :user
  end

  trait :published do
    status { "published" }
    published_at { Time.now }
    association :publisher, factory: :user

  end

  trait :hidden do
    status { "hidden" }
    published_at { Time.now }
    hidden_at { Time.now }
    association :publisher, factory: :user
    association :hider, factory: :user
  end

end
