FactoryBot.define do
  factory :webinar do
    name                { "Quickstart" }
    title               { "Teachable Quickstart Webinar" }
    url                 { "quickstart" }
    time                { Time.now }
    recurring           { true }
    recurring_info      { "Every Thursday at 2pm" }
    recurrence          { "---\n:every: :week\n:day:\n- 4\n:at:\n- - 14\n  - 0\n:on: :thursday\n" }
    bullet_points       { "- The easiest way to create your own online school and set up your first course using Teachable (without any of the technical headaches)\n- How to use Teachable to accept payments and make money by teaching your own online course\n- How to create a beautiful school that 100% matches your brand by adding your own logo, images, colors, and page elements with our easy to use page editor\n- LIVE Q&A with Cameron to answer every question you have about creating, promoting, and profiting from online courses" }
    time2               { nil }
    header              { "Teachable quickstart webinar" }
    subheader           { "Learn the exact steps you can take to create your own professional online school and start making money" }
    thank_you_video_id  { "fcjtl0zjw3" }
    upgrade_timeframe   { "monthly" }
    basic_replay_bundle { 605 }
    basic_play_bundle   { 606 }
    pro_replay_bundle   { 607 }
    pro_play_bundle     { nil }
    replay_video_id     { "rp4hwyazi1" }
  end
end


# Example Webinar Attributes

# {
#   "id"                  => 2,
#   "name"                => "Quickstart",
#   "title"               => "Teachable Quickstart Webinar",
#   "url"                 => "quickstart",
#   "time"                => Sat, 01 Jan 2000 00:00:00 EST -05:00,
#   "recurring"           => true,
#   "recurring_info"      => "Every Thursday at 2pm",
#   "recurrence"          => "---\n:every: :week\n:day:\n- 4\n:at:\n- - 14\n  - 0\n:on: :thursday\n",
#   "bullet_points"       => "- The easiest way to create your own online school and set up your first course using Teachable (without any of the technical headaches)\n- How to use Teachable to accept payments and make money by teaching your own online course\n- How to create a beautiful school that 100% matches your brand by adding your own logo, images, colors, and page elements with our easy to use page editor\n- LIVE Q&A with Cameron to answer every question you have about creating, promoting, and profiting from online courses",
#   "time2"               => nil,
#   "header"              => "Teachable quickstart webinar",
#   "subheader"           => "Learn the exact steps you can take to create your own professional online school and start making money",
#   "thank_you_video_id"  => "fcjtl0zjw3",
#   "upgrade_timeframe"   => "monthly",
#   "basic_replay_bundle" => 605,
#   "basic_play_bundle"   => 606,
#   "pro_replay_bundle"   => 607,
#   "pro_play_bundle"     => nil,
#   "replay_video_id"     => "rp4hwyazi1"
# }
