require "rails_helper"

RSpec.describe BannerField, type: :model do

  describe "validations and relations" do
    it { should validate_presence_of(:banner_field_key) }
    it { should validate_presence_of(:banner_id) }
    it { should belong_to(:banner) }
    subject { create(:banner_field, banner: create(:banner), banner_field_key: Banner.keys.first) }
    it {
      is_expected.to validate_uniqueness_of(:banner_field_key).scoped_to(:banner_id)
                                                              .with_message("cannot have duplicate banner fields for a single banner/banner field key")
    }
  end

end
