require "rails_helper"

RSpec.describe TrackingLinkRedirectEvent, type: :model do

  context "validations" do

    it { is_expected.to validate_length_of(:referrer).is_at_most(2083) }
    it { is_expected.to validate_length_of(:request_url).is_at_most(2083) }
    it { is_expected.to validate_length_of(:request_url).is_at_most(2083) }
    it { is_expected.to validate_presence_of(:anonymous_id) }
    it { is_expected.to validate_presence_of(:redirect_url) }
    it { is_expected.to validate_presence_of(:redirected_at) }
    it { is_expected.to validate_presence_of(:request_url) }
    it { is_expected.to validate_presence_of(:visitor_ip) }
  end

  context "associations" do
    it { is_expected.to belong_to(:tracking_link) }
    it { is_expected.to belong_to(:cms_user).with_foreign_key(:cms_user_id).class_name("User") }
  end

  context "immutability" do
    it { is_expected.to have_readonly_attribute(:anonymous_id) }
    it { is_expected.to have_readonly_attribute(:created_at) }
    it { is_expected.to have_readonly_attribute(:redirect_url) }
    it { is_expected.to have_readonly_attribute(:id) }
    it { is_expected.to have_readonly_attribute(:referrer) }
    it { is_expected.to have_readonly_attribute(:request_url) }
    it { is_expected.to have_readonly_attribute(:redirected_at) }
    it { is_expected.to have_readonly_attribute(:tracking_link_id) }
    it { is_expected.to have_readonly_attribute(:visitor_ip) }
    it { is_expected.to have_readonly_attribute(:visitor_user_agent) }
  end
end
