module BonusFabricators

  def generate_bonuses_for(upgrade_src)
    template                       = create(:template, name: "Page Bonus Bundle")
    upgrade_src_field              = create(:field, id: 95, name: "Upgrade Src", template_id: template.id, field_type: "text", char_limit: 30, order: 0)
    timeframe_field                = create(:field, name: "Timeframe",   template_id: template.id, field_type: "text", char_limit: 30, order: 1)
    basic_bonus_1_field            = create(:field, name: "Basic Bonus 1", template_id: template.id, field_type: "object", char_limit: 0, object_type: "Bonus", order: 2)
    basic_bonus_2_field            = create(:field, name: "Basic Bonus 2", template_id: template.id, field_type: "object", char_limit: 0, object_type: "Bonus", order: 3)

    objekt                         = create(:objekt, template_id: template.id)
    bonus_image                    = create(:upload, url: "https://cdn.filepicker.io/api/file/aMFkCABdRW6PR19u7oEJ")
    bonus_template                 = create(:template, image_id: bonus_image.id)
    bonus_1_objekt                 = create(:objekt, template_id: bonus_template.id)
    bonus_2_objekt                 = create(:objekt, template_id: bonus_template.id)

    name_field                     = create(:field, name: "Name", template_id: bonus_template.id, field_type: "text", char_limit: 25, object_type: "", order: 0)
    desc_field                     = create(:field, name: "Description", template_id: bonus_template.id, field_type: "text", char_limit: 25, object_type: "", order: 1)
    value_field                    = create(:field, name: "Value", template_id: bonus_template.id, field_type: "number", char_limit: 25, object_type: "", order: 2)
    course_id_field                = create(:field, name: "Course ID", template_id: bonus_template.id, field_type: "number", char_limit: 25, object_type: "", order: 3)
    image_field                    = create(:field, name: "Image", template_id: bonus_template.id, field_type: "image", char_limit: 25, object_type: "", order: 4)
    icon_field                     = create(:field, name: "Icon", template_id: bonus_template.id, field_type: "image", char_limit: 25, object_type: "", order: 5)

    bonus_1_name_objekt_field      = create(:objekt_field, field_id: name_field.id, value: "The Profitable Teacher", objekt_id: bonus_1_objekt.id)
    bonus_1_desc_objekt_field      = create(:objekt_field, field_id: desc_field.id, value: "Teachable’s flagship program explaining our 7-step process to create \u0026 launch a course", objekt_id: bonus_1_objekt.id)
    bonus_1_value_objekt_field     = create(:objekt_field, field_id: value_field.id, value: "348", objekt_id: bonus_1_objekt.id)
    bonus_1_course_id_objekt_field = create(:objekt_field, field_id: course_id_field.id, value: "48971", objekt_id: bonus_1_objekt.id)
    bonus_1_image_objekt_field     = create(:objekt_field, field_id: image_field.id, value: bonus_image.id.to_s, objekt_id: bonus_1_objekt.id)
    bonus_1_icon_objekt_field      = create(:objekt_field, field_id: icon_field.id, value: bonus_image.id.to_s, objekt_id: bonus_1_objekt.id)

    bonus_2_name_objekt_field      = create(:objekt_field, field_id: name_field.id, value: "Course Creation Workshop Series", objekt_id: bonus_2_objekt.id)
    bonus_2_desc_objekt_field      = create(:objekt_field, field_id: desc_field.id, value: "11 on-demand replays from the 2016 Teachable Summit, starring 28 speakers, like Pat Flynn \u0026 Mariah Coz", objekt_id: bonus_2_objekt.id)
    bonus_2_value_objekt_field     = create(:objekt_field, field_id: value_field.id, value: "199", objekt_id: bonus_2_objekt.id)
    bonus_2_course_id_objekt_field = create(:objekt_field, field_id: course_id_field.id, value: "124323", objekt_id: bonus_2_objekt.id)
    bonus_2_image_objekt_field     = create(:objekt_field, field_id: image_field.id, value: bonus_image.id.to_s, objekt_id: bonus_2_objekt.id)
    bonus_2_icon_objekt_field      = create(:objekt_field, field_id: icon_field.id, value: bonus_image.id.to_s, objekt_id: bonus_2_objekt.id)

    upgrade_objekt_field           = create(:objekt_field, field_id: upgrade_src_field.id, value: upgrade_src, objekt_id: objekt.id)
    timeframe_objekt_field         = create(:objekt_field, field_id: timeframe_field.id, value: "Monthly", objekt_id: objekt.id)
    basic_bonus_1_objekt_field     = create(:objekt_field, field_id: basic_bonus_1_field.id, value: bonus_1_objekt.id, objekt_id: objekt.id)
    basic_bonus_2_objekt_field     = create(:objekt_field, field_id: basic_bonus_2_field.id, value: bonus_2_objekt.id, objekt_id: objekt.id)
  end

  def generate_bonuses_for_webinar(upgrade_src)
    # image (used for bonus)
    bonus_image                    = create(:upload, url: "https://cdn.filepicker.io/api/file/aMFkCABdRW6PR19u7oEJ")

    # bonus template/fields
    bonus_template                 = create(:template, image_id: bonus_image.id)
    name_field                     = create(:field, name: "Name", template_id: bonus_template.id, field_type: "text", char_limit: 25, object_type: "", order: 0)
    desc_field                     = create(:field, name: "Description", template_id: bonus_template.id, field_type: "text", char_limit: 25, object_type: "", order: 1)
    value_field                    = create(:field, name: "Value", template_id: bonus_template.id, field_type: "number", char_limit: 25, object_type: "", order: 2)
    course_id_field                = create(:field, name: "Course ID", template_id: bonus_template.id, field_type: "number", char_limit: 25, object_type: "", order: 3)
    image_field                    = create(:field, name: "Image", template_id: bonus_template.id, field_type: "image", char_limit: 25, object_type: "", order: 4)
    icon_field                     = create(:field, name: "Icon", template_id: bonus_template.id, field_type: "image", char_limit: 25, object_type: "", order: 5)

    # bonus object
    bonus_1_objekt                 = create(:objekt, template_id: bonus_template.id)
    bonus_1_name_objekt_field      = create(:objekt_field, field_id: name_field.id, value: "The Profitable Teacher", objekt_id: bonus_1_objekt.id)
    bonus_1_desc_objekt_field      = create(:objekt_field, field_id: desc_field.id, value: "Teachable’s flagship program explaining our 7-step process to create \u0026 launch a course", objekt_id: bonus_1_objekt.id)
    bonus_1_value_objekt_field     = create(:objekt_field, field_id: value_field.id, value: "348", objekt_id: bonus_1_objekt.id)
    bonus_1_course_id_objekt_field = create(:objekt_field, field_id: course_id_field.id, value: "48971", objekt_id: bonus_1_objekt.id)
    bonus_1_image_objekt_field     = create(:objekt_field, field_id: image_field.id, value: bonus_image.id.to_s, objekt_id: bonus_1_objekt.id)
    bonus_1_icon_objekt_field      = create(:objekt_field, field_id: icon_field.id, value: bonus_image.id.to_s, objekt_id: bonus_1_objekt.id)

    # bundle template/fields
    bundle_template                = create(:template, name: "Webinar Bonus Bundle")
    upgrade_src_field              = create(:field, id: 95, name: "Upgrade Src", template_id: bundle_template.id, field_type: "text", char_limit: 30, order: 0)
    timeframe_field                = create(:field, name: "Timeframe",   template_id: bundle_template.id, field_type: "text", char_limit: 30, order: 1)
    basic_bonus_1_field            = create(:field, name: "Basic Bonus 1", template_id: bundle_template.id, field_type: "object", char_limit: 0, object_type: "Bonus", order: 2)

    # bundle object
    bundle_objekt                  = create(:objekt, template_id: bundle_template.id)
    upgrade_objekt_field           = create(:objekt_field, field_id: upgrade_src_field.id, value: upgrade_src, objekt_id: bundle_objekt.id)
    timeframe_objekt_field         = create(:objekt_field, field_id: timeframe_field.id, value: "Monthly", objekt_id: bundle_objekt.id)
    basic_bonus_1_objekt_field     = create(:objekt_field, field_id: basic_bonus_1_field.id, value: bonus_1_objekt.id, objekt_id: bundle_objekt.id)

    # webinar
    webinar                        = create(:webinar, url: upgrade_src, time: Time.now + 2.days, basic_replay_bundle: bundle_objekt.id, pro_replay_bundle: nil, basic_play_bundle: nil, pro_play_bundle: nil)
  end

end
