# coding: utf-8
DatabaseCleaner.clean_with :truncation

# Images I use a bunch:
Image.create(url: "https://cdn.filepicker.io/api/file/OyZcujDrS9Opk7iqiHsz", image_type: "page_partial", uploaded_by: 1)

Image.create(url: "https://cdn.filepicker.io/api/file/l4aann0URQqCHn7MgCij", image_type: "user", uploaded_by: 1)
User.create(name: "Peter Lemiszki", email: "peter@teachable.com", password: "password", title: "Front End Developer", team_id: 1, permission_id: 1, image_id: Image.all.length)

Image.create(url: "https://cdn.filepicker.io/api/file/cCKIfiieSTasZ8ZoJoGE", image_type: "user", uploaded_by: 1)
User.create(name: "Jackson Riso", email: "jackson@teachable.com", password: "password", title: "Growth and Marketing Manager", team_id: 1, permission_id: 1, image_id: Image.all.length)

Image.create(url: "https://cdn.filepicker.io/api/file/fYP1kQ3QyMvb4Py02QYd", image_type: "user", uploaded_by: 1)
User.create(name: "Allison Haag", email: "allison@teachable.com", password: "password", title: "Designer", team_id: 1, permission_id: 3, image_id: Image.all.length)

Team.create(name: "Growth")
Team.create(name: "Customer care")
Team.create(name: "Engineering")
Team.create(name: "Executive")

# Privilege.create(name: "Create/edit/publish/archive pages")
# Privilege.create(name: "Upload images & PDFs")
# Privilege.create(name: "Create new data object (benefit, bonus, testimonial, etc.)")
# Privilege.create(name: "Make changes to templates")
# Privilege.create(name: "Add new web page sections")
Privilege.create(name: "Update your name, email, and title")
Privilege.create(name: "Update your team")
Privilege.create(name: "Add/edit/delete users")
Privilege.create(name: "Add/edit/delete administrators")
Privilege.create(name: "Add/edit/delete super administrators")

Permission.create(name: "Super administrator", level: 3)
  PermissionPrivilege.create(permission_id: 1, privilege_id: 1)
  PermissionPrivilege.create(permission_id: 1, privilege_id: 2)
  PermissionPrivilege.create(permission_id: 1, privilege_id: 3)
  PermissionPrivilege.create(permission_id: 1, privilege_id: 4)
  PermissionPrivilege.create(permission_id: 1, privilege_id: 5)

Permission.create(name: "Administrator", level: 2)
  PermissionPrivilege.create(permission_id: 2, privilege_id: 1)
  PermissionPrivilege.create(permission_id: 2, privilege_id: 2)
  PermissionPrivilege.create(permission_id: 2, privilege_id: 3)

Permission.create(name: "User", level: 1)
  PermissionPrivilege.create(permission_id: 3, privilege_id: 1)

Permission.create(name: "No access", level: 0)

HeaderType.create!(name: "Small Green", order: 0)
HeaderType.create!(name: "Large Black", order: 1)

Image.create(url: "https://cdn.filepicker.io/api/file/T3F7L4PTPWdiC55gdZTw", image_type: "template", uploaded_by: 1)
Template.create(name: "Bonus", image_id: Image.all.length)
  Field.create(template_id: 1, name: "Name", field_type: "text", char_limit: 25, mandatory: true, order: 0) #1

Image.create(url: "https://cdn.filepicker.io/api/file/HdIZaq3cRUaYsK4wu6oa", image_type: "template", uploaded_by: 1)
Template.create(name: "School", image_id: Image.all.length)
  Field.create(template_id: 2, name: "School Name", field_type: "text", char_limit: 100, mandatory: true, order: 0) #2
  Field.create(template_id: 2, name: "Creator Name", field_type: "text", char_limit: 100, mandatory: true, order: 1) #3
  Field.create(template_id: 2, name: "Creator Image", field_type: "image", order: 2) #4
  Field.create(template_id: 2, name: "Creator Testimonial", field_type: "text", char_limit: 300, order: 3) #5
  Field.create(template_id: 2, name: "School Url", field_type: "text", char_limit: 100, order: 4) #6
  Field.create(template_id: 2, name: "Large School Image", field_type: "image", order: 5) #7
  Field.create(template_id: 2, name: "Creator Card Image", field_type: "image", order: 6) #8

# Add Fields to Bonus
  Field.create!(template_id: 1, name: "Image", field_type: "image", order: 1) #9
  Field.create!(template_id: 1, name: "Description", field_type: "text", char_limit: 200, order: 2) #10
  Field.create!(template_id: 1, name: "Value", field_type: "number", order: 3) #11

Image.create(url: "https://cdn.filepicker.io/api/file/MjfPRPVRSAuktEXCuALV", image_type: "template", uploaded_by: 1)
Template.create(name: "Testimonial", image_id: Image.all.length)
  Field.create(template_id: 3, name: "School", field_type: "object", object_type: "School", mandatory: true, order: 1) #12
  Field.create(template_id: 3, name: "Text", field_type: "text", char_limit: 500, mandatory: true, order: 0) #13

# Remove Testimonial Field from School
  Field.find(5).destroy!

# Add Field to School
  Field.create!(template_id: 2, name: "Blurb", field_type: "text", char_limit: 500, order: 6) #14

# OBJECT INSTANCES ---
Objekt.create(template_id: 2) #1
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "melyssagriffin.com")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Melyssa Griffin")
Image.create(url: "https://cdn.filepicker.io/api/file/IgamM6IzTySKfgHAeNUV", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://courses.thenectarcollective.com")
Image.create(url: "https://cdn.filepicker.io/api/file/XKMKaKhXSniPF7Ok6xh3", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "")

Objekt.create(template_id: 2) #2
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Live. Write. Thrive.")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "CS Lakin")
Image.create(url: "https://cdn.filepicker.io/api/file/1Q8XrSq5SbWFgfqocPw2", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://cslakin.teachable.com")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: "")
Image.create(url: "https://cdn.filepicker.io/api/file/SQqL7NUVR8Ov0zJv7CC9", image_type: "object", uploaded_by: 1) #10
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "")

Objekt.create(template_id: 2) #3
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Smart Passive Income")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Pat Flynn")
Image.create(url: "https://cdn.filepicker.io/api/file/UQ2vDQcTQq88XYQlisDg", image_type: "object", uploaded_by: 1) #11
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "")
Image.create(url: "https://cdn.filepicker.io/api/file/IC5in4HlQB23O5MEj7nu", image_type: "object", uploaded_by: 1) #12
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "")

Objekt.create(template_id: 2) #4
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Annapurna Living")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Carrie-Anne Moss")
Image.create(url: "https://cdn.filepicker.io/api/file/feb8L5uhQUuXe8fni2b9", image_type: "object", uploaded_by: 1) #13
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://annapurna-living.teachable.com")
Image.create(url: "https://cdn.filepicker.io/api/file/Z3QPdrLTGmmSeeYPH4BG", image_type: "object", uploaded_by: 1) #14
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Actress Carrie-Anne Moss created classes on yoga, meditation, motherhood & conscious living")

Objekt.create(template_id: 2) #5
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Every Tuesday")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Teela Cunningham")
Image.create(url: "https://cdn.filepicker.io/api/file/jRczQFwrTHGEeyIgTWJG", image_type: "object", uploaded_by: 1) #15
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://courses.every-tuesday.com/p/brush-lettering-with-watercolor")
Image.create(url: "https://cdn.filepicker.io/api/file/mbaJa7jMTsmjYCbjXK2I", image_type: "object", uploaded_by: 1) #16
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Discover your unique style and create beautiful brush lettering with watercolor")

Objekt.create(template_id: 2) #6
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Sketch Master")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Peter Nowell")
Image.create(url: "https://cdn.filepicker.io/api/file/jT5L8vR1qWrKfiUg3gCQ", image_type: "object", uploaded_by: 1) #17
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "")
Image.create(url: "https://cdn.filepicker.io/api/file/gAr2mYNQUGZz9mk23EMa", image_type: "object", uploaded_by: 1) #18
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Training courses to master the most popular screen-based design tool: Sketch")

Objekt.create(template_id: 2) #7
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "UAV Coach")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Alan Perlman")
Image.create(url: "https://cdn.filepicker.io/api/file/7xttxlETVOIUtnNtDWC5", image_type: "object", uploaded_by: 1) #19
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://learn.uavcoach.com")
Image.create(url: "https://cdn.filepicker.io/api/file/aw0n2GJiScSD4HqiAtCf", image_type: "object", uploaded_by: 1) #20
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "A community of 40k+ drone pilots that offers online training in drone flight, cinematography & more")

Objekt.create(template_id: 2) #8
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Julie Stoian")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Julie Stoian")
Image.create(url: "https://cdn.filepicker.io/api/file/HfVh1POeQCaTQbrr0D3r", image_type: "object", uploaded_by: 1) #21
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://school.juliestoian.com")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: "")
Image.create(url: "https://cdn.filepicker.io/api/file/pLEdRQsqT2O1TZvVOHQS", image_type: "object", uploaded_by: 1) #22
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "")

Objekt.create(template_id: 2) #9
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Wham Bam Instagram")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Caitlin Bacher")
Image.create(url: "https://cdn.filepicker.io/api/file/9SJM97BR3zTSZVr6nXHg", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "")

Objekt.create(template_id: 2) #10
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Self Publishing Formula")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "James Blatch")
Image.create(url: "https://cdn.filepicker.io/api/file/cMBKDiiNTpKZ6w3IVilX", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "https://selfpublishingformula.com")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "")

Objekt.create(template_id: 2) #11
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Femtrepreneur")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Mariah Coz")
Image.create(url: "https://cdn.filepicker.io/api/file/nbeXPoKQyMj5EKJhEpwg", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "https://www.femtrepreneur.co")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "")

# Bonuses:

Objekt.create(template_id: 1) #12
ObjektField.create(objekt_id: Objekt.all.length, field_id: 1, value: "The Profitable Teacher")
Image.create(url: "https://cdn.filepicker.io/api/file/tgNXP39TkubUpEJKnANQ", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 9, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 10, value: "Teachable’s flagship program explaining our 7-step process to create & launch a course")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 11, value: "348")

Objekt.create(template_id: 1) #13
ObjektField.create(objekt_id: Objekt.all.length, field_id: 1, value: "Course Creation Workshop Series")
Image.create(url: "https://cdn.filepicker.io/api/file/QArAQlX9QDaY5xu2iTqp", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 9, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 10, value: "11 on-demand replays from the 2016 Teachable Summit, starring 28 speakers, like Pat Flynn & Mariah Coz")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 11, value: "199")

Objekt.create(template_id: 1) #14
ObjektField.create(objekt_id: Objekt.all.length, field_id: 1, value: "Studio Setup Cheatsheet")
Image.create(url: "https://cdn.filepicker.io/api/file/0Tj0d2RTRxOdFyJ1bdCo", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 9, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 10, value: "Our DIY guide for building your own in-home video studio without the expensive equipment")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 11, value: "19")

Objekt.create(template_id: 1) #15
ObjektField.create(objekt_id: Objekt.all.length, field_id: 1, value: "Concierge onboarding")
Image.create(url: "https://cdn.filepicker.io/api/file/xBYJWoaQS6Sacx4jplrH", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 9, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 10, value: "Two 1-hour sessions with an onboarding specialist who will help you setup your Teachable school")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 11, value: "300")

Objekt.create(template_id: 1) #16
ObjektField.create(objekt_id: Objekt.all.length, field_id: 1, value: "8 weeks of Q&A group training")
Image.create(url: "https://cdn.filepicker.io/api/file/gh30prBS2ifVSkwkJS1D", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 9, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 10, value: "Live coaching calls every Friday at 2pm ET to answer your questions about setting up your course")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 11, value: "300")

Objekt.create(template_id: 3) #17
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "1")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "I've used Teachable to sell hundreds of thousands of dollars in online courses. If you are thinking of creating your own online course, Teachable is the place to be.")

Objekt.create(template_id: 3) #18
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "2")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "What really has clinched it for me, why I chose Teachable, and why I love it and will continue to do my online courses with Teachable, is the great support that they have.")

Objekt.create(template_id: 3) #19
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "7")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "I was struggling to get my course off the ground, but I discovered Teachable and it was so easy to set everything up, great support team, and overall an awesome experience.")

Objekt.create(template_id: 3) #20
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "8")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "I went from creating small, inexpensive courses to large courses that resulted in 5-figure income months. This is the perfect solution for service-based entrepreneurs who want to scale their business.")

Objekt.create(template_id: 3) #21
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "9")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "Since launching my first course a year ago today, I have 10X'ed my revenue and have more freedom than ever.")

Objekt.create(template_id: 3) #22
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "10")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "We've generated $560,000 from our first two launches on Teachable.")

Objekt.create(template_id: 3) #23
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "10")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "It was important to us that our courses would look beautiful and that the software would be easy to use.")

Objekt.create(template_id: 3) #24
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "11")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "I know how tough it can be to decide what platform your business is going to be run on. We couldn’t be happier with our decision to use Teachable.")

Objekt.create(template_id: 3) #25
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "11")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "Our students just know that we’re providing an amazing, easy experience and they rave about it to us!")

Objekt.create(template_id: 3) #26
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "1")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "Teachable incorporates sales pages, so if you’re not a designer or developer, you don’t have to worry about creating a killer sales page.")

# More Schools

Objekt.create(template_id: 2) #27
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Digital Scrapbooking")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Jessica Sprague")
Image.create(url: "https://cdn.filepicker.io/api/file/6Owd2hlXSIuRnIvjZ6Ft", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://jessicasprague.teachable.com")
Image.create(url: "https://cdn.filepicker.io/api/file/iYWjXOvQkiZz6BT4sSHN", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Turn your memories into beautifully designed digital scrapbooks with Photoshop")

Objekt.create(template_id: 2) #28
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "VR Dev School")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Lee Wasilenko")
Image.create(url: "https://cdn.filepicker.io/api/file/2eudRNA0RvagaLi2IkOg", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://learn.vrdev.school")
Image.create(url: "https://cdn.filepicker.io/api/file/tu5XbvwTKGEHs5vETe3T", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Create amazing virtual reality games for Oculus Rift, HTC Vive, Gear VR & more")

Objekt.create(template_id: 2) #29
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Make Fabulous Cakes")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Darlene Abarquez")
Image.create(url: "https://cdn.filepicker.io/api/file/2wEzpNMzSU6g5mgoUyGe", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://learn.make-fabulous-cakes.com")
Image.create(url: "https://cdn.filepicker.io/api/file/c5w2yicQz6aw0tqRCbRD", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Create amazing virtual reality games for Oculus Rift, HTC Vive, Gear VR & more")

Objekt.create(template_id: 2) #30
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Creative Watercolor")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Angela Fehr")
Image.create(url: "https://cdn.filepicker.io/api/file/wb7zB8cjRECP2Ma4GF4b", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://learn.angelafehr.com/p/creativewatercolour")
Image.create(url: "https://cdn.filepicker.io/api/file/VKjQWNtKQeuGxSIzn4mb", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Angela introduced her 42k+ subscribers to courses on techniques & applications for watercolor painting")

Objekt.create(template_id: 2) #31
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "52Kards")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Asad Chaudhry")
Image.create(url: "https://cdn.filepicker.io/api/file/OIXa6YDxQ26g0HUz5XYw", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://courses.52kards.com/p/the-foundations-of-card-magic")
Image.create(url: "https://cdn.filepicker.io/api/file/kZdZh8tRNaxdFDg4eQM4", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "The largest YouTube channel on card magic created a complete lesson plan for learning the foundation of this craft")

Objekt.create(template_id: 2) #32
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Minute Physics")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Henry Reich")
Image.create(url: "https://cdn.filepicker.io/api/file/EiWV0hHeTjSDG1nN8zZy", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://course.minutephysics.com")
Image.create(url: "https://cdn.filepicker.io/api/file/dfvrANPYQPOlrTVgHniH", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "With 3.6M+ subscribers, Henry Reich created an online course that distills how the world works into 60 bite-size lessons")

Objekt.create(template_id: 2) #33
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Kinobody")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Greg O'Gallagher")
Image.create(url: "https://cdn.filepicker.io/api/file/PjL5PWM1Rx68hKytowxz", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://my.kinobody.com")
Image.create(url: "https://cdn.filepicker.io/api/file/V83H0m7zTPe8xHT1Q2Aj", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Community of over 280k with 7 different programs on fitness and weight loss")

Objekt.create(template_id: 2) #34
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "FMBS")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Ryan Leslie")
Image.create(url: "https://cdn.filepicker.io/api/file/MK5gcRrhSliLXNzopBYq", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://fmbs.biz")
Image.create(url: "https://cdn.filepicker.io/api/file/8AGC5Fc0SGGOIPlJViwk", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Ryan teaches you how to make 10x more money being an indie musician")

Objekt.create(template_id: 2) #35
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Online School of Blacksmithing")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Alec Steele")
Image.create(url: "https://cdn.filepicker.io/api/file/dhCNdF4dQPeH9FtDREcn", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://beginblacksmithing.com")
Image.create(url: "https://cdn.filepicker.io/api/file/OjM8TsLiQJOR6hzinaGI", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Everything you need to know about blacksmithing: from setting up your first forge to making your own tools")

Objekt.create(template_id: 2) #36
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "How to Freedive")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Pete Ryder")
Image.create(url: "https://cdn.filepicker.io/api/file/5YCOTacSAKT0FhOJCbPs", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://howtofreedive.com/p/the-10-meter-freediver")
Image.create(url: "https://cdn.filepicker.io/api/file/DUdPhZgdRMKlvyWgF9Wn", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Learn how to freedive to depths of up to 10 meters on just a single breath of air")

Objekt.create(template_id: 2) #37
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Clickminded")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Tommy Griffith")
Image.create(url: "https://cdn.filepicker.io/api/file/73rmjlfLQjqIU0rMo3Y7", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://www.clickminded.com")
Image.create(url: "https://cdn.filepicker.io/api/file/ka9dEigUSBW0stDDtCRy", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "How to drive more customers to your site with search engine optimization")

Objekt.create(template_id: 2) #38
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Growth Hacker Marketing")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Ryan Holiday")
Image.create(url: "https://cdn.filepicker.io/api/file/BoFef6zMRcunsGeulnr5", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://learn.ryanholiday.net")
Image.create(url: "https://cdn.filepicker.io/api/file/84MytENmQUivNt0K5CUR", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Based on a best-selling book. A primer on the Future of PR, Marketing, and Advertising")

Objekt.create(template_id: 2) #39
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "How to Write a Novel")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Joanna Penn")
Image.create(url: "https://cdn.filepicker.io/api/file/hhsOqKtT1Wf4O4JLlf6L", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://creative-penn-courses.teachable.com/p/how-to-write-a-novel")
Image.create(url: "https://cdn.filepicker.io/api/file/ELbfPzMYRT6Ua93zuTSe", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Understand story structure and the elements of a novel to write & edit your manuscript")

Objekt.create(template_id: 2) #40
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Facebook Ads for Authors")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Mark Dawson")
Image.create(url: "https://cdn.filepicker.io/api/file/O64rIlAHQq1uojlNUUdi", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://learn.selfpublishingformula.com")
Image.create(url: "https://cdn.filepicker.io/api/file/zorIvhLjTWybdLZbHNQ7", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Revenue generating online marketing skills and tools for self-published authors")

Objekt.create(template_id: 2) #41
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Reach Your Readers")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Derek Murphy")
Image.create(url: "https://cdn.filepicker.io/api/file/SEs3RQHvRfO4xHOP9sCh", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://courses.creativindie.com/p/how-to-use-your-author-platform")
Image.create(url: "https://cdn.filepicker.io/api/file/M4wKxrA3Rf27gmi5rqTT", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "How to build an author platform that sells thousands of books on autopilot")

Objekt.create(template_id: 2) #42
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Get a Job Offer in 30 Days")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Charlie Hoehn")
Image.create(url: "https://cdn.filepicker.io/api/file/Xe8wvNQLSbiWqybLGLyC", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://rpg.usefedora.com")
Image.create(url: "https://cdn.filepicker.io/api/file/ep9ny5OOSauSDiwiR0Vp", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Learn how to find a job you love, market yourself, and get hired fast - even without experience")

Objekt.create(template_id: 2) #43
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Spacial Knowledge On Demand")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Discover Spatial")
Image.create(url: "https://cdn.filepicker.io/api/file/hWImUujdQsi39lsSGDFo", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://discoverspatial.teachable.com")
Image.create(url: "https://cdn.filepicker.io/api/file/Yqij8ytxTWbtQ5KTm4KA", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Easy to follow spatial courses & tutorials from the world's leading instructors")

Objekt.create(template_id: 2) #44
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "StackSkills")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Stackskills")
Image.create(url: "https://cdn.filepicker.io/api/file/lSdcDa26ToCJXIEz0l5A", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "https://stackskills.com")
Image.create(url: "https://cdn.filepicker.io/api/file/B307jr6iTQ6Kfza9JWYp", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Backed by 500Startups & Tim Draper, StackSkills distributes over 475 courses to 100k+ students")

Objekt.create(template_id: 2) #45
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Sales Hacker")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Sales Hacker")
Image.create(url: "https://cdn.filepicker.io/api/file/C38gCdclTS2WvabrcNJV", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://market.saleshacker.com")
Image.create(url: "https://cdn.filepicker.io/api/file/U7wVR2twQTOwiR2HJteY", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Innovative and up to date sales tactics, strategies, and hacks")

Objekt.create(template_id: 2) #46
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Learn the Right Design Skills")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Designers.How")
Image.create(url: "https://cdn.filepicker.io/api/file/Mfc3Myv5TzSih0YBP1Bv", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://xcode.usefedora.com/p/xcode")
Image.create(url: "https://cdn.filepicker.io/api/file/xX8t738eRiCGtubhokzj", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Learn new, next-generation design skills that will advance your career in record time")

Objekt.create(template_id: 2) #47
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Edurila")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Edurila")
Image.create(url: "https://cdn.filepicker.io/api/file/c6tvnzovShyiA6VCOkVy", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://edurila.com")
Image.create(url: "https://cdn.filepicker.io/api/file/djAj3vjQW2JVcZrgb5r7", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Over 100 courses covering everything from programming to design to making money")

Objekt.create(template_id: 2) #48
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "The New York Times")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "The New York Times")
Image.create(url: "https://cdn.filepicker.io/api/file/Fi9IhGSRl2pFWfPfMJyd", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://online.nytedu.com/p/how-to-tell-brand-stories-with-video")
Image.create(url: "https://cdn.filepicker.io/api/file/RyvHeVl5T96ajpoy3gXq", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Offer courses to both pre-college and professional audiences, reflecting the scope of The Times")

Objekt.create(template_id: 2) #49
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Grow Your Pet Care Business")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "FetchFind")
Image.create(url: "https://cdn.filepicker.io/api/file/L6F4n7xRMJBTUYybcOFw", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://www.fetchfind.com")
Image.create(url: "https://cdn.filepicker.io/api/file/usVSfpFSSh2P3Rxs5E9K", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Grow your pet care business with the world’s first and only pet‐centric online content marketplace")

Objekt.create(template_id: 2) #50
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Headspring Forward")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Headspring")
Image.create(url: "https://cdn.filepicker.io/api/file/mOExpaJVRuij6zbYuwxQ", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://forward.headspring.com")
Image.create(url: "https://cdn.filepicker.io/api/file/iYF9BlzS8iSl2D6t0k3b", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Enterprise software developer that uses Teachable to train their 100+ employees")

Objekt.create(template_id: 2) #51
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "ICANN Learn")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "ICANN")
Image.create(url: "https://cdn.filepicker.io/api/file/DtW8i1dRUeKpV13q6gQN", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://learn.icann.org")
Image.create(url: "https://cdn.filepicker.io/api/file/OV3mFxU8Qp2gADDwTZkM", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "The nonprofit that maintains the Internet's DNS system, uses Teachable for public multi-lingual education & private internal training")

Objekt.create(template_id: 2) #52
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "GNS3 Academy")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "GNS3")
Image.create(url: "https://cdn.filepicker.io/api/file/gh7WR7KVQ2amSpxc6XUe", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://academy.gns3.com")
Image.create(url: "https://cdn.filepicker.io/api/file/IFZCBi5RTyO7djTOnvR0", image_type: "object", uploaded_by: 1)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: Image.all.length)
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "Software for networking professionals with 2m+ downloads. By creating courses, GNS3 expanded its revenue streams")

Objekt.create(template_id: 2) #53
ObjektField.create(objekt_id: Objekt.all.length, field_id: 2, value: "Product Educator, Teachable")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 3, value: "Laurence Bradford")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 4, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 6, value: "http://blog.teachable.com/topic/product-updates")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 7, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 8, value: "")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 14, value: "")

Objekt.create(template_id: 3) #54
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "53")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "It's amazing getting to work with such creative and hard-working people. I learn something new every day.")

Objekt.create(template_id: 3) #55
ObjektField.create(objekt_id: Objekt.all.length, field_id: 12, value: "1")
ObjektField.create(objekt_id: Objekt.all.length, field_id: 13, value: "OMG. Imagine me using 20 of the praising hands emojis, because that's pretty much what I felt when I started using Teachable. I LOVE this platform!")

Plan.create!(name: "All Plans", annual_included: false, monthly_price: 0, order: 0, app_monthly_plan_id: 0)
Plan.create!(name: "Free", tagline: "Get started for free", annual_included: false, monthly_price: 0, includes_text: "All of our base features", order: 1, app_monthly_plan_id: 4)
Plan.create!(name: "Basic", tagline: "Create your first online course", annual_included: true, monthly_price: 39, annual_price: 348, includes_text: "All of our base features, plus:", order: 2, app_monthly_plan_id: 153, app_annual_plan_id: 152)
Plan.create!(name: "Professional", tagline: "Our most popular plan", annual_included: true, monthly_price: 119, annual_price: 1188, includes_text: "Everything in Basic, plus:", order: 3, app_monthly_plan_id: 186, app_annual_plan_id: 185)
Plan.create!(name: "Business", tagline: "Experience the best of Teachable", annual_included: true, monthly_price: 299, annual_price: 2988, includes_text: "Everything in Professional, plus:", order: 4, app_monthly_plan_id: 218, app_annual_plan_id:219)

Tooltip.create(text: "PayPal deposits once a month with a 30-day delay")
Tooltip.create(text: "0% rate only applies if you set up custom payment gateways via Stripe and PayPal. If you do not set up payment gateways, Teachable charges 2%")
Tooltip.create(text: "If you set up direct payment gateways via Stripe and PayPal. If you do not set up payment gateways, Teachable will pay you monthly")
Tooltip.create(text: "Use our Power Editor to create custom designs")
Tooltip.create(text: "On courses, students, and videos")
Tooltip.create(text: "Remove Teachable branding from your website")
Tooltip.create(text: "Two 1-hour sessions")

Feature.create(text: "2 owners/authors")
  PlanFeature.create(feature_id: 1, plan_id: 3, order: 2)
Feature.create(text: "25 owners/authors")
  PlanFeature.create(feature_id: 2, plan_id: 5, order: 2)
Feature.create(text: "5 owners/authors")
  PlanFeature.create(feature_id: 3, plan_id: 4, order: 2)
Feature.create(text: "5% transaction fees")
  PlanFeature.create(feature_id: 4, plan_id: 3, order: 0)
Feature.create(text: "Advanced reports")
  PlanFeature.create(feature_id: 5, plan_id: 4, order: 6, tooltip_id: 5)
Feature.create(text: "Advanced theme customization")
  PlanFeature.create(feature_id: 6, plan_id: 4, order: 5, tooltip_id: 4)
Feature.create(text: "Basic quizzes")
  PlanFeature.create(feature_id: 7, plan_id: 1, order: 7)
Feature.create(text: "Bulk student enrollments")
  PlanFeature.create(feature_id: 8, plan_id: 5, order: 6)
Feature.create(text: "Concierge onboarding")
  PlanFeature.create(feature_id: 9, plan_id: 5, order: 4, tooltip_id: 7)
Feature.create(text: "Coupon codes")
  PlanFeature.create(feature_id: 10, plan_id: 3, order: 5)
Feature.create(text: "Custom domain support")
  PlanFeature.create(feature_id: 11, plan_id: 3, order: 4)
Feature.create(text: "Discussion forums")
  PlanFeature.create(feature_id: 12, plan_id: 1, order: 6)
Feature.create(text: "Drip course content")
  PlanFeature.create(feature_id: 13, plan_id: 3, order: 6)
Feature.create(text: "Graded quizzes")
  PlanFeature.create(feature_id: 14, plan_id: 4, order: 4)
Feature.create(text: "Instant payouts")
  PlanFeature.create(feature_id: 15, plan_id: 4, order: 1, tooltip_id: 3)
  PlanFeature.create(feature_id: 15, plan_id: 5, order: 1, tooltip_id: 3)
Feature.create(text: "Integrated affiliate marketing")
  PlanFeature.create(feature_id: 16, plan_id: 3, order: 7)
Feature.create(text: "Integrated email marketing")
  PlanFeature.create(feature_id: 17, plan_id: 3, order: 8)
Feature.create(text: "Integrated payment processing")
  PlanFeature.create(feature_id: 18, plan_id: 1, order: 4)
Feature.create(text: "Manual student imports")
  PlanFeature.create(feature_id: 19, plan_id: 5, order: 5)
Feature.create(text: "Monthly payouts")
  PlanFeature.create(feature_id: 20, plan_id: 3, order: 1, tooltip_id: 1)
Feature.create(text: "No fees on free courses")
  PlanFeature.create(feature_id: 21, plan_id: 1, order: 8)
Feature.create(text: "No transaction fees")
  PlanFeature.create(feature_id: 22, plan_id: 4, order: 0, tooltip_id: 2)
  PlanFeature.create(feature_id: 22, plan_id: 5, order: 0)
Feature.create(text: "Priority product support")
  PlanFeature.create(feature_id: 23, plan_id: 4, order: 3)
  PlanFeature.create(feature_id: 23, plan_id: 5, order: 3)
Feature.create(text: "Product support")
  PlanFeature.create(feature_id: 24, plan_id: 3, order: 3)
Feature.create(text: "Student management and email")
  PlanFeature.create(feature_id: 25, plan_id: 1, order: 5)
Feature.create(text: "Third-party integrations")
  PlanFeature.create(feature_id: 26, plan_id: 3, order: 9)
Feature.create(text: "Unlimited courses")
  PlanFeature.create(feature_id: 27, plan_id: 1, order: 0)
Feature.create(text: "Unlimited hosting")
  PlanFeature.create(feature_id: 28, plan_id: 1, order: 3)
Feature.create(text: "Unlimited students")
  PlanFeature.create(feature_id: 29, plan_id: 1, order: 1)
Feature.create(text: "Unlimited video")
  PlanFeature.create(feature_id: 30, plan_id: 1, order: 2)
Feature.create(text: "Unbranded website")
  PlanFeature.create(feature_id: 31, plan_id: 4, order: 7, tooltip_id: 6)

PartialCategory.create(name: "General")
PartialCategory.create(name: "Forms")
PartialCategory.create(name: "Admin Only")

Partial.create!(name: "Nav Menu") #1
  PartialField.create(partial_id: 1, name: "Transparent?", field_type: "dropdown", mandatory: true, order: 0)
    MenuOption.create(optionable_id: 1, optionable_type: "PartialField", value: "No", order: 0)
    MenuOption.create(optionable_id: 1, optionable_type: "PartialField", value: "Yes", order: 1)
  PartialField.create(partial_id: 1, name: "Computer Margin Bottom", field_type: "number", mandatory: true, order: 1)
Partial.create!(name: "Footer") #2
Partial.create!(name: "Header Image Subheader") #3
  PartialField.create(partial_id: 3, name: "Header 1", field_type: "text", char_limit: 100, order: 0)
  PartialField.create(partial_id: 3, name: "Header 1 Margin Bottom", field_type: "number", order: 1)
  PartialField.create(partial_id: 3, name: "Header 2", field_type: "text", char_limit: 100, order: 2)
  PartialField.create(partial_id: 3, name: "Header 2 Margin Bottom", field_type: "number", order: 3)
  PartialField.create(partial_id: 3, name: "Image", field_type: "image", order: 4)
  PartialField.create(partial_id: 3, name: "Image Margin Bottom", field_type: "number", order: 5)
  PartialField.create(partial_id: 3, name: "Subheader", field_type: "text", char_limit: 100, order: 6)
  PartialField.create(partial_id: 3, name: "Subheader Custom Width", field_type: "number", order: 7) #10
  PartialField.create(partial_id: 3, name: "Computer Margin Bottom", field_type: "number", order: 8)
Partial.create!(name: "Triple Image") #4
  PartialField.create(partial_id: 4, name: "Image 1", field_type: "image", order: 0)
  PartialField.create(partial_id: 4, name: "Header 1", field_type: "text", char_limit: 50, order: 1)
  PartialField.create(partial_id: 4, name: "Text 1", field_type: "text", char_limit: 200, order: 2)
  PartialField.create(partial_id: 4, name: "Button 1", field_type: "text", char_limit: 25, order: 3)
  PartialField.create(partial_id: 4, name: "URL 1", field_type: "text", char_limit: 100, order: 4)
  PartialField.create(partial_id: 4, name: "Image 2", field_type: "image", order: 5)
  PartialField.create(partial_id: 4, name: "Header 2", field_type: "text", char_limit: 50, order: 6)
  PartialField.create(partial_id: 4, name: "Text 2", field_type: "text", char_limit: 200, order: 7)
  PartialField.create(partial_id: 4, name: "Button 2", field_type: "text", char_limit: 25, order: 8) #20
  PartialField.create(partial_id: 4, name: "URL 2", field_type: "text", char_limit: 100, order: 9)
  PartialField.create(partial_id: 4, name: "Image 3", field_type: "image", order: 10)
  PartialField.create(partial_id: 4, name: "Header 3", field_type: "text", char_limit: 50, order: 11)
  PartialField.create(partial_id: 4, name: "Text 3", field_type: "text", char_limit: 200, order: 12)
  PartialField.create(partial_id: 4, name: "Button 3", field_type: "text", char_limit: 25, order: 13)
  PartialField.create(partial_id: 4, name: "URL 3", field_type: "text", char_limit: 100, order: 14)
  PartialField.create(partial_id: 4, name: "Computer Margin Bottom", field_type: "number", order: 15)
Partial.create!(name: "Big Image") #5
  PartialField.create(partial_id: 5, name: "Image", field_type: "image", mandatory: true, order: 0) #28
  PartialField.create(partial_id: 5, name: "Mobile/Tablet Height", field_type: "number", mandatory: true, order: 1) #29
  PartialField.create(partial_id: 5, name: "Fixed Height Desktop (Optional)", field_type: "number", order: 2) #30
Partial.create!(name: "Pricing Table") #6
  PartialField.create(partial_id: 6, name: "Header", field_type: "text", char_limit: 100, order: 1) #31
  PartialField.create(partial_id: 6, name: "Subheader", field_type: "text", char_limit: 200, order: 2) #32
Partial.create!(name: "CTA") #7
  PartialField.create(partial_id: 7, name: "Small Header", field_type: "text", char_limit: 50, order: 0) #33
  PartialField.create(partial_id: 7, name: "Large Header", field_type: "text", char_limit: 100, order: 1) #34
  PartialField.create(partial_id: 7, name: "Large Header Width", field_type: "number", order: 2) #35
  PartialField.create(partial_id: 7, name: "Button Text", field_type: "text", char_limit: 50, order: 3) #36
  PartialField.create(partial_id: 7, name: "Button Url", field_type: "text", char_limit: 200, order: 4) #37
  PartialField.create(partial_id: 7, name: "Computer Margin Bottom", field_type: "number", order: 5) #38
Partial.create!(name: "FAQ 7") #8
  PartialField.create(partial_id: 8, name: "Header", field_type: "text", char_limit: 100, order: 0) #39
  PartialField.create(partial_id: 8, name: "Question 1 (Left Column)", field_type: "text", char_limit: 100, order: 1) #40
  PartialField.create(partial_id: 8, name: "Answer 1 (Left Column)", field_type: "text", char_limit: 1000, order: 2) #41
  PartialField.create(partial_id: 8, name: "Question 2 (Left Column)", field_type: "text", char_limit: 100, order: 3) #42
  PartialField.create(partial_id: 8, name: "Answer 2 (Left Column)", field_type: "text", char_limit: 1000, order: 4) #43
  PartialField.create(partial_id: 8, name: "Question 3 (Left Column)", field_type: "text", char_limit: 100, order: 5) #44
  PartialField.create(partial_id: 8, name: "Answer 3 (Left Column)", field_type: "text", char_limit: 1000, order: 6) #45
  PartialField.create(partial_id: 8, name: "Question 4 (Left Column)", field_type: "text", char_limit: 100, order: 7) #46
  PartialField.create(partial_id: 8, name: "Answer 4 (Left Column)", field_type: "text", char_limit: 1000, order: 8) #47
  PartialField.create(partial_id: 8, name: "Question 5 (Left Column)", field_type: "text", char_limit: 100, order: 9) #48
  PartialField.create(partial_id: 8, name: "Answer 5 (Left Column)", field_type: "text", char_limit: 1000, order: 10) #49
  PartialField.create(partial_id: 8, name: "Question 6 (Left Column)", field_type: "text", char_limit: 100, order: 11) #50
  PartialField.create(partial_id: 8, name: "Answer 6 (Left Column)", field_type: "text", char_limit: 1000, order: 12) #51
  PartialField.create(partial_id: 8, name: "Question 7 (Left Column)", field_type: "text", char_limit: 100, order: 13) #52
  PartialField.create(partial_id: 8, name: "Answer 7 (Left Column)", field_type: "text", char_limit: 1000, order: 14) #53
  PartialField.create(partial_id: 8, name: "Question 1 (Right Column)", field_type: "text", char_limit: 100, order: 15) #54
  PartialField.create(partial_id: 8, name: "Answer 1 (Right Column)", field_type: "text", char_limit: 1000, order: 16) #55
  PartialField.create(partial_id: 8, name: "Question 2 (Right Column)", field_type: "text", char_limit: 100, order: 17) #56
  PartialField.create(partial_id: 8, name: "Answer 2 (Right Column)", field_type: "text", char_limit: 1000, order: 18) #57
  PartialField.create(partial_id: 8, name: "Question 3 (Right Column)", field_type: "text", char_limit: 100, order: 19) #58
  PartialField.create(partial_id: 8, name: "Answer 3 (Right Column)", field_type: "text", char_limit: 1000, order: 20) #59
  PartialField.create(partial_id: 8, name: "Question 4 (Right Column)", field_type: "text", char_limit: 100, order: 21) #60
  PartialField.create(partial_id: 8, name: "Answer 4 (Right Column)", field_type: "text", char_limit: 1000, order: 22) #61
  PartialField.create(partial_id: 8, name: "Question 5 (Right Column)", field_type: "text", char_limit: 100, order: 23) #62
  PartialField.create(partial_id: 8, name: "Answer 5 (Right Column)", field_type: "text", char_limit: 1000, order: 24) #63
  PartialField.create(partial_id: 8, name: "Question 6 (Right Column)", field_type: "text", char_limit: 100, order: 25) #64
  PartialField.create(partial_id: 8, name: "Answer 6 (Right Column)", field_type: "text", char_limit: 1000, order: 26) #65
  PartialField.create(partial_id: 8, name: "Question 7 (Right Column)", field_type: "text", char_limit: 100, order: 27) #66
  PartialField.create(partial_id: 8, name: "Answer 7 (Right Column)", field_type: "text", char_limit: 1000, order: 28) #67
  PartialField.create(partial_id: 8, name: "Computer Margin Bottom", field_type: "number", order: 29) #68
Partial.create!(name: "Three Points And Image") #9
  PartialField.create(partial_id: 9, name: "Header 1", field_type: "text", char_limit: 100, order: 0) #69
  PartialField.create(partial_id: 9, name: "Text 1", field_type: "text", char_limit: 200, order: 1) #70
  PartialField.create(partial_id: 9, name: "Header 2", field_type: "text", char_limit: 100, order: 2) #71
  PartialField.create(partial_id: 9, name: "Text 2", field_type: "text", char_limit: 200, order: 3) #72
  PartialField.create(partial_id: 9, name: "Header 3", field_type: "text", char_limit: 100, order: 4) #73
  PartialField.create(partial_id: 9, name: "Text 3", field_type: "text", char_limit: 200, order: 5) #74
  PartialField.create(partial_id: 9, name: "Image", field_type: "image", mandatory: true, order: 6) #75
  PartialField.create(partial_id: 9, name: "Below Image Background Color", field_type: "color", mandatory: true, order: 7) #76
  PartialField.create(partial_id: 9, name: "Image Header", field_type: "text", char_limit: 100, order: 8) #77
  PartialField.create(partial_id: 9, name: "Image Text", field_type: "text", char_limit: 200, order: 9) #78
  PartialField.create(partial_id: 9, name: "CTA Text", field_type: "text", char_limit: 100, order: 10) #79
  PartialField.create(partial_id: 9, name: "CTA Url", field_type: "text", char_limit: 100, order: 11) #80
  PartialField.create(partial_id: 9, name: "Computer Margin Bottom", field_type: "number", order: 12) #81
Partial.create!(name: "Testimonial Carousel") #10
  PartialField.create(partial_id: 10, name: "Quote 1", field_type: "text", mandatory: true, char_limit: 200, order: 0) #82
  PartialField.create(partial_id: 10, name: "Image 1", field_type: "image", mandatory: true, order: 1) #83
  PartialField.create(partial_id: 10, name: "Attribution 1", field_type: "text", mandatory: true, char_limit: 100, order: 2) #84
  PartialField.create(partial_id: 10, name: "Quote 2", field_type: "text", char_limit: 200, order: 3) #85
  PartialField.create(partial_id: 10, name: "Image 2", field_type: "image", order: 4) #86
  PartialField.create(partial_id: 10, name: "Attribution 2", field_type: "text", char_limit: 100, order: 5) #87
  PartialField.create(partial_id: 10, name: "Quote 3", field_type: "text", char_limit: 200, order: 6) #88
  PartialField.create(partial_id: 10, name: "Image 3", field_type: "image", order: 7) #89
  PartialField.create(partial_id: 10, name: "Attribution 3", field_type: "text", char_limit: 100, order: 8) #90
  PartialField.create(partial_id: 10, name: "Margin Bottom", field_type: "number", order: 9) #91
Partial.create!(name: "Hero") #11
  PartialField.create(partial_id: 11, name: "Image", field_type: "image", mandatory: true, order: 0) #92
  PartialField.create(partial_id: 11, name: "Header", field_type: "text", char_limit: 100, order: 3) #93
  PartialField.create(partial_id: 11, name: "Text", field_type: "text", char_limit: 300, order: 5) #94
  PartialField.create(partial_id: 11, name: "Button Text", field_type: "text", char_limit: 100, order: 8) #95
  PartialField.create(partial_id: 11, name: "Button Url", field_type: "text", char_limit: 100, order: 9) #96
  PartialField.create(partial_id: 11, name: "Mobile/Tablet Height", field_type: "number", mandatory: true, order: 10) #97
  PartialField.create(partial_id: 11, name: "Fixed Height Desktop (Optional)", field_type: "number", order: 11) #98
  PartialField.create(partial_id: 11, name: "Computer Margin Bottom", field_type: "number", order: 12) #99
Partial.create!(name: "Impressive Numbers") #12
  PartialField.create(partial_id: Partial.all.length, name: "Computer Margin Bottom", field_type: "number", order: 0) #100
Partial.create!(name: "Image - Text Column Wide") #13
  PartialField.create(partial_id: Partial.all.length, name: "Image", field_type: "image", mandatory: true, order: 0) #101
  PartialField.create(partial_id: Partial.all.length, name: "Header", field_type: "text", char_limit: 100, order: 2) #102
  PartialField.create(partial_id: Partial.all.length, name: "Header Margin Under 1025px", field_type: "dropdown", order: 0) #103
  PartialField.create(partial_id: Partial.all.length, name: "Text", field_type: "text", char_limit: 1000, order: 3) #104
  PartialField.create(partial_id: Partial.all.length, name: "Computer Margin Bottom", field_type: "number", order: 5) #105
Partial.create!(name: "Green Quote") #14
  PartialField.create(partial_id: Partial.all.length, name: "Header 1", field_type: "header", char_limit: 100, order: 2) #106
  PartialField.create(partial_id: Partial.all.length, name: "Text 1", field_type: "text", char_limit: 200, order: 3) #107
  PartialField.create(partial_id: Partial.all.length, name: "Header 2", field_type: "header", char_limit: 100, order: 4) #108
  PartialField.create(partial_id: Partial.all.length, name: "Text 2", field_type: "text", char_limit: 200, order: 5) #109
  PartialField.create(partial_id: Partial.all.length, name: "Header 3", field_type: "header", char_limit: 100, order: 6) #110
  PartialField.create(partial_id: Partial.all.length, name: "Text 3", field_type: "text", char_limit: 200, order: 7) #111
  PartialField.create(partial_id: Partial.all.length, name: "Image", field_type: "image", order: 8) #112
  PartialField.create!(partial_id: Partial.all.length, name: "Testimonial", field_type: "object", object_type: "Testimonial", mandatory: true, order: 9) #113
  PartialField.create(partial_id: Partial.all.length, name: "Computer Margin Bottom", field_type: "number", order: 10) #114
Partial.create!(name: "Five Simple Steps") #15
  PartialField.create(partial_id: Partial.all.length, name: "Computer Margin Bottom", field_type: "number", order: 0) #115
Partial.create!(name: "Showcase") #16
  PartialField.create(partial_id: Partial.all.length, name: "School 1", field_type: "object", object_type: "School", mandatory: true, order: 0) #116
  PartialField.create(partial_id: Partial.all.length, name: "School 2", field_type: "object", object_type: "School", mandatory: true, order: 1) #117
  PartialField.create(partial_id: Partial.all.length, name: "School 3", field_type: "object", object_type: "School", mandatory: true, order: 2) #118
  PartialField.create(partial_id: Partial.all.length, name: "School 4", field_type: "object", object_type: "School", mandatory: true, order: 3) #119
  PartialField.create(partial_id: Partial.all.length, name: "School 5", field_type: "object", object_type: "School", mandatory: true, order: 4) #120
  PartialField.create(partial_id: Partial.all.length, name: "Computer Margin Bottom", field_type: "number", order: 5) #121
Partial.create!(name: "Testimonial Cards") #17
  PartialField.create(partial_id: Partial.all.length, name: "Testimonial 1", field_type: "object", object_type: "Testimonial", mandatory: true, order: 0) #122
  PartialField.create(partial_id: Partial.all.length, name: "Testimonial 2", field_type: "object", object_type: "Testimonial", mandatory: true, order: 1) #123
  PartialField.create(partial_id: Partial.all.length, name: "Testimonial 3", field_type: "object", object_type: "Testimonial", mandatory: true, order: 2) #124
  PartialField.create(partial_id: Partial.all.length, name: "Computer Margin Bottom", field_type: "number", order: 3) #125
Partial.create!(name: "Webinar") #18
  PartialField.create(partial_id: Partial.all.length, name: "Computer Margin Bottom", field_type: "number", order: 0) #126
Partial.create!(name: "Boxes of People") #19
  PartialField.create(partial_id: Partial.all.length, name: "Header", field_type: "text", char_limit: 100, mandatory: true, order: 0) #127
  PartialField.create(partial_id: Partial.all.length, name: "Subheader", field_type: "text", char_limit: 200, mandatory: true, order: 1) #128
  PartialField.create(partial_id: 19, name: "Remove Margin Bottom When >= 1200px", field_type: "dropdown", mandatory: true, order: 2) #129
    MenuOption.create(optionable_id: 129, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create(optionable_id: 129, optionable_type: "PartialField", value: "No", order: 1)
  PartialField.create(partial_id: Partial.all.length, name: "Computer Margin Bottom", field_type: "number", order: 3) #130
Partial.create!(name: "Three Testimonials") #20
  PartialField.create(partial_id: 20, name: "Testimonial 1", field_type: "object", object_type: "Testimonial", mandatory: true, order: 0) #131
  PartialField.create(partial_id: 20, name: "Testimonial 2", field_type: "object", object_type: "Testimonial", mandatory: true, order: 1) #132
  PartialField.create(partial_id: 20, name: "Testimonial 3", field_type: "object", object_type: "Testimonial", mandatory: true, order: 2) #133
  PartialField.create(partial_id: 20, name: "Computer Margin Bottom", field_type: "number", order: 3) #134
# Remove old Testimonial partial:
  Partial.find(10).destroy
# Add Field to Pricing Table:
  PartialField.create(partial_id: 6, name: "Computer Margin Bottom", field_type: "number", order: 12) #135
# Add Fields to Hero:
  PartialField.create(partial_id: 11, name: "Text Position", field_type: "dropdown", order: 1) #136
    MenuOption.create(optionable_id: 136, optionable_type: "PartialField", value: "Left", order: 0)
    MenuOption.create(optionable_id: 136, optionable_type: "PartialField", value: "Center", order: 1)
  PartialField.create(partial_id: 11, name: "Superheader", field_type: "text", char_limit: 100, order: 2) #137
Partial.create!(name: "Privacy Policy") #21
Partial.create!(name: "Terms of Service") #22
Partial.create!(name: "Log In Form") #23
Partial.create!(name: "Sign Up Form") #24
Partial.create!(name: "Forgot Password Form") #25
Partial.create!(name: "Support Log In") #26
Partial.create!(name: "Text Column - Big Image") #27
  PartialField.create(partial_id: 27, name: "Small Header", field_type: "text", char_limit: 100, order: 0) #138
  PartialField.create(partial_id: 27, name: "Large Header", field_type: "text", char_limit: 200, order: 1) #139
  PartialField.create(partial_id: 27, name: "Image", field_type: "image", order: 3) #140
  PartialField.create(partial_id: 27, name: "Side Header 1", field_type: "header", char_limit: 100, order: 11) #141
  PartialField.create(partial_id: 27, name: "Text 1", field_type: "text", char_limit: 300, order: 12) #142
  PartialField.create(partial_id: 27, name: "Side Header 2", field_type: "header", char_limit: 100, order: 13) #143
  PartialField.create(partial_id: 27, name: "Text 2", field_type: "text", char_limit: 300, order: 14) #144
  PartialField.create(partial_id: 27, name: "Side Header 3", field_type: "header", char_limit: 100, order: 15) #145
  PartialField.create(partial_id: 27, name: "Text 3", field_type: "text", char_limit: 300, order: 16) #146
  PartialField.create(partial_id: 27, name: "Computer Margin Bottom", field_type: "number", order: 17) #147
  PartialField.create(partial_id: 27, name: "Tablet Margin Bottom", field_type: "number", order: 18) #148
  PartialField.create(partial_id: 27, name: "Mobile Margin Bottom", field_type: "number", order: 19) #149
# Add Field to Image <--> Text
  PartialField.create(partial_id: 13, name: "Text Max Width", field_type: "number", order: 4) #150
Partial.create!(name: "Six Icons") #28
  PartialField.create(partial_id: 28, name: "Small Header", field_type: "text", char_limit: 100, order: 0) #151
  PartialField.create(partial_id: 28, name: "Large Header", field_type: "text", char_limit: 200, order: 1) #152
  PartialField.create(partial_id: 28, name: "Images Max Width", field_type: "number", order: 4) #153
  PartialField.create(partial_id: 28, name: "Images Align", field_type: "dropdown", order: 6) #154
    MenuOption.create(optionable_id: 154, optionable_type: "PartialField", value: "Left", order: 0)
    MenuOption.create(optionable_id: 154, optionable_type: "PartialField", value: "Center", order: 1)
  PartialField.create(partial_id: 28, name: "Image 1", field_type: "image", order: 8) #155
  PartialField.create(partial_id: 28, name: "Header 1", field_type: "text", char_limit: 100, order: 9) #156
  PartialField.create(partial_id: 28, name: "Text 1", field_type: "text", char_limit: 200, order: 10) #157
  PartialField.create(partial_id: 28, name: "Image 2", field_type: "image", order: 11) #158
  PartialField.create(partial_id: 28, name: "Header 2", field_type: "text", char_limit: 100, order: 12) #159
  PartialField.create(partial_id: 28, name: "Text 2", field_type: "text", char_limit: 200, order: 13) #160
  PartialField.create(partial_id: 28, name: "Image 3", field_type: "image", order: 14) #161
  PartialField.create(partial_id: 28, name: "Header 3", field_type: "text", char_limit: 100, order: 15) #162
  PartialField.create(partial_id: 28, name: "Text 3", field_type: "text", char_limit: 200, order: 16) #163
  PartialField.create(partial_id: 28, name: "Image 4", field_type: "image", order: 17) #164
  PartialField.create(partial_id: 28, name: "Header 4", field_type: "text", char_limit: 100, order: 18) #165
  PartialField.create(partial_id: 28, name: "Text 4", field_type: "text", char_limit: 200, order: 19) #166
  PartialField.create(partial_id: 28, name: "Image 5", field_type: "image", order: 20) #167
  PartialField.create(partial_id: 28, name: "Header 5", field_type: "text", char_limit: 100, order: 21) #168
  PartialField.create(partial_id: 28, name: "Text 5", field_type: "text", char_limit: 200, order: 22) #169
  PartialField.create(partial_id: 28, name: "Image 6", field_type: "image", order: 23) #170
  PartialField.create(partial_id: 28, name: "Header 6", field_type: "text", char_limit: 100, order: 24) #171
  PartialField.create(partial_id: 28, name: "Text 6", field_type: "text", char_limit: 200, order: 25) #172
  PartialField.create(partial_id: 28, name: "Computer Margin Bottom", field_type: "number", order: 26) #173
# Add Tablet/Mobile Margin Bottom to Headers <--> Image and Quote
  PartialField.create(partial_id: 13, name: "Tablet Margin Bottom", field_type: "number", order: 6) #174
  PartialField.create(partial_id: 13, name: "Mobile Margin Bottom", field_type: "number", order: 7) #175
# Add Number Headers, Big Header Max Width, Image Margin to Headers <--> Image
  PartialField.create(partial_id: 27, name: "Numbers Above Headers", field_type: "dropdown", order: 10) #176
    MenuOption.create(optionable_id: 176, optionable_type: "PartialField", value: "No", order: 0)
    MenuOption.create(optionable_id: 176, optionable_type: "PartialField", value: "Yes", order: 1)
  PartialField.create(partial_id: 27, name: "Large Header Max Width", field_type: "number", order: 2) #177
  PartialField.create(partial_id: 27, name: "Computer Image Margin Left (Percentage)", field_type: "number", order: 4) #178
Partial.create!(name: "Bonus List") #29
  PartialField.create(partial_id: 29, name: "Header", field_type: "text", char_limit: 100, order: 0) #179
  PartialField.create(partial_id: 29, name: "Header Max Width", field_type: "number", order: 1) #180
  PartialField.create(partial_id: 29, name: "Subheader", field_type: "text", char_limit: 200, order: 2) #181
  PartialField.create(partial_id: 29, name: "Bonus 1", field_type: "object", object_type: "Bonus", order: 3) #182
  PartialField.create(partial_id: 29, name: "Bonus 2", field_type: "object", object_type: "Bonus", order: 4) #183
  PartialField.create(partial_id: 29, name: "Bonus 3", field_type: "object", object_type: "Bonus", order: 5) #184
  PartialField.create(partial_id: 29, name: "Bonus 4", field_type: "object", object_type: "Bonus", order: 6) #185
  PartialField.create(partial_id: 29, name: "Bonus 5", field_type: "object", object_type: "Bonus", order: 7) #186
  PartialField.create(partial_id: 29, name: "Bonus 6", field_type: "object", object_type: "Bonus", order: 8) #187
  PartialField.create(partial_id: 29, name: "Computer Margin Bottom", field_type: "number", order: 9) #188
  PartialField.create(partial_id: 29, name: "Tablet Margin Bottom", field_type: "number", order: 10) #189
  PartialField.create(partial_id: 29, name: "Mobile Margin Bottom", field_type: "number", order: 11) #190
Partial.create!(name: "Plus Bonus List") #30
  PartialField.create(partial_id: 30, name: "Header", field_type: "text", char_limit: 100, order: 0) #191
  PartialField.create(partial_id: 30, name: "Header Max Width", field_type: "number", order: 1) #192
  PartialField.create(partial_id: 30, name: "Bonus 1", field_type: "object", object_type: "Bonus", order: 3) #193
  PartialField.create(partial_id: 30, name: "Bonus 2", field_type: "object", object_type: "Bonus", order: 4) #194
  PartialField.create(partial_id: 30, name: "Bonus 3", field_type: "object", object_type: "Bonus", order: 5) #195
  PartialField.create(partial_id: 30, name: "Bonus 4", field_type: "object", object_type: "Bonus", order: 6) #196
  PartialField.create(partial_id: 30, name: "Bonus 5", field_type: "object", object_type: "Bonus", order: 7) #197
  PartialField.create(partial_id: 30, name: "Bonus 6", field_type: "object", object_type: "Bonus", order: 8) #198
  PartialField.create(partial_id: 30, name: "Computer Margin Bottom", field_type: "number", order: 9) #199
  PartialField.create(partial_id: 30, name: "Tablet Margin Bottom", field_type: "number", order: 10) #200
  PartialField.create(partial_id: 30, name: "Mobile Margin Bottom", field_type: "number", order: 11) #201
# Add Fields to Pricing Table
  PartialField.create(partial_id: 6, name: "Negative Top Margin", field_type: "dropdown", order: 0) #202
    MenuOption.create(optionable_id: 202, optionable_type: "PartialField", value: "No", order: 0)
    MenuOption.create(optionable_id: 202, optionable_type: "PartialField", value: "Yes", order: 1)
  PartialField.create(partial_id: 6, name: "Tablet Margin Bottom", field_type: "number", order: 13) #203
  PartialField.create(partial_id: 6, name: "Mobile Margin Bottom", field_type: "number", order: 14) #204
  PartialField.create(partial_id: 6, name: "Starting Position", field_type: "dropdown", order: 3) #205
    MenuOption.create(optionable_id: 205, optionable_type: "PartialField", value: "Monthly", order: 0)
    MenuOption.create(optionable_id: 205, optionable_type: "PartialField", value: "Annual", order: 1)
  PartialField.create(partial_id: 6, name: "Show Monthly/Annual Switch", field_type: "dropdown", order: 4) #206
    MenuOption.create(optionable_id: 206, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create(optionable_id: 206, optionable_type: "PartialField", value: "No", order: 1)
# Add Fields to Testimonial Cards
  PartialField.create(partial_id: 17, name: "Tablet Margin Bottom", field_type: "number", order: 4) #207
  PartialField.create(partial_id: 17, name: "Mobile Margin Bottom", field_type: "number", order: 5) #208
# Add Fields to FAQ
  PartialField.create(partial_id: 8, name: "Tablet Margin Bottom", field_type: "number", order: 30) #209
  PartialField.create(partial_id: 8, name: "Mobile Margin Bottom", field_type: "number", order: 31) #210
# Add Fields to CTA
  PartialField.create(partial_id: 7, name: "Tablet Margin Bottom", field_type: "number", order: 6) #211
  PartialField.create(partial_id: 7, name: "Mobile Margin Bottom", field_type: "number", order: 7) #212
# Add Fields to Headers <--> Image
  PartialField.create(partial_id: 27, name: "Show Image in Mobile View", field_type: "dropdown", order: 8) #213
    MenuOption.create(optionable_id: 213, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create(optionable_id: 213, optionable_type: "PartialField", value: "No", order: 1)
# Add Fields to Six Icons
  PartialField.create!(partial_id: 28, name: "Tablet Margin Bottom", field_type: "number", order: 27) #214
  PartialField.create!(partial_id: 28, name: "Mobile Margin Bottom", field_type: "number", order: 28) #215
# Add Fields to Green Testimonial
  PartialField.create!(partial_id: 14, name: "Tablet Margin Bottom", field_type: "number", order: 11) #216
  PartialField.create!(partial_id: 14, name: "Mobile Margin Bottom", field_type: "number", order: 12) #217
# Add Fields to Pricing Table
  PartialField.create!(partial_id: 6, name: "Monthly Basic Coupon Code", field_type: "text", char_limit: 50, order: 6) #218
  PartialField.create!(partial_id: 6, name: "Monthly Professional Coupon Code", field_type: "text", char_limit: 50, order: 7) #219
  PartialField.create!(partial_id: 6, name: "Monthly High Volume Coupon Code", field_type: "text", char_limit: 50, order: 8) #220
  PartialField.create!(partial_id: 6, name: "Upgrade Src", field_type: "text", char_limit: 25, order: 5) #221
  PartialField.create!(partial_id: 6, name: "Annual Basic Coupon Code", field_type: "text", char_limit: 50, order: 9) #222
  PartialField.create!(partial_id: 6, name: "Annual Professional Coupon Code", field_type: "text", char_limit: 50, order: 10) #223
# Add Field to Hero
  PartialField.create!(partial_id: 11, name: "Button Type", field_type: "dropdown", order: 7) #224
    MenuOption.create(optionable_id: 224, optionable_type: "PartialField", value: "Orange", order: 0)
    MenuOption.create(optionable_id: 224, optionable_type: "PartialField", value: "Arrow", order: 1)
Partial.create!(name: "Sub Nav Menu") #31
  PartialField.create!(partial_id: 31, name: "Option 1 Text", field_type: "text", char_limit: 50, order: 0) #225
  PartialField.create!(partial_id: 31, name: "Option 1 URL", field_type: "text", char_limit: 50, order: 1) #226
  PartialField.create!(partial_id: 31, name: "Option 2 Text", field_type: "text", char_limit: 50, order: 2) #227
  PartialField.create!(partial_id: 31, name: "Option 2 URL", field_type: "text", char_limit: 50, order: 3) #228
  PartialField.create!(partial_id: 31, name: "Option 3 Text", field_type: "text", char_limit: 50, order: 4) #229
  PartialField.create!(partial_id: 31, name: "Option 3 URL", field_type: "text", char_limit: 50, order: 5) #230
  PartialField.create!(partial_id: 31, name: "Option 4 Text", field_type: "text", char_limit: 50, order: 6) #231
  PartialField.create!(partial_id: 31, name: "Option 4 URL", field_type: "text", char_limit: 50, order: 7) #232
  PartialField.create!(partial_id: 31, name: "Option 5 Text", field_type: "text", char_limit: 50, order: 8) #233
  PartialField.create!(partial_id: 31, name: "Option 5 URL", field_type: "text", char_limit: 50, order: 9) #234
  PartialField.create!(partial_id: 31, name: "Computer Margin Bottom", field_type: "number", order: 12) #235
  PartialField.create!(partial_id: 31, name: "Tablet Margin Bottom", field_type: "number", order: 13) #236
  PartialField.create!(partial_id: 31, name: "Mobile Margin Bottom", field_type: "number", order: 15) #237
Partial.create!(name: "Big Image - Text Column") #32
  PartialField.create(partial_id: 32, name: "Small Header", field_type: "text", char_limit: 100, order: 0) #238
  PartialField.create(partial_id: 32, name: "Large Header", field_type: "text", char_limit: 200, order: 1) #239
  PartialField.create(partial_id: 32, name: "Large Header Max Width", field_type: "number", order: 2) #240
  PartialField.create(partial_id: 32, name: "Image", field_type: "image", order: 3) #241
  PartialField.create(partial_id: 32, name: "Image Margin Top", field_type: "number", order: 4) #242
  PartialField.create(partial_id: 32, name: "Computer Image Margin Right (Percentage)", field_type: "number", order: 5) #243
  PartialField.create(partial_id: 32, name: "Numbers Above Headers", field_type: "dropdown", order: 9) #244
    MenuOption.create(optionable_id: 244, optionable_type: "PartialField", value: "No", order: 0)
    MenuOption.create(optionable_id: 244, optionable_type: "PartialField", value: "Yes", order: 1)
  PartialField.create(partial_id: 32, name: "Side Header 1", field_type: "text", char_limit: 100, order: 10) #245
  PartialField.create(partial_id: 32, name: "Text 1", field_type: "text", char_limit: 300, order: 11) #246
  PartialField.create(partial_id: 32, name: "Side Header 2", field_type: "text", char_limit: 100, order: 12) #247
  PartialField.create(partial_id: 32, name: "Text 2", field_type: "text", char_limit: 300, order: 13) #248
  PartialField.create(partial_id: 32, name: "Side Header 3", field_type: "text", char_limit: 100, order: 14) #249
  PartialField.create(partial_id: 32, name: "Text 3", field_type: "text", char_limit: 300, order: 15) #250
  PartialField.create(partial_id: 32, name: "Computer Margin Bottom", field_type: "number", order: 16) #251
  PartialField.create(partial_id: 32, name: "Tablet Margin Bottom", field_type: "number", order: 17) #252
  PartialField.create(partial_id: 32, name: "Show Image in Mobile View", field_type: "dropdown", order: 7) #253
    MenuOption.create(optionable_id: 253, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create(optionable_id: 253, optionable_type: "PartialField", value: "No", order: 1)
  PartialField.create(partial_id: 32, name: "Mobile Margin Bottom", field_type: "number", order: 18) #254
# Add Fields to Six Icons
  PartialField.create!(partial_id: 28, name: "Large Header Max Width", field_type: "number", order: 2) #255
  PartialField.create!(partial_id: 28, name: "Images Max Height", field_type: "number", order: 5) #256
Partial.create!(name: "Green Quote Mirrored") #33
  PartialField.create!(partial_id: 33, name: "Header 1", field_type: "header", char_limit: 100, order: 2) #257
  PartialField.create!(partial_id: 33, name: "Text 1", field_type: "text", char_limit: 200, order: 3) #258
  PartialField.create!(partial_id: 33, name: "Header 2", field_type: "header", char_limit: 100, order: 4) #259
  PartialField.create!(partial_id: 33, name: "Text 2", field_type: "text", char_limit: 200, order: 5) #260
  PartialField.create!(partial_id: 33, name: "Header 3", field_type: "header", char_limit: 100, order: 6) #261
  PartialField.create!(partial_id: 33, name: "Text 3", field_type: "text", char_limit: 200, order: 7) #262
  PartialField.create!(partial_id: 33, name: "Image", field_type: "image", order: 8) #263
  PartialField.create!(partial_id: 33, name: "Testimonial", field_type: "object", object_type: "Testimonial", mandatory: true, order: 9) #264
  PartialField.create!(partial_id: 33, name: "Computer Margin Bottom", field_type: "number", order: 10) #265
  PartialField.create!(partial_id: 33, name: "Tablet Margin Bottom", field_type: "number", order: 11) #266
  PartialField.create!(partial_id: 33, name: "Mobile Margin Bottom", field_type: "number", order: 12) #267
# Add Fields to Hero
  PartialField.create!(partial_id: 11, name: "Tablet Margin Bottom", field_type: "number", order: 13) #268
  PartialField.create!(partial_id: 11, name: "Mobile Margin Bottom", field_type: "number", order: 14) #269
Partial.create!(name: "Text Column - Image - Text Column") #34
  PartialField.create!(partial_id: 34, name: "Small Header", field_type: "text", char_limit: 100, order: 3) #270
  PartialField.create!(partial_id: 34, name: "Large Header", field_type: "text", char_limit: 200, order: 4) #271
  PartialField.create!(partial_id: 34, name: "Large Header Max Width", field_type: "number", order: 5) #272
  PartialField.create!(partial_id: 34, name: "Background Color", field_type: "color", order: 6) #273
  PartialField.create!(partial_id: 34, name: "Left Column Header 1", field_type: "text", char_limit: 100, order: 7) #274
  PartialField.create!(partial_id: 34, name: "Left Column Text 1", field_type: "text", char_limit: 300, order: 8) #275
  PartialField.create!(partial_id: 34, name: "Left Column Header 2", field_type: "text", char_limit: 100, order: 9) #276
  PartialField.create!(partial_id: 34, name: "Left Column Text 2", field_type: "text", char_limit: 300, order: 10) #277
  PartialField.create!(partial_id: 34, name: "Left Column Header 3", field_type: "text", char_limit: 100, order: 11) #278
  PartialField.create!(partial_id: 34, name: "Left Column Text 3", field_type: "text", char_limit: 300, order: 12) #279
  PartialField.create!(partial_id: 34, name: "Center Image", field_type: "image", order: 13) #280
  PartialField.create!(partial_id: 34, name: "Right Column Header 1", field_type: "text", char_limit: 100, order: 14) #281
  PartialField.create!(partial_id: 34, name: "Right Column Text 1", field_type: "text", char_limit: 300, order: 15) #282
  PartialField.create!(partial_id: 34, name: "Right Column Header 2", field_type: "text", char_limit: 100, order: 16) #283
  PartialField.create!(partial_id: 34, name: "Right Column Text 2", field_type: "text", char_limit: 300, order: 17) #284
  PartialField.create!(partial_id: 34, name: "Right Column Header 3", field_type: "text", char_limit: 100, order: 18) #285
  PartialField.create!(partial_id: 34, name: "Right Column Text 3", field_type: "text", char_limit: 300, order: 19) #286
  PartialField.create!(partial_id: 34, name: "Computer Margin Bottom", field_type: "number", order: 23) #287
  PartialField.create!(partial_id: 34, name: "Tablet Margin Bottom", field_type: "number", order: 24) #288
  PartialField.create!(partial_id: 34, name: "Mobile Margin Bottom", field_type: "number", order: 25) #289
Partial.create!(name: "Accept Payments") #35
Partial.create!(name: "Image - Text Column") #36
  PartialField.create(partial_id: 36, name: "Background Color", field_type: "color", order: 0) #290
  PartialField.create(partial_id: 36, name: "Computer Padding Top", field_type: "number", order: 1) #291
  PartialField.create(partial_id: 36, name: "Tablet Padding Top", field_type: "number", order: 2) #292
  PartialField.create(partial_id: 36, name: "Mobile Padding Top", field_type: "number", order: 3) #293
  PartialField.create(partial_id: 36, name: "Small Header", field_type: "text", char_limit: 100, order: 4) #294
  PartialField.create(partial_id: 36, name: "Large Header", field_type: "text", char_limit: 200, order: 5) #295
  PartialField.create(partial_id: 36, name: "Large Header Max Width", field_type: "number", order: 6) #296
  PartialField.create(partial_id: 36, name: "Image", field_type: "image", order: 7) #297
  PartialField.create(partial_id: 36, name: "Show Image in Mobile View", field_type: "dropdown", order: 10) #298
    MenuOption.create(optionable_id: 298, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create(optionable_id: 298, optionable_type: "PartialField", value: "No", order: 1)
  PartialField.create(partial_id: 36, name: "Header 1", field_type: "header", char_limit: 100, order: 12) #299
  PartialField.create(partial_id: 36, name: "Text 1", field_type: "text", char_limit: 300, order: 13) #300
  PartialField.create(partial_id: 36, name: "Header 2", field_type: "header", char_limit: 100, order: 14) #301
  PartialField.create(partial_id: 36, name: "Text 2", field_type: "text", char_limit: 300, order: 15) #302
  PartialField.create(partial_id: 36, name: "Header 3", field_type: "header", char_limit: 100, order: 16) #303
  PartialField.create(partial_id: 36, name: "Text 3", field_type: "text", char_limit: 300, order: 17) #304
  PartialField.create(partial_id: 36, name: "Computer Padding Bottom", field_type: "number", order: 18) #305
  PartialField.create(partial_id: 36, name: "Tablet Padding Bottom", field_type: "number", order: 19) #306
  PartialField.create(partial_id: 36, name: "Mobile Padding Bottom", field_type: "number", order: 20) #307
  PartialField.create(partial_id: 36, name: "Computer Margin Bottom", field_type: "number", order: 21) #308
  PartialField.create(partial_id: 36, name: "Tablet Margin Bottom", field_type: "number", order: 22) #309
  PartialField.create(partial_id: 36, name: "Mobile Margin Bottom", field_type: "number", order: 23) #310
Partial.create!(name: "Horizontal Line") #37
  PartialField.create(partial_id: 37, name: "Computer Margin Bottom", field_type: "number", order: 21) #311
  PartialField.create(partial_id: 37, name: "Tablet Margin Bottom", field_type: "number", order: 22) #312
  PartialField.create(partial_id: 37, name: "Mobile Margin Bottom", field_type: "number", order: 23) #313
Partial.create!(name: "ID Tag") #38
  PartialField.create(partial_id: 38, name: "Label", field_type: "text", char_limit: 100, order: 0) #314
Partial.create!(name: "Text Column - Image") #39
  PartialField.create!(partial_id: 39, name: "Background Color", field_type: "color", order: 0) #315
  PartialField.create!(partial_id: 39, name: "Computer Padding Top", field_type: "number", order: 1) #316
  PartialField.create!(partial_id: 39, name: "Tablet Padding Top", field_type: "number", order: 2) #317
  PartialField.create!(partial_id: 39, name: "Mobile Padding Top", field_type: "number", order: 3) #318
  PartialField.create!(partial_id: 39, name: "Small Header", field_type: "text", char_limit: 100, order: 4) #319
  PartialField.create!(partial_id: 39, name: "Large Header", field_type: "text", char_limit: 200, order: 5) #320
  PartialField.create!(partial_id: 39, name: "Large Header Max Width", field_type: "number", order: 6) #321
  PartialField.create!(partial_id: 39, name: "Image", field_type: "image", order: 7) #322
  PartialField.create!(partial_id: 39, name: "Show Image in Mobile View", field_type: "dropdown", order: 11) #323
    MenuOption.create!(optionable_id: 323, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create!(optionable_id: 323, optionable_type: "PartialField", value: "No", order: 1)
  PartialField.create!(partial_id: 39, name: "Header 1", field_type: "header", char_limit: 100, order: 13) #324
  PartialField.create!(partial_id: 39, name: "Text 1", field_type: "text", char_limit: 300, order: 14) #325
  PartialField.create!(partial_id: 39, name: "Header 2", field_type: "header", char_limit: 100, order: 15) #326
  PartialField.create!(partial_id: 39, name: "Text 2", field_type: "text", char_limit: 300, order: 16) #327
  PartialField.create!(partial_id: 39, name: "Header 3", field_type: "header", char_limit: 100, order: 17) #328
  PartialField.create!(partial_id: 39, name: "Text 3", field_type: "text", char_limit: 300, order: 18) #329
  PartialField.create!(partial_id: 39, name: "Computer Padding Bottom", field_type: "number", order: 19) #330
  PartialField.create!(partial_id: 39, name: "Tablet Padding Bottom", field_type: "number", order: 20) #331
  PartialField.create!(partial_id: 39, name: "Mobile Padding Bottom", field_type: "number", order: 21) #332
  PartialField.create!(partial_id: 39, name: "Computer Margin Bottom", field_type: "number", order: 22) #333
  PartialField.create!(partial_id: 39, name: "Tablet Margin Bottom", field_type: "number", order: 23) #334
  PartialField.create!(partial_id: 39, name: "Mobile Margin Bottom", field_type: "number", order: 24) #335
# add fields to sub nav menu
  PartialField.create!(partial_id: 31, name: "Option 6 Text", field_type: "text", char_limit: 50, order: 10) #336
  PartialField.create!(partial_id: 31, name: "Option 6 URL", field_type: "text", char_limit: 50, order: 11) #337
# add fields to text-column - image - text-column
  PartialField.create(partial_id: 34, name: "Computer Padding Top", field_type: "number", order: 0) #338
  PartialField.create(partial_id: 34, name: "Tablet Padding Top", field_type: "number", order: 1) #339
  PartialField.create(partial_id: 34, name: "Mobile Padding Top", field_type: "number", order: 2) #340
  PartialField.create(partial_id: 34, name: "Computer Padding Bottom", field_type: "number", order: 20) #341
  PartialField.create(partial_id: 34, name: "Tablet Padding Bottom", field_type: "number", order: 21) #342
  PartialField.create(partial_id: 34, name: "Mobile Padding Bottom", field_type: "number", order: 22) #343
# add fields to accept payments
  PartialField.create!(partial_id: 35, name: "Computer Margin Bottom", field_type: "number", order: 0) #344
  PartialField.create!(partial_id: 35, name: "Tablet Margin Bottom", field_type: "number", order: 1) #345
  PartialField.create!(partial_id: 35, name: "Mobile Margin Bottom", field_type: "number", order: 2) #346
# add fields to image - text column
  PartialField.create(partial_id: 36, name: "Computer Image Margin Left (Percentage)", field_type: "number", order: 8) #347
  PartialField.create(partial_id: 36, name: "Tablet Image Margin Left (Percentage)", field_type: "number", order: 9) #348
  PartialField.create(partial_id: 36, name: "Mobile Image Margin Left (Percentage)", field_type: "number", order: 11) #349
# add fields to big image - text column
  PartialField.create(partial_id: 32, name: "Tablet Image Margin Left (Percentage)", field_type: "number", order: 6) #350
  PartialField.create(partial_id: 32, name: "Mobile Image Margin Left (Percentage)", field_type: "number", order: 8) #351
# add fields to text column - big image
  PartialField.create(partial_id: 27, name: "Show Image in Tablet View", field_type: "dropdown", order: 6) #352
    MenuOption.create(optionable_id: 352, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create(optionable_id: 352, optionable_type: "PartialField", value: "No", order: 1)
  PartialField.create(partial_id: 27, name: "Tablet Image Margin Left (Percentage)", field_type: "number", order: 7) #353
  PartialField.create(partial_id: 27, name: "Mobile Image Margin Left (Percentage)", field_type: "number", order: 9) #354
# add fields to text column - image
  PartialField.create(partial_id: 39, name: "Show Image in Tablet View", field_type: "dropdown", order: 9) #355
    MenuOption.create(optionable_id: 355, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create(optionable_id: 355, optionable_type: "PartialField", value: "No", order: 1)
  PartialField.create(partial_id: 39, name: "Computer Image Margin Left (Percentage)", field_type: "number", order: 8) #356
  PartialField.create(partial_id: 39, name: "Tablet Image Margin Left (Percentage)", field_type: "number", order: 10) #357
  PartialField.create(partial_id: 39, name: "Mobile Image Margin Left (Percentage)", field_type: "number", order: 12) #358
# add fields to hero
  PartialField.create(partial_id: 11, name: "Header Max Width", field_type: "number", order: 4) #359
  PartialField.create(partial_id: 11, name: "Text Max Width", field_type: "number", order: 6) #360
Partial.create!(name: "Example Schools") #40
  PartialField.create!(partial_id: 40, name: "Header", field_type: "text", char_limit: 100, order: 0) #361
  PartialField.create!(partial_id: 40, name: "Subheader", field_type: "text", char_limit: 200, order: 1) #362
  PartialField.create!(partial_id: 40, name: "School 1", field_type: "object", object_type: "School", order: 2) #363
  PartialField.create!(partial_id: 40, name: "School 2", field_type: "object", object_type: "School", order: 3) #364
  PartialField.create!(partial_id: 40, name: "School 3", field_type: "object", object_type: "School", order: 4) #365
  PartialField.create!(partial_id: 40, name: "School 4", field_type: "object", object_type: "School", order: 5) #366
  PartialField.create!(partial_id: 40, name: "School 5", field_type: "object", object_type: "School", order: 6) #367
  PartialField.create!(partial_id: 40, name: "Computer Margin Bottom", field_type: "number", order: 7) #368
  PartialField.create!(partial_id: 40, name: "Tablet Margin Bottom", field_type: "number", order: 8) #369
  PartialField.create!(partial_id: 40, name: "Mobile Margin Bottom", field_type: "number", order: 9) #370
# add field to Sub Nav Menu
  PartialField.create!(partial_id: 31, name: "Visible in Mobile?", field_type: "dropdown", order: 14) #371
    MenuOption.create!(optionable_id: 371, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create!(optionable_id: 371, optionable_type: "PartialField", value: "No", order: 1)
Partial.create!(name: "Enterprise Logos") #41
  PartialField.create!(partial_id: 41, name: "Header", field_type: "text", char_limit: 200, order: 0) #372
  PartialField.create!(partial_id: 41, name: "Computer Margin Bottom", field_type: "number", order: 1) #373
  PartialField.create!(partial_id: 41, name: "Tablet Margin Bottom", field_type: "number", order: 2) #374
  PartialField.create!(partial_id: 41, name: "Mobile Margin Bottom", field_type: "number", order: 3) #375
# add field to Six Icons
  PartialField.create!(partial_id: 28, name: "Header Color", field_type: "color", order: 7) #376
Partial.create!(name: "List - Image") #42
  PartialField.create!(partial_id: 42, name: "Header", field_type: "text", char_limit: 200, order: 0) #377
  PartialField.create!(partial_id: 42, name: "List", field_type: "text", char_limit: 1000, order: 1) #378
  PartialField.create!(partial_id: 42, name: "Partial Height", field_type: "number", order: 2) #379
  PartialField.create!(partial_id: 42, name: "Text Background Color", field_type: "color", order: 3) #380
  PartialField.create!(partial_id: 42, name: "Image", field_type: "image", order: 4) #381
  PartialField.create!(partial_id: 42, name: "Computer Margin Bottom", field_type: "number", order: 5) #382
  PartialField.create!(partial_id: 42, name: "Tablet Margin Bottom", field_type: "number", order: 6) #383
  PartialField.create!(partial_id: 42, name: "Mobile Margin Bottom", field_type: "number", order: 7) #384
Partial.create!(name: "Text - Image with Envelope") #43
  PartialField.create!(partial_id: 43, name: "Left Header", field_type: "text", char_limit: 200, order: 0) #385
  PartialField.create!(partial_id: 43, name: "Left Text", field_type: "text", char_limit: 1000, order: 1) #386
  PartialField.create!(partial_id: 43, name: "Image", field_type: "image", order: 2) #387
  PartialField.create!(partial_id: 43, name: "Image Header", field_type: "text", char_limit: 200, order: 3) #388
  PartialField.create!(partial_id: 43, name: "Image Text", field_type: "text", char_limit: 1000, order: 4) #389
  PartialField.create!(partial_id: 43, name: "Computer Margin Bottom", field_type: "number", order: 5) #390
  PartialField.create!(partial_id: 43, name: "Tablet Margin Bottom", field_type: "number", order: 6) #391
  PartialField.create!(partial_id: 43, name: "Mobile Margin Bottom", field_type: "number", order: 7) #392
Partial.create!(name: "Enterprise Form") #44
  PartialField.create!(partial_id: 44, name: "Computer Margin Bottom", field_type: "number", order: 0) #393
  PartialField.create!(partial_id: 44, name: "Tablet Margin Bottom", field_type: "number", order: 1) #394
  PartialField.create!(partial_id: 44, name: "Mobile Margin Bottom", field_type: "number", order: 2) #395
# add fields to ID
  PartialField.create!(partial_id: 38, name: "Computer Margin Bottom", field_type: "number", order: 2) #396
  PartialField.create!(partial_id: 38, name: "Tablet Margin Bottom", field_type: "number", order: 3) #397
  PartialField.create!(partial_id: 38, name: "Mobile Margin Bottom", field_type: "number", order: 4) #398
Partial.create!(name: "Plain Text") #45
  PartialField.create!(partial_id: 45, name: "Small Header", field_type: "text", char_limit: 100, order: 0) #399
  PartialField.create!(partial_id: 45, name: "Large Header", field_type: "text", char_limit: 200, order: 1) #400
  PartialField.create!(partial_id: 45, name: "Large Header Max Width", field_type: "number", order: 2) #401
  PartialField.create!(partial_id: 45, name: "Text", field_type: "text", char_limit: 1000, order: 3) #402
  PartialField.create!(partial_id: 45, name: "Text Max Width", field_type: "number", order: 4) #403
  PartialField.create!(partial_id: 45, name: "Computer Margin Bottom", field_type: "number", order: 5) #404
  PartialField.create!(partial_id: 45, name: "Tablet Margin Bottom", field_type: "number", order: 6) #405
  PartialField.create!(partial_id: 45, name: "Mobile Margin Bottom", field_type: "number", order: 7) #406
# add field to Green Quote
  PartialField.create!(partial_id: 14, name: "Negative Top Margin?", field_type: "dropdown", mandatory: true, order: 0) #407
    MenuOption.create!(optionable_id: 407, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create!(optionable_id: 407, optionable_type: "PartialField", value: "No", order: 1)
Partial.create!(name: "Work Perks") #46
  PartialField.create!(partial_id: 46, name: "Computer Margin Bottom", field_type: "number", order: 0) #408
  PartialField.create!(partial_id: 46, name: "Tablet Margin Bottom", field_type: "number", order: 1) #409
  PartialField.create!(partial_id: 46, name: "Mobile Margin Bottom", field_type: "number", order: 2) #410
Partial.create!(name: 'Job Listings') #47
  PartialField.create!(partial_id: 47, name: "Computer Margin Bottom", field_type: "number", order: 0) #411
  PartialField.create!(partial_id: 47, name: "Tablet Margin Bottom", field_type: "number", order: 1) #412
  PartialField.create!(partial_id: 47, name: "Mobile Margin Bottom", field_type: "number", order: 2) #413
# add field to Image - Text
  PartialField.create!(partial_id: 13, name: "Background Color", field_type: "color", order: 1) #414
# add field to Green Quote
  PartialField.create!(partial_id: 14, name: "Background Color", field_type: "color", order: 1) #415
# add fields to Mirrored Green Quote
  PartialField.create!(partial_id: 33, name: "Negative Top Margin?", field_type: "dropdown", mandatory: true, order: 0) #416
    MenuOption.create!(optionable_id: 416, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create!(optionable_id: 416, optionable_type: "PartialField", value: "No", order: 1)
  PartialField.create!(partial_id: 33, name: "Background Color", field_type: "color", order: 1) #417
Partial.create!(name: 'Pick Your Funnel') #48
  PartialField.create!(partial_id: 48, name: "Computer Margin Bottom", field_type: "number", order: 0) #418
  PartialField.create!(partial_id: 48, name: "Tablet Margin Bottom", field_type: "number", order: 1) #419
  PartialField.create!(partial_id: 48, name: "Mobile Margin Bottom", field_type: "number", order: 2) #420
Partial.create!(name: 'Affiliate Expectations') #49
  PartialField.create!(partial_id: 49, name: "Computer Margin Bottom", field_type: "number", order: 3) #421
  PartialField.create!(partial_id: 49, name: "Tablet Margin Bottom", field_type: "number", order: 4) #422
  PartialField.create!(partial_id: 49, name: "Mobile Margin Bottom", field_type: "number", order: 5) #423
Partial.create!(name: 'Arrow Bullet Points') #50
  PartialField.create!(partial_id: 50, name: "Left Side Background Color", field_type: "color", order: 0) #424
  PartialField.create!(partial_id: 50, name: "Large Header", field_type: "header", char_limit: 200, order: 1) #425
  PartialField.create!(partial_id: 50, name: "Text Below Header", field_type: "text", char_limit: 200, order: 2) #426
  PartialField.create!(partial_id: 50, name: "Bullet Point 1", field_type: "text", char_limit: 200, order: 3) #427
  PartialField.create!(partial_id: 50, name: "Bullet Point 2", field_type: "text", char_limit: 200, order: 4) #428
  PartialField.create!(partial_id: 50, name: "Bullet Point 3", field_type: "text", char_limit: 200, order: 5) #429
  PartialField.create!(partial_id: 50, name: "Bullet Point 4", field_type: "text", char_limit: 200, order: 6) #430
  PartialField.create!(partial_id: 50, name: "Bullet Point 5", field_type: "text", char_limit: 200, order: 7) #431
  PartialField.create!(partial_id: 50, name: "Image", field_type: "image", order: 8) #432
  PartialField.create!(partial_id: 50, name: "Right Side Background Color", field_type: "color", order: 9) #433
  PartialField.create!(partial_id: 50, name: "Right Side Header", field_type: "text", char_limit: 200, order: 10) #434
  PartialField.create!(partial_id: 50, name: "Right Side Text", field_type: "text", char_limit: 1000, order: 11) #435
  PartialField.create!(partial_id: 50, name: "Computer Margin Bottom", field_type: "number", order: 12) #436
  PartialField.create!(partial_id: 50, name: "Tablet Margin Bottom", field_type: "number", order: 13) #437
  PartialField.create!(partial_id: 50, name: "Mobile Margin Bottom", field_type: "number", order: 14) #438
# add fields to impressive Numbers
  PartialField.create(partial_id: 12, name: "Tablet Margin Bottom", field_type: "number", order: 1) #439
  PartialField.create(partial_id: 12, name: "Mobile Margin Bottom", field_type: "number", order: 2) #440
# add fields to six Icons
  PartialField.create(partial_id: 28, name: "Grid", field_type: "dropdown", order: 4) #441
    MenuOption.create(optionable_id: 441, optionable_type: "PartialField", value: "3 x 2", order: 0)
    MenuOption.create(optionable_id: 441, optionable_type: "PartialField", value: "2 x 3", order: 1)
Partial.create!(name: 'Affiliate Customer Bonuses') #51
  PartialField.create!(partial_id: 51, name: "Computer Margin Bottom", field_type: "number", order: 0) #442
  PartialField.create!(partial_id: 51, name: "Tablet Margin Bottom", field_type: "number", order: 1) #443
  PartialField.create!(partial_id: 51, name: "Mobile Margin Bottom", field_type: "number", order: 2) #444
Partial.create!(name: 'Affiliate Promotion Schedule') #52
  PartialField.create!(partial_id: 52, name: "Computer Margin Bottom", field_type: "number", order: 7) #445
  PartialField.create!(partial_id: 52, name: "Tablet Margin Bottom", field_type: "number", order: 8) #446
  PartialField.create!(partial_id: 52, name: "Mobile Margin Bottom", field_type: "number", order: 9) #447
# add fields to affiliate expectations
  PartialField.create!(partial_id: 49, name: "Lifetime Attendees", field_type: "text", char_limit: 20, order: 0) #448
  PartialField.create!(partial_id: 49, name: "Historical earnings per click", field_type: "text", char_limit: 20, order: 1) #449
  PartialField.create!(partial_id: 49, name: "Average registration rate", field_type: "text", char_limit: 20, order: 2) #450
# add fields to affiliate promotion Schedule
  PartialField.create!(partial_id: 52, name: "6 Days Before Text", field_type: "text", char_limit: 1000, order: 0) #451
  PartialField.create!(partial_id: 52, name: "6 Days Before Image", field_type: "image", order: 1) #452
  PartialField.create!(partial_id: 52, name: "6 Days Before Email Copy Link", field_type: "text", char_limit: 200, order: 2) #453
  PartialField.create!(partial_id: 52, name: "4 Days Before Image", field_type: "image", order: 3) #454
  PartialField.create!(partial_id: 52, name: "4 Days Before Email Copy Link", field_type: "text", char_limit: 200, order: 4) #455
  PartialField.create!(partial_id: 52, name: "1 Day Before Image", field_type: "image", order: 5) #456
  PartialField.create!(partial_id: 52, name: "1 Day Before Email Copy Link", field_type: "text", char_limit: 200, order: 6) #457
# add field to pricing table
  PartialField.create!(partial_id: 6, name: "Show Test Run (Free Plan) Link", field_type: "dropdown", order: 11) #458
    MenuOption.create!(optionable_id: 458, optionable_type: "PartialField", value: "Yes", order: 0)
    MenuOption.create!(optionable_id: 458, optionable_type: "PartialField", value: "No", order: 1)
Partial.create!(name: "Text Column - Image Wide") #53
  PartialField.create!(partial_id: 53, name: "Image", field_type: "image", mandatory: true, order: 0) #459
  PartialField.create!(partial_id: 53, name: "Background Color", field_type: "color", order: 1) #460
  PartialField.create!(partial_id: 53, name: "Header", field_type: "header", char_limit: 100, order: 2) #461
  PartialField.create!(partial_id: 53, name: "Text", field_type: "text", char_limit: 1000, order: 3) #462
  PartialField.create!(partial_id: 53, name: "Text Max Width", field_type: "number", order: 4) #463
  PartialField.create!(partial_id: 53, name: "Computer Margin Bottom", field_type: "number", order: 5) #464
  PartialField.create!(partial_id: 53, name: "Tablet Margin Bottom", field_type: "number", order: 6) #465
  PartialField.create!(partial_id: 53, name: "Mobile Margin Bottom", field_type: "number", order: 7) #466
# remove field from image - text wide
  PartialField.find(103).destroy
Partial.create!(name: "Pricing Comparison") #54
# add fields to Webinar
  PartialField.create!(partial_id: 18, name: "Tablet Margin Bottom", field_type: "number", order: 1) #467
  PartialField.create!(partial_id: 18, name: "Mobile Margin Bottom", field_type: "number", order: 2) #468
# add fields to Nav Menu
  PartialField.create!(partial_id: 1, name: "Tablet Margin Bottom", field_type: "number", order: 2) #469
  PartialField.create!(partial_id: 1, name: "Mobile Margin Bottom", field_type: "number", order: 3) #470
# add fields to Big Image
  PartialField.create!(partial_id: 5, name: "Computer Margin Bottom", field_type: "number", order: 3) #471
  PartialField.create!(partial_id: 5, name: "Tablet Margin Bottom", field_type: "number", order: 4) #472
  PartialField.create!(partial_id: 5, name: "Mobile Margin Bottom", field_type: "number", order: 5) #473
# add fields to Boxes of People
  PartialField.create!(partial_id: 19, name: "Tablet Margin Bottom", field_type: "number", order: 4) #474
  PartialField.create!(partial_id: 19, name: "Mobile Margin Bottom", field_type: "number", order: 5) #475
# add fields to 5 Simple Steps
  PartialField.create!(partial_id: 15, name: "Tablet Margin Bottom", field_type: "number", order: 1) #476
  PartialField.create!(partial_id: 15, name: "Mobile Margin Bottom", field_type: "number", order: 2) #477
# add fields to Header Image Subheader
  PartialField.create!(partial_id: 3, name: "Tablet Margin Bottom", field_type: "number", order: 9) #478
  PartialField.create!(partial_id: 3, name: "Mobile Margin Bottom", field_type: "number", order: 10) #479
# add fields to Showcase
  PartialField.create!(partial_id: 16, name: "Tablet Margin Bottom", field_type: "number", order: 6) #480
  PartialField.create!(partial_id: 16, name: "Mobile Margin Bottom", field_type: "number", order: 7) #481
# add fields to Three Points and Image
  PartialField.create!(partial_id: 9, name: "Tablet Margin Bottom", field_type: "number", order: 13) #482
  PartialField.create!(partial_id: 9, name: "Mobile Margin Bottom", field_type: "number", order: 14) #483
# add fields to Three Testimonials
  PartialField.create!(partial_id: 20, name: "Tablet Margin Bottom", field_type: "number", order: 5) #484
  PartialField.create!(partial_id: 20, name: "Mobile Margin Bottom", field_type: "number", order: 6) #485
# add fields to Triple Image
  PartialField.create!(partial_id: 4, name: "Tablet Margin Bottom", field_type: "number", order: 16) #486
  PartialField.create!(partial_id: 4, name: "Mobile Margin Bottom", field_type: "number", order: 17) #487
# add field to ID Tag
  PartialField.create!(partial_id: 38, name: "Background Color", field_type: "color", order: 1) #488

Page.create!(name: "Homepage", url: "/", title_text: "Create and Sell Your Own Online Courses | Teachable", description: "Create and sell beautiful online courses with the platform used by the best online entrepreneurs to sell $50m+ to over 4 million students worldwide.", creator_id: 1, active: true, canonical_url: "https://teachable.com")
  PagePartial.create!(page_id: 1, partial_id: 1, order: 0) #1
    PagePartialField.create(page_partial_id: 1, partial_field_id: 1, value: "Yes")
    PagePartialField.create(page_partial_id: 1, partial_field_id: 2, value: "0")
    PagePartialField.create(page_partial_id: 1, partial_field_id: 469, value: "0")
    PagePartialField.create(page_partial_id: 1, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: 1, partial_id: 11, order: 1) #2
    Image.create(url: "https://cdn.filepicker.io/api/file/Nguc5KucTFiKr7jppmMZ", image_type: "page_partial", uploaded_by: 1) #30
    PagePartialField.create(page_partial_id: 2, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create(page_partial_id: 2, partial_field_id: 136, value: "Left")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 137, value: "")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 93, value: "Create and sell beautiful online courses")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 94, value: "Your skills and experiences are unique and valuable. Easily build a beautiful course website, share your knowledge, and be rewarded for it.")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 95, value: "Get started")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 716, value: "/create-account")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 97, value: "600")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 98, value: "850")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 99, value: "105")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 224, value: "Orange")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 268, value: "105")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 269, value: "105")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 359, value: "0")
    PagePartialField.create(page_partial_id: 2, partial_field_id: 360, value: "0")
  PagePartial.create!(page_id: 1, partial_id: 12, order: 2) #3
    PagePartialField.create(page_partial_id: 3, partial_field_id: 100, value: "115")
    PagePartialField.create(page_partial_id: 3, partial_field_id: 439, value: "115")
    PagePartialField.create(page_partial_id: 3, partial_field_id: 440, value: "115")
  PagePartial.create!(page_id: 1, partial_id: 13, order: 3) #4
    Image.create(url: "https://cdn.filepicker.io/api/file/MR88uAVUTouZxH3Z91ib", image_type: "page_partial", uploaded_by: 1) #31
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 101, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 414, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 102, value: "Provide a world-class learning experience")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 104, value: "Let Teachable do the heavy lifting so you can focus on what matters - creating courses with our user-friendly interface.\n\nAllow your students to easily sign up to your school, view curriculums and previews, and purchase your courses.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 150, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 105, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 174, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 175, value: "100")
  PagePartial.create!(page_id: 1, partial_id: 14, order: 4) #5
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 407, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 415, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 106, value: "Effortless setup")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 107, value: "With just a few clicks, you’ll get a fully functioning school with learning management, payment gateways, and sales & marketing tools.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 108, value: "Exceptional learning experience")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 109, value: "Your content is your greatest asset. Take it to the next level with Teachable’s top-notch virtual classroom experience.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 110, value: "Simple yet powerful website customization")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 111, value: "Get a professional website out-of-the-box with minimal configuration necessary. Plus, enjoy full control to personalize any aspect of it.")
    Image.create(url: "https://cdn.filepicker.io/api/file/OoXjVgOKSeWiLVfe1Bpd", image_type: "page_partial", uploaded_by: 1) #32
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 112, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 113, value: "17")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 114, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 216, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 217, value: "100")
  PagePartial.create!(page_id: 1, partial_id: 15, order: 5) #6
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 115, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 476, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 477, value: "150")
  PagePartial.create!(page_id: 1, partial_id: 16, order: 6) #7
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 116, value: "3")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 117, value: "4")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 118, value: "5")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 119, value: "1")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 120, value: "6")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 121, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 480, value: "125")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 481, value: "85")
  PagePartial.create!(page_id: 1, partial_id: 17, order: 7) #8
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 122, value: "18")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 123, value: "19")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 124, value: "20")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 125, value: "115")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 207, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 208, value: "100")
  PagePartial.create!(page_id: 1, partial_id: 7, order: 8) #9
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 33, value: "WHAT ARE YOU WAITING FOR?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 34, value: "Join thousands of teachers making a difference every day using Teachable")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 35, value: "750")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 36, value: "Get started for free")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 716, value: "/create-account")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 38, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 211, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 212, value: "60")
  PagePartial.create!(page_id: 1, partial_id: 18, order: 9) #10
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 126, value: "140")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 467, value: "140")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 468, value: "80")
  PagePartial.create!(page_id: 1, partial_id: 19, order: 10) #11
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 127, value: "Your success is our success")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 128, value: "Our diverse team of professionals shares a passion for online education. We tirelessly work to improve our product, content, and community to help you achieve your goals")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 129, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 130, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 474, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 475, value: "80")
  PagePartial.create!(page_id: 1, partial_id: 7, order: 11) #12
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 33, value: "WHAT ARE YOU WAITING FOR?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 34, value: "Start now and turn your knowledge into a profitable online course")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 35, value: "750")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 36, value: "Get started in seconds")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 716, value: "/create-account")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 38, value: "85")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 211, value: "85")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 212, value: "85")
  PagePartial.create!(page_id: 1, partial_id: 2, order: 12) #13
Page.create!(name: "404", url: "/404_error", title_text: "Teachable | Page not found", description: "Start teaching online. Use Teachable to create your own online course.", creator_id: 1, active: true , canonical_url: "https://teachable.com/404_error")
  PagePartial.create!(page_id: 2, partial_id: 1, order: 0) #14
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "80")
  PagePartial.create!(page_id: 2, partial_id: 3, order: 1) #15
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 3, value: "404 ERROR")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 4, value: "15")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 5, value: "PAGE NOT FOUND")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 6, value: "50")
    Image.create(url: "https://cdn.filepicker.io/api/file/MsLuWSF6TmiEeZlrMols", image_type: "page_partial", uploaded_by: 1) #33
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 7, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 8, value: "45")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 9, value: "We can’t seem to find the page you’re looking for. Here are some helpful links instead:")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 10, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 11, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 478, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 479, value: "60")
  PagePartial.create!(page_id: 2, partial_id: 4, order: 2) #16
    Image.create(url: "https://cdn.filepicker.io/api/file/25sZNkRERuinr3rOKjYG", image_type: "page_partial", uploaded_by: 1) #34
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 12, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 13, value: "Teachable Blog")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 14, value: "Lessons learned from our community of 50,000+ to help you create content, build audiences and teach online")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 15, value: "Learn More")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 16, value: "http://blog.teachable.com")
    Image.create(url: "https://cdn.filepicker.io/api/file/nBTbrfnzRducWJR9k1bI", image_type: "page_partial", uploaded_by: 1) #35
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 17, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 18, value: "Our Quickstart live training")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 19, value: "Send targeted emails to students based on enrollment, completion, code redemption, and a dozen other filters.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 20, value: "Sign Up")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 21, value: "http://workshops.teachable.com/quickstart/register?src=404")
    Image.create(url: "https://cdn.filepicker.io/api/file/MqzdDCqTjSuJUOETMY8H", image_type: "page_partial", uploaded_by: 1) #36
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 22, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 23, value: "Knowledge Base")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 24, value: "Self-serve support articles to get your Teachable school up and running, from choosing a theme to setting up payments")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 25, value: "Learn More")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 26, value: "http://support.teachable.com")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 27, value: "120")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 486, value: "120")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 487, value: "120")
  PagePartial.create!(page_id: 2, partial_id: 2, order: 3) #17
Page.create!(name: "Pricing", url: "/pricing", title_text: "Teachable | Compare Our Pricing or Start With the Free Plan", description: "Per-user pricing sucks. That’s why all our pricing plans support unlimited courses and students - even on the free plan!", creator_id: 1, active: true , canonical_url: "https://teachable.com/pricing") #3
  PagePartial.create!(page_id: 3, partial_id: 1, order: 0) #18
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: 3, partial_id: 5, order: 1) #19
    Image.create(url: "https://cdn.filepicker.io/api/file/8ZQHFkuuQaicWWD8ZR3t", image_type: "page_partial", uploaded_by: 1) #37
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 28, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 29, value: "750")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 30, value: "750")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 471, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 472, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 473, value: "0")
  PagePartial.create!(page_id: 3, partial_id: 6, order: 2) #20
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 202, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 31, value: "Unlimited courses and students on all plans")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 32, value: "Per-user pricing sucks. That’s why all our pricing plans support as many courses and students as you want.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 135, value: "130")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 203, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 204, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 205, value: "Monthly")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 206, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 218, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 219, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 220, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 458, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 221, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 222, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 223, value: "")
  PagePartial.create!(page_id: 3, partial_id: 20, order: 3) #21
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 131, value: "21")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 132, value: "22")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 133, value: "24")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 134, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 484, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 485, value: "60")
  PagePartial.create!(page_id: 3, partial_id: 9, order: 4) #22
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 69, value: "Looking for an enterprise solution? Get a powerful, easy-to-use course platform")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 70, value: "Hit your goals with a single comprehensive solution that anyone within your organization can use.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 71, value: "Premium support directly from Teachable experts")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 72, value: "Enterprises get direct access to a dedicated account manager to help with strategic consulting, support, onboarding and training.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 73, value: "Say goodbye to threading together multiple providers")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 74, value: "Web hosting, payments, video delivery, and analytics – we’re happy to be the only solution you’ll need.")
    Image.create(url: "https://cdn.filepicker.io/api/file/zx57QqXOQQGlkvwfjIbU", image_type: "page_partial", uploaded_by: 1) #38
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 75, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 76, value: "#FF7F45")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 77, value: "Interested in Teachable’s Enterprise plans?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 78, value: "Talk directly with a member of our team and find out how you can join companies like The New York Times, Mozilla, ICANN, and the University of Pennsylvania using the easiest learning management system in the world.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 79, value: "Find out more")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 80, value: "https://teachable.com/enterprise")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 81, value: "85")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 482, value: "85")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 483, value: "85")
  PagePartial.create!(page_id: 3, partial_id: 8, order: 5) #23
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 39, value: "Answers to all your questions")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 40, value: "Which plan do you recommend?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 41, value: "The most popular plan is our Professional plan. However, we also offer a free plan so you can try out Teachable and see if it’s a good fit for you.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 42, value: "What happens if I want to cancel my plan?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 43, value: "We'll be sad to see you go, but you can cancel your Teachable plan at any time. We don't lock you into any lengthy contract. Moreover, since you own all school data as well as the domain name (if using a custom one), you can download your course, student, and revenue information so you can build your own website or use another service.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 44, value: "Can I use my own domain name?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 45, value: "On our Basic plan and above, you can use your own domain name (example.com). Additionally, every Teachable plan comes with a completely free yourschool.teachable.com domain name that you’re welcome to use.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 46, value: "Do you charge a setup fee?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 47, value: "With Teachable, there are absolutely no setup fees. You can launch your school for free!")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 48, value: "How do transaction fees work?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 49, value: "Every time a user purchases a course, course bundle, or subscription, we collect a transaction fee according to your pricing plan. Higher-priced monthly plans have lower transaction fees. If you are on our Free, Basic, Professional or High Volume plans and are using the Teachable payment gateway, we also charge a standard payment processing fee of 2.9% + $0.30 on paid courses.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 50, value: "When do I get paid?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 51, value: "When using Teachable’s payment gateway, you’ll be paid at the beginning of each month for purchases made at least 30 days ago. For example, if one student pays you on March 5, and another pays you on March 25, you’ll receive both students’ payments at the beginning of May. This system allows us enough time to honor our 30-day refund policy. However, if you’re using a custom payment gateway (available on the Professional plan and above), payouts will be distributed almost immediately.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 52, value: "Can Teachable be used for enterprise applications like internal training?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 53, value: "Absolutely! Some of our biggest clients use Teachable for internal training. Our High Volume and Enterprise plans allow you to import your employees for private training.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 54, value: "Can I offer free courses with Teachable?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 55, value: "Absolutely! And when you create a free course, we do not charge any fees on enrollments.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 56, value: "Do I need a web host?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 57, value: "Nope. Teachable hosts all your course content (even though, to your audience, it looks like you’re hosting it!)")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 58, value: "Is there a limit to how much content I can upload?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 59, value: "Every Teachable plan includes unlimited video and course content bandwidth. Upload as many courses, videos, PDFs, etc. as you like.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 60, value: "Do I need a payment processor?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 61, value: "Teachable handles the payment processing for you, so you don’t need a separate processor. We accept credit card, debit card, and PayPal. (However, on the Professional plan and above, you can also use your own payment gateways and take advantage of instant payouts!)")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 62, value: "What happens if I cannot set up direct payouts via Stripe Connect or PayPal?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 63, value: "Every time a user If you cannot set up custom payment gateways on the Professional plan or above, Teachable can collect funds for you and pay you on our regular payment schedule. When using our payment gateway, we have a payment processing fee of 2.9% + 30¢, plus a fee that varies based on your plan:\n\n*   Free: $1 + 10%\n*   Basic: 5%\n*   Professional: 0%\n*   High Volume: 0%")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 64, value: "Who pays my affiliates and authors out?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 65, value: "If you have custom gateways enabled (Stripe and/or PayPal), you are responsible for paying authors and affiliates out. If you use Teachable’s payment gateway, we will automatically pay out your authors and affiliates, send them the necessary tax forms at the end of the year, and take care of all the reporting.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 66, value: "Who can I contact with additional questions?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 67, value: "After creating an account, you can easily submit a support ticket from the admin area. Alternatively, you are always welcome to contact us through our [help form](https://teachable.com/help) if you have any questions prior to creating your first course.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 68, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 209, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 210, value: "60")
  PagePartial.create!(page_id: 3, partial_id: 7, order: 6) #24
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 33, value: "WHAT ARE YOU WAITING FOR?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 34, value: "Start now and turn your knowledge into a profitable online course")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 35, value: "525")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 36, value: "Get started for free")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 716, value: "/create-account")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 38, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 211, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 212, value: "40")
  PagePartial.create!(page_id: 3, partial_id: 5, order: 7) #25
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 28, value: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 29, value: "375")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 30, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 471, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 472, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 473, value: "0")
  PagePartial.create!(page_id: 3, partial_id: 2, order: 8) #26
Page.create!(name: "Privacy Policy", url: "/privacy-policy", title_text: "Start teaching online. Use Teachable to create your own online course.", description: "Start teaching online. Use Teachable to create your own online course.", creator_id: 1, active: true , canonical_url: "https://teachable.com/privacy-policy") #4
  PagePartial.create!(page_id: 4, partial_id: 1, order: 0) #27
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: 4, partial_id: 11, order: 1) #28
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.find_by_url('https://cdn.filepicker.io/api/file/Nguc5KucTFiKr7jppmMZ').id)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Center")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Privacy Policy")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "Last updated November 24, 2016")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "500")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "500")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Orange")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "0")
  PagePartial.create!(page_id: 4, partial_id: 21, order: 2) #29
  PagePartial.create!(page_id: 4, partial_id: 2, order: 3) #30
Page.create!(name: "Terms of Service", url: "/terms-of-use", title_text: "Start teaching online. Use Teachable to create your own online course.", description: "Start teaching online. Use Teachable to create your own online course.", creator_id: 1, active: true , canonical_url: "https://teachable.com/terms-of-use") #4
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #31
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #32
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.find_by_url('https://cdn.filepicker.io/api/file/Nguc5KucTFiKr7jppmMZ').id)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Center")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Terms of Service")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "Last updated November 24, 2016")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "500")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "500")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Orange")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 22, order: 2) #33
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 3) #34
Page.create!(name: "Log In", url: "/login", title_text: "Log in to Teachable", description: "Log in to your Teachable account.", creator_id: 1, active: true , canonical_url: "https://teachable.com/login") #5
  PagePartial.create!(page_id: Page.all.length, partial_id: 23, order: 0) #35
Page.create!(name: "Welcome - Upgrade", url: "/welcome/upgrade", title_text: "Teach online and make a living doing what you love | Teachable", description: "Create an online course & earn a full-time income on the platform used by the world’s best instructors to teach online and reach millions of students", creator_id: 1, active: true, index_page: false, canonical_url: "https://teachable.com/welcome/upgrade") #6
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #36
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #37
    Image.create(url: "https://cdn.filepicker.io/api/file/IMQJr9tFSTi2xrztY5fF", image_type: "page_partial", uploaded_by: 1) #40
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Left")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "Special Offer For First Time Customers")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Learn why everyone loves Teachable")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "Upgrade to a paid Teachable plan and get a premium course creation bundle")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "Get started now")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "#above-pricing-table")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "850")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "90")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Orange")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "90")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "90")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 27, order: 2) #38
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 138, value: "Create a course")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 139, value: "You’re ready to create an online course")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 177, value: "0")
    Image.create(url: "https://cdn.filepicker.io/api/file/tGmRfvHRRTWmsiGNb9CW", image_type: "page_partial", uploaded_by: 1) #41
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 140, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 178, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 176, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 141, value: "You are excited to start...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 142, value: "You’re pumped to share your knowledge with the world and earn passive income while doing it.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 143, value: "...but you're not excited about everything else.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 144, value: "You dread having to cobble together a membership site, video host, payment plugin, and email integration. Even when you manage to figure it all out, the finished product falls painfully short of what you imagined.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 145, value: "One tool could change everything.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 146, value: "You don’t need a website developer on retainer, a fancy recording studio, or a massive email list to create and profit from your own online course.\n\n**All you need is an idea...and one simple tool.**")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 147, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 148, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 213, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 149, value: "50")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 352, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 353, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 354, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 13, order: 3) #39
    Image.create(url: "https://cdn.filepicker.io/api/file/MR88uAVUTouZxH3Z91ib", image_type: "page_partial", uploaded_by: 1) #42
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 101, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 414, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 102, value: "Teachable helps you create & sell your online course")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 104, value: "With our easy-to-use online course creation platform, you can create courses without ever having to worry about tech, hosting, design, or marketing integrations.\n\nIt’s so easy that over 7,500 instructors have made over $36m in course sales in just two years by using Teachable.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 150, value: "457")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 105, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 174, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 175, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 28, order: 4) #40
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 151, value: "Powerful Features")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 152, value: "Out of the box, Teachable comes with amazing features like...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 255, value: "730")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 441, value: "3 x 2")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 153, value: "70")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 256, value: "70")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 154, value: "Left")
    Image.create(url: "https://cdn.filepicker.io/api/file/bvMlc0TiK9nydl7kpS8Q", image_type: "page_partial", uploaded_by: 1) #43
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 155, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 156, value: "Unlimited courses & students")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 157, value: "We never limit on usage. You can host as many courses and students as you want, with no extra charges. Oh, and it comes with unlimted video and hosting as well.")
    Image.create(url: "https://cdn.filepicker.io/api/file/fnXq589HRoGLSS2DTFNz", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 158, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 159, value: "Fully optimized for web and mobile")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 160, value: "Your website is fully responsive to give your students a consistent and captivating learning experience across desktops, tablets, and smartphones.")
    Image.create(url: "https://cdn.filepicker.io/api/file/RnWkbE72SqehJHIuKuDL", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 161, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 162, value: "User-friendly website builder")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 163, value: "Customize your online school with an intuitive user interface. Design your homepage, lectures, and sales pages to fit your specific needs.")
    Image.create(url: "https://cdn.filepicker.io/api/file/fPZPo7cuSaaTsQSBYU3h", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 164, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 165, value: "In-built marketing tools")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 166, value: "Our conversion-optimized landing pages, affiliate program, and infinite marketing integrations make it easy to market and sell your online course.")
    Image.create(url: "https://cdn.filepicker.io/api/file/p2LJ8QpQHWfUO0JK3KvJ", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 167, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 168, value: "Quizzes, forums, & drip content")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 169, value: "Enhance your students’ learning experience and build an engaged community using the native comments, quizzes and drip content features.")
    Image.create(url: "https://cdn.filepicker.io/api/file/B0WzJl9qSSeKl8166VYl", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 170, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 171, value: ". . . AND much more")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 172, value: "From hosting on custom domains to extensive analytics tracking student engagement, Teachable is the must-have product for any online course creator.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 173, value: "170")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 214, value: "170")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 215, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 376, value: "#1EA69A")
  PagePartial.create!(page_id: Page.all.length, partial_id: 14, order: 5) #41
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 407, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 415, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 106, value: "Special bonuses for new users")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 107, value: "When you sign up for Teachable through this special offer, you will also receive a bundle of valuable gifts.\n\nWe're giving you ALL the tools you need. Think amazing software so you can easily create your own beautiful online course website and a proven, step-by-step process from entrepreneurs who have successfully launched their own profitable courses.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 108, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 109, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 110, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 111, value: "")
    Image.create(url: "https://cdn.filepicker.io/api/file/75zS2riKSNK7AupWarZO", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 112, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 113, value: "23")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 114, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 216, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 217, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 27, order: 6) #42
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 138, value: "How This Works")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 139, value: "When you upgrade to a Teachable monthly Basic or Professional plan today, you’ll receive two things...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 177, value: "555")
    Image.create(url: "https://cdn.filepicker.io/api/file/BAqsUqt6Shi3LPa1K4nb", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 140, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 178, value: "-40")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 176, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 141, value: "Full access to Teachable’s premium software")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 142, value: "Join over 7,500 instructors who use Teachable to share their knowledge. Easily create an online course with our powerful yet simple all-in-one platform.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 143, value: "Course Creation Bundle")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 144, value: "This is our special bundle of resources, tried and true, to help you create and sell your own online course. The bundle is worth up to $1,000, but you get them free! *(Just until the timer runs out.)*")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 145, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 146, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 147, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 148, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 213, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 149, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 352, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 353, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 354, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 29, order: 7) #43
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 179, value: "In the Course Creation Bundle you get these three awesome bonuses...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 180, value: "750")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 181, value: "You’ll learn our proven process to create and sell online courses, plus all the tips and tricks in between")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 182, value: "12")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 183, value: "13")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 184, value: "14")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 185, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 186, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 187, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 188, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 189, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 190, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 30, order: 8) #44
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 191, value: "Plus, if you upgrade to Professional, you’ll also receive...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 192, value: "500")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 193, value: "15")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 194, value: "16")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 195, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 196, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 197, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 198, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 199, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 200, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 201, value: "60")
  PagePartial.create!(page_id: Page.all.length, partial_id: 6, order: 10) #45
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 202, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 31, value: "Join 7,500+ online entreprenuers on Teachable")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 32, value: "Choose what Teachable plan is best for you, whether it's to get started or to grow your business")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 135, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 203, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 204, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 205, value: "Monthly")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 206, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 218, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 219, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 220, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 221, value: "welcome-upgrade")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 222, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 223, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 458, value: "No")
  PagePartial.create!(page_id: Page.all.length, partial_id: 17, order: 11) #46
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 122, value: "18")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 123, value: "19")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 124, value: "20")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 125, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 207, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 208, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 8, order: 12) #47
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 39, value: "Answers to all your questions")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 40, value: "Which plan do you recommend?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 41, value: "The most popular plan is our Professional plan. However, we also offer a free plan so you can try out Teachable and see if it’s a good fit for you.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 42, value: "What happens if I want to cancel my plan?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 43, value: "We'll be sad to see you go, but you can cancel your Teachable plan at any time. We don't lock you into any lengthy contract. Moreover, since you own all school data as well as the domain name (if using a custom one), you can download your course, student, and revenue information so you can build your own website or use another service.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 44, value: "Can I use my own domain name?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 45, value: "On our Basic plan and above, you can use your own domain name (example.com). Additionally, every Teachable plan comes with a completely free yourschool.teachable.com domain name that you’re welcome to use.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 46, value: "Do you charge a setup fee?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 47, value: "With Teachable, there are absolutely no setup fees. You can launch your school for free!")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 48, value: "How do transaction fees work?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 49, value: "Every time a user purchases a course, course bundle, or subscription, we collect a transaction fee according to your pricing plan. Higher-priced monthly plans have lower transaction fees. If you are on our Free, Basic, Professional or High Volume plans and are using the Teachable payment gateway, we also charge a standard payment processing fee of 2.9% + $0.30 on paid courses.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 50, value: "When do I get paid?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 51, value: "When using Teachable’s payment gateway, you’ll be paid at the beginning of each month for purchases made at least 30 days ago. For example, if one student pays you on March 5, and another pays you on March 25, you’ll receive both students’ payments at the beginning of May. This system allows us enough time to honor our 30-day refund policy. However, if you’re using a custom payment gateway (available on the Professional plan and above), payouts will be distributed almost immediately.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 52, value: "Can Teachable be used for enterprise applications like internal training?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 53, value: "Absolutely! Some of our biggest clients use Teachable for internal training. Our High Volume and Enterprise plans allow you to import your employees for private training.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 54, value: "Can I offer free courses with Teachable?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 55, value: "Absolutely! And when you create a free course, we do not charge any fees on enrollments.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 56, value: "Do I need a web host?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 57, value: "Nope. Teachable hosts all your course content (even though, to your audience, it looks like you’re hosting it!)")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 58, value: "Is there a limit to how much content I can upload?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 59, value: "Every Teachable plan includes unlimited video and course content bandwidth. Upload as many courses, videos, PDFs, etc. as you like.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 60, value: "Do I need a payment processor?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 61, value: "Teachable handles the payment processing for you, so you don’t need a separate processor. We accept credit card, debit card, and PayPal. (However, on the Professional plan and above, you can also use your own payment gateways and take advantage of instant payouts!)")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 62, value: "What happens if I cannot set up direct payouts via Stripe Connect or PayPal?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 63, value: "Every time a user If you cannot set up custom payment gateways on the Professional plan or above, Teachable can collect funds for you and pay you on our regular payment schedule. When using our payment gateway, we have a payment processing fee of 2.9% + 30¢, plus a fee that varies based on your plan:\n\n*   Free: $1 + 10%\n*   Basic: 5%\n*   Professional: 0%\n*   High Volume: 0%")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 64, value: "Who pays my affiliates and authors out?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 65, value: "If you have custom gateways enabled (Stripe and/or PayPal), you are responsible for paying authors and affiliates out. If you use Teachable’s payment gateway, we will automatically pay out your authors and affiliates, send them the necessary tax forms at the end of the year, and take care of all the reporting.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 66, value: "Who can I contact with additional questions?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 67, value: "After creating an account, you can easily submit a support ticket from the admin area. Alternatively, you are always welcome to contact us through our [help form](https://teachable.com/help) if you have any questions prior to creating your first course.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 68, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 209, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 210, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 7, order: 13) #48
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 33, value: "WHAT ARE YOU WAITING FOR?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 34, value: "Start now and turn your knowledge into a profitable online course")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 35, value: "525")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 36, value: "Get started")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 37, value: "#above-pricing-table")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 38, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 211, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 212, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 5, order: 14) #49
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 28, value: "1")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 29, value: "375")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 30, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 471, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 472, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 473, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 15) #50
Page.create!(name: "Sign Up", url: "/create-account-v2", title_text: "Create an Account | Teachable", description: "Sign up for a Teachable account.", creator_id: 1, active: true , canonical_url: "https://teachable.com/create-account-v2") #7
Page.create!(name: "Creator Checkout", url: "/create-account", title_text: "Create an Account | Teachable", description: "Sign up for a Teachable account.", creator_id: 1, active: true , canonical_url: "https://teachable.com/create-account") #7
  PagePartial.create!(page_id: Page.all.length, partial_id: 24, order: 0) #51
Page.create!(name: "Forgot Password", url: "/forgot-password", title_text: "Start teaching online. Use Teachable to create your own online course.", description: "Start teaching online. Use Teachable to create your own online course.", creator_id: 1, active: true , canonical_url: "https://teachable.com/forgot-password") #8
  PagePartial.create!(page_id: Page.all.length, partial_id: 25, order: 0) #52
Page.create!(name: "Support Login", url: "/support-login", title_text: "Start teaching online. Use Teachable to create your own online course.", description: "Start teaching online. Use Teachable to create your own online course.", creator_id: 1, active: true , canonical_url: "https://teachable.com/support-login") #9
  PagePartial.create!(page_id: Page.all.length, partial_id: 26, order: 0) #53
Page.create!(name: "Features", url: "/features", title_text: "Teachable | All the Features Your Online School Needs", description: "Teachable’s features make it easy to create, publish, monitor, and grow your online school and courses.", creator_id: 1, active: true , canonical_url: "https://teachable.com/features") #10
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #54
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #55
    Image.create(url: "https://cdn.filepicker.io/api/file/mhQx0RZ7Tru0LFeoo5XL", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Center")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Simple. Powerful. Beautiful.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "All the features you need to create and sell online courses")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "#sub-menu")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "500")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "500")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Arrow")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 31, order: 3) #56
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 225, value: "Customization")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 226, value: "#customization")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 227, value: "Learning Tools")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 228, value: "#learning-tools")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 229, value: "Marketing")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 230, value: "#marketing")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 231, value: "Analytics")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 232, value: "#analytics")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 233, value: "Hosting & Security")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 234, value: "#hosting-and-security")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 336, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 337, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 235, value: "40")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 236, value: "40")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 371, value: "No")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 237, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 38, order: 4) #57
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "customization")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 27, order: 5) #58
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 138, value: "Customization")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 139, value: "Package and personalize your content as a stunning online course")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 177, value: "530")
    Image.create(url: "https://cdn.filepicker.io/api/file/rcLcOpsDQGWzNmkoCx9u", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 140, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 178, value: "-30")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 176, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 141, value: "Create engaging multimedia lectures")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 142, value: "Add video, image, text, audio, and PDF files. Easily import content directly from Dropbox, Google Drive, or OneDrive.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 143, value: "Build a beautiful website")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 144, value: "You can work with your existing website or create new pages on Teachable, all with our intuitive drag-and-drop builder.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 145, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 146, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 147, value: "450")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 213, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 352, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 353, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 354, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 148, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 149, value: "50")
  PagePartial.create!(page_id: Page.all.length, partial_id: 32, order: 6) #59
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 238, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 239, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 240, value: "530")
    Image.create(url: "https://cdn.filepicker.io/api/file/9F4tWpFTUiO6JKUI6NQf", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 241, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 242, value: "-40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 243, value: "15")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 350, value: "-10")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 253, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 351, value: "-10")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 244, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 245, value: "Delight students on any device")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 246, value: "Your course website is fully responsive, so students can view your content from computers, tablets, and smartphones.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 247, value: "Modify any aspect of your school")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 248, value: "With our Power Editor, you or your team can dig into the code and make advanced customizations.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 249, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 250, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 251, value: "270")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 252, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 254, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 14, order: 7) #60
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 407, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 415, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 106, value: "Publish sales pages that convert")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 107, value: "Easily draft, customize, and launch new course pages with a powerful page editor.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 108, value: "Use our domain to connect your own")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 109, value: "Start with your own free domain (yourschool.teachable.com), host under your own domain name (yourschool.com), or link to a subdomain (school.yoursite.com).")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 110, value: "Reach students worldwide in any language")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 111, value: "Modify the language used in any part of your site to support international audiences.")
    Image.create(url: "https://cdn.filepicker.io/api/file/75zS2riKSNK7AupWarZO", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 112, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 113, value: "23")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 114, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 216, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 217, value: "60")
  PagePartial.create!(page_id: Page.all.length, partial_id: 38, order: 8) #61
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "learning-tools")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 28, order: 9) #62
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 151, value: "Learning Tools")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 152, value: "Enhance the learning experience and build an engaged student community")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 255, value: "630")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 441, value: "3 x 2")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 153, value: "350")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 256, value: "206")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 154, value: "Center")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 376, value: "#1EA69A")
    Image.create(url: "https://cdn.filepicker.io/api/file/HD1ZtrsRTmC0vhfz08dg", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 155, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 156, value: "Quizzes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 157, value: "Easily create a quiz with our native feature to reinforce learning, summarize essential information, and check in on your students’ progress.")
    Image.create(url: "https://cdn.filepicker.io/api/file/T3OgaFGR86p4vSoBA8Wr", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 158, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 159, value: "Discussion forums")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 160, value: "Spark conversations and answer questions within your lectures using our native comments feature. Optionally, moderate comments before they appear publicly.")
    Image.create(url: "https://cdn.filepicker.io/api/file/xCMmKphjS12fGIv1M3tY", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 161, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 162, value: "Blog")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 163, value: "Demonstrate authority in your field, provide insights, and share updates with your students using a built-in blog managed right from your school admin.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 164, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 165, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 166, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 167, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 168, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 169, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 170, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 171, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 172, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 173, value: "200")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 214, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 215, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 33, order: 10) #63
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 416, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 417, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 257, value: "Student feedback")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 258, value: "Include Google Forms, surveys, and other tools to collect information from your students that helps you understand and serve them better.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 259, value: "Support integrations")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 260, value: "Use Zapier to connect your school with virtually every known support tool, including Intercom, Olark, and Zendesk.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 261, value: "Student list segmentation")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 262, value: "Keep in touch with your students by sending targeted emails based on enrollment, completion, code redemption, and a dozen other filters.")
    Image.create(url: "https://cdn.filepicker.io/api/file/LaxErFzWQePwLRqnD8Gm", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 263, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 264, value: "25")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 265, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 266, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 267, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 38, order: 12) #64
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "marketing")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 34, order: 13) #65
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 338, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 339, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 340, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 270, value: "Marketing")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 271, value: "Leverage a wide variety of built-in marketing tools to grow your business")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 272, value: "530")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 273, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 274, value: "Coupons and promotions")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 275, value: "Incentivize enrollments by creating dollar-amount or percentage-off coupons with custom expiration times.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 276, value: "Advanced pricing options")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 277, value: "Charge a one-time fee, sell a subscription, or set up a payment plan, and offer individual or bundled courses.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 278, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 279, value: "")
    Image.create(url: "https://cdn.filepicker.io/api/file/tJ5eaTR1TImcI1rbrY8N", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 280, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 281, value: "Your own affiliate program")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 282, value: "Reward others for sharing your course and track their results with the built-in affiliate marketing feature.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 283, value: "Customizable sales pages")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 284, value: "Use our conversion-optimized sales page template, or create your own custom landing pages.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 285, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 286, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 341, value: "20")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 342, value: "20")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 343, value: "20")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 287, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 288, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 289, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 5, order: 14) #66
    Image.create(url: "https://cdn.filepicker.io/api/file/Wm28SuypSZ2Tl6OhSM2g", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 28, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 29, value: "200")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 30, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 471, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 472, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 473, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 35, order: 15) #67
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 344, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 345, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 346, value: "60")
  PagePartial.create!(page_id: Page.all.length, partial_id: 14, order: 16) #68
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 407, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 415, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 106, value: "Virtually infinite marketing integrations")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 107, value: "Integrate your school with MailChimp, AWeber, Infusionsoft, Mixpanel, and almost any other marketing tool via Zapier.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 108, value: "Conversion pixels support")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 109, value: "Gain valuable insights about your advertising’s effectiveness by adding conversion pixels to your site.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 110, value: "First and last touch attribution")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 111, value: "Determine the initial source where a student heard about you, and identify which campaign converted them into customers.")
    Image.create(url: "https://cdn.filepicker.io/api/file/uoFTeB8cSrSjMFOLYyOl", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 112, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 113, value: "26")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 114, value: "115")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 216, value: "115")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 217, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 7, order: 17) #69
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 33, value: "WHAT ARE YOU WAITING FOR?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 34, value: "Join thousands of teachers making a difference every day using Teachable")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 35, value: "750")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 36, value: "Get started for free")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 716, value: "/create-account")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 38, value: "115")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 211, value: "115")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 212, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 37, order: 18) #70
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 311, value: "75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 312, value: "75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 313, value: "60")
  PagePartial.create!(page_id: Page.all.length, partial_id: 38, order: 19) #71
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "analytics")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 39, order: 20) #72
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 315, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 316, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 317, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 318, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 319, value: "Analytics")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 320, value: "Get instant insights into your school with built-in reporting tools")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 321, value: "555")
    Image.create(url: "https://cdn.filepicker.io/api/file/WPMHtqJDT8mX43mT6C7W", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 322, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 356, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 355, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 357, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 323, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 358, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 324, value: "Comprehensive dashboard")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 325, value: "See a snapshot of student signups and revenue across a defined time period on your Teachable dashboard.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 326, value: "Course-wide student insights")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 327, value: "Understand your average lecture completion rates and sort by student account type (free, full price, or discounted).")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 328, value: "Contact and revenue data exports")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 329, value: "Export your student contact list or course revenue data at any time to perform deeper analysis.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 330, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 331, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 332, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 333, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 334, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 335, value: "80")
  PagePartial.create!(page_id: Page.all.length, partial_id: 36, order: 21) #73
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 290, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 291, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 292, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 293, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 294, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 295, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 296, value: "0")
    Image.create(url: "https://cdn.filepicker.io/api/file/5rDOkE8ORzCXQRKmV2Ts", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 297, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 347, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 348, value: "-10")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 298, value: "Yes")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 349, value: "-8")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 299, value: "Analytics integrations")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 300, value: "By integrating Zapier, you can send custom course-related events to virtually any analytics tool.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 301, value: "Multiple-instructor support")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 302, value: "Allow others to author and manage courses on your school and pay out your instructors on a monthly basis.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 303, value: "Student enrollments and refunds")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 304, value: "Manually enroll students in new courses when necessary and process full or partial refunds.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 305, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 306, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 307, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 308, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 309, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 310, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 38, order: 22) #74
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "hosting-and-security")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 28, order: 23) #75
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 151, value: "Hosting & Security")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 152, value: "Get a team of experts looking out for your school")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 255, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 441, value: "3 x 2")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 153, value: "44")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 256, value: "50")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 154, value: "Left")
    Image.create!(url: "https://cdn.filepicker.io/api/file/UbyPdmSqTFuik2orzOkv", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 155, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 156, value: "Seamless hosting")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 157, value: "Teachable hosts your course content for you and backs up your site and student data so you don’t have to worry about it.")
    Image.create!(url: "https://cdn.filepicker.io/api/file/rhI8RO51QoCLGIPU9ye5", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 158, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 159, value: "Data ownership")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 160, value: "Own and control all of the content and student data from your Teachable schools and courses.")
    Image.create!(url: "https://cdn.filepicker.io/api/file/skHFuyn6RZeeDKAHh6TD", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 161, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 162, value: "24/7 monitoring")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 163, value: "We work around the clock to fix issues as they arise and make sure your virtual school doors stay open.")
    Image.create!(url: "https://cdn.filepicker.io/api/file/II8GXOCDTGG1Kii5Snbu", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 164, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 165, value: "Instant upgrades")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 166, value: "Automatically receive the latest features immediately, without having to manually update.")
    Image.create!(url: "https://cdn.filepicker.io/api/file/YOMRf9jWSh2o8GKeuaRz", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 167, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 168, value: "SSL certificate")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 169, value: "A 2048-bit SSL certificate keeps your students' information secure during login and checkout.")
    Image.create!(url: "https://cdn.filepicker.io/api/file/TRPVPYfRGuZiLWvEgoIm", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 170, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 171, value: "Secured payment data")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 172, value: "We only work with payment providers that are PCI level-1 compliant, so your and your users’ data is safe and secure.")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 173, value: "110")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 214, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 215, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 376, value: "#1EA69A")
  PagePartial.create!(page_id: Page.all.length, partial_id: 7, order: 24) #76
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 33, value: "WHAT ARE YOU WAITING FOR?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 34, value: "Join thousands of teachers making a difference every day using Teachable")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 35, value: "750")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 36, value: "Get started for free")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 716, value: "/create-account")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 38, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 211, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 212, value: "60")
  PagePartial.create!(page_id: Page.all.length, partial_id: 5, order: 25) #77
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 28, value: "1")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 29, value: "375")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 30, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 471, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 472, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 473, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 26) #78
Page.create!(name: "Examples", url: "/examples", title_text: "Teachable | Examples of Online Courses Built Using Teachable", description: "From scrapbooking to coding. From enterprises to solopreneurs. The best instructors in the world build their online courses on Teachable.", creator_id: 1, active: true , canonical_url: "https://teachable.com/examples") #11
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #79
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #80
    Image.create(url: "https://cdn.filepicker.io/api/file/vNCMiPpT6qrvVvHcJUwQ", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Center")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "The best instructors in the world build their online courses on Teachable")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "From scrapbooking to coding. From enterprises to solopreneurs. Our instructors prove that everything is teachable")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Orange")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "550")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "500")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "770")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "600")
  PagePartial.create!(page_id: Page.all.length, partial_id: 31, order: 2) #81
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 225, value: "Creators")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 226, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 227, value: "YouTubers")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 228, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 229, value: "Niche Experts")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 230, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 231, value: "Authors")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 232, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 233, value: "Marketplaces")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 234, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 336, value: "Enterprises")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 337, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 235, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 236, value: "80")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 371, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 237, value: "80")
  PagePartial.create!(page_id: Page.all.length, partial_id: 40, order: 3) #82
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 361, value: "Creators")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 362, value: "Create a lifestyle business doing what you love, be it scrapbooking, photography, animation and design, or anything else you can dream up")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 363, value: "27")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 364, value: "28")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 365, value: "5")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 366, value: "6")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 367, value: "29")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 368, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 369, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 370, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 40, visible: false, order: 4) #83
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 361, value: "YouTubers")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 362, value: "Transform your videos into a profitable online course and delight your community with premium content")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 363, value: "30")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 364, value: "31")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 365, value: "32")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 366, value: "33")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 367, value: "34")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 368, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 369, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 370, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 40, visible: false, order: 5) #84
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 361, value: "Niche Experts")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 362, value: "Showcase and monetize your expertise on any field. Some of our most successful instructors teach courses on niche topics")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 363, value: "35")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 364, value: "7")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 365, value: "36")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 366, value: "4")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 367, value: "37")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 368, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 369, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 370, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 40, visible: false, order: 6) #85
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 361, value: "Authors")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 362, value: "Turn your words, insights, and industry experience into a highly marketable online product that’s easy to create")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 363, value: "38")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 364, value: "39")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 365, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 366, value: "41")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 367, value: "42")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 368, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 369, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 370, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 40, visible: false, order: 7) #86
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 361, value: "Marketplaces")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 362, value: "Create your own course marketplace. Bring teachers together and automatically pay them a revenue share on their courses")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 363, value: "43")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 364, value: "44")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 365, value: "45")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 366, value: "46")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 367, value: "47")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 368, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 369, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 370, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 40, visible: false, order: 8) #87
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 361, value: "Enterprises")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 362, value: "Use Teachable within your organization to provide value to your customers, train employees, or sell courses to the general public")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 363, value: "48")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 364, value: "49")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 365, value: "50")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 366, value: "51")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 367, value: "52")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 368, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 369, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 370, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 37, order: 9) #88
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 311, value: "155")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 312, value: "125")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 313, value: "75")
  PagePartial.create!(page_id: Page.all.length, partial_id: 7, order: 10) #89
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 33, value: "WHAT ARE YOU WAITING FOR?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 34, value: "Start now and turn your knowledge into a profitable online course")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 35, value: "750")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 36, value: "Get started for free")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 716, value: "/create-account")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 38, value: "125")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 211, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 212, value: "50")
  PagePartial.create!(page_id: Page.all.length, partial_id: 5, order: 11) #90
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 28, value: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 29, value: "375")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 30, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 471, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 472, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 473, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 12) #91
Page.create!(name: "Enterprise", url: "/enterprise", title_text: "Teachable | Simple and Powerful Enterprise eLearning Platform", description: "Use Teachable's simple and reliable eLearning solution to train your employees, educate your community, or sell online courses.", creator_id: 1, active: true , canonical_url: "https://teachable.com/enterprise") #12
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #92
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #93
    Image.create(url: "https://cdn.filepicker.io/api/file/u5ghbFaWRrmb7oOZHM1x", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Left")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Simple and powerful eLearning platform for your enterprise")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "Use one simple and reliable solution to train your employees, educate your community, or sell online courses")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Orange")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "Contact us for a private demo")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "#enterprise-form")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "550")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "850")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "50")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "50")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "50")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "650")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "600")
  PagePartial.create!(page_id: Page.all.length, partial_id: 41, order: 2) #94
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 372, value: "Market leaders use Teachable to enrich their brand & business.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 373, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 374, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 375, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 37, order: 3) #95
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 311, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 312, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 313, value: "60")
  PagePartial.create!(page_id: Page.all.length, partial_id: 28, order: 4) #96
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 151, value: "Go Enterprise")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 152, value: "Powerful features for high-volume businesses in an affordable and easy to use platform")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 255, value: "730")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 441, value: "3 x 2")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 153, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 256, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 154, value: "Left")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 376, value: "#FF7F45")
    Image.create(url: "https://cdn.filepicker.io/api/file/U7w48oH1RgKOv4Sm2mTE", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 155, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 156, value: "One-stop eLearning solution")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 157, value: "Web hosting, payments, video delivery, and analytics—we’re happy to be the only solution you’ll need.")
    Image.create(url: "https://cdn.filepicker.io/api/file/tP0F9dOURgWhmLyL99fA", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 158, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 159, value: "Integrate seamlessly")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 160, value: "Easily connect all your tools—from email service providers to calendars to bookkeeping applications.")
    Image.create(url: "https://cdn.filepicker.io/api/file/7pIv2mWeR12adkRZg6Y9", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 161, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 162, value: "Focus on the content, we’ll do the rest")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 163, value: "Our user-friendly platform allows anyone in your organization to publish professional courses in minutes.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 164, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 165, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 166, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 167, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 168, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 169, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 170, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 171, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 172, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 173, value: "160")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 214, value: "160")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 215, value: "79.5")
  PagePartial.create!(page_id: Page.all.length, partial_id: 42, order: 5) #97
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 377, value: "Why choose Teachable?")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 378, value: "*   Your own custom domain. (www.yourawesometraining.com)\n*   Keep 90%+ of your revenue with lower transactions fees\n*   Integrate easily with your email service provider\n*   Remove Teachable branding from your course website\n*   Invite multiple instructors to teach courses in your school\n*   Track course engagement with advanced analytics")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 379, value: "642")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 380, value: "#FF7F45")
    Image.create!(url: "https://cdn.filepicker.io/api/file/LmdDtfGQvaE6wxn2p1R7", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 381, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 382, value: "115")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 383, value: "115")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 384, value: "115")
  PagePartial.create!(page_id: Page.all.length, partial_id: 7, order: 6) #98
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 33, value: "NEED MORE?")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 34, value: "Need a custom online learning platform? Tell us how we can help")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 35, value: "750")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 36, value: "Talk to a member of our team")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 37, value: "#enterprise-form")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 38, value: "115")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 211, value: "115")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 212, value: "115")
  PagePartial.create!(page_id: Page.all.length, partial_id: 43, order: 7) #99
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 385, value: "Gold-standard support from expert account managers")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 386, value: "Get access to a dedicated account manager to ensure your product support requests are addressed as soon as possible.\n\nYour account manager acts as a concierge onboarding specialist, assisting in your school setup so you can get started without any technical headaches.")
    Image.create!(url: "https://cdn.filepicker.io/api/file/WrqoIesRTZqJhqRWk3Qg", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 387, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 388, value: "Hi! My name is Cameron Mattis")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 389, value: "Your Enterprise Account Manager")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 390, value: "30")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 391, value: "30")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 392, value: "30")
  PagePartial.create!(page_id: Page.all.length, partial_id: 38, order: 8) #100
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "enterprise-form")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 44, order: 9) #101
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 393, value: "50")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 394, value: "50")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 395, value: "50")
  PagePartial.create!(page_id: Page.all.length, partial_id: 5, order: 10) #102
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 28, value: "1")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 29, value: "375")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 30, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 471, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 472, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 473, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 11) #103
Page.create!(name: "Careers", url: "/careers", title_text: "Jobs at Teachable", description: "Let’s revolutionize education together.", creator_id: 1, active: true , canonical_url: "https://teachable.com/careers") #13
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #104
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #105
    Image.create!(url: "https://cdn.filepicker.io/api/file/mVbnFsd7QVyTRPAZAbM7", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Left")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Let’s revolutionize education")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "We’re out to transform the way knowledge is shared by empowering passionate individuals to kick-start entrepreneurial careers, creating and selling online courses – no matter what their skillset is")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Orange")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "Join us")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "#job-listings")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "550")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "850")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "50")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "650")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "600")
  PagePartial.create!(page_id: Page.all.length, partial_id: 45, order: 2) #106
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 399, value: "New York, NY")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 400, value: "Step inside our office")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 401, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 402, value: "Based in New York City, we’re a venture-backed startup with a rapidly growing user base and a mission to change the education technology industry.")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 403, value: "542")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 404, value: "120")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 405, value: "120")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 406, value: "60")
  PagePartial.create!(page_id: Page.all.length, partial_id: 14, order: 3) #107
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 407, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 415, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 106, header_type: 2, value: "Why Teachable?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 107, value: "We keep an open, interactive space for team collaboration in order to make a valuable impact on a day-to-day basis. Even if perfection is impossible, we strive for it anyway. Why? We want to produce the best damn ed-tech product out there. (Plus, “A” for effort, right?)\n\nOur whole team is always learning and growing. From hack-weeks to company learning initiatives, we’re always working toward a higher level of intelligence and understanding.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 108, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 109, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 110, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 111, value: "")
    Image.create(url: "https://cdn.filepicker.io/api/file/zInZxPkRh3KdtFcWcZjw", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 112, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 113, value: "54")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 114, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 216, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 217, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 28, order: 4) #108
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 151, value: "Company Values")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 152, value: "The Teachable culture")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 255, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 441, value: "3 x 2")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 153, value: "70")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 256, value: "70")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 154, value: "Left")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 376, value: "#1EA69A")
    Image.create!(url: "https://cdn.filepicker.io/api/file/CsMsF9JT6mmUpTcYhZaQ", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 155, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 156, value: "Hit heavy, stay small")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 157, value: "Tight-knit, dynamic teams work with more agility, communication, and freedom than large-scale companies.")
    Image.create!(url: "https://cdn.filepicker.io/api/file/tvhEqZIdTTqzg6zHi9wO", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 158, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 159, value: "Ambition by the boatload")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 160, value: "We love people who aim for greatness. They inspire and excite their teammates, raising the bar for all of us.")
    Image.create!(url: "https://cdn.filepicker.io/api/file/prtKj25nS9itaQf624hB", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 161, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 162, value: "Open communication")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 163, value: "We’re big fans of transparency for many reasons, but the abridged version is: it makes everything we do SO much easier.")
    Image.create!(url: "https://cdn.filepicker.io/api/file/j3LKa8tXQ86i1sGd3XXh", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 164, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 165, value: "Autonomy and attitude")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 166, value: "We’re a team of self-starters who take serious pride in our work – and it shows.")
    Image.create!(url: "https://cdn.filepicker.io/api/file/m8w17AWfT6G9TN3WP0wk", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 167, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 168, value: "Support and win")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 169, value: "When we empower others to succeed, we all win. (And we’re not talking about participation trophies.)")
    Image.create!(url: "https://cdn.filepicker.io/api/file/9mHxQvoJRhSo698eQORN", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 170, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 171, value: "Teamwork makes the dream work")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 172, value: "We work together to bring our passions and expertise to make Teachable the best it can be.")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 173, value: "110")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 214, value: "110")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 215, value: "110")
  PagePartial.create!(page_id: Page.all.length, partial_id: 46, order: 5) #109
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 408, value: "80")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 409, value: "40")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 410, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 47, order: 7) #110
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 411, value: "200")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 412, value: "160")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 413, value: "160")
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 8) #111
Page.create!(name: "Affiliates", url: "/affiliates", title_text: "Start teaching online. Use Teachable to create your own online course.", description: "Start teaching online. Use Teachable to create your own online course.", creator_id: 1, active: true , canonical_url: "https://teachable.com/affiliates") #14
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #112
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #113
    Image.create!(url: "https://cdn.filepicker.io/api/file/fs80S6UJRUO03xhE0huZ", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Left")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Can we send you a check every month?")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "Earn ongoing monthly income by joining the free Teachable affiliate program")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Orange")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "Sign Up")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "https://teachable.typeform.com/to/Y1NIZ3")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "550")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "850")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "50")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "650")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "600")
  PagePartial.create!(page_id: Page.all.length, partial_id: 27, order: 2) #114
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 138, value: "Become an affiliate")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 139, value: "Why would you choose Teachable?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 177, value: "0")
    Image.create(url: "https://cdn.filepicker.io/api/file/hUH8wVQMR42swUFAlIF4", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 140, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 178, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 176, value: "No")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 141, header_type: 2, value: "The best affiliate program in the industry")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 142, value: "We pay out **30% commissions** with a 90-day cookie-- that’s one of the highest commissions in the biz. You could earn hundreds off a single email.")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 143, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 144, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 145, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 146, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 147, value: "300")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 148, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 213, value: "No")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 149, value: "50")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 352, value: "Yes")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 353, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 354, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 13, order: 3) #115
    Image.create(url: "https://cdn.filepicker.io/api/file/6mySKI2NRX6ScQtso4Uk", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 101, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 414, value: "#F4FAFA")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 102, value: "Send traffic once, earn forever")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 104, value: "Our customers pay us every month, which means we pay you every month. Once you refer someone to us, you earn a commission every month for the first year after they become a customer.\n\nWe’ll deposit money straight into your PayPal account each and every month—hassle-free and guaranteed.")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 150, value: "450")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 105, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 174, value: "75")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 175, value: "75")
  PagePartial.create!(page_id: Page.all.length, partial_id: 39, order: 4) #116
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 315, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 316, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 317, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 318, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 319, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 320, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 321, value: "0")
    Image.create(url: "https://cdn.filepicker.io/api/file/njphvhxDTum2zU9x0xtD", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 322, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 356, value: "20")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 355, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 357, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 323, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 358, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 324, header_type: 2, value: "Drive purchases with our conversion-optimized funnels")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 325, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 326, value: "Pick the best funnel for your audience")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 327, value: "Choose from four A/B tested funnels, all of which come with an overview of the target audience, accompanying visuals, email swipe copy and historical earnings per click.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 328, value: "Easy-access affiliate code")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 329, value: "Your unique affiliate code is always accessible in your affiliate portal and we track every page on Teachable.com (including our blog!), making it easy to earn commission off any page.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 330, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 331, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 332, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 333, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 334, value: "75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 335, value: "75")
  # add id tag to features page
  PagePartial.create!(page_id: 11, partial_id: 38, order: 2) #117
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "sub-menu")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 33, order: 5) #106
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 416, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 417, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 257, header_type: 2, value: "Best of all, your audience will love us")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 258, value: "We know you don’t choose affiliate partners lightly. When you send a customer to us, we give them the red carpet treatment. They’ll receive...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 259, value: "The most powerful platform in the industry")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 260, value: "We are trusted by over 10,000 talented artists, writers, entrepreneurs and business teams.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 261, value: "Exclusive, high-leverage bonuses")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 262, value: "Each funnel comes with a special online bundle of premium trainings to help your audience create and launch their own online course.")
    Image.create(url: "https://cdn.filepicker.io/api/file/pdDasVpyRQSy7v01QXOm", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 263, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 264, value: "17")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 265, value: "90")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 266, value: "90")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 267, value: "90")
  # add id tag to careers page
  PagePartial.create!(page_id: 14, partial_id: 38, order: 6) #118
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "job-listings")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 32, order: 6) #119
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 238, value: "Perfect Fit")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 239, value: "Our most successful affiliates have two things...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 240, value: "542")
    Image.create(url: "https://cdn.filepicker.io/api/file/fkOi2iYCSdyi5S9mWBz0", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 241, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 242, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 243, value: "15")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 350, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 253, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 351, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 244, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 245, value: "An engaged audience")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 246, value: "This could be an email list, Twitter following, popular Facebook page or a high-traffic, niche blog.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 247, value: "Teachable experience")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 248, value: "You've used (and loved!) our product, have created your own online course or have helped others create their own courses.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 249, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 250, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 251, value: "220")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 252, value: "115")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 254, value: "75")
  PagePartial.create!(page_id: Page.all.length, partial_id: 7, order: 7) #120
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 33, value: "WHAT ARE YOU WAITING FOR?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 34, value: "Join Teachable's affiliate program today")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 35, value: "750")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 36, value: "Sign up")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 37, value: "https://teachable.typeform.com/to/Y1NIZ3")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 38, value: "90")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 211, value: "75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 212, value: "75")
  PagePartial.create!(page_id: Page.all.length, partial_id: 37, order: 8) #121
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 311, value: "90")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 312, value: "75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 313, value: "75")
  PagePartial.create!(page_id: Page.all.length, partial_id: 8, order: 9) #123
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 39, value: "Answers to all your questions")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 40, value: "Which plan do you recommend?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 41, value: "The most popular plan is our Professional plan. However, we also offer a free plan so you can try out Teachable and see if it’s a good fit for you.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 42, value: "Do you charge a setup fee?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 43, value: "With Teachable, there are absolutely no setup fees. You can launch your school for free!")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 44, value: "How do transaction fees work?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 45, value: "Every time a user purchases a course, course bundle, or subscription, we collect a transaction fee according to your pricing plan. Higher-priced monthly plans have lower transaction fees. If you are on our Free, Basic, Professional or High Volume plans and are using the Teachable payment gateway, we also charge a standard payment processing fee of 2.9% + $0.30 on paid courses.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 46, value: "When do I get paid?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 47, value: "When using Teachable’s payment gateway, you’ll be paid at the beginning of each month for purchases made at least 30 days ago. For example, if one student pays you on March 5, and another pays you on March 25, you’ll receive both students’ payments at the beginning of May. This system allows us enough time to honor our 30-day refund policy. However, if you’re using a custom payment gateway (available on the Professional plan and above), payouts will be distributed almost immediately.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 48, value: "What happens if I want to cancel my plan?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 49, value: "We'll be sad to see you go, but you can cancel your Teachable plan at any time. We don't lock you into any lengthy contract. Moreover, since you own all school data as well as the domain name (if using a custom one), you can download your course, student, and revenue information so you can build your own website or use another service.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 50, value: "Can I use my own domain name?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 51, value: "On our Basic plan and above, you can use your own domain name (example.com). Additionally, every Teachable plan comes with a completely free yourschool.teachable.com domain name that you’re welcome to use.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 52, value: "Can Teachable be used for enterprise applications like internal training?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 53, value: "Absolutely! Some of our biggest clients use Teachable for internal training. Our High Volume and Enterprise plans allow you to import your employees for private training.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 54, value: "Can I offer free courses with Teachable?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 55, value: "Absolutely! And when you create a free course, we do not charge any fees on enrollments.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 56, value: "Do I need a payment processor?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 57, value: "Teachable handles the payment processing for you, so you don’t need a separate processor. We accept credit card, debit card, and PayPal. (However, on the Professional plan and above, you can also use your own payment gateways and take advantage of instant payouts!)")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 58, value: "What happens if I cannot set up direct payouts via Stripe Connect or PayPal?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 59, value: "Every time a user If you cannot set up custom payment gateways on the Professional plan or above, Teachable can collect funds for you and pay you on our regular payment schedule. When using our payment gateway, we have a payment processing fee of 2.9% + 30¢, plus a fee that varies based on your plan:\n\n*   Free: $1 + 10%\n*   Basic: 5%\n*   Professional: 0%\n*   High Volume: 0%")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 60, value: "Who pays my affiliates and authors out?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 61, value: "If you have custom gateways enabled (Stripe and/or PayPal), you are responsible for paying authors and affiliates out. If you use Teachable’s payment gateway, we will automatically pay out your authors and affiliates, send them the necessary tax forms at the end of the year, and take care of all the reporting.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 62, value: "Do I need a web host?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 63, value: "Nope. Teachable hosts all your course content (even though, to your audience, it looks like you’re hosting it!)")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 64, value: "Is there a limit to how much content I can upload?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 65, value: "Every Teachable plan includes unlimited video and course content bandwidth. Upload as many courses, videos, PDFs, etc. as you like :)")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 66, value: "Who can I contact with additional questions?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 67, value: "After creating an account, you can easily submit a support ticket from the admin area. Alternatively, you are always welcome to contact us through our [help form](https://teachable.com/help) if you have any questions prior to creating your first course.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 68, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 209, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 210, value: "60")
  PagePartial.create!(page_id: Page.all.length, partial_id: 5, order: 10) #124
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 28, value: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 29, value: "375")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 30, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 471, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 472, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 473, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 11) #125
Page.create!(name: "Affiliate Funnels", url: "/affiliates/funnels", title_text: "Start teaching online. Use Teachable to create your own online course.", description: "Start teaching online. Use Teachable to create your own online course.", creator_id: 1, active: true , canonical_url: "https://teachable.com/affiliates/funnels") #15
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #126
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #127
    Image.create!(url: "https://cdn.filepicker.io/api/file/KjB4OG3TMWP5MTU0GVbx", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Left")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Welcome to the Teachable Affiliate Program")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "Everything you need to start referring and earning money every month through the Teachable affiliate program")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Arrow")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "#below-hero")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "550")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "850")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "650")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "600")
  PagePartial.create!(page_id: Page.all.length, partial_id: 38, order: 2) #128
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "below-hero")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 39, order: 3) #129
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 315, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 316, value: "75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 317, value: "75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 318, value: "75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 319, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 320, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 321, value: "0")
    Image.create(url: "https://cdn.filepicker.io/api/file/W2rgSqVfQxChC0547q90", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 322, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 356, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 355, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 357, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 323, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 358, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 324, header_type: 2, value: "Always use your affiliate code")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 325, value: "We track every page on teachable.com, blog.teachable.com, and workshops.teachable.com (the site we use for webinars).\n\nWhile we recommend using one of our funnels, you can send traffic to any page on those domains. Your affiliate code can be found in your confirmation email, or by logging into your affiliate account.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 326, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 327, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 328, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 329, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 330, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 331, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 332, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 333, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 334, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 335, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 48, order: 4) #130
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 418, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 419, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 420, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 39, order: 5) #131
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 315, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 316, value: "50")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 317, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 318, value: "50")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 319, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 320, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 321, value: "0")
    Image.create(url: "https://cdn.filepicker.io/api/file/Q9ORguFyTZWvKn2K8Fgu", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 322, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 356, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 355, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 357, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 323, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 358, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 324, header_type: 2, value: "Your monthly payments")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 325, value: "Get monthly automatic payments on the first of the month, every month. No need to request payments or set a calendar reminder.\n\nWe’ll send you an email every month with a payment notification and you’ll see your affiliate commissions just show up like magic in your PayPal account.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 326, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 327, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 328, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 329, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 330, value: "50")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 331, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 332, value: "50")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 333, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 334, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 335, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 5, order: 6) #132
    Image.create(url: "https://cdn.filepicker.io/api/file/EQopsPYmQzuewArw166L", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 28, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 29, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 30, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 471, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 472, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 473, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 8, order: 7) #133
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 39, value: "Answers to all your questions")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 40, value: "Which plan do you recommend?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 41, value: "The most popular plan is our Professional plan. However, we also offer a free plan so you can try out Teachable and see if it’s a good fit for you.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 42, value: "Do you charge a setup fee?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 43, value: "With Teachable, there are absolutely no setup fees. You can launch your school for free!")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 44, value: "How do transaction fees work?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 45, value: "Every time a user purchases a course, course bundle, or subscription, we collect a transaction fee according to your pricing plan. Higher-priced monthly plans have lower transaction fees. If you are on our Free, Basic, Professional or High Volume plans and are using the Teachable payment gateway, we also charge a standard payment processing fee of 2.9% + $0.30 on paid courses.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 46, value: "When do I get paid?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 47, value: "When using Teachable’s payment gateway, you’ll be paid at the beginning of each month for purchases made at least 30 days ago. For example, if one student pays you on March 5, and another pays you on March 25, you’ll receive both students’ payments at the beginning of May. This system allows us enough time to honor our 30-day refund policy. However, if you’re using a custom payment gateway (available on the Professional plan and above), payouts will be distributed almost immediately.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 48, value: "What happens if I want to cancel my plan?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 49, value: "We'll be sad to see you go, but you can cancel your Teachable plan at any time. We don't lock you into any lengthy contract. Moreover, since you own all school data as well as the domain name (if using a custom one), you can download your course, student, and revenue information so you can build your own website or use another service.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 50, value: "Can I use my own domain name?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 51, value: "On our Basic plan and above, you can use your own domain name (example.com). Additionally, every Teachable plan comes with a completely free yourschool.teachable.com domain name that you’re welcome to use.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 52, value: "Can Teachable be used for enterprise applications like internal training?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 53, value: "Absolutely! Some of our biggest clients use Teachable for internal training. Our High Volume and Enterprise plans allow you to import your employees for private training.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 54, value: "Can I offer free courses with Teachable?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 55, value: "Absolutely! And when you create a free course, we do not charge any fees on enrollments.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 56, value: "Do I need a payment processor?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 57, value: "Teachable handles the payment processing for you, so you don’t need a separate processor. We accept credit card, debit card, and PayPal. (However, on the Professional plan and above, you can also use your own payment gateways and take advantage of instant payouts!)")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 58, value: "What happens if I cannot set up direct payouts via Stripe Connect or PayPal?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 59, value: "Every time a user If you cannot set up custom payment gateways on the Professional plan or above, Teachable can collect funds for you and pay you on our regular payment schedule. When using our payment gateway, we have a payment processing fee of 2.9% + 30¢, plus a fee that varies based on your plan:\n\n*   Free: $1 + 10%\n*   Basic: 5%\n*   Professional: 0%\n*   High Volume: 0%")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 60, value: "Who pays my affiliates and authors out?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 61, value: "If you have custom gateways enabled (Stripe and/or PayPal), you are responsible for paying authors and affiliates out. If you use Teachable’s payment gateway, we will automatically pay out your authors and affiliates, send them the necessary tax forms at the end of the year, and take care of all the reporting.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 62, value: "Do I need a web host?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 63, value: "Nope. Teachable hosts all your course content (even though, to your audience, it looks like you’re hosting it!)")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 64, value: "Is there a limit to how much content I can upload?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 65, value: "Every Teachable plan includes unlimited video and course content bandwidth. Upload as many courses, videos, PDFs, etc. as you like :)")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 66, value: "Who can I contact with additional questions?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 67, value: "After creating an account, you can easily submit a support ticket from the admin area. Alternatively, you are always welcome to contact us through our [help form](https://teachable.com/help) if you have any questions prior to creating your first course.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 68, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 209, value: "60")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 210, value: "60")
  PagePartial.create!(page_id: Page.all.length, partial_id: 5, order: 8) #134
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 28, value: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 29, value: "375")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 30, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 471, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 472, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 473, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 9) #135
Page.create!(name: "Affiliate Funnels - Quickstart", url: "/affiliates/funnels/quickstart", title_text: "Start teaching online. Use Teachable to create your own online course.", description: "Start teaching online. Use Teachable to create your own online course.", creator_id: 1, active: true , canonical_url: "https://teachable.com/affiliates/funnels/quickstart") #16
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #136
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #137
    Image.create!(url: "https://cdn.filepicker.io/api/file/6LhhDxwTRbKKVKXDdikR", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Left")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "TEACHABLE AFFILIATE FUNNEL: FOR BEGINNERS")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Quickstart webinar")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "Our most popular training webinar—the best introduction to everything Teachable has to offer")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Arrow")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "#below-hero")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "550")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "750")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "75")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "75")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "75")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "650")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "600")
  PagePartial.create!(page_id: Page.all.length, partial_id: 38, order: 2) #138
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "below-hero")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 49, order: 3) #139
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 448, value: "21k+")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 449, value: "$2.75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 450, value: "25%")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 421, value: "120")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 422, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 423, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 50, order: 4) #140
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 424, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 425, header_type: 2, value: "Who should attend?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 426, value: "This webinar is a perfect starting point for:")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 427, value: "People who know about the world of online courses...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 428, value: "And are ready to create their first course.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 429, value: "Maybe they already have an audience, and they’re looking for MORE")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 430, value: "More business, more freedom, more money in the bank")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 431, value: "")
    Image.create!(url: "https://cdn.filepicker.io/api/file/23MEKAgTfqEoXCPUrpe6", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 432, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 433, value: "#1EA69A")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 434, value: "Why this works?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 435, value: "This isn't your average webinar. We pack a ton of content into this free workshop and your audience will leave this webinar ready to start teaching their first course on Teachable within the week.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 436, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 437, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 438, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 28, order: 5) #141
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 151, value: "The Benefits")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 152, value: "Attendees will learn how to...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 153, value: "65")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 441, value: "2 x 3")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 154, value: "Center")
    Image.create(url: "https://cdn.filepicker.io/api/file/HshKnOQQeSGsxzaWtlPw", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 155, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 156, value: "Set up their first course")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 157, value: "The easiest way to create their own online school and set up their first course (without any of the technical headaches)")
    Image.create(url: "https://cdn.filepicker.io/api/file/hqg3DrPYR5S0tDUwV2wO", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 158, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 159, value: "Monetize their expertise")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 160, value: "Use Teachable to accept payments and make money by teaching their own online course")
    Image.create(url: "https://cdn.filepicker.io/api/file/ZZ4iZo38RkuS1qZtzj7n", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 161, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 162, value: "Make their course look beautiful")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 163, value: "Create a beautiful school that 100% matches their brand by adding their own logo, images, colors, and page elements with our easy to use page editor.")
    Image.create(url: "https://cdn.filepicker.io/api/file/425BPeWOQm65X8Z6BEDz", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 164, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 165, value: "Get their questions answered")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 166, value: "LIVE Q&A with Cameron and Kristina to answer every question you have about creating, promoting, and profiting from online courses.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 167, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 168, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 169, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 170, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 171, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 172, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 173, value: "200")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 255, value: "630")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 256, value: "65")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 376, value: "#1EA69A")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 214, value: "200")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 215, value: "200")
  PagePartial.create!(page_id: Page.all.length, partial_id: 51, order: 6) #142
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 442, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 443, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 444, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 52, order: 7) #143
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 451, value: "The first email in this series is an invitation to join the Quickstart webinar. It happens every Thursday at 2pm ET (11am PT) so we recommend you invite your audience on a Friday (6 days before the event).")
    Image.create!(url: "https://cdn.filepicker.io/api/file/FgIo7UHjTKKUl8T6RigL", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 452, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 453, value: "https://docs.google.com/document/d/1lfbHIYO-HY9nY4EsS1b3gIdr1bq2CsjsO1phRd2RIwU/edit#heading=h.b2fos1sl16op")
    Image.create!(url: "https://cdn.filepicker.io/api/file/EIkckpJQhmT6BDvqFk28", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 454, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 455, value: "https://docs.google.com/document/d/1ksU69p-4014_axMljQ98xetnG6VEJLpmAXPpx6leiBo/edit")
    Image.create!(url: "https://cdn.filepicker.io/api/file/b1qON34USBymoOO1n51r", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 456, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 457, value: "https://docs.google.com/document/d/1W9lwzMD9z-tVo0eL4jL5QS98smZ9kwrGabfnsSWdorY/edit")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 445, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 446, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 447, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 8) #144
Page.create!(name: "Affiliate Funnels - 7 Steps", url: "/affiliates/funnels/7-steps", title_text: "Start teaching online. Use Teachable to create your own online course.", description: "Start teaching online. Use Teachable to create your own online course.", creator_id: 1, active: true , canonical_url: "https://teachable.com/affiliates/funnels/7-steps") #17
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #145
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #146
    Image.create!(url: "https://cdn.filepicker.io/api/file/ArvcGeRRRdq4zFxrE36o", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Center")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "TEACHABLE AFFILIATE FUNNEL: FOR BEGINNERS")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "7 Steps to Launch")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "The perfect intro for those new to online course creation. If they sign-up through your affiliate link, they’ll also get access to premium bonuses to sweeten the deal")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Arrow")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "#below-hero")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "550")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "750")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "75")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "75")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "75")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "650")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "600")
  PagePartial.create!(page_id: Page.all.length, partial_id: 38, order: 2) #147
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "below-hero")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 49, order: 3) #148
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 448, value: "46k+")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 449, value: "$2.50")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 450, value: "33%")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 421, value: "120")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 422, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 423, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 50, order: 4) #149
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 424, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 425, header_type: 2, value: "Who should attend?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 426, value: "This webinar is a perfect starting point for:")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 427, value: "People curious about the world of online courses...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 428, value: "But are a little overwhelmed, too")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 429, value: "A traditional 9-5 job isn’t good enough, so they’re looking for MORE")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 430, value: "More business, more time with family, more money in the bank")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 431, value: "")
    Image.create!(url: "https://cdn.filepicker.io/api/file/avjYM8BBQuWSFacKyB7E", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 432, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 433, value: "#1EA69A")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 434, value: "Why this works?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 435, value: "This isn't your average webinar. We pack a ton of content into this free workshop and your readers will come away with an actionable gameplan (and a gorgeous workbook to put it in).")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 436, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 437, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 438, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 28, order: 5) #150
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 151, value: "The Benefits")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 152, value: "Attendees will learn how to...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 153, value: "65")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 441, value: "2 x 3")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 154, value: "Center")
    Image.create(url: "https://cdn.filepicker.io/api/file/T4PqKOyTeHMxHkKwnInA", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 155, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 156, value: "Follow our 7-step process")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 157, value: "Our 7-step process for creating, marketing and profiting from their own online course (even if they’ve never taught a day in their lives)")
    Image.create(url: "https://cdn.filepicker.io/api/file/0DyzJrmSuuI8GPZ1ndqa", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 158, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 159, value: "Monetize their expertise")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 160, value: "How freelancers and creatives can monetize their expertise, without being chained to billable hours or client demand")
    Image.create(url: "https://cdn.filepicker.io/api/file/ntOXS9vwSDhsZUcfoe3W", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 161, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 162, value: "Get their course online")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 163, value: "How to easily get their course online in under an hour, zero technical skills required")
    Image.create(url: "https://cdn.filepicker.io/api/file/nS0nsaPfTqGLQdYeZHdN", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 164, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 165, value: "Find a profitable course idea")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 166, value: "The easiest way to find their most profitable course idea using our super simple 3-tier framework")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 167, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 168, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 169, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 170, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 171, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 172, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 173, value: "200")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 255, value: "630")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 256, value: "65")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 376, value: "#1EA69A")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 214, value: "200")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 215, value: "200")
  PagePartial.create!(page_id: Page.all.length, partial_id: 51, order: 6) #151
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 442, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 443, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 444, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 52, order: 7) #152
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 451, value: "The first email in this series is an invitation to join the 7 Steps webinar. It happens every Tuesday at 2pm ET (11am PT) so we recommend you invite your audience on a Wednesday (6 days before the event).")
    Image.create!(url: "https://cdn.filepicker.io/api/file/fpYAeJl1Tx69y7FZgHnM", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 452, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 453, value: "https://docs.google.com/document/d/1uNmHwk-zShFMMZPjOZjq1hu7x2I8F56_68nATpN18wM/edit?usp=sharing")
    Image.create!(url: "https://cdn.filepicker.io/api/file/JSE3dTweSIiR90ndR0TZ", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 454, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 455, value: "https://docs.google.com/document/d/1ST704jFRiQQN5axJ8ceIWEo-ZdugXlxDEHF8hmdjba4")
    Image.create!(url: "https://cdn.filepicker.io/api/file/jt8bbXlkQf2EoSpdQfMg", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 456, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 457, value: "https://docs.google.com/document/d/12_CADpxjecGmoigXaJamw5lXfTd7Vayf3uNrtnaj_-Y/edit")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 445, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 446, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 447, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 8) #153
Page.create!(name: "Quickstart Offer", url: "/quickstart-offer", title_text: "Teachable | Teach online", description: "Start teaching online. Use Teachable to create your own online course.", creator_id: 1, active: true , canonical_url: "https://teachable.com/quickstart-offer") #18
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #154
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #155
    Image.create!(url: "https://cdn.filepicker.io/api/file/78EMECerRibU9Y8uagVb", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Left")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Special offer for new customers!")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "When you upgrade right now to any paid Teachable plan, you'll receive a bundle of special bonuses to get you better results, MUCH faster")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Orange")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "Get the bundle now")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "#pricing-table")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "700")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "850")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "650")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 39, order: 2) #156
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 315, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 316, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 317, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 318, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 319, value: "Create a Course")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 320, value: "If you want to launch an online course, there are TWO things you need")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 321, value: "555")
    Image.create(url: "https://cdn.filepicker.io/api/file/dfFmMycTTSPOHSm3yIkP", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 322, value: Image.all.length)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 356, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 355, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 357, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 323, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 358, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 324, value: "First, you need AMAZING software")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 325, value: "You need the technology that will allow you to easily create your own beautiful online course website, without any of the technical headaches.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 326, value: "Second, you need a proven method")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 327, value: "You need a proven, step-by-step process from entrepreneurs who have launched their own successful online courses to eliminate the mistakes.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 328, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 329, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 330, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 331, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 332, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 333, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 334, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 335, value: "80")
  PagePartial.create!(page_id: Page.all.length, partial_id: 33, order: 3) #157
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 416, value: "No")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 417, value: "#F4FAFA")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 257, header_type: 2, value: "Teachable helps you create & sell your online course")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 258, value: "With our easy-to-use online course creation platform, you can create courses without ever having to worry about tech, hosting, design, or marketing integrations.\n\nIt’s so easy that over 10k instructors have made over _$50m in course sales_ in just two years by using Teachable.")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 259, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 260, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 261, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 262, value: "")
    Image.create(url: "https://cdn.filepicker.io/api/file/TuqpTsYQlWsZ3KgX0omQ", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 263, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 264, value: "55")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 265, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 266, value: "100")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 267, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 27, order: 4) #158
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 138, value: "How This Works")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 139, value: "When you upgrade to a Teachable monthly Basic or Professional plan today, you’ll receive two things...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 177, value: "555")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 140, value: "103")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 178, value: "-40")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 176, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 141, value: "Full access to Teachable’s premium software")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 142, value: "Join over 7,500 instructors who use Teachable to share their knowledge. Easily create an online course with our powerful yet simple all-in-one platform.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 143, value: "Course Creation Bundle")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 144, value: "This is our special bundle of resources, tried and true, to help you create and sell your own online course. The bundle is worth up to $1,000, but you get them free! *(Just until the timer runs out.)*")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 145, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 146, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 147, value: "150")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 148, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 213, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 149, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 352, value: "Yes")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 353, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 354, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 29, order: 5) #159
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 179, value: "In the Course Creation Bundle you get these three awesome bonuses...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 180, value: "750")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 181, value: "You’ll learn our proven process to create and sell online courses, plus all the tips and tricks in between")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 182, value: "12")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 183, value: "13")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 184, value: "14")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 185, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 186, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 187, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 188, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 189, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 190, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 30, order: 6) #160
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 191, value: "Plus, if you upgrade to Professional, you’ll also receive...")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 192, value: "500")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 193, value: "15")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 194, value: "16")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 195, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 196, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 197, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 198, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 199, value: "75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 200, value: "75")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 201, value: "75")
  PagePartial.create!(page_id: Page.all.length, partial_id: 38, order: 7) #161
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "pricing-table")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
  PagePartial.create!(page_id: Page.all.length, partial_id: 6, order: 8) #162
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 202, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 31, value: "Join 10k+ online entrepreneurs on Teachable")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 32, value: "Choose what Teachable plan is best for you, whether it's to get started or to grow your business")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 205, value: "Monthly")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 206, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 221, value: "quickstart-offer")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 218, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 219, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 220, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 222, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 223, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 458, value: "No")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 135, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 203, value: "100")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 204, value: "100")
  PagePartial.create!(page_id: Page.all.length, partial_id: 36, order: 9) #163
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 290, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 291, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 292, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 293, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 294, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 295, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 296, value: "0")
    Image.create(url: "https://cdn.filepicker.io/api/file/vPF4TdEsQ5yfHc91WZVL", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 297, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 347, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 348, value: "10")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 298, value: "Yes")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 349, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 299, header_type: "2", value: "This deal is only for brand new customers")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 300, value: "When the time runs out, this deal is gone.\n\nYes, this is a special promotion and it's only available for a limited time. But we're giving you some time to check out the platform, play with the product and see for yourself if it's a good fit. We think you'll be impressed.")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 301, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 302, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 303, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 304, value: "")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 305, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 306, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 307, value: "0")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 308, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 309, value: "80")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 310, value: "80")
  PagePartial.create!(page_id: Page.all.length, partial_id: 53, order: 10) #164
    Image.create(url: "https://cdn.filepicker.io/api/file/RRvXA5REQurQuOVaHBFw", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 459, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 460, value: "#F4FAFA")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 461, value: "Our promise to you")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 462, value: "Everything you see here is valued at over $1,000. But today, you get everything here for just $39/m on the Basic plan or $99/m on the Professional plan.\n\nAnd it gets better: this is 100% risk free for you. Take the courses, download everything, get results. If you're not thrilled with everything you get, contact us at support.teachable.com and we'll offer you a 30-day 100% money back guarantee. (No questions asked, seriously.)\n\nThat's how confident we are that you're getting everything you need to create and launch your own online course with Teachable.\n\nSee you on the inside!")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 463, value: "450")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 464, value: "200")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 465, value: "200")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 466, value: "200")
  PagePartial.create!(page_id: Page.all.length, partial_id: 7, order: 11) #165
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 33, value: "WHAT ARE YOU WAITING FOR?")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 34, value: "Join thousands of teachers making a difference every day using Teachable")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 35, value: "525")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 36, value: "Upgrade now")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 37, value: "#pricing-table")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 38, value: "200")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 211, value: "200")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 212, value: "200")
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 12) #166
Page.create!(name: "Pricing Comparison", url: "/pricing/comparison", title_text: "Teachable | Compare and Pick the Right Pricing Plan for You", description: "Compare all four of our plans in one place and choose the one that fits your needs.", creator_id: 1, active: true , canonical_url: "https://teachable.com/pricing/comparison") #19
  PagePartial.create!(page_id: Page.all.length, partial_id: 1, order: 0) #167
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 1, value: "Yes")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 2, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 469, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 470, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 11, order: 1) #168
    Image.create!(url: "https://cdn.filepicker.io/api/file/GZ4fa2XgQCRkjaadlLLg", image_type: "page_partial", uploaded_by: 1)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 92, value: Image.all.length)
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 136, value: "Center")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 137, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 93, value: "Compare all four of our plans in one place")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 94, value: "Everything you need to know about Teachable plans")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 224, value: "Orange")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 95, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 96, value: "")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 97, value: "500")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 98, value: "500")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 359, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 360, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 99, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 268, value: "0")
    PagePartialField.create!(page_partial_id: PagePartial.all.length, partial_field_id: 269, value: "0")
  PagePartial.create!(page_id: Page.all.length, partial_id: 54, order: 2) #169
  PagePartial.create!(page_id: Page.all.length, partial_id: 2, order: 3) #170
# add ID tag to welcome page
  PagePartial.create!(page_id: 7, partial_id: 38, order: 9) #171
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "above-pricing-table")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#FFFFFF")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
# add ID tag to features page
  PagePartial.create!(page_id: 11, partial_id: 38, order: 11) #172
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 314, value: "placeholder")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 488, value: "#F4FAFA")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 396, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 397, value: "40")
    PagePartialField.create(page_partial_id: PagePartial.all.length, partial_field_id: 398, value: "40")
# add mobile image to hero partial
  PartialField.create(partial_id: 11, name: "Mobile Image", field_type: "image", mandatory: false, order: 1) #489
